#include <generated/autoconf.h>
#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/errno.h>
#include <linux/string.h>
#include <linux/mm.h>
#include <linux/slab.h>
#include <linux/delay.h>
#include <linux/fb.h>
#include <linux/init.h>
#include <linux/ioport.h>
#include <linux/pci.h>
#include <asm/uaccess.h>
#include <linux/interrupt.h>
#include <linux/pagemap.h>
#include <linux/radix-tree.h>
#include <linux/blkdev.h>
#include <linux/module.h>
#include <linux/blkpg.h>
#include <linux/buffer_head.h>
#include <linux/mpage.h>
#include <linux/ioctl.h> /* needed for the _IOW etc stuff used later */
#include <linux/sched.h>
#include <linux/dcache.h>
//#include <linux/pageremap.h>
#include <linux/platform_device.h>
#include "../../../../../drivers/staging/android/ion/ion.h"
#include <mach/rtk_ipc_shm.h>

#ifdef CONFIG_REALTEK_RPC
#include <linux/RPCDriver.h>
#endif
#ifdef CONFIG_REALTEK_AVCPU
#include "../avcpu.h"
#endif

#define RTKFB_SET_VSYNC_INT _IOW('F', 206, unsigned int)

//#define USE_FPGA_FLIP_TEST
//#define USE_RPC_TEST

//#include <platform.h>
#include "../rtk_fb.h"
#include "dc2vo.h"
#ifdef USE_FPGA_FLIP_TEST
#include "fpga/main/fpga.h"
#include "fpga/osd/osd.h"
#endif

static int debug    = 0;
static int warning  = 1;
static int info     = 1;
#define dprintk(msg...) if (debug)   { printk(KERN_DEBUG    "D/DC: " msg); }
#define eprintk(msg...) if (1)       { printk(KERN_ERR      "E/DC: " msg); }
#define wprintk(msg...) if (warning) { printk(KERN_WARNING  "W/DC: " msg); }
#define iprintk(msg...) if (info)    { printk(KERN_INFO     "I/DC: " msg); }

#ifndef DC_UNREFERENCED_PARAMETER
#define DC_UNREFERENCED_PARAMETER(param) (param) = (param)
#endif

static int DCINIT = 0;
extern struct ion_device *rtk_phoenix_ion_device;

typedef struct {
    REFCLOCK                *REF_CLK;
    RINGBUFFER_HEADER       *RING_HEADER;
    void                    *RING_HEADER_BASE;
    struct ion_client       *gpsIONClient;
    unsigned int            gAlpha;     /*  [0] Pixel Alpha    [0x01 ~ 0xFF] Global Alpha */

    unsigned int            *CLK_ADDR_LOW;
    unsigned int            *CLK_ADDR_HI;

    int64_t                 PTS;
    unsigned long           CTX;
    unsigned int            flags;

    int64_t                 PREV_TICK;
    unsigned int            RATE_GAP;
    unsigned int            RATE_HZ;

    unsigned int            ISR_TIMEOUT;
    atomic_t                ISR_FLIP;
    atomic_t                ISR_VSYNC;

    /*
     * vo_vsync_flag : VSync enable and notify. (VOut => SCPU)
     */
    void *                  vo_vsync_flag;

    unsigned int            uiRes32Width;
    unsigned int            uiRes32Height;

    DC_SYSTEM_TIME_INFO     DC_TIME_INFO;
} DC_INFO;

enum {
    RPC_READY  = (1U << 0),
    FLIP       = (1U << 1),
    ISR_INIT   = (1U << 2),
    WAIT_VSYNC = (1U << 3),
    CHANGE_RES = (1U << 4),
    BG_SWAP    = (1U << 5),
    SUSPEND    = (1U << 6),
};

DECLARE_WAIT_QUEUE_HEAD(DC_WAIT_OSD_COMPLETE);
DECLARE_WAIT_QUEUE_HEAD(DC_WAIT_VSYNC);
#ifdef CONFIG_RTK_RPC
static DC_INFO *gpdc_info;
DEFINE_SPINLOCK(gASLock);
EXPORT_SYSMBOL(gASLock);
#else
static DEFINE_SPINLOCK(gASLock);
#endif

#ifdef USE_FPGA_FLIP_TEST
#include <linux/kthread.h>
static struct task_struct *vsync_tsk;
static int vsync_thread(void *arg)
{
    unsigned int timeout;
    VENUSFB_MACH_INFO * video_info = (VENUSFB_MACH_INFO *)arg;
    DC_INFO * pdc_info = (DC_INFO*)video_info->dc_info;

    for(;;) {
        if (kthread_should_stop()) break;
        do {
            set_current_state(TASK_INTERRUPTIBLE);
            timeout = schedule_timeout(HZ/60);
        } while(timeout);

        if(atomic_read(&pdc_info->ISR_VSYNC) > 0)
            wake_up(&DC_WAIT_VSYNC);

        if(atomic_read(&pdc_info->ISR_FLIP) > 0)
            wake_up(&DC_WAIT_OSD_COMPLETE);
    }
    dprintk("[%s] break\n",__func__);

    return 0;
}
#endif

void DC_Reset_OSD_param(struct fb_info *fb, VENUSFB_MACH_INFO * video_info)
{
    DC_INFO * pdc_info = (DC_INFO*)video_info->dc_info;
    DC_UNREFERENCED_PARAMETER (fb);
    pdc_info->PTS = 0;
    pdc_info->CTX = 0;
    pdc_info->PREV_TICK = 0;
    clkResetPresentation(pdc_info->REF_CLK);
}

int DC_Set_RPCAddr(struct fb_info *fb, VENUSFB_MACH_INFO * video_info, DCRT_PARAM_RPC_ADDR* param)
{

    DC_INFO * pdc_info = (DC_INFO*)video_info->dc_info;
    DC_UNREFERENCED_PARAMETER (pdc_info);
    DC_UNREFERENCED_PARAMETER (fb);
    DC_UNREFERENCED_PARAMETER (video_info);

    #if 0
    // Set RefClk Table
    pdc_info->REF_CLK = (REFCLOCK*)
        phys_to_virt((phys_addr_t)ulPhyAddrFilter(param->refclockAddr));
        //ioremap((phys_addr_t)ulPhyAddrFilter(param->refclockAddr),sizeof(pdc_info->REF_CLK));

    // Set CMD Queue (Ring Buffer)
    pdc_info->RING_HEADER = (RINGBUFFER_HEADER*)
        phys_to_virt((phys_addr_t)ulPhyAddrFilter(param->ringPhyAddr));
        //ioremap((phys_addr_t)ulPhyAddrFilter(param->ringPhyAddr),sizeof(pdc_info->RING_HEADER));
    #endif

    dprintk("[%s] REFCLK: phy:0x%08x vir:0x%08x\n",__func__,param->refclockAddr,pdc_info->REF_CLK);
    dprintk("[%s] RING_HEADER: phy:0x%08x vir:0x%08x\n",__func__,param->ringPhyAddr,pdc_info->RING_HEADER);
    DC_Reset_OSD_param(fb,video_info);

    pdc_info->REF_CLK->mastership.videoMode = AVSYNC_FORCED_MASTER;

    {
        DC_PRESENTATION_INFO pos;
        clkGetPresentation(pdc_info->REF_CLK, &pos);
        iprintk("CLK pts:%lld ctx:%ld\n", pos.videoSystemPTS,pos.videoContext);
        iprintk("drvBeAddr:%x s:%lu id:%lu rw:(%x %x) #rPtr:%lu\n",
                (unsigned int)pli_IPCReadULONG((BYTE*)&pdc_info->RING_HEADER->beginAddr),
                pli_IPCReadULONG((BYTE*)&pdc_info->RING_HEADER->size),
                pli_IPCReadULONG((BYTE*)&pdc_info->RING_HEADER->bufferID),
                (unsigned int)pli_IPCReadULONG( (BYTE*)&pdc_info->RING_HEADER->readPtr[0]),
                (unsigned int)pli_IPCReadULONG( (BYTE*)&pdc_info->RING_HEADER->writePtr),
                pli_IPCReadULONG((BYTE*) &pdc_info->RING_HEADER->numOfReadPtr)
              );
    }

    smp_mb();
    pdc_info->flags |= RPC_READY;
    smp_mb();

    return 0;
}

int Get_RefClock(struct fb_info *fb, VENUSFB_MACH_INFO * video_info, REFCLOCK* pclk)
{
    DC_INFO * pdc_info = (DC_INFO*)video_info->dc_info;
    REFCLOCK* clk = pdc_info->REF_CLK; 
    DC_UNREFERENCED_PARAMETER (pdc_info);
    DC_UNREFERENCED_PARAMETER (fb);
    DC_UNREFERENCED_PARAMETER (video_info);
    if(clk == NULL) return -EAGAIN;
    else {
        unsigned long PliReadMastership = (unsigned long)   pli_IPCReadULONG        ((BYTE*)&clk->mastership      );
        pclk->mastership.systemMode     = (unsigned char)   ((PliReadMastership & 0xff000000) >> 24);
        pclk->mastership.videoMode      = (unsigned char)   ((PliReadMastership & 0x00ff0000) >> 16);
        pclk->mastership.audioMode      = (unsigned char)   ((PliReadMastership & 0x0000ff00) >> 8);
        pclk->mastership.masterState    = (unsigned char)   ((PliReadMastership & 0x000000ff) >> 0);
        pclk->AO_Underflow              = (unsigned long)   pli_IPCReadULONG        ((BYTE*)&clk->AO_Underflow    );
        pclk->GPTSTimeout               = (long long)       pli_IPCReadULONGLONG    ((BYTE*)&clk->GPTSTimeout     );
        pclk->RCD                       = (long long)       pli_IPCReadULONGLONG    ((BYTE*)&clk->RCD             );
        pclk->RCD_ext                   = (unsigned long)   pli_IPCReadULONG        ((BYTE*)&clk->RCD_ext         );
        pclk->VO_Underflow              = (unsigned long)   pli_IPCReadULONG        ((BYTE*)&clk->VO_Underflow    );
        pclk->audioContext              = (unsigned long)   pli_IPCReadULONG        ((BYTE*)&clk->audioContext    );
        pclk->videoContext              = (unsigned long)   pli_IPCReadULONG        ((BYTE*)&clk->videoContext    );
        pclk->masterGPTS                = (long long)       pli_IPCReadULONGLONG    ((BYTE*)&clk->masterGPTS      );
        pclk->audioSystemPTS            = (long long)       pli_IPCReadULONGLONG    ((BYTE*)&clk->audioSystemPTS  );
        pclk->videoSystemPTS            = (long long)       pli_IPCReadULONGLONG    ((BYTE*)&clk->videoSystemPTS  );
        pclk->audioRPTS                 = (long long)       pli_IPCReadULONGLONG    ((BYTE*)&clk->audioRPTS       );
        pclk->videoRPTS                 = (long long)       pli_IPCReadULONGLONG    ((BYTE*)&clk->videoRPTS       );
    }
    return 0;
}

int DC_Get_BufferAddr(struct fb_info *fb, VENUSFB_MACH_INFO * video_info,DCRT_PARAM_BUF_ADDR* param)
{
    DC_INFO * pdc_info = (DC_INFO*)video_info->dc_info;
    DC_UNREFERENCED_PARAMETER (pdc_info);
    DC_UNREFERENCED_PARAMETER (video_info);
    //TODO: Info from fb framebuffer info
#if 1
    memset(param, 0, sizeof(param));
    param->width  = fb->var.xres;
    param->height = fb->var.yres;
    return 0;
#else
    DC_NOHW_DEVINFO *psDevInfo;
    psDevInfo = GetAnchorPtr();
    if( param->buf_id <= DC_NOHW_MAX_BACKBUFFERS)
    {
        param->buf_Paddr = psDevInfo->asBackBuffers[param->buf_id].sSysAddr.uiAddr | 0xa0000000;
        param->buf_Vaddr = (unsigned int)psDevInfo->asBackBuffers[param->buf_id].sCPUVAddr;
        param->buf_size = psDevInfo->sSysDims.ui32Height * psDevInfo->sSysDims.ui32ByteStride;
        param->width = psDevInfo->sSysDims.ui32Width;
        param->height = psDevInfo->sSysDims.ui32Height;
        param->format =  psDevInfo->sSysFormat.pixelformat; //PVRSRV_PIXEL_FORMAT
        DCRT_DEBUG("get BUF_ADDR 0x%x 0x%x id:%d %u %d wh(%u %u)\n", param->buf_Paddr,
                param->buf_Vaddr,
                param->buf_id, param->buf_size, param->format, param->width, param->height);
    }
    else
    {
        memset(param, 0, sizeof(param));
    }
    return 0;
#endif
}

int DC_Wait_Vsync(struct fb_info *fb, VENUSFB_MACH_INFO * video_info, unsigned long long *nsecs)
{
    DC_INFO * pdc_info = (DC_INFO*)video_info->dc_info;
    DC_UNREFERENCED_PARAMETER (pdc_info);
    DC_UNREFERENCED_PARAMETER (fb);
    DC_UNREFERENCED_PARAMETER (video_info);

    if (atomic_read(&pdc_info->ISR_VSYNC) > 0)
    {
        //printk("%s:%d BUG!!!! Wait_Vsync, pdc_info->ISR_VSYNC = %d\n", __func__, __LINE__, atomic_read(&pdc_info->ISR_VSYNC));
        sleep_on_timeout(&DC_WAIT_VSYNC,  pdc_info->ISR_TIMEOUT);
        goto wake_up_all;
    }

    smp_mb();
    pdc_info->flags |= WAIT_VSYNC;
    smp_mb();

    // WIAT VSYNC EVENT
    {
        long timeout;
        atomic_inc(&pdc_info->ISR_VSYNC);
        timeout = sleep_on_timeout(&DC_WAIT_VSYNC,  pdc_info->ISR_TIMEOUT);
        if(timeout == 0) {
            wprintk("dc2vo tOut:%lu %d\n", pdc_info->CTX, atomic_read(&pdc_info->ISR_VSYNC));
        }else {
            //kjw test0
            //printk("DC sOk\n");
        }
        atomic_dec(&pdc_info->ISR_VSYNC);
    }

    smp_mb();
    pdc_info->flags &= ~WAIT_VSYNC;
    smp_mb();

wake_up_all:
    // WRITE NSECS TO USER
    *nsecs = ktime_to_ns(ktime_get());
    return 0;
}

int DC_Set_RateInfo(struct fb_info *fb, VENUSFB_MACH_INFO * video_info,DCRT_PARAM_RATE_INFO* param)
{
    DC_INFO * pdc_info = (DC_INFO*)video_info->dc_info;
    DC_UNREFERENCED_PARAMETER (pdc_info);
    DC_UNREFERENCED_PARAMETER (fb);
    DC_UNREFERENCED_PARAMETER (video_info);
    pdc_info->RATE_GAP = param->pts_gap;
    pdc_info->RATE_HZ = param->hz;
    pdc_info->CLK_ADDR_LOW = (unsigned int*)ioremap((phys_addr_t)ulPhyAddrFilter(param->clockAddrLow) ,0x4);
    pdc_info->CLK_ADDR_HI =  (unsigned int*)ioremap((phys_addr_t)ulPhyAddrFilter(param->clockAddrHi)   ,0x4);
    //pdc_info->CLK_ADDR_LOW = (unsigned int*)phys_to_virt((phys_addr_t)ulPhyAddrFilter(param->clockAddrLow));
    //pdc_info->CLK_ADDR_HI =  (unsigned int*)phys_to_virt((phys_addr_t)ulPhyAddrFilter(param->clockAddrHi));
    iprintk("DC rInfo: %u %u  pdc_info->CLK_ADDR_LOW=0x%x pdc_info->CLK_ADDR_HI=0x%x\n",
            pdc_info->RATE_GAP, pdc_info->RATE_HZ, (unsigned int)pdc_info->CLK_ADDR_LOW, (unsigned int)pdc_info->CLK_ADDR_HI);
    return 0;
}

int DC_Get_Clock_Map_Info(struct fb_info *fb, VENUSFB_MACH_INFO * video_info,DC_CLOCK_MAP_INFO * param)
{
    DC_INFO * pdc_info = (DC_INFO*)video_info->dc_info;
    DC_UNREFERENCED_PARAMETER (pdc_info);
    DC_UNREFERENCED_PARAMETER (fb);
    DC_UNREFERENCED_PARAMETER (video_info);
#if 1
    wprintk("[%s] WE ARE NOT SUPPORT!\n",__func__);
    memset(param,0,sizeof(DC_CLOCK_MAP_INFO));
#else
    if(pdc_info->CLK_ADDR_LOW == NULL || pdc_info->CLK_ADDR_HI == NULL) return -EAGAIN;
    else {
        DC_CLOCK_MAP_INFO info;
        info.HiOffset   = ((unsigned int)pdc_info->CLK_ADDR_HI) &  (PAGE_SIZE-1);
        info.LowOffset  = ((unsigned int)pdc_info->CLK_ADDR_LOW) & (PAGE_SIZE-1);
        memcpy(param,&info,sizeof(DC_CLOCK_MAP_INFO));
    }
#endif
    return 0;
}

int DC_Get_Clock_Info(struct fb_info *fb, VENUSFB_MACH_INFO * video_info,REFCLOCK * RefClock)
{
    DC_INFO * pdc_info = (DC_INFO*)video_info->dc_info;
    DC_UNREFERENCED_PARAMETER (pdc_info);
    DC_UNREFERENCED_PARAMETER (fb);
    DC_UNREFERENCED_PARAMETER (video_info);
    return Get_RefClock(fb,video_info,RefClock);
}

int DC_Reset_RefClock_Table(struct fb_info *fb, VENUSFB_MACH_INFO * video_info,unsigned int option)
{
    DC_INFO * pdc_info = (DC_INFO*)video_info->dc_info;
    REFCLOCK* clk = pdc_info->REF_CLK; 
    DC_UNREFERENCED_PARAMETER (pdc_info);
    DC_UNREFERENCED_PARAMETER (fb);
    DC_UNREFERENCED_PARAMETER (video_info);
    if( clk != NULL)
    {
        if(option & ResetOption_videoSystemPTS)
            pli_IPCWriteULONGLONG(  (BYTE*)&clk->videoSystemPTS     , -1);
        if(option & ResetOption_audioSystemPTS)
            pli_IPCWriteULONGLONG(  (BYTE*)&clk->audioSystemPTS     , -1);
        if(option & ResetOption_videoRPTS)
            pli_IPCWriteULONGLONG(  (BYTE*)&clk->videoRPTS          , -1);
        if(option & ResetOption_audioRPTS)
            pli_IPCWriteULONGLONG(  (BYTE*)&clk->audioRPTS          , -1);
        if(option & ResetOption_videoContext)
            pli_IPCWriteULONG(      (BYTE*)&clk->videoContext       ,(unsigned long)-1);
        if(option & ResetOption_audioContext)
            pli_IPCWriteULONG(      (BYTE*)&clk->audioContext       ,(unsigned long)-1);
        if(option & ResetOption_videoEndOfSegment)
            pli_IPCWriteULONG(      (BYTE*)&clk->videoEndOfSegment  ,(long)-1);
        //if(option & ResetOption_RCD)
        //    pli_IPCWriteULONGLONG(  (BYTE*)&clk->RCD                ,-1);
        return 0;
    }
    else return -1;
}

int DC_Get_System_Time_Info(struct fb_info *fb, VENUSFB_MACH_INFO * video_info, DC_SYSTEM_TIME_INFO * param)
{
    DC_INFO * pdc_info = (DC_INFO*)video_info->dc_info;
    DC_UNREFERENCED_PARAMETER (pdc_info);
    DC_UNREFERENCED_PARAMETER (fb);
    DC_UNREFERENCED_PARAMETER (video_info);
    pdc_info->DC_TIME_INFO.RATE_GAP         =                   pdc_info->RATE_GAP;
    pdc_info->DC_TIME_INFO.PTS              =                   pdc_info->PTS;
    pdc_info->DC_TIME_INFO.CTX              =                   pdc_info->CTX;
    pdc_info->DC_TIME_INFO.RefClockAddr     = (unsigned int)    pdc_info->REF_CLK;
    pdc_info->DC_TIME_INFO.ClockAddr_HI     = (unsigned int)    pdc_info->CLK_ADDR_HI;
    pdc_info->DC_TIME_INFO.ClockAddr_LOW    = (unsigned int)    pdc_info->CLK_ADDR_LOW;
    pdc_info->DC_TIME_INFO.WAIT_ISR         =                   atomic_read(&pdc_info->ISR_FLIP);
    pdc_info->DC_TIME_INFO.RTK90KClock      = 0;
    pdc_info->DC_TIME_INFO.RTK90KClock      = ((unsigned long long)*(unsigned int *) pdc_info->CLK_ADDR_HI)<<32;
    pdc_info->DC_TIME_INFO.RTK90KClock     |= (*(unsigned int *) pdc_info->CLK_ADDR_LOW);

    if(Get_RefClock(fb,video_info,&pdc_info->DC_TIME_INFO.RefClock) != 0) return -EAGAIN;
    memcpy(param,&pdc_info->DC_TIME_INFO,sizeof(DC_SYSTEM_TIME_INFO));
    return 0;
}

int DC_Get_Surface(struct fb_info *fb, VENUSFB_MACH_INFO * video_info, DCRT_PARAM_SURFACE* param)
{
#if 1
    DC_UNREFERENCED_PARAMETER (fb);
    DC_UNREFERENCED_PARAMETER (video_info);
    DC_UNREFERENCED_PARAMETER (param);
    wprintk("[%s] WE ARE NOT SUPPORT!\n",__func__);
    return 0;
#else
    int err=0;
    int idx = 0;
    DC_NOHW_DEVINFO *psDevInfo = (DC_NOHW_DEVINFO *)gpvAnchor;
    DCRT_VSYNC_FLIP_ITEM *psFlipItem= NULL;
    unsigned long ulLockFlags;

    if( psDevInfo == NULL || psDevInfo->psSwapChain == NULL) {
        err = -ENOENT;
        goto DC_Get_Surface_End;
    }
    else if( psDevInfo->ui32BufferSize < param->buf_size) {
        err = -EINVAL;
        goto DC_Get_Surface_End;
    }
    spin_lock_irqsave(&psDevInfo->psSwapChainLock, ulLockFlags);
    if( psDevInfo->ulInsertIndex != psDevInfo->ulRemoveIndex)
    {
        idx = psDevInfo->ulInsertIndex;
    }
    else { //==, use last one
        idx = psDevInfo->ulInsertIndex;
    }
    psFlipItem = &psDevInfo->psVSyncFlips[idx];
    {
        unsigned int srcAddr  = (unsigned int )phys_to_virt(psFlipItem->phyAddr);
        unsigned int dstAddr = (unsigned int )phys_to_virt(param->buf_Paddr);
        if( md_memcpy( (void*)dstAddr, (void*)srcAddr,  param->buf_size, true) != 0 )
        {  //md copy err
            err = -EAGAIN;
        }
    }
    spin_unlock_irqrestore(&psDevInfo->psSwapChainLock, ulLockFlags);
DC_Get_Surface_End:
    if( err) {
        //****   ****//
    }
    return err;
#endif
}

int DC_Set_ION_Share_Memory(struct fb_info *fb, VENUSFB_MACH_INFO * video_info, DC_ION_SHARE_MEMORY * param)
{
    DC_INFO * pdc_info = (DC_INFO*)video_info->dc_info;
    DC_UNREFERENCED_PARAMETER (fb);
    DC_UNREFERENCED_PARAMETER (video_info);
    if (pdc_info->gpsIONClient == NULL)
        pdc_info->gpsIONClient = ion_client_create(rtk_phoenix_ion_device,"dc2vo");

    if (param->sfd_refclk != NULL) {
        struct ion_handle *refclk_handle;
        refclk_handle = ion_import_dma_buf(pdc_info->gpsIONClient,param->sfd_refclk);
        pdc_info->REF_CLK = ion_map_kernel(pdc_info->gpsIONClient,refclk_handle);
        dprintk("[%s] refclk sfd:%d handle:%d vAddr:0x%08x\n",__func__,
                param->sfd_refclk,refclk_handle,pdc_info->REF_CLK);
    }
    if (param->sfd_rbHeader!= NULL) {
        struct ion_handle *rbHeader_handle;
        rbHeader_handle = ion_import_dma_buf(pdc_info->gpsIONClient,param->sfd_rbHeader);
        pdc_info->RING_HEADER =  ion_map_kernel(pdc_info->gpsIONClient,rbHeader_handle);
        dprintk("[%s] rbHeader sfd:%d handle:%d vAddr:0x%08x\n",__func__,
                param->sfd_rbHeader,rbHeader_handle,pdc_info->RING_HEADER);
    }
    if (param->sfd_rbBase != NULL) {
        struct ion_handle *rbBase_handle;
        rbBase_handle = ion_import_dma_buf(pdc_info->gpsIONClient,param->sfd_rbBase);
        pdc_info->RING_HEADER_BASE = ion_map_kernel(pdc_info->gpsIONClient,rbBase_handle);
        dprintk("[%s] rbHeaderBase sfd:%d handle:%d vAddr:0x%08x\n",__func__,
                param->sfd_rbBase,rbBase_handle,pdc_info->RING_HEADER_BASE);
    }
    return 0;
}

int DC_Set_Buffer_Info(struct fb_info *fb, VENUSFB_MACH_INFO * video_info, DC_BUFFER_INFO * param)
{
    DC_INFO * pdc_info = (DC_INFO*)video_info->dc_info;
    DC_UNREFERENCED_PARAMETER (fb);
    DC_UNREFERENCED_PARAMETER (video_info);
    if (pdc_info == NULL || param == NULL)
        goto err;

    if (param->enable)
        pdc_info->flags |= CHANGE_RES;
    else
        pdc_info->flags &= ~CHANGE_RES;

    pdc_info->uiRes32Width = param->width;
    pdc_info->uiRes32Height = param->height;

    dprintk("[%s] enable:%d width:%d height:%d\n",__func__,param->enable,param->width,param->height);
    return 0;
err:
    eprintk("[%s] ERROR!",__func__);
    return -1;
}

int DC_Ioctl (struct fb_info *fb, VENUSFB_MACH_INFO * video_info,unsigned int cmd, unsigned int arg)
{
    int retval = 0;
#define goERROR(tag) {eprintk("ERROR! CMD = %u LINE = %d tag = %d",cmd,__LINE__,tag); goto ERROR;}
    switch (cmd) {
        case DC2VO_GET_BUFFER_ADDR       :
            {
                DCRT_PARAM_BUF_ADDR param;
                if (copy_from_user(&param, (void *)arg, sizeof(param)) != 0)    goERROR(0);
                retval = DC_Get_BufferAddr(fb,video_info,&param);
                if (copy_to_user((void *)arg, &param, sizeof(param)) != 0)      goERROR(0);
                break;
            }
        case DC2VO_SET_RING_INFO         :
            {
                DCRT_PARAM_RPC_ADDR param;
                if (copy_from_user(&param, (void *)arg, sizeof(param)) != 0)    goERROR(0);
                retval = DC_Set_RPCAddr(fb,video_info,&param);
                break;
            }
        case DC2VO_SET_OUT_RATE_INFO     :
            {
                DCRT_PARAM_RATE_INFO param;
                if (copy_from_user(&param, (void *)arg, sizeof(param)) != 0)    goERROR(0);
                if( param.param_size != sizeof(DCRT_PARAM_RATE_INFO) )          goERROR(0);
                retval = DC_Set_RateInfo(fb,video_info,&param);
                break;
            }
        case DC2VO_GET_CLOCK_MAP_INFO    :
            {
                DC_CLOCK_MAP_INFO  param;
                if(DC_Get_Clock_Map_Info(fb,video_info,&param) != 0)           goERROR(0);
                if(copy_to_user((void *)arg,&param,sizeof(DC_CLOCK_MAP_INFO)) != 0) goERROR(0);
                break;
            }
        case DC2VO_GET_CLOCK_INFO        :
            {
                REFCLOCK RefClock;
                if(DC_Get_Clock_Info(fb,video_info,&RefClock) != 0)            goERROR(0);
                if(copy_to_user((void *)arg,&RefClock,sizeof(REFCLOCK)) != 0)   goERROR(0);
                break;
            }
        case DC2VO_RESET_CLOCK_TABLE     :
            {
                unsigned int option = 0;
                if(copy_from_user(&option,(void *)arg,sizeof(option)) != 0)     goERROR(0);
                if(DC_Reset_RefClock_Table(fb,video_info,option) != 0)         goERROR(0);
                break;
            }
        case FBIO_WAITFORVSYNC           :
        case DC2VO_WAIT_FOR_VSYNC        :
            {
                unsigned long long nsecs;
                if (DC_Wait_Vsync(fb, video_info, &nsecs) != 0)                goERROR(0);
                if(copy_to_user((void *)arg,&nsecs,sizeof(nsecs)) != 0)         goERROR(0);
                break;
            }
        case DC2VO_GET_SURFACE           :
            {
                DCRT_PARAM_SURFACE param;
                if (copy_from_user(&param, (void *)arg, sizeof(param)) != 0)    goERROR(0);
                if( param.param_size != sizeof(DCRT_PARAM_SURFACE) )            goERROR(0);
                retval = DC_Get_Surface(fb, video_info, &param);
                break;
            }
        case DC2VO_GET_SYSTEM_TIME_INFO  :
            {
                DC_SYSTEM_TIME_INFO param;
                DC_Get_System_Time_Info(fb,video_info,&param);
                if(copy_to_user((void *)arg,&param,sizeof(DC_SYSTEM_TIME_INFO)) != 0) goERROR(0);
                break;
            }
        case DC2VO_GET_MAX_FRAME_BUFFER  :
            {
                unsigned int MAX_FRAME_BUFFER = DC_NOHW_MAX_BACKBUFFERS;
                if (copy_to_user((void *)arg, &MAX_FRAME_BUFFER, sizeof(MAX_FRAME_BUFFER)) != 0) goERROR(0);
                break;
            }
        case RTKFB_SET_VSYNC_INT         :
            {
                /*
                 * 1: enable vsync
                 * 0: disable vsync
                 */
                break;
            }
        case DC2VO_SET_ION_SHARE_MEMORY  :
            {
                DC_ION_SHARE_MEMORY param;
                if (copy_from_user(&param, (void *)arg, sizeof(param)) != 0)    goERROR(0);
                if (DC_Set_ION_Share_Memory(fb, video_info, &param) != 0)       goERROR(0);
                break;
            }
        case DC2VO_SET_BUFFER_INFO       :
            {
                DC_BUFFER_INFO param;
                if (copy_from_user(&param, (void *)arg, sizeof(param)) != 0)    goERROR(0);
                if (DC_Set_Buffer_Info(fb, video_info, &param) != 0)            goERROR(0);
                break;
            }
        case DC2VO_SET_BG_SWAP           :
            {
                DC_INFO * pdc_info = (DC_INFO*)video_info->dc_info;
                unsigned int swap;
                if (pdc_info == NULL)                                           goERROR(0);
                if (copy_from_user(&swap, (void *)arg, sizeof(swap)) != 0)      goERROR(0);

                if (swap)
                    pdc_info->flags |= BG_SWAP;
                else
                    pdc_info->flags &= ~BG_SWAP;

                break;
            }
        case DC2VO_SET_GLOBAL_ALPHA      :
            {
                DC_INFO * pdc_info = (DC_INFO*)video_info->dc_info;
                unsigned int alpha;
                if (pdc_info == NULL)                                           goERROR(0);
                if (copy_from_user(&alpha, (void *)arg, sizeof(alpha)) != 0)    goERROR(0);

                if (alpha <= 0xFF)
                    pdc_info->gAlpha = alpha;
                else
                    pdc_info->gAlpha = 0; /* 0 : Pixel Alpha */

                break;
            }
        case DC2VO_SET_SYSTEM_TIME_INFO  :
        case DC2VO_SET_BUFFER_ADDR       :
        case DC2VO_SET_DISABLE           :
        case DC2VO_SET_MODIFY            :
            {
                dprintk("[%s %d] CMD = %u \n",__func__,__LINE__,cmd);
                break;
            }
        default:
            retval = -EAGAIN;
#ifdef USE_FPGA_FLIP_TEST
            return OSD_Ioctl(cmd,arg);
#endif
    }
    return retval;
ERROR:
#undef goERROR
    return -EFAULT;
}

int DC_Swap_Buffer (struct fb_info *fb, VENUSFB_MACH_INFO * video_info)
{
    DC_INFO * pdc_info = (DC_INFO*)video_info->dc_info;
    VIDEO_GRAPHIC_PICTURE_OBJECT obj ;
    unsigned int ui32Width      = fb->var.xres;
    unsigned int ui32Height     = fb->var.yres;
    unsigned int ui32ByteStride = fb->fix.line_length;
    unsigned int phyAddr = fb->fix.smem_start
                                    + fb->fix.line_length * fb->var.yoffset
                                    + fb->var.xoffset *  (fb->var.bits_per_pixel / 8 );
    if (pdc_info->flags & SUSPEND)
        return 0;

    if (pdc_info->flags & CHANGE_RES && pdc_info->uiRes32Width > 0 && pdc_info->uiRes32Height > 0) {
        ui32Width = pdc_info->uiRes32Width;
        ui32Height = pdc_info->uiRes32Height;
    }

    if (atomic_read(&pdc_info->ISR_FLIP) > 0)
    {
        dprintk("%s:%d BUG!!!! Swap_Buffer, pdc_info->ISR_FLIP = %d\n", __func__, __LINE__, atomic_read(&pdc_info->ISR_FLIP));
    }
    smp_mb();
    pdc_info->flags |= FLIP;
    smp_mb();
    //dprintk("[%s %d] phyAddr = 0x%08x pdc_info->RING_HEADER = 0x%08x\n", __func__, __LINE__,
    //        phyAddr, (unsigned int)pdc_info->RING_HEADER);
#if defined(USE_RPC_TEST) || ! defined(USE_FPGA_FLIP_TEST)
    if ( !(pdc_info->flags & RPC_READY) ) {
        eprintk("[%s %d] phyAddr = 0x%08x pdc_info->RING_HEADER = 0x%08x\n", __func__, __LINE__,
                phyAddr, (unsigned int)pdc_info->RING_HEADER);
        msleep(16);
        goto ERROR;
    }
#else
    OSDShowPic2(ui32Width,ui32Height,phyAddr);
    {
        long timeout;
        atomic_inc(&pdc_info->ISR_FLIP);
        timeout = sleep_on_timeout(&DC_WAIT_OSD_COMPLETE,  pdc_info->ISR_TIMEOUT);
        atomic_dec(&pdc_info->ISR_FLIP);
    }
    return 0;
#endif

#if 0
    // SET AO AVSYNC MODE
    static int FLIP_OPEN_AVSYNC_INIT = 0;
    if(FLIP_OPEN_AVSYNC_INIT == 0){
        VIDEO_GRAPHIC_DISPLAY_INFO cmd;
        cmd.header.type = VIDEO_GRAPHIC_INBAND_CMD_TYPE_DISPLAY_INFO;
        cmd.header.size = sizeof(cmd);
        cmd.displayEachPic = 0;
        /* [cmd.displayEachPic] 
         * 1: each picture sent by upstream must be displayed,
         * 0: follow av-sync to drop/repeat picture */
        if( ICQ_WriteCmd(&cmd, pdc_info->RING_HEADER, pdc_info->RING_HEADER_BASE) != 0){
            eprintk("[%s %d]ERROR!! Write CMD Error!\n",__FUNCTION__,__LINE__);
            goto ERROR;
        }
        else
            FLIP_OPEN_AVSYNC_INIT = 1;
    }
#endif

    // GET RTK 90KCLOCK
    {
        unsigned long flags;
        //local_irq_save(flags);
        pdc_info->PREV_TICK = *pdc_info->CLK_ADDR_LOW;
        pdc_info->PREV_TICK = pdc_info->PREV_TICK | (((int64_t)*pdc_info->CLK_ADDR_HI) << 32); 
        //local_irq_restore(flags);
    }

#if 0
    pdc_info->PTS =   (signed long long) pdc_info->PREV_TICK
            + (signed long long) pli_IPCReadULONGLONG((BYTE*)&pdc_info->REF_CLK->RCD)
            + pdc_info->RATE_GAP;
#else
    pdc_info->PTS = 0;
#endif
    if( pdc_info->CTX == -1) pdc_info->CTX = 0;  //////////////////////////

    // WRITE CMD TO VOUT RING BUFFER
    obj.header.type         = VIDEO_GRAPHIC_INBAND_CMD_TYPE_PICTURE_OBJECT ;
    obj.header.size         = sizeof(VIDEO_GRAPHIC_PICTURE_OBJECT);
    obj.context             = ++pdc_info->CTX ;
    obj.PTSH                = pdc_info->PTS>>32;
    obj.PTSL                = pdc_info->PTS;
    obj.colorkey            = -1 ;  
    obj.alpha               = pdc_info->gAlpha;
    obj.x                   = 0 ;
    obj.y                   = 0 ;  
    obj.format              = (pdc_info->flags & BG_SWAP) ? INBAND_CMD_GRAPHIC_FORMAT_RGBA8888 : INBAND_CMD_GRAPHIC_FORMAT_ARGB8888_LITTLE;
    obj.width               = ui32Width;  
    obj.height              = ui32Height;  
    obj.pitch               = ui32ByteStride;
    obj.address             = phyAddr;
    obj.address_right       = 0 ;
    obj.pitch_right         = 0;
    obj.picLayout           = INBAND_CMD_GRAPHIC_2D_MODE;//obj.picLayout = INBAND_CMD_GRAPHIC_FRAME_PACKING;
    obj.dataByte1           = 0;
    obj.dataByte2           = 0;
    obj.dataByte3           = 0;
    if( ICQ_WriteCmd(&obj, pdc_info->RING_HEADER, pdc_info->RING_HEADER_BASE) != 0)
    {
        eprintk("[%s %d]ERROR!! Write CMD Error!\n",__FUNCTION__,__LINE__);
        goto ERROR;
    }

#ifndef USE_RPC_TEST
    // WAIT BUFFER COMPLETE
    {
        unsigned int time_start,time_end;
        unsigned int time_temp;
        time_temp = 0;
        time_start = (unsigned int)*pdc_info->CLK_ADDR_LOW;
#if 1
        {
            unsigned long refContext;
            unsigned long objContext;
            int maxWaitVsync = 10;
            do {
                refContext = pli_IPCReadULONG((BYTE*)&pdc_info->REF_CLK->videoContext);
                objContext = obj.context;

                if ( refContext > objContext ) {
                    wprintk(" refContext:%ld objContext:%ld\n",refContext,objContext);
                    break;
                }

                if ( (objContext - refContext) <= 1)
                    break;

                atomic_inc(&pdc_info->ISR_FLIP);
                if ( sleep_on_timeout(&DC_WAIT_OSD_COMPLETE,  pdc_info->ISR_TIMEOUT) == 0 ) {
                    unsigned int flag = pli_IPCReadULONG((BYTE*)pdc_info->vo_vsync_flag);
                    eprintk("[%s %d] wait vsync timeout! objContext:%ld refContext:%ld flipCount:%u vo_vsync_flag:0x%08x\n",
                            __func__, __LINE__, objContext, refContext, atomic_read(&pdc_info->ISR_FLIP), flag);
                    atomic_dec(&pdc_info->ISR_FLIP);
                    break;
                }
                atomic_dec(&pdc_info->ISR_FLIP);

                maxWaitVsync --;
            } while (maxWaitVsync);

            if ( 0 == maxWaitVsync)
                eprintk("[%s] refContext:%ld objContext:%ld (wait loop => too many times)\n",__func__,refContext,objContext);
        }
        #if 0
        {
            #define MAX_LOG_ADDR 5
            static int count = 0;
            static int print_count = 0;
            static unsigned int pan_addr[MAX_LOG_ADDR];
            pan_addr[count] = (unsigned int) phyAddr;
            count ++;
            if (count >= MAX_LOG_ADDR) count = 0;
            if ((print_count % (60*10)) == 0) {
                int i;
                for (i=0;i<MAX_LOG_ADDR;i++)
                    printk("############ pan_addr[%d] = 0x%08x ###########\n",i,pan_addr[i]);
            }
            print_count++;
        }
        #endif
#else
        {
            long timeout;
            int  max_sleep_count = 5;
            atomic_inc(&pdc_info->ISR_FLIP);
RESLEEP:
            timeout = sleep_on_timeout(&DC_WAIT_OSD_COMPLETE,  pdc_info->ISR_TIMEOUT);
            if(timeout == 0) {
                unsigned int flag = pli_IPCReadULONG((BYTE*)pdc_info->vo_vsync_flag);
                eprintk("[%s %d] tOut:%lu %d\n flag:0x%08x", __func__, __LINE__, pdc_info->CTX, atomic_read(&pdc_info->ISR_FLIP), flag);
            }else {
                unsigned long ipc_read_ulong;
                unsigned int context;
                ipc_read_ulong=pli_IPCReadULONG((BYTE*)&pdc_info->REF_CLK->videoContext);
                context = obj.context;
                if(context ==  ipc_read_ulong) goto NORMAL;
                if(context <  ipc_read_ulong){
                    wprintk(" context:%ld <  ipc_read_ulong:%ld\n",context,ipc_read_ulong);
                    goto NORMAL;
                }
                if((context -  ipc_read_ulong) > DC_NOHW_MAX_BACKBUFFERS){
                    eprintk(" ( context:%ld -  videoContext:%ld ) > %d\n",context,ipc_read_ulong,DC_NOHW_MAX_BACKBUFFERS);
                    goto NORMAL;
                }
                if (max_sleep_count <= 0) {
                    eprintk("[%s] context:%ld videoContext:%ld (wait loop => too many times)\n",__func__,context,ipc_read_ulong);
                    goto NORMAL;
                }
                --max_sleep_count;
                goto RESLEEP;
            }
NORMAL:
            atomic_dec(&pdc_info->ISR_FLIP);
        }
#endif
        time_end = (unsigned int)*pdc_info->CLK_ADDR_LOW;
        pdc_info->DC_TIME_INFO.OSD2VO_Delay_us = (((time_end-time_start)/90)*1000);
        if (time_end == pdc_info->DC_TIME_INFO.FlipTimeTemp) {
            iprintk("CLK????   0x%08x = %u\n",pdc_info->CLK_ADDR_LOW,time_end);
        } else {
            pdc_info->DC_TIME_INFO.FPS = ( 90000/(time_end - pdc_info->DC_TIME_INFO.FlipTimeTemp));
        }
        pdc_info->DC_TIME_INFO.FlipTimeTemp=time_end;
    }
#else
    {
        long timeout;
        atomic_inc(&pdc_info->ISR_FLIP);
        timeout = sleep_on_timeout(&DC_WAIT_OSD_COMPLETE,  pdc_info->ISR_TIMEOUT);
        atomic_dec(&pdc_info->ISR_FLIP);
    }
#endif
    smp_mb();
    pdc_info->flags &= ~FLIP;
    smp_mb();
    return 0;
ERROR:
    return -EFAULT;
}

#ifdef CONFIG_RTK_RPC
void dc_irq_handler(void)
#else
irqreturn_t dc_irq_handler(int irq, void *dev_id)
#endif
{
#ifdef CONFIG_RTK_RPC
    if (DCINIT == 0) return IRQ_HANDLED;
    DC_INFO * pdc_info = gpdc_info;
    irqreturn_t  retVal = IRQ_NONE;
#else
    VENUSFB_MACH_INFO * video_info = (VENUSFB_MACH_INFO *)dev_id;
    DC_INFO * pdc_info = (DC_INFO*)video_info->dc_info;
    irqreturn_t  retVal = IRQ_NONE;
    DC_UNREFERENCED_PARAMETER (pdc_info);
#endif

    // CHECK INTERRUPT
    if(! DC_HAS_BIT(pdc_info->vo_vsync_flag, DC_VO_FEEDBACK_NOTIFY) )
        return IRQ_NONE;
    else {
        //unsigned long flags;
        //spin_lock_irqsave(&gASLock,flags);
        DC_RESET_BIT(pdc_info->vo_vsync_flag,  DC_VO_FEEDBACK_NOTIFY) ;
        //spin_unlock_irqrestore(&gASLock,flags);
    }

    // WAKE UP
    if(atomic_read(&pdc_info->ISR_VSYNC) > 0)
        wake_up(&DC_WAIT_VSYNC);

    if(atomic_read(&pdc_info->ISR_FLIP) > 0)
        wake_up(&DC_WAIT_OSD_COMPLETE);

#if 0
    if(  DC_HAS_BIT(SE_VO_SYNC_ADDR, DC_VO_SET_NOTIFY) ) 
    {  //se enable isr too! 
        retVal = IRQ_NONE;
    }
    else
#endif
        retVal =  IRQ_HANDLED;

    return retVal;
}
#ifdef CONFIG_RTK_RPC
EXPORT_SYSMBOL(dc_irq_handler);
#endif

int Activate_vSync(VENUSFB_MACH_INFO * video_info)
{
#ifdef USE_FPGA_FLIP_TEST
    return 0;
#endif
    dprintk("%s:%d DEBUG!!!! \n", __func__, __LINE__);
    DC_INFO * pdc_info = (DC_INFO*)video_info->dc_info;
    int result=0;
    DC_UNREFERENCED_PARAMETER (pdc_info);
#ifndef CONFIG_RTK_RPC
    dprintk("%s:%d DEBUG!!!! \n", __func__, __LINE__);
    if( !(pdc_info->flags & ISR_INIT))
    {
        result = request_irq(DCRT_IRQ, dc_irq_handler, IRQF_SHARED, "dc2vo", (void *) video_info);
        if(result)
        {
            eprintk("DC: irq ins fail %i\n", DCRT_IRQ);
            return result;
        }
        else {
            dprintk("DC irq Ins\n");
            smp_mb();
            pdc_info->flags |= ISR_INIT;
            smp_mb();
        }
    }
#endif
    dprintk("%s:%d DEBUG!!!! \n", __func__, __LINE__);
    spin_lock_irq(&gASLock);
    DC_SET_BIT(pdc_info->vo_vsync_flag, DC_VO_SET_NOTIFY);
    spin_unlock_irq(&gASLock);
    return result;
}

int DeInit_vSync(VENUSFB_MACH_INFO * video_info)
{
    DC_INFO * pdc_info = (DC_INFO*)video_info->dc_info;
    unsigned long ulLockFlags;
    static spinlock_t  vSyncLock;
    DC_UNREFERENCED_PARAMETER (pdc_info);
    spin_lock_irqsave(&vSyncLock, ulLockFlags);
    if( pdc_info->flags & ISR_INIT ) {
#ifndef CONFIG_RTK_RPC
        free_irq(DCRT_IRQ, (void *) video_info);
#endif
        smp_mb();
        pdc_info->flags &= ~ISR_INIT;
        smp_mb();
        dprintk("DC irqUn\n");
    }
    spin_unlock_irqrestore(&vSyncLock, ulLockFlags);
    return 0;
}

int DC_Init(VENUSFB_MACH_INFO * video_info)
{
    int retval = 0;
    if (DCINIT) goto DONE;

    if (video_info->dc_info == NULL) {
        iprintk("ALLOC DC INFO BUFFER!\n");
        video_info->dc_info = kmalloc(sizeof(DC_INFO),GFP_KERNEL);
        // DC_INFO SET DEFAULT
        memset(video_info->dc_info,0,sizeof(DC_INFO));
        {
            DC_INFO * pdc_info = (DC_INFO*)video_info->dc_info;
            struct RTK119X_ipc_shm __iomem *ipc = (void __iomem *)IPC_SHM_VIRT;
            pdc_info->RATE_GAP      = 1500;
            pdc_info->RATE_HZ       = 60000;
            pdc_info->gAlpha        = 0;
            pdc_info->ISR_TIMEOUT   = HZ;
            pdc_info->flags         |= BG_SWAP;
            iprintk("[%s] HZ=%d ISR_TIMEOUT=%d\n",__func__,HZ,pdc_info->ISR_TIMEOUT);
#if 0
            pdc_info->vo_vsync_flag = ioremap((phys_addr_t)DC_VO_SYNC_ADDR,sizeof(unsigned int));
#else
            pdc_info->vo_vsync_flag = &ipc->vo_int_sync;
#endif
#ifdef CONFIG_RTK_RPC
            gpdc_info = (DC_INFO*)video_info->dc_info;
#endif
        }
    } else
        wprintk("ALLOC DC INFO BUFFER ARE ALREADY DONE? (0x%08x)\n", (unsigned int)video_info->dc_info);

#ifdef USE_FPGA_FLIP_TEST
    {
        vsync_tsk = kthread_create(vsync_thread, video_info, "vsync_thread");
        if (IS_ERR(vsync_tsk)) {
            vsync_tsk = NULL;
            dprintk("[%s %d] ERROR!\n",__func__,__LINE__);
        } else {
            wake_up_process(vsync_tsk);
        }
    }
#endif
    if (Activate_vSync(video_info)) {
        eprintk("[%s %d] ERROR! video_info = 0x%08x\n",__func__,__LINE__,(unsigned int)video_info);
        retval = (int) video_info;
        goto DONE;
    }
    DCINIT = 1;
DONE:
    return retval;
}

void DC_Deinit(VENUSFB_MACH_INFO * video_info)
{
#ifdef USE_FPGA_FLIP_TEST
    kthread_stop(vsync_tsk);
#endif
    iprintk("[%s %d]\n",__func__,__LINE__);
    DeInit_vSync(video_info);
    if (video_info->dc_info != NULL) {
#if 1
        iprintk("[%s %d] NOT TO FREE DC INFO BUFFER!",__func__,__LINE__);
#else
        kfree(video_info->dc_info);
        video_info->dc_info = NULL;
#endif
    } else {
        wprintk("[%s %d] video_info->dc_info == NULL \n",__func__,__LINE__);
    }
    DCINIT = 0;
}

int DC_Suspend (VENUSFB_MACH_INFO * video_info)
{
    DC_INFO * pdc_info = (DC_INFO*)video_info->dc_info;
    int max_count = 16;
    DC_RESET_BIT(pdc_info->vo_vsync_flag, DC_VO_SET_NOTIFY);
    smp_mb();
    pdc_info->flags |= SUSPEND;
    smp_mb();
    while((pdc_info->flags & FLIP) && (max_count > 0)) {
        msleep(1);
        max_count--;
    }

    if (max_count == 0)
        eprintk("[%s %d] TIMEOUT! flags:0x%08x \n",__func__,__LINE__,pdc_info->flags);

    return 0;
}

int DC_Resume (VENUSFB_MACH_INFO * video_info)
{
    DC_INFO * pdc_info = (DC_INFO*)video_info->dc_info;
    DC_SET_BIT(pdc_info->vo_vsync_flag, DC_VO_SET_NOTIFY);
    smp_mb();
    pdc_info->flags         &= ~SUSPEND;
    smp_mb();
    return 0;
}

#ifdef CONFIG_REALTEK_AVCPU
int DC_avcpu_event_notify(unsigned long action, VENUSFB_MACH_INFO * video_info)
{
    DC_INFO * pdc_info = (DC_INFO*)video_info->dc_info;
    switch (action) {
        case AVCPU_RESET_PREPARE:
            smp_mb();
            pdc_info->flags &= ~RPC_READY;
            smp_mb();
            DC_RESET_BIT(pdc_info->vo_vsync_flag, DC_VO_SET_NOTIFY);
            break;
        case AVCPU_RESET_DONE:
            DC_SET_BIT(pdc_info->vo_vsync_flag, DC_VO_SET_NOTIFY);
            break;
        case AVCPU_SUSPEND:
        case AVCPU_RESUME:
            break;
        default:
            break;
    }
    return 0;
}
#endif
