#include <linux/module.h>
#include <linux/proc_fs.h>
#include <linux/seq_file.h>
#include <linux/kernel.h>
#include <asm/uaccess.h>
#include <linux/cdev.h>
#include <linux/timer.h>
#include <asm/gpio.h>
#include <linux/fs.h>
#include <linux/file.h>
#include <gpio/board_gpio.h>
#include <linux/delay.h>

static char proc_data_1[MAX_PROC_SIZE];
static char proc_data_2[MAX_PROC_SIZE];
static char proc_data_3[MAX_PROC_SIZE];
static char proc_data_4[MAX_PROC_SIZE];
static char proc_data_5[MAX_PROC_SIZE];
static char proc_data_6[MAX_PROC_SIZE];
static char proc_data_7[MAX_PROC_SIZE];
static char proc_data_but[MAX_PROC_SIZE];

static char led_stat_1;
static char led_stat_2;
static char led_stat_3;
static char led_stat_4;
static char led_stat_5;
static char led_stat_6;
static char led_stat_7;
static char button_stat_1;

static struct proc_dir_entry *proc_write_entry;
static struct proc_dir_entry *proc_parent;

static struct timer_list led_timer_on;
static struct timer_list led_timer_off;
static struct timer_list led_timer_1m_on;
static struct timer_list led_timer_1m_off;

int blink_enable_1=0;
int blink_enable_2=0;
int blink_enable_3=0;
int blink_enable_4=0;
int blink_enable_5=0;
int blink_enable_6=0;
int blink_enable_7=0;
int button_flag = 0;
int init_r2d = 0;
int init_count = 0;


void led_timer_1m_trun_off(unsigned long data)
{
	if (data == PWR_LED)
	{
		gpio_direction_output(PWR_LED, 1);
        gpio_set_value(PWR_LED, HIGH);
		led_stat_1 = '0';		
	}
	else if(data == FUNC_LED1)
	{
		gpio_direction_output(FUNC_LED1, 1);
        gpio_set_value(FUNC_LED1, HIGH);
		led_stat_2 = '0';		
	}
	else if(data == FUNC_LED2)
	{
		gpio_direction_output(FUNC_LED2, 1);
        gpio_set_value(FUNC_LED2, HIGH);
		led_stat_3 = '0';		
	}	
	else if(data == INFO_LED)
	{
		gpio_direction_output(INFO_LED, 1);
        gpio_set_value(INFO_LED, HIGH);
		led_stat_4 = '0';		
	}	
	else if(data == ERR_LED)
	{
		gpio_direction_output(ERR_LED, 1);
        gpio_set_value(ERR_LED, HIGH);
		led_stat_5 = '0';		
	}	
	else if(data == HDD1_ERR_LED)
	{
		gpio_direction_output(HDD1_ERR_LED, 1);
        gpio_set_value(HDD1_ERR_LED, HIGH);
		led_stat_6 = '0';		
	}	
	else if(data == HDD2_ERR_LED)
	{
		gpio_direction_output(HDD2_ERR_LED, 1);
        gpio_set_value(HDD2_ERR_LED, HIGH);
		led_stat_7 = '0';		
	}	
}

void led_timer_1m_trun_on(unsigned long data)
{
	if (data == PWR_LED)
	{
		gpio_direction_output(PWR_LED, 1);
        gpio_set_value(PWR_LED, !HIGH);
	}
	else if(data == FUNC_LED1)
	{
		gpio_direction_output(FUNC_LED1, 1);
        gpio_set_value(FUNC_LED1, !HIGH);		
	}
	else if(data == FUNC_LED2)
	{
		gpio_direction_output(FUNC_LED2, 1);
        gpio_set_value(FUNC_LED2, !HIGH);		
	}
	else if(data == INFO_LED)
	{
		gpio_direction_output(INFO_LED, 1);
        gpio_set_value(INFO_LED, !HIGH);		
	}
	else if(data == ERR_LED)
	{
		gpio_direction_output(ERR_LED, 1);
        gpio_set_value(ERR_LED, !HIGH);		
	}
	else if(data == HDD1_ERR_LED)
	{
		gpio_direction_output(HDD1_ERR_LED, 1);
        gpio_set_value(HDD1_ERR_LED, !HIGH);		
	}
	else if(data == HDD2_ERR_LED)
	{
		gpio_direction_output(HDD2_ERR_LED, 1);
        gpio_set_value(HDD2_ERR_LED, !HIGH);		
	}
	
	led_timer_1m_off.expires = jiffies + 60 * (HZ); //2.4s
	add_timer(&led_timer_1m_off);
}

void led_light_1m(int pin)
{
	del_timer(&led_timer_1m_on);
	del_timer(&led_timer_1m_off);

	init_timer(&led_timer_1m_on);	
	init_timer(&led_timer_1m_off);	
	
	led_timer_1m_on.function = led_timer_1m_trun_on;	
	led_timer_1m_off.function = led_timer_1m_trun_off;	
	
	led_timer_1m_on.data = ((unsigned long) pin);	
	led_timer_1m_off.data = ((unsigned long) pin);	
	
	led_timer_1m_on.expires = jiffies + HZ / 10;	
	led_timer_1m_off.expires = jiffies + HZ / 10;	
	
	add_timer(&led_timer_1m_on);	
}

static int led_proc_show_1(struct seq_file *m, void *v) {
	
	seq_printf(m, "%c", led_stat_1);	
	
  return 0;
}

static int led_proc_open_1(struct inode *inode, struct  file *file) {
  return single_open(file, led_proc_show_1, NULL);
}

static ssize_t write_proc_1(struct file *filp,const char *buf,size_t count,loff_t *offp)
{
	printk(KERN_INFO "Gemtek LED write1\n");
    if(count > MAX_PROC_SIZE)
        count = MAX_PROC_SIZE;
    if(copy_from_user(proc_data_1, buf, count))
        return -EFAULT;
    if(proc_data_1[0] == '0') {
		blink_enable_1 = 0;
		led_stat_1 = '0';
        gpio_direction_output(PWR_LED, 1);
        gpio_set_value(PWR_LED, HIGH);
    } else if(proc_data_1[0] == '1') {
		blink_enable_1 = 0;
		led_stat_1 = '1';
        gpio_direction_output(PWR_LED, 0);
        gpio_set_value(PWR_LED, !HIGH);
    } else if(proc_data_1[0] == '2') {
			led_stat_1 = '2';
			blink_enable_1=1;
    }
	else if(proc_data_1[0] == '3') {
			led_stat_1 = '1';
			blink_enable_1 = 0;				
			led_light_1m(PWR_LED);
    }

    return count;
}

static int led_proc_show_2(struct seq_file *m, void *v) {
	seq_printf(m, "%c", led_stat_2);	
  return 0;
}

static int led_proc_open_2(struct inode *inode, struct  file *file) {
  return single_open(file, led_proc_show_2, NULL);
}

static ssize_t write_proc_2(struct file *filp,const char *buf,size_t count,loff_t *offp)
{
	printk(KERN_INFO "Gemtek LED write2\n");
    if(count > MAX_PROC_SIZE)
        count = MAX_PROC_SIZE;
    if(copy_from_user(proc_data_2, buf, count))
        return -EFAULT;
    if(proc_data_2[0] == '0') {
		blink_enable_2 = 0;
		led_stat_2 = '0';
        gpio_direction_output(FUNC_LED1, 1);
        gpio_set_value(FUNC_LED1, HIGH);
    } else if(proc_data_2[0] == '1') {
		blink_enable_2 = 0;
		led_stat_2 = '1';
        gpio_direction_output(FUNC_LED1, 0);
        gpio_set_value(FUNC_LED1, !HIGH);
    } else if(proc_data_2[0] == '2') {
			blink_enable_2=1;
			led_stat_2 = '2';
    }
	else if(proc_data_2[0] == '3') {
			led_stat_2 = '1';
			blink_enable_2 = 0;			
			led_light_1m(FUNC_LED1);
    }

    return count;
}

static int led_proc_show_3(struct seq_file *m, void *v) {
	
	seq_printf(m, "%c", led_stat_3);	
	
  return 0;
}

static int led_proc_open_3(struct inode *inode, struct  file *file) {
  return single_open(file, led_proc_show_3, NULL);
}

static ssize_t write_proc_3(struct file *filp,const char *buf,size_t count,loff_t *offp)
{
	printk(KERN_INFO "Gemtek LED write3\n");
    if(count > MAX_PROC_SIZE)
        count = MAX_PROC_SIZE;
    if(copy_from_user(proc_data_3, buf, count))
        return -EFAULT;
    if(proc_data_3[0] == '0') {
		blink_enable_3 = 0;
		led_stat_3 = '0';
        gpio_direction_output(FUNC_LED2, 1);
        gpio_set_value(FUNC_LED2, HIGH);
    } else if(proc_data_3[0] == '1') {
		blink_enable_3 = 0;
		led_stat_3 = '1';
        gpio_direction_output(FUNC_LED2, 0);
        gpio_set_value(FUNC_LED2, !HIGH);
    } else if(proc_data_3[0] == '2') {
			led_stat_3 = '2';
			blink_enable_3=1;
    }
	else if(proc_data_3[0] == '3') {
			led_stat_3 = '1';
			blink_enable_3 = 0;				
			led_light_1m(FUNC_LED2);
    }

    return count;
}

static int led_proc_show_4(struct seq_file *m, void *v) {
	
	seq_printf(m, "%c", led_stat_4);	
	
  return 0;
}

static int led_proc_open_4(struct inode *inode, struct  file *file) {
  return single_open(file, led_proc_show_4, NULL);
}

static ssize_t write_proc_4(struct file *filp,const char *buf,size_t count,loff_t *offp)
{
	printk(KERN_INFO "Gemtek LED write4\n");
    if(count > MAX_PROC_SIZE)
        count = MAX_PROC_SIZE;
    if(copy_from_user(proc_data_4, buf, count))
        return -EFAULT;
    if(proc_data_4[0] == '0') {
		blink_enable_4 = 0;
		led_stat_4 = '0';
        gpio_direction_output(INFO_LED, 1);
        gpio_set_value(INFO_LED, HIGH);
    } else if(proc_data_4[0] == '1') {
		blink_enable_4 = 0;
		led_stat_4 = '1';
        gpio_direction_output(INFO_LED, 0);
        gpio_set_value(INFO_LED, !HIGH);
    } else if(proc_data_4[0] == '2') {
			led_stat_4 = '2';
			blink_enable_4=1;
    }
	else if(proc_data_4[0] == '3') {
			led_stat_4 = '1';
			blink_enable_4 = 0;				
			led_light_1m(INFO_LED);
    }

    return count;
}

static int led_proc_show_5(struct seq_file *m, void *v) {
	
	seq_printf(m, "%c", led_stat_5);	
	
  return 0;
}

static int led_proc_open_5(struct inode *inode, struct  file *file) {
  return single_open(file, led_proc_show_5, NULL);
}

static ssize_t write_proc_5(struct file *filp,const char *buf,size_t count,loff_t *offp)
{
	printk(KERN_INFO "Gemtek LED write5\n");
    if(count > MAX_PROC_SIZE)
        count = MAX_PROC_SIZE;
    if(copy_from_user(proc_data_5, buf, count))
        return -EFAULT;
    if(proc_data_5[0] == '0') {
		blink_enable_5 = 0;
		led_stat_5 = '0';
        gpio_direction_output(ERR_LED, 1);
        gpio_set_value(ERR_LED, HIGH);
    } else if(proc_data_5[0] == '1') {
		blink_enable_5 = 0;
		led_stat_5 = '1';
        gpio_direction_output(ERR_LED, 0);
        gpio_set_value(ERR_LED, !HIGH);
    } else if(proc_data_5[0] == '2') {
			led_stat_5 = '2';
			blink_enable_5=1;
    }
	else if(proc_data_5[0] == '3') {
			led_stat_5 = '1';
			blink_enable_5 = 0;				
			led_light_1m(ERR_LED);
    }

    return count;
}

static int led_proc_show_6(struct seq_file *m, void *v) {
	
	seq_printf(m, "%c", led_stat_6);	
	
  return 0;
}

static int led_proc_open_6(struct inode *inode, struct  file *file) {
  return single_open(file, led_proc_show_6, NULL);
}

static ssize_t write_proc_6(struct file *filp,const char *buf,size_t count,loff_t *offp)
{
	printk(KERN_INFO "Gemtek LED write6\n");
    if(count > MAX_PROC_SIZE)
        count = MAX_PROC_SIZE;
    if(copy_from_user(proc_data_6, buf, count))
        return -EFAULT;
    if(proc_data_6[0] == '0') {
		blink_enable_6 = 0;
		led_stat_6 = '0';
        gpio_direction_output(HDD1_ERR_LED, 1);
        gpio_set_value(HDD1_ERR_LED, HIGH);
    } else if(proc_data_6[0] == '1') {
		blink_enable_6 = 0;
		led_stat_6 = '1';
        gpio_direction_output(HDD1_ERR_LED, 0);
        gpio_set_value(HDD1_ERR_LED, !HIGH);
    } else if(proc_data_6[0] == '2') {
			led_stat_6 = '2';
			blink_enable_6=1;
    }
	else if(proc_data_6[0] == '3') {
			led_stat_6 = '1';
			blink_enable_6 = 0;				
			led_light_1m(HDD1_ERR_LED);
    }

    return count;
}

static int led_proc_show_7(struct seq_file *m, void *v) {
	
	seq_printf(m, "%c", led_stat_7);	
	
  return 0;
}

static int led_proc_open_7(struct inode *inode, struct  file *file) {
  return single_open(file, led_proc_show_7, NULL);
}

static ssize_t write_proc_7(struct file *filp,const char *buf,size_t count,loff_t *offp)
{
	printk(KERN_INFO "Gemtek LED write7\n");
    if(count > MAX_PROC_SIZE)
        count = MAX_PROC_SIZE;
    if(copy_from_user(proc_data_7, buf, count))
        return -EFAULT;
    if(proc_data_7[0] == '0') {
		blink_enable_7 = 0;
		led_stat_7 = '0';
        gpio_direction_output(HDD2_ERR_LED, 1);
        gpio_set_value(HDD2_ERR_LED, HIGH);
    } else if(proc_data_7[0] == '1') {
		blink_enable_7 = 0;
		led_stat_7 = '1';
        gpio_direction_output(HDD2_ERR_LED, 0);
        gpio_set_value(HDD2_ERR_LED, !HIGH);
    } else if(proc_data_7[0] == '2') {
			led_stat_7 = '2';
			blink_enable_7=1;
    }
	else if(proc_data_7[0] == '3') {
			led_stat_7 = '1';
			blink_enable_7 = 0;				
			led_light_1m(HDD2_ERR_LED);
    }

    return count;
}
/*
static int led_proc_show_but1(struct seq_file *m, void *v) {
	seq_printf(m, "%c", button_stat_1);	
  return 0;
}

static int led_proc_open_but1(struct inode *inode, struct  file *file) {
  return single_open(file, led_proc_show_but1, NULL);
}

static ssize_t write_proc_but1(struct file *filp,const char *buf,size_t count,loff_t *offp)
{
	printk(KERN_INFO "Gemtek button write1\n");
    if(count > MAX_PROC_SIZE)
        count = MAX_PROC_SIZE;
    if(copy_from_user(proc_data_but, buf, count))
        return -EFAULT;
    
	if(proc_data_but[0] == '-') {		
		button_stat_1 = '-';		
        button_flag = 0;			
    } 

    return count;
}
*/
static const struct file_operations proc_fuc1 = {
  .owner = THIS_MODULE,
  .open = led_proc_open_1,
  .read = seq_read,
  .write = write_proc_1,
  .llseek = seq_lseek,
  .release = single_release,
};

static const struct file_operations proc_fuc2 = {
  .owner = THIS_MODULE,
  .open = led_proc_open_2,
  .read = seq_read,
  .write = write_proc_2,
  .llseek = seq_lseek,
  .release = single_release,
};
static const struct file_operations proc_fuc3 = {
  .owner = THIS_MODULE,
  .open = led_proc_open_3,
  .read = seq_read,
  .write = write_proc_3,
  .llseek = seq_lseek,
  .release = single_release,
};
static const struct file_operations proc_fuc4= {
  .owner = THIS_MODULE,
  .open = led_proc_open_4,
  .read = seq_read,
  .write = write_proc_4,
  .llseek = seq_lseek,
  .release = single_release,
};
static const struct file_operations proc_fuc5 = {
  .owner = THIS_MODULE,
  .open = led_proc_open_5,
  .read = seq_read,
  .write = write_proc_5,
  .llseek = seq_lseek,
  .release = single_release,
};
static const struct file_operations proc_fuc6 = {
  .owner = THIS_MODULE,
  .open = led_proc_open_6,
  .read = seq_read,
  .write = write_proc_6,
  .llseek = seq_lseek,
  .release = single_release,
};
static const struct file_operations proc_fuc7 = {
  .owner = THIS_MODULE,
  .open = led_proc_open_7,
  .read = seq_read,
  .write = write_proc_7,
  .llseek = seq_lseek,
  .release = single_release,
};
/*
static const struct file_operations proc_fuc_but1 = {
  .owner = THIS_MODULE,
  .open = led_proc_open_but1,
  .read = seq_read,
  .write = write_proc_but1,  
  .llseek = seq_lseek,
  .release = single_release,
};
*/
int create_new_proc_entry(void)
{
	char pin[5];	
	proc_parent = proc_mkdir("led",NULL);
    if(!proc_parent)
    {
        printk(KERN_INFO "Error creating proc entry");
        return -ENOMEM;
    }
	//Power LED White
	memset(pin, 0x00, sizeof(pin));
	sprintf(pin, "led%d", PWR_LED);
	proc_write_entry = proc_create(pin, 0, proc_parent, &proc_fuc1);
	
	if(!proc_write_entry)
    {
        printk(KERN_INFO "Error creating proc entry");
        return -ENOMEM;
    }	
	
    //Function LED White
	memset(pin, 0x00, sizeof(pin));
	sprintf(pin, "led%d", FUNC_LED1);
    proc_write_entry = proc_create(pin, 0, proc_parent, &proc_fuc2);
    if(!proc_write_entry)
    {
        printk(KERN_INFO "Error creating proc entry");
        return -ENOMEM;
    }
	
	//Function LED Red
	memset(pin, 0x00, sizeof(pin));
	sprintf(pin, "led%d", FUNC_LED2);
    proc_write_entry = proc_create(pin, 0, proc_parent, &proc_fuc3);
    if(!proc_write_entry)
    {
        printk(KERN_INFO "Error creating proc entry");
        return -ENOMEM;
    }
	
	//Info LED Orange
	memset(pin, 0x00, sizeof(pin));
	sprintf(pin, "led%d", INFO_LED);
    proc_write_entry = proc_create(pin, 0, proc_parent, &proc_fuc4);
    if(!proc_write_entry)
    {
        printk(KERN_INFO "Error creating proc entry");
        return -ENOMEM;
    }
	
	//Err LED Red
	memset(pin, 0x00, sizeof(pin));
	sprintf(pin, "led%d", ERR_LED);
    proc_write_entry = proc_create(pin, 0, proc_parent, &proc_fuc5);
    if(!proc_write_entry)
    {
        printk(KERN_INFO "Error creating proc entry");
        return -ENOMEM;
    }
	
	//HDD1 ERR LED Red
	memset(pin, 0x00, sizeof(pin));
	sprintf(pin, "led%d", HDD1_ERR_LED);
    proc_write_entry = proc_create(pin, 0, proc_parent, &proc_fuc6);
    if(!proc_write_entry)
    {
        printk(KERN_INFO "Error creating proc entry");
        return -ENOMEM;
    }
	
	//HDD2 ERR LED Red
	memset(pin, 0x00, sizeof(pin));
	sprintf(pin, "led%d", HDD2_ERR_LED);
    proc_write_entry = proc_create(pin, 0, proc_parent, &proc_fuc7);
    if(!proc_write_entry)
    {
        printk(KERN_INFO "Error creating proc entry");
        return -ENOMEM;
    }
    
	/*
	//function switch
	memset(pin, 0x00, sizeof(pin));
	sprintf(pin, "but%d", FUNC_SW);
    proc_write_entry = proc_create(pin, 0, proc_parent, &proc_fuc_but1);
    if(!proc_write_entry)
    {
        printk(KERN_INFO "Error creating proc entry");
        return -ENOMEM;
    }
   
    printk(KERN_INFO "proc gtk_but1 initialized");
	*/
	return 1;
}

void led_timer_turn_on(unsigned long data)
{
//  printk(KERN_INFO "led_timer_turn_on!!!!\n");
	if(blink_enable_1 == 1)
	{
        gpio_direction_output(PWR_LED, 1);
        gpio_set_value(PWR_LED, HIGH);
	}
	if(blink_enable_2 == 1)
	{
        gpio_direction_output(FUNC_LED1, 1);
        gpio_set_value(FUNC_LED1, HIGH);
	}
	if(blink_enable_3 == 1)
	{
        gpio_direction_output(FUNC_LED2, 1);
        gpio_set_value(FUNC_LED2, HIGH);
	}
	if(blink_enable_4 == 1)
	{
        gpio_direction_output(INFO_LED, 1);
        gpio_set_value(INFO_LED, HIGH);
	}
	if(blink_enable_5 == 1)
	{
        gpio_direction_output(ERR_LED, 1);
        gpio_set_value(ERR_LED, HIGH);
	}
	if(blink_enable_6 == 1)
	{
        gpio_direction_output(HDD1_ERR_LED, 1);
        gpio_set_value(HDD1_ERR_LED, HIGH);
	}
	if(blink_enable_7 == 1)
	{
        gpio_direction_output(HDD2_ERR_LED, 1);
        gpio_set_value(HDD2_ERR_LED, HIGH);
	}
	/*if (init_r2d)
	{
		if (gpio_get_value(FUNC_SW) == 0 && button_flag == 1)
		{		
			button_stat_1 = '1';			
			init_r2d = 0;
			gpio_free(FUNC_SW);
		}	
		if (gpio_get_value(FUNC_SW) == 1)
			button_flag = 1;
			
		init_count++;	
		
		if (init_count >= MAX_INIT_COUNT)
		{
			button_stat_1 = '-';			
			blink_enable_2 = 0;
			gpio_set_value(FUNC_LED1, HIGH);
			init_r2d = 0;
			led_stat_2 = '0';
			gpio_free(FUNC_SW);
		}
	}	*/	
	
	led_timer_off.expires = jiffies + (HZ * 2 * 2 / 10);
	add_timer(&led_timer_off);
	
}

void led_timer_turn_off(unsigned long data)
{
//  printk(KERN_INFO "led_timer_turn_off!!!!\n");
	if(blink_enable_1 == 1)
	{
        gpio_direction_output(PWR_LED, 0);
        gpio_set_value(PWR_LED, !HIGH);
	}
	if(blink_enable_2 == 1)
	{
        gpio_direction_output(FUNC_LED1, 0);
        gpio_set_value(FUNC_LED1, !HIGH);
	}
	if(blink_enable_3 == 1)
	{
        gpio_direction_output(FUNC_LED2, 0);
        gpio_set_value(FUNC_LED2, !HIGH);
	}
	if(blink_enable_4 == 1)
	{
        gpio_direction_output(INFO_LED, 0);
        gpio_set_value(INFO_LED, !HIGH);
	}
	if(blink_enable_5 == 1)
	{
        gpio_direction_output(ERR_LED, 0);
        gpio_set_value(ERR_LED, !HIGH);
	}
	if(blink_enable_6 == 1)
	{
        gpio_direction_output(HDD1_ERR_LED, 0);
        gpio_set_value(HDD1_ERR_LED, !HIGH);
	}
	if(blink_enable_7 == 1)
	{
        gpio_direction_output(HDD2_ERR_LED, 0);
        gpio_set_value(HDD2_ERR_LED, !HIGH);
	}
	/*if (init_r2d)
	{
		if (gpio_get_value(FUNC_SW) == 0 && button_flag == 1)
		{		
			button_stat_1 = '1';			
			init_r2d = 0;
			gpio_free(FUNC_SW);
		}	
		if(gpio_get_value(FUNC_SW) == 1)
			button_flag = 1;
			
		init_count++;

		if (init_count >= MAX_INIT_COUNT)
		{
			button_stat_1 = '-';			
			blink_enable_2 = 0;
			gpio_set_value(FUNC_LED1, HIGH);
			init_r2d = 0;
			led_stat_2 = '0';
			gpio_free(FUNC_SW);
		}
	}	*/
	led_timer_on.expires = jiffies + (HZ * 2 * 2 / 10);
	add_timer(&led_timer_on);
	
}

void init_gpio(int pin)
{
	int ret = 0;
	ret = gpio_request(pin, NULL);
	if (ret != 0) {
		gpio_free(pin);
		gpio_request(pin, NULL);
	}
	gpio_direction_output(pin, 0);
	gpio_set_value(pin, HIGH);
}

static int __init proc_init(void) {
	int ret = 0;
	int gpio_4_val = 0;
	int i;
	char pin[]={PWR_LED, FUNC_LED1, FUNC_LED2, INFO_LED, ERR_LED, HDD1_ERR_LED, HDD2_ERR_LED};
	
	
	printk(KERN_INFO "Gemtek LED init\n");
	
	for (i=0;i<7;i++)	
		init_gpio(pin[i]);	
	
	
	memset(proc_data_1, 0, sizeof(proc_data_1));
    memset(proc_data_2, 0, sizeof(proc_data_2));    
    memset(proc_data_3, 0, sizeof(proc_data_3));    
    memset(proc_data_4, 0, sizeof(proc_data_4));    
    memset(proc_data_5, 0, sizeof(proc_data_5));    
    memset(proc_data_6, 0, sizeof(proc_data_6));    
    memset(proc_data_7, 0, sizeof(proc_data_7));    
    memset(proc_data_but, 0, sizeof(proc_data_but));    
    
    proc_data_1[0] = '0';
    proc_data_2[0] = '0';	
    proc_data_3[0] = '0';	
    proc_data_4[0] = '0';	
    proc_data_5[0] = '0';	
    proc_data_6[0] = '0';	
    proc_data_7[0] = '0';	
    proc_data_but[0] = '0';	
	
	create_new_proc_entry();	
	/*
	ret = gpio_request(FUNC_SW, NULL);
	if (ret != 0) {
		gpio_free(FUNC_SW);
	}
	gpio_direction_input(FUNC_SW);
	gpio_4_val = gpio_get_value(FUNC_SW);	
	
	if (gpio_4_val == 0)
	{
		blink_enable_2 = 1;
		led_stat_2 = '2';
		init_r2d = 1;
		button_stat_1 = '0';
	}
	else
		gpio_free(FUNC_SW);
	*/
	init_timer(&led_timer_on);
	init_timer(&led_timer_off);
	/* 定義 timer 所執行之函式 */
	led_timer_on.function = led_timer_turn_on;
	led_timer_off.function = led_timer_turn_off;
	/* 定義 timer 傳入函式之 Data */
	led_timer_on.data = ((unsigned long) 0);
	led_timer_off.data = ((unsigned long) 0);
	/* 定義 timer Delay 時間 */
	led_timer_on.expires = jiffies + HZ;
	led_timer_off.expires = jiffies + HZ;
	/* 啟動 Timer*/
	add_timer(&led_timer_on); 
	
	return 0;
}

static void __exit proc_cleanup(void) {
	remove_proc_entry("proc_entry", NULL);
	gpio_free(PWR_LED);
	gpio_free(FUNC_LED1);	
	gpio_free(FUNC_LED2);	
	gpio_free(INFO_LED);	
	gpio_free(ERR_LED);	
	gpio_free(HDD1_ERR_LED);	
	gpio_free(HDD2_ERR_LED);	
	del_timer(&led_timer_on);
	del_timer(&led_timer_off);
}

MODULE_LICENSE("GPL");
module_init(proc_init);
module_exit(proc_cleanup);

/* Enable HDD1 power on LS520D*/
static int hdd1_pwr_ctl(void){
	int i, hdd_value[2] = {0};
	int hdd_detect[2] = { HDD1_ATTACH, HDD2_ATTACH };

	for(i=0; i<2; i++){
		if(gpio_request(hdd_detect[i], NULL)){
			gpio_free(hdd_detect[i]);
			gpio_request(hdd_detect[i], NULL);
		}
		gpio_direction_input(hdd_detect[i]);
		hdd_value[i] = gpio_get_value(hdd_detect[i]);
		gpio_free(hdd_detect[i]);
	}

	/* Low(0) for HDD attach */
	if(0 == hdd_value[0] && 0 == hdd_value[1]){
	/* Here: 3.1 seconds after HDD2 power up */
	msleep(5600);
	/* Here: 8 seconds */
	}

	if(gpio_request(HDD1_PWR, NULL)){
		gpio_free(HDD1_PWR);
		gpio_request(HDD1_PWR, NULL);
	}
	gpio_direction_output(HDD1_PWR, 1);
	gpio_free(HDD1_PWR);

	return 0;
}

late_initcall(hdd1_pwr_ctl);
