#ifndef __HDMI_RX_MAC_REG__H
#define __HDMI_RX_MAC_REG__H

// HDMI MAC
// HDMI Register Address base 0x1800F000

#define HDMI_TMDS_MSR0_VADDR                       (0x0000)
#define HDMI_TMDS_MSR1_VADDR                       (0x0004)
#define HDMI_TMDS_CRCC_VADDR                       (0x0008)
#define HDMI_TMDS_CRCO0_VADDR                      (0x000c)
#define HDMI_TMDS_CRCO1_VADDR                      (0x0010)
#define HDMI_TMDS_CTRL_VADDR                       (0x0014)
#define HDMI_TMDS_OUTCTL_VADDR                     (0x0018)
#define HDMI_TMDS_PWDCTL_VADDR                     (0x001c)
#define HDMI_TMDS_Z0CC_VADDR                       (0x0020)
#define HDMI_TMDS_CPS_VADDR                        (0x0024)
#define HDMI_TMDS_UDC_VADDR                        (0x0028)
#define HDMI_TMDS_ERRC_VADDR                       (0x002c)
#define HDMI_TMDS_OUT_CTRL_VADDR                   (0x0030)
#define HDMI_TMDS_ROUT_VADDR                       (0x0034)
#define HDMI_TMDS_GOUT_VADDR                       (0x0038)
#define HDMI_TMDS_BOUT_VADDR                       (0x003c)
#define HDMI_TMDS_DPC0_VADDR                       (0x0040)
#define HDMI_TMDS_DPC1_VADDR                       (0x0044)
#define HDMI_TMDS_DPC_SET0_VADDR                   (0x0048)
#define HDMI_TMDS_DPC_SET1_VADDR                   (0x004c)
#define HDMI_TMDS_DPC_SET2_VADDR                   (0x0050)
#define HDMI_TMDS_DPC_SET3_VADDR                   (0x0054)
#define HDMI_TMDS_DET_CTL_VADDR                    (0x0058)
#define HDMI_TMDS_DET_STS_VADDR                    (0x005c)
#define HDMI_HDMI_SR_VADDR                         (0x0080)
#define HDMI_HDMI_GPVS_VADDR                       (0x0084)
#define HDMI_HDMI_PSAP_VADDR                       (0x0088)
#define HDMI_HDMI_PSDP_VADDR                       (0x008c)
#define HDMI_HDMI_SCR_VADDR                        (0x0090)
#define HDMI_HDMI_BCHCR_VADDR                      (0x0094)
#define HDMI_HDMI_AVMCR_VADDR                      (0x0098)
#define HDMI_HDMI_WDCR0_VADDR                      (0x009c)
#define HDMI_HDMI_DBCR_VADDR                       (0x00a0)
#define HDMI_HDMI_AWDSR_VADDR                      (0x00a4)
#define HDMI_HDMI_VWDSR_VADDR                      (0x00a8)
#define HDMI_HDMI_PAMICR_VADDR                     (0x00ac)
#define HDMI_HDMI_PTRSV1_VADDR                     (0x00b0)
#define HDMI_HDMI_PVGCR0_VADDR                     (0x00b4)
#define HDMI_HDMI_PVSR0_VADDR                      (0x00b8)
#define HDMI_HDMI_VCR_VADDR                        (0x00bc)
#define HDMI_HDMI_ACRCR_VADDR                      (0x00c0)
#define HDMI_HDMI_ACRSR0_VADDR                     (0x00c4)
#define HDMI_HDMI_ACRSR1_VADDR                     (0x00c8)
#define HDMI_HDMI_ACS0_VADDR                       (0x00cc)
#define HDMI_HDMI_ACS1_VADDR                       (0x00d0)
#define HDMI_HDMI_INTCR_VADDR                      (0x00d4)
#define HDMI_HDMI_ALCR_VADDR                       (0x00d8)
#define HDMI_HDMI_AOCR_VADDR                       (0x00dc)
#define HDMI_HDMI_BCSR_VADDR                       (0x00e0)
#define HDMI_HDMI_ASR0_VADDR                       (0x00e4)
#define HDMI_HDMI_ASR1_VADDR                       (0x00e8)
#define HDMI_HDMI_VIDEO_FORMAT_VADDR               (0x00ec)
#define HDMI_HDMI_3D_FORMAT_VADDR                  (0x00f0)
#define HDMI_AUDIO_SAMPLE_RATE_CHANGE_IRQ_VADDR    (0x0100)
#define HDMI_HIGH_BIT_RATE_AUDIO_PACKET_VADDR      (0x0104)
#define HDMI_HDMI_AFCR_VADDR                       (0x0108)
#define HDMI_HDMI_AFSR_VADDR                       (0x010c)
#define HDMI_HDMI_MAGCR0_VADDR                     (0x0110)
#define HDMI_HDMI_MAG_M_FINAL_VADDR                (0x0114)
#define HDMI_ZCD_CTRL_VADDR                        (0x0118)
#define HDMI_AUDIO_FREQDET_VADDR                   (0x011c)
#define HDMI_RANGE0_1_VADDR                        (0x0120)
#define HDMI_RANGE2_3_VADDR                        (0x0124)
#define HDMI_RANGE4_5_VADDR                        (0x0128)
#define HDMI_PRESET_S_CODE0_VADDR                  (0x012c)
#define HDMI_PRESET_S_CODE1_VADDR                  (0x0130)
#define HDMI_LEADING_GB_CMP_CTRL                                      (0x0140)
#define HDMI_LEADING_GB_CMP_TIMES                                     (0x0144)
#define HDMI_LEADING_GB_CMP_CNT                                       (0x0148)
#define AUDIO_CTS_UP_BOUND                                            (0x014c)
#define AUDIO_CTS_LOW_BOUND                                           (0x0150)
#define AUDIO_N_UP_BOUND                                              (0x0154)
#define AUDIO_N_LOW_BOUND                                             (0x0158)
#define MHL_HDMI_MAC_CTRL                                             (0x015c)
#define HDMI_HDCP_BIST_VADDR                       (0x0200)
#define HDMI_HDCP_CR_VADDR                         (0x0204)
#define HDMI_HDCP_DKAP_VADDR                       (0x0208)
#define HDMI_HDCP_PCR_VADDR                        (0x020c)
#define HDMI_HDCP_FLAG1_VADDR                      (0x0210)
#define HDMI_HDCP_FLAG2_VADDR                      (0x0214)
#define HDMI_HDCP_AP_VADDR                         (0x0218)
#define HDMI_HDCP_DP_VADDR                         (0x021c)
#define HDMI_HDMI_CMCR_VADDR                       (0x0300)
#define HDMI_HDMI_MCAPR_VADDR                      (0x0304)
#define HDMI_HDMI_SCAPR_VADDR                      (0x0308)
#define HDMI_HDMI_DCAPR0_VADDR                     (0x030c)
#define HDMI_HDMI_PSCR_VADDR                       (0x0310)
#define HDMI_HDMI_AFDD_VADDR                       (0x031c)
#define HDMI_HDMI_FTR_VADDR                        (0x0320)
#define HDMI_HDMI_FBR_VADDR                        (0x0324)
#define HDMI_HDMI_ICPSNCR0_VADDR                   (0x0328)
#define HDMI_HDMI_PCPSNCR0_VADDR                   (0x032c)
#define HDMI_HDMI_ICTPSR0_VADDR                    (0x0330)
#define HDMI_HDMI_PCTPSR0_VADDR                    (0x0334)
#define HDMI_HDMI_ICBPSR0_VADDR                    (0x0338)
#define HDMI_HDMI_PCBPSR0_VADDR                    (0x033c)
#define HDMI_HDMI_NTX1024TR0_VADDR                 (0x0340)
#define HDMI_HDMI_STBPR_VADDR                      (0x0344)
#define HDMI_HDMI_NCPER_VADDR                      (0x0348)
#define HDMI_RHDMI_PETR_VADDR                      (0x034c)
#define HDMI_HDMI_AAPNR_VADDR                      (0x0350)
#define HDMI_HDMI_APDMCR_VADDR                     (0x0354)
#define HDMI_HDMI_APTMCR0_VADDR                    (0x0358)
#define HDMI_HDMI_APTMCR1_VADDR                    (0x035c)
#define HDMI_NPECR                                                    (0x0360)
#define HDMI_HDMI_APLLCR0_VADDR                    (0x0380)
#define HDMI_HDMI_APLLCR1_VADDR                    (0x0384)
#define HDMI_HDMI_APLLCR2_VADDR                    (0x0388)
#define HDMI_HDMI_APLLCR3_VADDR                    (0x038c)
#define HDMI_HDMI_VPLLCR0_VADDR                    (0x0400)
#define HDMI_HDMI_VPLLCR1_VADDR                    (0x0404)
#define HDMI_HDMI_VPLLCR2_VADDR                    (0x0408)
#define HDMI_MN_SCLKG_CTRL_VADDR                   (0x0410)
#define HDMI_MN_SCLKG_DIVS_VADDR                   (0x0414)

#define HDMI_VCR_cbus_ddc_chsel_shift                                 (28)
#define HDMI_VCR_hdmi_field_shift                                     (27)
#define HDMI_VCR_int_pro_chg_flag_shift                               (26)
#define HDMI_VCR_int_pro_chg_wd_en_shift                              (25)
#define HDMI_VCR_int_pro_chg_int_en_shift                             (24)
#define HDMI_VCR_hdcp_ddc_chsel_shift                                 (22)
#define HDMI_VCR_iclk_sel_shift                                       (20)
#define HDMI_VCR_csc_r_shift                                          (18)
#define HDMI_VCR_hdirq_shift                                          (17)
#define HDMI_VCR_csam_shift                                           (16)
#define HDMI_VCR_csc_shift                                            (14)
#define HDMI_VCR_field_decide_sel_shift                               (13)
#define HDMI_VCR_prdsam_shift                                         (12)
#define HDMI_VCR_dsc_r_shift                                          (8)
#define HDMI_VCR_eoi_shift                                            (7)
#define HDMI_VCR_eot_shift                                            (6)
#define HDMI_VCR_se_shift                                             (5)
#define HDMI_VCR_rs_shift                                             (4)
#define HDMI_VCR_dsc_shift                                            (0)
#define HDMI_VCR_cbus_ddc_chsel_mask                                  (0x10000000)
#define HDMI_VCR_hdmi_field_mask                                      (0x08000000)
#define HDMI_VCR_int_pro_chg_flag_mask                                (0x04000000)
#define HDMI_VCR_int_pro_chg_wd_en_mask                               (0x02000000)
#define HDMI_VCR_int_pro_chg_int_en_mask                              (0x01000000)
#define HDMI_VCR_hdcp_ddc_chsel_mask                                  (0x00C00000)
#define HDMI_VCR_iclk_sel_mask                                        (0x00300000)
#define HDMI_VCR_csc_r_mask                                           (0x000C0000)
#define HDMI_VCR_hdirq_mask                                           (0x00020000)
#define HDMI_VCR_csam_mask                                            (0x00010000)
#define HDMI_VCR_csc_mask                                             (0x0000C000)
#define HDMI_VCR_field_decide_sel_mask                                (0x00002000)
#define HDMI_VCR_prdsam_mask                                          (0x00001000)
#define HDMI_VCR_dsc_r_mask                                           (0x00000F00)
#define HDMI_VCR_eoi_mask                                             (0x00000080)
#define HDMI_VCR_eot_mask                                             (0x00000040)
#define HDMI_VCR_se_mask                                              (0x00000020)
#define HDMI_VCR_rs_mask                                              (0x00000010)
#define HDMI_VCR_dsc_mask                                             (0x0000000F)
#define HDMI_VCR_cbus_ddc_chsel(data)                                 (0x10000000&((data)<<28))
#define HDMI_VCR_hdmi_field(data)                                     (0x08000000&((data)<<27))
#define HDMI_VCR_int_pro_chg_flag(data)                               (0x04000000&((data)<<26))
#define HDMI_VCR_int_pro_chg_wd_en(data)                              (0x02000000&((data)<<25))
#define HDMI_VCR_int_pro_chg_int_en(data)                             (0x01000000&((data)<<24))
#define HDMI_VCR_hdcp_ddc_chsel(data)                                 (0x00C00000&((data)<<22))
#define HDMI_VCR_iclk_sel(data)                                       (0x00300000&((data)<<20))
#define HDMI_VCR_csc_r(data)                                          (0x000C0000&((data)<<18))
#define HDMI_VCR_hdirq(data)                                          (0x00020000&((data)<<17))
#define HDMI_VCR_csam(data)                                           (0x00010000&((data)<<16))
#define HDMI_VCR_csc(data)                                            (0x0000C000&((data)<<14))
#define HDMI_VCR_field_decide_sel(data)                               (0x00002000&((data)<<13))
#define HDMI_VCR_prdsam(data)                                         (0x00001000&((data)<<12))
#define HDMI_VCR_dsc_r(data)                                          (0x00000F00&((data)<<8))
#define HDMI_VCR_eoi(data)                                            (0x00000080&((data)<<7))
#define HDMI_VCR_eot(data)                                            (0x00000040&((data)<<6))
#define HDMI_VCR_se(data)                                             (0x00000020&((data)<<5))
#define HDMI_VCR_rs(data)                                             (0x00000010&((data)<<4))
#define HDMI_VCR_dsc(data)                                            (0x0000000F&(data))
#define HDMI_VCR_get_cbus_ddc_chsel(data)                             ((0x10000000&(data))>>28)
#define HDMI_VCR_get_hdmi_field(data)                                 ((0x08000000&(data))>>27)
#define HDMI_VCR_get_int_pro_chg_flag(data)                           ((0x04000000&(data))>>26)
#define HDMI_VCR_get_int_pro_chg_wd_en(data)                          ((0x02000000&(data))>>25)
#define HDMI_VCR_get_int_pro_chg_int_en(data)                         ((0x01000000&(data))>>24)
#define HDMI_VCR_get_hdcp_ddc_chsel(data)                             ((0x00C00000&(data))>>22)
#define HDMI_VCR_get_iclk_sel(data)                                   ((0x00300000&(data))>>20)
#define HDMI_VCR_get_csc_r(data)                                      ((0x000C0000&(data))>>18)
#define HDMI_VCR_get_hdirq(data)                                      ((0x00020000&(data))>>17)
#define HDMI_VCR_get_csam(data)                                       ((0x00010000&(data))>>16)
#define HDMI_VCR_get_csc(data)                                        ((0x0000C000&(data))>>14)
#define HDMI_VCR_get_field_decide_sel(data)                           ((0x00002000&(data))>>13)
#define HDMI_VCR_get_prdsam(data)                                     ((0x00001000&(data))>>12)
#define HDMI_VCR_get_dsc_r(data)                                      ((0x00000F00&(data))>>8)
#define HDMI_VCR_get_eoi(data)                                        ((0x00000080&(data))>>7)
#define HDMI_VCR_get_eot(data)                                        ((0x00000040&(data))>>6)
#define HDMI_VCR_get_se(data)                                         ((0x00000020&(data))>>5)
#define HDMI_VCR_get_rs(data)                                         ((0x00000010&(data))>>4)
#define HDMI_VCR_get_dsc(data)                                        (0x0000000F&(data))

#define TMDS_OUTCTL_trcoe_r_shift                                     (13)
#define TMDS_OUTCTL_tgcoe_r_shift                                     (12)
#define TMDS_OUTCTL_tbcoe_r_shift                                     (11)
#define TMDS_OUTCTL_ocke_r_shift                                      (10)
#define TMDS_OUTCTL_aoe_shift                                         (9)
#define TMDS_OUTCTL_trcoe_shift                                       (8)
#define TMDS_OUTCTL_tgcoe_shift                                       (7)
#define TMDS_OUTCTL_tbcoe_shift                                       (6)
#define TMDS_OUTCTL_ocke_shift                                        (5)
#define TMDS_OUTCTL_ockie_shift                                       (4)
#define TMDS_OUTCTL_dummy1800d018_3_shift                             (3)
#define TMDS_OUTCTL_clk25xinv_r_shift                                 (2)
#define TMDS_OUTCTL_clk25xinv_g_shift                                 (1)
#define TMDS_OUTCTL_clk25xinv_b_shift                                 (0)
#define TMDS_OUTCTL_trcoe_r_mask                                      (0x00002000)
#define TMDS_OUTCTL_tgcoe_r_mask                                      (0x00001000)
#define TMDS_OUTCTL_tbcoe_r_mask                                      (0x00000800)
#define TMDS_OUTCTL_ocke_r_mask                                       (0x00000400)
#define TMDS_OUTCTL_aoe_mask                                          (0x00000200)
#define TMDS_OUTCTL_trcoe_mask                                        (0x00000100)
#define TMDS_OUTCTL_tgcoe_mask                                        (0x00000080)
#define TMDS_OUTCTL_tbcoe_mask                                        (0x00000040)
#define TMDS_OUTCTL_ocke_mask                                         (0x00000020)
#define TMDS_OUTCTL_ockie_mask                                        (0x00000010)
#define TMDS_OUTCTL_dummy1800d018_3_mask                              (0x00000008)
#define TMDS_OUTCTL_clk25xinv_r_mask                                  (0x00000004)
#define TMDS_OUTCTL_clk25xinv_g_mask                                  (0x00000002)
#define TMDS_OUTCTL_clk25xinv_b_mask                                  (0x00000001)
#define TMDS_OUTCTL_trcoe_r(data)                                     (0x00002000&((data)<<13))
#define TMDS_OUTCTL_tgcoe_r(data)                                     (0x00001000&((data)<<12))
#define TMDS_OUTCTL_tbcoe_r(data)                                     (0x00000800&((data)<<11))
#define TMDS_OUTCTL_ocke_r(data)                                      (0x00000400&((data)<<10))
#define TMDS_OUTCTL_aoe(data)                                         (0x00000200&((data)<<9))
#define TMDS_OUTCTL_trcoe(data)                                       (0x00000100&((data)<<8))
#define TMDS_OUTCTL_tgcoe(data)                                       (0x00000080&((data)<<7))
#define TMDS_OUTCTL_tbcoe(data)                                       (0x00000040&((data)<<6))
#define TMDS_OUTCTL_ocke(data)                                        (0x00000020&((data)<<5))
#define TMDS_OUTCTL_ockie(data)                                       (0x00000010&((data)<<4))
#define TMDS_OUTCTL_dummy1800d018_3(data)                             (0x00000008&((data)<<3))
#define TMDS_OUTCTL_clk25xinv_r(data)                                 (0x00000004&((data)<<2))
#define TMDS_OUTCTL_clk25xinv_g(data)                                 (0x00000002&((data)<<1))
#define TMDS_OUTCTL_clk25xinv_b(data)                                 (0x00000001&(data))
#define TMDS_OUTCTL_get_trcoe_r(data)                                 ((0x00002000&(data))>>13)
#define TMDS_OUTCTL_get_tgcoe_r(data)                                 ((0x00001000&(data))>>12)
#define TMDS_OUTCTL_get_tbcoe_r(data)                                 ((0x00000800&(data))>>11)
#define TMDS_OUTCTL_get_ocke_r(data)                                  ((0x00000400&(data))>>10)
#define TMDS_OUTCTL_get_aoe(data)                                     ((0x00000200&(data))>>9)
#define TMDS_OUTCTL_get_trcoe(data)                                   ((0x00000100&(data))>>8)
#define TMDS_OUTCTL_get_tgcoe(data)                                   ((0x00000080&(data))>>7)
#define TMDS_OUTCTL_get_tbcoe(data)                                   ((0x00000040&(data))>>6)
#define TMDS_OUTCTL_get_ocke(data)                                    ((0x00000020&(data))>>5)
#define TMDS_OUTCTL_get_ockie(data)                                   ((0x00000010&(data))>>4)
#define TMDS_OUTCTL_get_dummy1800d018_3(data)                         ((0x00000008&(data))>>3)
#define TMDS_OUTCTL_get_clk25xinv_r(data)                             ((0x00000004&(data))>>2)
#define TMDS_OUTCTL_get_clk25xinv_g(data)                             ((0x00000002&(data))>>1)
#define TMDS_OUTCTL_get_clk25xinv_b(data)                             (0x00000001&(data))

#define HDMI_AVMCR_wd_vclk_en_shift                                   (9)
#define HDMI_AVMCR_avmute_flag_shift                                  (8)
#define HDMI_AVMCR_avmute_win_en_shift                                (7)
#define HDMI_AVMCR_aoc_shift                                          (6)
#define HDMI_AVMCR_aomc_shift                                         (5)
#define HDMI_AVMCR_awd_shift                                          (4)
#define HDMI_AVMCR_ve_shift                                           (3)
#define HDMI_AVMCR_ampic_shift                                        (2)
#define HDMI_AVMCR_vdpic_shift                                        (1)
#define HDMI_AVMCR_nfpss_shift                                        (0)
#define HDMI_AVMCR_wd_vclk_en_mask                                    (0x00000200)
#define HDMI_AVMCR_avmute_flag_mask                                   (0x00000100)
#define HDMI_AVMCR_avmute_win_en_mask                                 (0x00000080)
#define HDMI_AVMCR_aoc_mask                                           (0x00000040)
#define HDMI_AVMCR_aomc_mask                                          (0x00000020)
#define HDMI_AVMCR_awd_mask                                           (0x00000010)
#define HDMI_AVMCR_ve_mask                                            (0x00000008)
#define HDMI_AVMCR_ampic_mask                                         (0x00000004)
#define HDMI_AVMCR_vdpic_mask                                         (0x00000002)
#define HDMI_AVMCR_nfpss_mask                                         (0x00000001)
#define HDMI_AVMCR_wd_vclk_en(data)                                   (0x00000200&((data)<<9))
#define HDMI_AVMCR_avmute_flag(data)                                  (0x00000100&((data)<<8))
#define HDMI_AVMCR_avmute_win_en(data)                                (0x00000080&((data)<<7))
#define HDMI_AVMCR_aoc(data)                                          (0x00000040&((data)<<6))
#define HDMI_AVMCR_aomc(data)                                         (0x00000020&((data)<<5))
#define HDMI_AVMCR_awd(data)                                          (0x00000010&((data)<<4))
#define HDMI_AVMCR_ve(data)                                           (0x00000008&((data)<<3))
#define HDMI_AVMCR_ampic(data)                                        (0x00000004&((data)<<2))
#define HDMI_AVMCR_vdpic(data)                                        (0x00000002&((data)<<1))
#define HDMI_AVMCR_nfpss(data)                                        (0x00000001&(data))
#define HDMI_AVMCR_get_wd_vclk_en(data)                               ((0x00000200&(data))>>9)
#define HDMI_AVMCR_get_avmute_flag(data)                              ((0x00000100&(data))>>8)
#define HDMI_AVMCR_get_avmute_win_en(data)                            ((0x00000080&(data))>>7)
#define HDMI_AVMCR_get_aoc(data)                                      ((0x00000040&(data))>>6)
#define HDMI_AVMCR_get_aomc(data)                                     ((0x00000020&(data))>>5)
#define HDMI_AVMCR_get_awd(data)                                      ((0x00000010&(data))>>4)
#define HDMI_AVMCR_get_ve(data)                                       ((0x00000008&(data))>>3)
#define HDMI_AVMCR_get_ampic(data)                                    ((0x00000004&(data))>>2)
#define HDMI_AVMCR_get_vdpic(data)                                    ((0x00000002&(data))>>1)
#define HDMI_AVMCR_get_nfpss(data)                                    (0x00000001&(data))

#define HDCP_CR_namfe_shift                                           (7)
#define HDCP_CR_dummy1800d204_6_shift                                 (6)
#define HDCP_CR_ivsp_shift                                            (5)
#define HDCP_CR_invvs_shift                                           (4)
#define HDCP_CR_ivspm_shift                                           (3)
#define HDCP_CR_maddf_shift                                           (2)
#define HDCP_CR_dkapde_shift                                          (1)
#define HDCP_CR_hdcp_en_shift                                         (0)
#define HDCP_CR_namfe_mask                                            (0x00000080)
#define HDCP_CR_dummy1800d204_6_mask                                  (0x00000040)
#define HDCP_CR_ivsp_mask                                             (0x00000020)
#define HDCP_CR_invvs_mask                                            (0x00000010)
#define HDCP_CR_ivspm_mask                                            (0x00000008)
#define HDCP_CR_maddf_mask                                            (0x00000004)
#define HDCP_CR_dkapde_mask                                           (0x00000002)
#define HDCP_CR_hdcp_en_mask                                          (0x00000001)
#define HDCP_CR_namfe(data)                                           (0x00000080&((data)<<7))
#define HDCP_CR_dummy1800d204_6(data)                                 (0x00000040&((data)<<6))
#define HDCP_CR_ivsp(data)                                            (0x00000020&((data)<<5))
#define HDCP_CR_invvs(data)                                           (0x00000010&((data)<<4))
#define HDCP_CR_ivspm(data)                                           (0x00000008&((data)<<3))
#define HDCP_CR_maddf(data)                                           (0x00000004&((data)<<2))
#define HDCP_CR_dkapde(data)                                          (0x00000002&((data)<<1))
#define HDCP_CR_hdcp_en(data)                                         (0x00000001&(data))
#define HDCP_CR_get_namfe(data)                                       ((0x00000080&(data))>>7)
#define HDCP_CR_get_dummy1800d204_6(data)                             ((0x00000040&(data))>>6)
#define HDCP_CR_get_ivsp(data)                                        ((0x00000020&(data))>>5)
#define HDCP_CR_get_invvs(data)                                       ((0x00000010&(data))>>4)
#define HDCP_CR_get_ivspm(data)                                       ((0x00000008&(data))>>3)
#define HDCP_CR_get_maddf(data)                                       ((0x00000004&(data))>>2)
#define HDCP_CR_get_dkapde(data)                                      ((0x00000002&(data))>>1)
#define HDCP_CR_get_hdcp_en(data)                                     (0x00000001&(data))

#define HDMI_VPLLCR1_dpll_cp_shift                                    (21)
#define HDMI_VPLLCR1_dpll_seltst_shift                                (19)
#define HDMI_VPLLCR1_dpll_cs_shift                                    (17)
#define HDMI_VPLLCR1_dpll_reserve_shift                               (9)
#define HDMI_VPLLCR1_dpll_bpphs_shift                                 (8)
#define HDMI_VPLLCR1_dpll_wdo_shift                                   (7)
#define HDMI_VPLLCR1_dpll_wdrst_shift                                 (6)
#define HDMI_VPLLCR1_dpll_wdset_shift                                 (5)
#define HDMI_VPLLCR1_dummy1800d404_4_shift                            (4)
#define HDMI_VPLLCR1_dpll_stop_shift                                  (3)
#define HDMI_VPLLCR1_dpll_freeze_shift                                (2)
#define HDMI_VPLLCR1_dpll_vcorstb_shift                               (1)
#define HDMI_VPLLCR1_dpll_pwdn_shift                                  (0)
#define HDMI_VPLLCR1_dpll_cp_mask                                     (0x00600000)
#define HDMI_VPLLCR1_dpll_seltst_mask                                 (0x00180000)
#define HDMI_VPLLCR1_dpll_cs_mask                                     (0x00060000)
#define HDMI_VPLLCR1_dpll_reserve_mask                                (0x00000200)
#define HDMI_VPLLCR1_dpll_bpphs_mask                                  (0x00000100)
#define HDMI_VPLLCR1_dpll_wdo_mask                                    (0x00000080)
#define HDMI_VPLLCR1_dpll_wdrst_mask                                  (0x00000040)
#define HDMI_VPLLCR1_dpll_wdset_mask                                  (0x00000020)
#define HDMI_VPLLCR1_dummy1800d404_4_mask                             (0x00000010)
#define HDMI_VPLLCR1_dpll_stop_mask                                   (0x00000008)
#define HDMI_VPLLCR1_dpll_freeze_mask                                 (0x00000004)
#define HDMI_VPLLCR1_dpll_vcorstb_mask                                (0x00000002)
#define HDMI_VPLLCR1_dpll_pwdn_mask                                   (0x00000001)
#define HDMI_VPLLCR1_dpll_cp(data)                                    (0x00600000&((data)<<21))
#define HDMI_VPLLCR1_dpll_seltst(data)                                (0x00180000&((data)<<19))
#define HDMI_VPLLCR1_dpll_cs(data)                                    (0x00060000&((data)<<17))
#define HDMI_VPLLCR1_dpll_reserve(data)                               (0x00000200&((data)<<9))
#define HDMI_VPLLCR1_dpll_bpphs(data)                                 (0x00000100&((data)<<8))
#define HDMI_VPLLCR1_dpll_wdo(data)                                   (0x00000080&((data)<<7))
#define HDMI_VPLLCR1_dpll_wdrst(data)                                 (0x00000040&((data)<<6))
#define HDMI_VPLLCR1_dpll_wdset(data)                                 (0x00000020&((data)<<5))
#define HDMI_VPLLCR1_dummy1800d404_4(data)                            (0x00000010&((data)<<4))
#define HDMI_VPLLCR1_dpll_stop(data)                                  (0x00000008&((data)<<3))
#define HDMI_VPLLCR1_dpll_freeze(data)                                (0x00000004&((data)<<2))
#define HDMI_VPLLCR1_dpll_vcorstb(data)                               (0x00000002&((data)<<1))
#define HDMI_VPLLCR1_dpll_pwdn(data)                                  (0x00000001&(data))
#define HDMI_VPLLCR1_get_dpll_cp(data)                                ((0x00600000&(data))>>21)
#define HDMI_VPLLCR1_get_dpll_seltst(data)                            ((0x00180000&(data))>>19)
#define HDMI_VPLLCR1_get_dpll_cs(data)                                ((0x00060000&(data))>>17)
#define HDMI_VPLLCR1_get_dpll_reserve(data)                           ((0x00000200&(data))>>9)
#define HDMI_VPLLCR1_get_dpll_bpphs(data)                             ((0x00000100&(data))>>8)
#define HDMI_VPLLCR1_get_dpll_wdo(data)                               ((0x00000080&(data))>>7)
#define HDMI_VPLLCR1_get_dpll_wdrst(data)                             ((0x00000040&(data))>>6)
#define HDMI_VPLLCR1_get_dpll_wdset(data)                             ((0x00000020&(data))>>5)
#define HDMI_VPLLCR1_get_dummy1800d404_4(data)                        ((0x00000010&(data))>>4)
#define HDMI_VPLLCR1_get_dpll_stop(data)                              ((0x00000008&(data))>>3)
#define HDMI_VPLLCR1_get_dpll_freeze(data)                            ((0x00000004&(data))>>2)
#define HDMI_VPLLCR1_get_dpll_vcorstb(data)                           ((0x00000002&(data))>>1)
#define HDMI_VPLLCR1_get_dpll_pwdn(data)                              (0x00000001&(data))

#define HDMI_APLLCR1_dpll_cp_shift                                    (21)
#define HDMI_APLLCR1_dpll_seltst_shift                                (19)
#define HDMI_APLLCR1_dpll_cs_shift                                    (17)
#define HDMI_APLLCR1_dpll_reserve_shift                               (9)
#define HDMI_APLLCR1_dpll_bpphs_shift                                 (8)
#define HDMI_APLLCR1_dpll_wdo_shift                                   (7)
#define HDMI_APLLCR1_dpll_wdrst_shift                                 (6)
#define HDMI_APLLCR1_dpll_wdset_shift                                 (5)
#define HDMI_APLLCR1_dummy1800d384_4_shift                            (4)
#define HDMI_APLLCR1_dpll_stop_shift                                  (3)
#define HDMI_APLLCR1_dpll_freeze_shift                                (2)
#define HDMI_APLLCR1_dpll_vcorstb_shift                               (1)
#define HDMI_APLLCR1_dpll_pwdn_shift                                  (0)
#define HDMI_APLLCR1_dpll_cp_mask                                     (0x00600000)
#define HDMI_APLLCR1_dpll_seltst_mask                                 (0x00180000)
#define HDMI_APLLCR1_dpll_cs_mask                                     (0x00060000)
#define HDMI_APLLCR1_dpll_reserve_mask                                (0x00000200)
#define HDMI_APLLCR1_dpll_bpphs_mask                                  (0x00000100)
#define HDMI_APLLCR1_dpll_wdo_mask                                    (0x00000080)
#define HDMI_APLLCR1_dpll_wdrst_mask                                  (0x00000040)
#define HDMI_APLLCR1_dpll_wdset_mask                                  (0x00000020)
#define HDMI_APLLCR1_dummy1800d384_4_mask                             (0x00000010)
#define HDMI_APLLCR1_dpll_stop_mask                                   (0x00000008)
#define HDMI_APLLCR1_dpll_freeze_mask                                 (0x00000004)
#define HDMI_APLLCR1_dpll_vcorstb_mask                                (0x00000002)
#define HDMI_APLLCR1_dpll_pwdn_mask                                   (0x00000001)
#define HDMI_APLLCR1_dpll_cp(data)                                    (0x00600000&((data)<<21))
#define HDMI_APLLCR1_dpll_seltst(data)                                (0x00180000&((data)<<19))
#define HDMI_APLLCR1_dpll_cs(data)                                    (0x00060000&((data)<<17))
#define HDMI_APLLCR1_dpll_reserve(data)                               (0x00000200&((data)<<9))
#define HDMI_APLLCR1_dpll_bpphs(data)                                 (0x00000100&((data)<<8))
#define HDMI_APLLCR1_dpll_wdo(data)                                   (0x00000080&((data)<<7))
#define HDMI_APLLCR1_dpll_wdrst(data)                                 (0x00000040&((data)<<6))
#define HDMI_APLLCR1_dpll_wdset(data)                                 (0x00000020&((data)<<5))
#define HDMI_APLLCR1_dummy1800d384_4(data)                            (0x00000010&((data)<<4))
#define HDMI_APLLCR1_dpll_stop(data)                                  (0x00000008&((data)<<3))
#define HDMI_APLLCR1_dpll_freeze(data)                                (0x00000004&((data)<<2))
#define HDMI_APLLCR1_dpll_vcorstb(data)                               (0x00000002&((data)<<1))
#define HDMI_APLLCR1_dpll_pwdn(data)                                  (0x00000001&(data))
#define HDMI_APLLCR1_get_dpll_cp(data)                                ((0x00600000&(data))>>21)
#define HDMI_APLLCR1_get_dpll_seltst(data)                            ((0x00180000&(data))>>19)
#define HDMI_APLLCR1_get_dpll_cs(data)                                ((0x00060000&(data))>>17)
#define HDMI_APLLCR1_get_dpll_reserve(data)                           ((0x00000200&(data))>>9)
#define HDMI_APLLCR1_get_dpll_bpphs(data)                             ((0x00000100&(data))>>8)
#define HDMI_APLLCR1_get_dpll_wdo(data)                               ((0x00000080&(data))>>7)
#define HDMI_APLLCR1_get_dpll_wdrst(data)                             ((0x00000040&(data))>>6)
#define HDMI_APLLCR1_get_dpll_wdset(data)                             ((0x00000020&(data))>>5)
#define HDMI_APLLCR1_get_dummy1800d384_4(data)                        ((0x00000010&(data))>>4)
#define HDMI_APLLCR1_get_dpll_stop(data)                              ((0x00000008&(data))>>3)
#define HDMI_APLLCR1_get_dpll_freeze(data)                            ((0x00000004&(data))>>2)
#define HDMI_APLLCR1_get_dpll_vcorstb(data)                           ((0x00000002&(data))>>1)
#define HDMI_APLLCR1_get_dpll_pwdn(data)                              (0x00000001&(data))
#define HDMI_APLLCR1_dpll_CS_MASK                                        ((1<<18)|(1<<17))
#define HDMI_APLLCR1_dpll_CS_42P                                          (0)
#define HDMI_APLLCR1_dpll_CS_50P                                          (1<<17)
#define HDMI_APLLCR1_dpll_CS_58P                                          (2<<17)
#define HDMI_APLLCR1_dpll_CS_66P                                          (3<<17)

#define HDMI_ACRSR0_cts_shift                                         (0)
#define HDMI_ACRSR0_cts_mask                                          (0x000FFFFF)
#define HDMI_ACRSR0_cts(data)                                         (0x000FFFFF&(data))
#define HDMI_ACRSR0_get_cts(data)                                     (0x000FFFFF&(data))

#define HDMI_ACRSR1_n_shift                                           (0)
#define HDMI_ACRSR1_n_mask                                            (0x000FFFFF)
#define HDMI_ACRSR1_n(data)                                           (0x000FFFFF&(data))
#define HDMI_ACRSR1_get_n(data)                                       (0x000FFFFF&(data))

#define HDMI_WDCR0_vwdap_shift                                        (23)
#define HDMI_WDCR0_vwdlf_shift                                        (22)
#define HDMI_WDCR0_vwdafo_shift                                       (21)
#define HDMI_WDCR0_vwdafu_shift                                       (20)
#define HDMI_WDCR0_yv_shift                                           (16)
#define HDMI_WDCR0_awdck_shift                                        (15)
#define HDMI_WDCR0_awdlf_shift                                        (14)
#define HDMI_WDCR0_ch_st_sel_shift                                    (13)
#define HDMI_WDCR0_vwdact_shift                                       (12)
#define HDMI_WDCR0_xv_shift                                           (8)
#define HDMI_WDCR0_asmfe_shift                                        (7)
#define HDMI_WDCR0_load_d_shift                                       (6)
#define HDMI_WDCR0_bt_track_en_shift                                  (5)
#define HDMI_WDCR0_awdct_shift                                        (4)
#define HDMI_WDCR0_awdap_shift                                        (3)
#define HDMI_WDCR0_awdfo_shift                                        (2)
#define HDMI_WDCR0_awdfu_shift                                        (1)
#define HDMI_WDCR0_ct_shift                                           (0)
#define HDMI_WDCR0_vwdap_mask                                         (0x00800000)
#define HDMI_WDCR0_vwdlf_mask                                         (0x00400000)
#define HDMI_WDCR0_vwdafo_mask                                        (0x00200000)
#define HDMI_WDCR0_vwdafu_mask                                        (0x00100000)
#define HDMI_WDCR0_yv_mask                                            (0x000F0000)
#define HDMI_WDCR0_awdck_mask                                         (0x00008000)
#define HDMI_WDCR0_awdlf_mask                                         (0x00004000)
#define HDMI_WDCR0_ch_st_sel_mask                                     (0x00002000)
#define HDMI_WDCR0_vwdact_mask                                        (0x00001000)
#define HDMI_WDCR0_xv_mask                                            (0x00000F00)
#define HDMI_WDCR0_asmfe_mask                                         (0x00000080)
#define HDMI_WDCR0_load_d_mask                                        (0x00000040)
#define HDMI_WDCR0_bt_track_en_mask                                   (0x00000020)
#define HDMI_WDCR0_awdct_mask                                         (0x00000010)
#define HDMI_WDCR0_awdap_mask                                         (0x00000008)
#define HDMI_WDCR0_awdfo_mask                                         (0x00000004)
#define HDMI_WDCR0_awdfu_mask                                         (0x00000002)
#define HDMI_WDCR0_ct_mask                                            (0x00000001)
#define HDMI_WDCR0_vwdap(data)                                        (0x00800000&((data)<<23))
#define HDMI_WDCR0_vwdlf(data)                                        (0x00400000&((data)<<22))
#define HDMI_WDCR0_vwdafo(data)                                       (0x00200000&((data)<<21))
#define HDMI_WDCR0_vwdafu(data)                                       (0x00100000&((data)<<20))
#define HDMI_WDCR0_yv(data)                                           (0x000F0000&((data)<<16))
#define HDMI_WDCR0_awdck(data)                                        (0x00008000&((data)<<15))
#define HDMI_WDCR0_awdlf(data)                                        (0x00004000&((data)<<14))
#define HDMI_WDCR0_ch_st_sel(data)                                    (0x00002000&((data)<<13))
#define HDMI_WDCR0_vwdact(data)                                       (0x00001000&((data)<<12))
#define HDMI_WDCR0_xv(data)                                           (0x00000F00&((data)<<8))
#define HDMI_WDCR0_asmfe(data)                                        (0x00000080&((data)<<7))
#define HDMI_WDCR0_load_d(data)                                       (0x00000040&((data)<<6))
#define HDMI_WDCR0_bt_track_en(data)                                  (0x00000020&((data)<<5))
#define HDMI_WDCR0_awdct(data)                                        (0x00000010&((data)<<4))
#define HDMI_WDCR0_awdap(data)                                        (0x00000008&((data)<<3))
#define HDMI_WDCR0_awdfo(data)                                        (0x00000004&((data)<<2))
#define HDMI_WDCR0_awdfu(data)                                        (0x00000002&((data)<<1))
#define HDMI_WDCR0_ct(data)                                           (0x00000001&(data))
#define HDMI_WDCR0_get_vwdap(data)                                    ((0x00800000&(data))>>23)
#define HDMI_WDCR0_get_vwdlf(data)                                    ((0x00400000&(data))>>22)
#define HDMI_WDCR0_get_vwdafo(data)                                   ((0x00200000&(data))>>21)
#define HDMI_WDCR0_get_vwdafu(data)                                   ((0x00100000&(data))>>20)
#define HDMI_WDCR0_get_yv(data)                                       ((0x000F0000&(data))>>16)
#define HDMI_WDCR0_get_awdck(data)                                    ((0x00008000&(data))>>15)
#define HDMI_WDCR0_get_awdlf(data)                                    ((0x00004000&(data))>>14)
#define HDMI_WDCR0_get_ch_st_sel(data)                                ((0x00002000&(data))>>13)
#define HDMI_WDCR0_get_vwdact(data)                                   ((0x00001000&(data))>>12)
#define HDMI_WDCR0_get_xv(data)                                       ((0x00000F00&(data))>>8)
#define HDMI_WDCR0_get_asmfe(data)                                    ((0x00000080&(data))>>7)
#define HDMI_WDCR0_get_load_d(data)                                   ((0x00000040&(data))>>6)
#define HDMI_WDCR0_get_bt_track_en(data)                              ((0x00000020&(data))>>5)
#define HDMI_WDCR0_get_awdct(data)                                    ((0x00000010&(data))>>4)
#define HDMI_WDCR0_get_awdap(data)                                    ((0x00000008&(data))>>3)
#define HDMI_WDCR0_get_awdfo(data)                                    ((0x00000004&(data))>>2)
#define HDMI_WDCR0_get_awdfu(data)                                    ((0x00000002&(data))>>1)
#define HDMI_WDCR0_get_ct(data)                                       (0x00000001&(data))

#define HDMI_CMCR_icmux_shift                                         (7)
#define HDMI_CMCR_ocs_shift                                           (5)
#define HDMI_CMCR_dbdcb_shift                                         (4)
#define HDMI_CMCR_dummy1800d300_3_0_shift                             (0)
#define HDMI_CMCR_icmux_mask                                          (0x00000080)
#define HDMI_CMCR_ocs_mask                                            (0x00000060)
#define HDMI_CMCR_dbdcb_mask                                          (0x00000010)
#define HDMI_CMCR_dummy1800d300_3_0_mask                              (0x0000000F)
#define HDMI_CMCR_icmux(data)                                         (0x00000080&((data)<<7))
#define HDMI_CMCR_ocs(data)                                           (0x00000060&((data)<<5))
#define HDMI_CMCR_dbdcb(data)                                         (0x00000010&((data)<<4))
#define HDMI_CMCR_dummy1800d300_3_0(data)                             (0x0000000F&(data))
#define HDMI_CMCR_get_icmux(data)                                     ((0x00000080&(data))>>7)
#define HDMI_CMCR_get_ocs(data)                                       ((0x00000060&(data))>>5)
#define HDMI_CMCR_get_dbdcb(data)                                     ((0x00000010&(data))>>4)
#define HDMI_CMCR_get_dummy1800d300_3_0(data)                         (0x0000000F&(data))

#define HDMI_APLLCR0_dpll_reg_shift                                   (30)
#define HDMI_APLLCR0_dpll_m_shift                                     (22)
#define HDMI_APLLCR0_dpll_reser_shift                                 (17)
#define HDMI_APLLCR0_dpll_bpn_shift                                   (16)
#define HDMI_APLLCR0_dpll_o_shift                                     (14)
#define HDMI_APLLCR0_dpll_n_shift                                     (6)
#define HDMI_APLLCR0_dpll_rs_shift                                    (3)
#define HDMI_APLLCR0_dpll_ip_shift                                    (0)
#define HDMI_APLLCR0_dpll_reg_mask                                    (0xC0000000)
#define HDMI_APLLCR0_dpll_m_mask                                      (0x3FC00000)
#define HDMI_APLLCR0_dpll_reser_mask                                  (0x001E0000)
#define HDMI_APLLCR0_dpll_bpn_mask                                    (0x00010000)
#define HDMI_APLLCR0_dpll_o_mask                                      (0x0000C000)
#define HDMI_APLLCR0_dpll_n_mask                                      (0x000001C0)
#define HDMI_APLLCR0_dpll_rs_mask                                     (0x00000038)
#define HDMI_APLLCR0_dpll_ip_mask                                     (0x00000007)
#define HDMI_APLLCR0_dpll_reg(data)                                   (0xC0000000&((data)<<30))
#define HDMI_APLLCR0_dpll_m(data)                                     (0x3FC00000&((data)<<22))
#define HDMI_APLLCR0_dpll_reser(data)                                 (0x001E0000&((data)<<17))
#define HDMI_APLLCR0_dpll_bpn(data)                                   (0x00010000&((data)<<16))
#define HDMI_APLLCR0_dpll_o(data)                                     (0x0000C000&((data)<<14))
#define HDMI_APLLCR0_dpll_n(data)                                     (0x000001C0&((data)<<6))
#define HDMI_APLLCR0_dpll_rs(data)                                    (0x00000038&((data)<<3))
#define HDMI_APLLCR0_dpll_ip(data)                                    (0x00000007&(data))
#define HDMI_APLLCR0_get_dpll_reg(data)                               ((0xC0000000&(data))>>30)
#define HDMI_APLLCR0_get_dpll_m(data)                                 ((0x3FC00000&(data))>>22)
#define HDMI_APLLCR0_get_dpll_reser(data)                             ((0x001E0000&(data))>>17)
#define HDMI_APLLCR0_get_dpll_bpn(data)                               ((0x00010000&(data))>>16)
#define HDMI_APLLCR0_get_dpll_o(data)                                 ((0x0000C000&(data))>>14)
#define HDMI_APLLCR0_get_dpll_n(data)                                 ((0x000001C0&(data))>>6)
#define HDMI_APLLCR0_get_dpll_rs(data)                                ((0x00000038&(data))>>3)
#define HDMI_APLLCR0_get_dpll_ip(data)                                (0x00000007&(data))

#define HDMI_AAPNR_cmvtc_shift                                        (7)
#define HDMI_AAPNR_cmvbc_shift                                        (6)
#define HDMI_AAPNR_ssdmou_shift                                       (5)
#define HDMI_AAPNR_tef_shift                                          (4)
#define HDMI_AAPNR_w1c5_shift                                         (3)
#define HDMI_AAPNR_pem_shift                                          (2)
#define HDMI_AAPNR_esdm_shift                                         (1)
#define HDMI_AAPNR_dummy1800d350_0_shift                              (0)
#define HDMI_AAPNR_cmvtc_mask                                         (0x00000080)
#define HDMI_AAPNR_cmvbc_mask                                         (0x00000040)
#define HDMI_AAPNR_ssdmou_mask                                        (0x00000020)
#define HDMI_AAPNR_tef_mask                                           (0x00000010)
#define HDMI_AAPNR_w1c5_mask                                          (0x00000008)
#define HDMI_AAPNR_pem_mask                                           (0x00000004)
#define HDMI_AAPNR_esdm_mask                                          (0x00000002)
#define HDMI_AAPNR_dummy1800d350_0_mask                               (0x00000001)
#define HDMI_AAPNR_cmvtc(data)                                        (0x00000080&((data)<<7))
#define HDMI_AAPNR_cmvbc(data)                                        (0x00000040&((data)<<6))
#define HDMI_AAPNR_ssdmou(data)                                       (0x00000020&((data)<<5))
#define HDMI_AAPNR_tef(data)                                          (0x00000010&((data)<<4))
#define HDMI_AAPNR_w1c5(data)                                         (0x00000008&((data)<<3))
#define HDMI_AAPNR_pem(data)                                          (0x00000004&((data)<<2))
#define HDMI_AAPNR_esdm(data)                                         (0x00000002&((data)<<1))
#define HDMI_AAPNR_dummy1800d350_0(data)                              (0x00000001&(data))
#define HDMI_AAPNR_get_cmvtc(data)                                    ((0x00000080&(data))>>7)
#define HDMI_AAPNR_get_cmvbc(data)                                    ((0x00000040&(data))>>6)
#define HDMI_AAPNR_get_ssdmou(data)                                   ((0x00000020&(data))>>5)
#define HDMI_AAPNR_get_tef(data)                                      ((0x00000010&(data))>>4)
#define HDMI_AAPNR_get_w1c5(data)                                     ((0x00000008&(data))>>3)
#define HDMI_AAPNR_get_pem(data)                                      ((0x00000004&(data))>>2)
#define HDMI_AAPNR_get_esdm(data)                                     ((0x00000002&(data))>>1)
#define HDMI_AAPNR_get_dummy1800d350_0(data)                          (0x00000001&(data))

#define HDMI_NPECR_ncts_disable_pe_check_en_shift                     (31)
#define HDMI_NPECR_ncts_re_enable_off_en_shift                        (30)
#define HDMI_NPECR_ncts_disable_pe_check_status_shift                 (29)
#define HDMI_NPECR_ncts_disable_pe_check_irq_en_shift                 (28)
#define HDMI_NPECR_dummy1800d360_27_20_shift                          (20)
#define HDMI_NPECR_ncts_disable_pe_check_cnt_shift                    (0)
#define HDMI_NPECR_ncts_disable_pe_check_en_mask                      (0x80000000)
#define HDMI_NPECR_ncts_re_enable_off_en_mask                         (0x40000000)
#define HDMI_NPECR_ncts_disable_pe_check_status_mask                  (0x20000000)
#define HDMI_NPECR_ncts_disable_pe_check_irq_en_mask                  (0x10000000)
#define HDMI_NPECR_dummy1800d360_27_20_mask                           (0x0FF00000)
#define HDMI_NPECR_ncts_disable_pe_check_cnt_mask                     (0x000FFFFF)
#define HDMI_NPECR_ncts_disable_pe_check_en(data)                     (0x80000000&((data)<<31))
#define HDMI_NPECR_ncts_re_enable_off_en(data)                        (0x40000000&((data)<<30))
#define HDMI_NPECR_ncts_disable_pe_check_status(data)                 (0x20000000&((data)<<29))
#define HDMI_NPECR_ncts_disable_pe_check_irq_en(data)                 (0x10000000&((data)<<28))
#define HDMI_NPECR_dummy1800d360_27_20(data)                          (0x0FF00000&((data)<<20))
#define HDMI_NPECR_ncts_disable_pe_check_cnt(data)                    (0x000FFFFF&(data))
#define HDMI_NPECR_get_ncts_disable_pe_check_en(data)                 ((0x80000000&(data))>>31)
#define HDMI_NPECR_get_ncts_re_enable_off_en(data)                    ((0x40000000&(data))>>30)
#define HDMI_NPECR_get_ncts_disable_pe_check_status(data)             ((0x20000000&(data))>>29)
#define HDMI_NPECR_get_ncts_disable_pe_check_irq_en(data)             ((0x10000000&(data))>>28)
#define HDMI_NPECR_get_dummy1800d360_27_20(data)                      ((0x0FF00000&(data))>>20)
#define HDMI_NPECR_get_ncts_disable_pe_check_cnt(data)                (0x000FFFFF&(data))

#define HDMI_PSCR_fdint_shift                                         (5)
#define HDMI_PSCR_etcn_shift                                          (4)
#define HDMI_PSCR_etfd_shift                                          (3)
#define HDMI_PSCR_etfbc_shift                                         (2)
#define HDMI_PSCR_pecs_shift                                          (0)
#define HDMI_PSCR_fdint_mask                                          (0x000000E0)
#define HDMI_PSCR_etcn_mask                                           (0x00000010)
#define HDMI_PSCR_etfd_mask                                           (0x00000008)
#define HDMI_PSCR_etfbc_mask                                          (0x00000004)
#define HDMI_PSCR_pecs_mask                                           (0x00000003)
#define HDMI_PSCR_fdint(data)                                         (0x000000E0&((data)<<5))
#define HDMI_PSCR_etcn(data)                                          (0x00000010&((data)<<4))
#define HDMI_PSCR_etfd(data)                                          (0x00000008&((data)<<3))
#define HDMI_PSCR_etfbc(data)                                         (0x00000004&((data)<<2))
#define HDMI_PSCR_pecs(data)                                          (0x00000003&(data))
#define HDMI_PSCR_get_fdint(data)                                     ((0x000000E0&(data))>>5)
#define HDMI_PSCR_get_etcn(data)                                      ((0x00000010&(data))>>4)
#define HDMI_PSCR_get_etfd(data)                                      ((0x00000008&(data))>>3)
#define HDMI_PSCR_get_etfbc(data)                                     ((0x00000004&(data))>>2)
#define HDMI_PSCR_get_pecs(data)                                      (0x00000003&(data))

#define HDMI_ICPSNCR0_ich_shift                                       (8)
#define HDMI_ICPSNCR0_icl_shift                                       (0)
#define HDMI_ICPSNCR0_ich_mask                                        (0x0000FF00)
#define HDMI_ICPSNCR0_icl_mask                                        (0x000000FF)
#define HDMI_ICPSNCR0_ich(data)                                       (0x0000FF00&((data)<<8))
#define HDMI_ICPSNCR0_icl(data)                                       (0x000000FF&(data))
#define HDMI_ICPSNCR0_get_ich(data)                                   ((0x0000FF00&(data))>>8)
#define HDMI_ICPSNCR0_get_icl(data)                                   (0x000000FF&(data))

#define HDMI_PCPSNCR0_pch_shift                                       (8)
#define HDMI_PCPSNCR0_pcl_shift                                       (0)
#define HDMI_PCPSNCR0_pch_mask                                        (0x0000FF00)
#define HDMI_PCPSNCR0_pcl_mask                                        (0x000000FF)
#define HDMI_PCPSNCR0_pch(data)                                       (0x0000FF00&((data)<<8))
#define HDMI_PCPSNCR0_pcl(data)                                       (0x000000FF&(data))
#define HDMI_PCPSNCR0_get_pch(data)                                   ((0x0000FF00&(data))>>8)
#define HDMI_PCPSNCR0_get_pcl(data)                                   (0x000000FF&(data))

#define AUDIO_CTS_UP_BOUND_cts_over_flag_shift                        (31)
#define AUDIO_CTS_UP_BOUND_cts_clip_en_shift                          (20)
#define AUDIO_CTS_UP_BOUND_cts_up_bound_shift                         (0)
#define AUDIO_CTS_UP_BOUND_cts_over_flag_mask                         (0x80000000)
#define AUDIO_CTS_UP_BOUND_cts_clip_en_mask                           (0x00100000)
#define AUDIO_CTS_UP_BOUND_cts_up_bound_mask                          (0x000FFFFF)
#define AUDIO_CTS_UP_BOUND_cts_over_flag(data)                        (0x80000000&((data)<<31))
#define AUDIO_CTS_UP_BOUND_cts_clip_en(data)                          (0x00100000&((data)<<20))
#define AUDIO_CTS_UP_BOUND_cts_up_bound(data)                         (0x000FFFFF&(data))
#define AUDIO_CTS_UP_BOUND_get_cts_over_flag(data)                    ((0x80000000&(data))>>31)
#define AUDIO_CTS_UP_BOUND_get_cts_clip_en(data)                      ((0x00100000&(data))>>20)
#define AUDIO_CTS_UP_BOUND_get_cts_up_bound(data)                     (0x000FFFFF&(data))

#define TMDS_CPS_pll_div2_en_shift                                    (9)
#define TMDS_CPS_no_clk_in_shift                                      (8)
#define TMDS_CPS_clkv_meas_sel_shift                                  (6)
#define TMDS_CPS_de_inv_disable_shift                                 (5)
#define TMDS_CPS_de_err_pulse_en_shift                                (4)
#define TMDS_CPS_clr_infoframe_dvi_shift                              (3)
#define TMDS_CPS_auto_dvi2hdmi_shift                                  (2)
#define TMDS_CPS_dummy1800d024_1_0_shift                              (0)
#define TMDS_CPS_pll_div2_en_mask                                     (0x00000200)
#define TMDS_CPS_no_clk_in_mask                                       (0x00000100)
#define TMDS_CPS_clkv_meas_sel_mask                                   (0x000000C0)
#define TMDS_CPS_de_inv_disable_mask                                  (0x00000020)
#define TMDS_CPS_de_err_pulse_en_mask                                 (0x00000010)
#define TMDS_CPS_clr_infoframe_dvi_mask                               (0x00000008)
#define TMDS_CPS_auto_dvi2hdmi_mask                                   (0x00000004)
#define TMDS_CPS_dummy1800d024_1_0_mask                               (0x00000003)
#define TMDS_CPS_pll_div2_en(data)                                    (0x00000200&((data)<<9))
#define TMDS_CPS_no_clk_in(data)                                      (0x00000100&((data)<<8))
#define TMDS_CPS_clkv_meas_sel(data)                                  (0x000000C0&((data)<<6))
#define TMDS_CPS_de_inv_disable(data)                                 (0x00000020&((data)<<5))
#define TMDS_CPS_de_err_pulse_en(data)                                (0x00000010&((data)<<4))
#define TMDS_CPS_clr_infoframe_dvi(data)                              (0x00000008&((data)<<3))
#define TMDS_CPS_auto_dvi2hdmi(data)                                  (0x00000004&((data)<<2))
#define TMDS_CPS_dummy1800d024_1_0(data)                              (0x00000003&(data))
#define TMDS_CPS_get_pll_div2_en(data)                                ((0x00000200&(data))>>9)
#define TMDS_CPS_get_no_clk_in(data)                                  ((0x00000100&(data))>>8)
#define TMDS_CPS_get_clkv_meas_sel(data)                              ((0x000000C0&(data))>>6)
#define TMDS_CPS_get_de_inv_disable(data)                             ((0x00000020&(data))>>5)
#define TMDS_CPS_get_de_err_pulse_en(data)                            ((0x00000010&(data))>>4)
#define TMDS_CPS_get_clr_infoframe_dvi(data)                          ((0x00000008&(data))>>3)
#define TMDS_CPS_get_auto_dvi2hdmi(data)                              ((0x00000004&(data))>>2)
#define TMDS_CPS_get_dummy1800d024_1_0(data)                          (0x00000003&(data))

#define TMDS_DPC_SET0_dpc_bypass_dis_shift                            (8)
#define TMDS_DPC_SET0_dpc_en_shift                                    (7)
#define TMDS_DPC_SET0_phase_errcnt_in_shift                           (4)
#define TMDS_DPC_SET0_phase_clrcnt_in_shift                           (1)
#define TMDS_DPC_SET0_phase_clr_sel_shift                             (0)
#define TMDS_DPC_SET0_dpc_bypass_dis_mask                             (0x00000100)
#define TMDS_DPC_SET0_dpc_en_mask                                     (0x00000080)
#define TMDS_DPC_SET0_phase_errcnt_in_mask                            (0x00000070)
#define TMDS_DPC_SET0_phase_clrcnt_in_mask                            (0x0000000E)
#define TMDS_DPC_SET0_phase_clr_sel_mask                              (0x00000001)
#define TMDS_DPC_SET0_dpc_bypass_dis(data)                            (0x00000100&((data)<<8))
#define TMDS_DPC_SET0_dpc_en(data)                                    (0x00000080&((data)<<7))
#define TMDS_DPC_SET0_phase_errcnt_in(data)                           (0x00000070&((data)<<4))
#define TMDS_DPC_SET0_phase_clrcnt_in(data)                           (0x0000000E&((data)<<1))
#define TMDS_DPC_SET0_phase_clr_sel(data)                             (0x00000001&(data))
#define TMDS_DPC_SET0_get_dpc_bypass_dis(data)                        ((0x00000100&(data))>>8)
#define TMDS_DPC_SET0_get_dpc_en(data)                                ((0x00000080&(data))>>7)
#define TMDS_DPC_SET0_get_phase_errcnt_in(data)                       ((0x00000070&(data))>>4)
#define TMDS_DPC_SET0_get_phase_clrcnt_in(data)                       ((0x0000000E&(data))>>1)
#define TMDS_DPC_SET0_get_phase_clr_sel(data)                         (0x00000001&(data))

#define HDMI_VPLLCR0_dpll_reg_shift                                   (30)
#define HDMI_VPLLCR0_dpll_m_shift                                     (22)
#define HDMI_VPLLCR0_dpll_reser_shift                                 (17)
#define HDMI_VPLLCR0_dpll_bpn_shift                                   (16)
#define HDMI_VPLLCR0_dpll_o_shift                                     (14)
#define HDMI_VPLLCR0_dpll_n_shift                                     (6)
#define HDMI_VPLLCR0_dpll_rs_shift                                    (3)
#define HDMI_VPLLCR0_dpll_ip_shift                                    (0)
#define HDMI_VPLLCR0_dpll_reg_mask                                    (0xC0000000)
#define HDMI_VPLLCR0_dpll_m_mask                                      (0x3FC00000)
#define HDMI_VPLLCR0_dpll_reser_mask                                  (0x001E0000)
#define HDMI_VPLLCR0_dpll_bpn_mask                                    (0x00010000)
#define HDMI_VPLLCR0_dpll_o_mask                                      (0x0000C000)
#define HDMI_VPLLCR0_dpll_n_mask                                      (0x000001C0)
#define HDMI_VPLLCR0_dpll_rs_mask                                     (0x00000038)
#define HDMI_VPLLCR0_dpll_ip_mask                                     (0x00000007)
#define HDMI_VPLLCR0_dpll_reg(data)                                   (0xC0000000&((data)<<30))
#define HDMI_VPLLCR0_dpll_m(data)                                     (0x3FC00000&((data)<<22))
#define HDMI_VPLLCR0_dpll_reser(data)                                 (0x001E0000&((data)<<17))
#define HDMI_VPLLCR0_dpll_bpn(data)                                   (0x00010000&((data)<<16))
#define HDMI_VPLLCR0_dpll_o(data)                                     (0x0000C000&((data)<<14))
#define HDMI_VPLLCR0_dpll_n(data)                                     (0x000001C0&((data)<<6))
#define HDMI_VPLLCR0_dpll_rs(data)                                    (0x00000038&((data)<<3))
#define HDMI_VPLLCR0_dpll_ip(data)                                    (0x00000007&(data))
#define HDMI_VPLLCR0_get_dpll_reg(data)                               ((0xC0000000&(data))>>30)
#define HDMI_VPLLCR0_get_dpll_m(data)                                 ((0x3FC00000&(data))>>22)
#define HDMI_VPLLCR0_get_dpll_reser(data)                             ((0x001E0000&(data))>>17)
#define HDMI_VPLLCR0_get_dpll_bpn(data)                               ((0x00010000&(data))>>16)
#define HDMI_VPLLCR0_get_dpll_o(data)                                 ((0x0000C000&(data))>>14)
#define HDMI_VPLLCR0_get_dpll_n(data)                                 ((0x000001C0&(data))>>6)
#define HDMI_VPLLCR0_get_dpll_rs(data)                                ((0x00000038&(data))>>3)
#define HDMI_VPLLCR0_get_dpll_ip(data)                                (0x00000007&(data))

#define TMDS_PWDCTL_ecc_r_shift                                       (31)
#define TMDS_PWDCTL_erip_r_shift                                      (30)
#define TMDS_PWDCTL_egip_r_shift                                      (29)
#define TMDS_PWDCTL_ebip_r_shift                                      (28)
#define TMDS_PWDCTL_dummy1800d01c_27_10_shift                         (10)
#define TMDS_PWDCTL_video_preamble_off_en_shift                       (9)
#define TMDS_PWDCTL_hs_width_sel_shift                                (8)
#define TMDS_PWDCTL_deo_shift                                         (7)
#define TMDS_PWDCTL_brcw_shift                                        (6)
#define TMDS_PWDCTL_pnsw_shift                                        (5)
#define TMDS_PWDCTL_iccaf_shift                                       (4)
#define TMDS_PWDCTL_ecc_shift                                         (3)
#define TMDS_PWDCTL_erip_shift                                        (2)
#define TMDS_PWDCTL_egip_shift                                        (1)
#define TMDS_PWDCTL_ebip_shift                                        (0)
#define TMDS_PWDCTL_ecc_r_mask                                        (0x80000000)
#define TMDS_PWDCTL_erip_r_mask                                       (0x40000000)
#define TMDS_PWDCTL_egip_r_mask                                       (0x20000000)
#define TMDS_PWDCTL_ebip_r_mask                                       (0x10000000)
#define TMDS_PWDCTL_dummy1800d01c_27_10_mask                          (0x0FFFFC00)
#define TMDS_PWDCTL_video_preamble_off_en_mask                        (0x00000200)
#define TMDS_PWDCTL_hs_width_sel_mask                                 (0x00000100)
#define TMDS_PWDCTL_deo_mask                                          (0x00000080)
#define TMDS_PWDCTL_brcw_mask                                         (0x00000040)
#define TMDS_PWDCTL_pnsw_mask                                         (0x00000020)
#define TMDS_PWDCTL_iccaf_mask                                        (0x00000010)
#define TMDS_PWDCTL_ecc_mask                                          (0x00000008)
#define TMDS_PWDCTL_erip_mask                                         (0x00000004)
#define TMDS_PWDCTL_egip_mask                                         (0x00000002)
#define TMDS_PWDCTL_ebip_mask                                         (0x00000001)
#define TMDS_PWDCTL_ecc_r(data)                                       (0x80000000&((data)<<31))
#define TMDS_PWDCTL_erip_r(data)                                      (0x40000000&((data)<<30))
#define TMDS_PWDCTL_egip_r(data)                                      (0x20000000&((data)<<29))
#define TMDS_PWDCTL_ebip_r(data)                                      (0x10000000&((data)<<28))
#define TMDS_PWDCTL_dummy1800d01c_27_10(data)                         (0x0FFFFC00&((data)<<10))
#define TMDS_PWDCTL_video_preamble_off_en(data)                       (0x00000200&((data)<<9))
#define TMDS_PWDCTL_hs_width_sel(data)                                (0x00000100&((data)<<8))
#define TMDS_PWDCTL_deo(data)                                         (0x00000080&((data)<<7))
#define TMDS_PWDCTL_brcw(data)                                        (0x00000040&((data)<<6))
#define TMDS_PWDCTL_pnsw(data)                                        (0x00000020&((data)<<5))
#define TMDS_PWDCTL_iccaf(data)                                       (0x00000010&((data)<<4))
#define TMDS_PWDCTL_ecc(data)                                         (0x00000008&((data)<<3))
#define TMDS_PWDCTL_erip(data)                                        (0x00000004&((data)<<2))
#define TMDS_PWDCTL_egip(data)                                        (0x00000002&((data)<<1))
#define TMDS_PWDCTL_ebip(data)                                        (0x00000001&(data))
#define TMDS_PWDCTL_get_ecc_r(data)                                   ((0x80000000&(data))>>31)
#define TMDS_PWDCTL_get_erip_r(data)                                  ((0x40000000&(data))>>30)
#define TMDS_PWDCTL_get_egip_r(data)                                  ((0x20000000&(data))>>29)
#define TMDS_PWDCTL_get_ebip_r(data)                                  ((0x10000000&(data))>>28)
#define TMDS_PWDCTL_get_dummy1800d01c_27_10(data)                     ((0x0FFFFC00&(data))>>10)
#define TMDS_PWDCTL_get_video_preamble_off_en(data)                   ((0x00000200&(data))>>9)
#define TMDS_PWDCTL_get_hs_width_sel(data)                            ((0x00000100&(data))>>8)
#define TMDS_PWDCTL_get_deo(data)                                     ((0x00000080&(data))>>7)
#define TMDS_PWDCTL_get_brcw(data)                                    ((0x00000040&(data))>>6)
#define TMDS_PWDCTL_get_pnsw(data)                                    ((0x00000020&(data))>>5)
#define TMDS_PWDCTL_get_iccaf(data)                                   ((0x00000010&(data))>>4)
#define TMDS_PWDCTL_get_ecc(data)                                     ((0x00000008&(data))>>3)
#define TMDS_PWDCTL_get_erip(data)                                    ((0x00000004&(data))>>2)
#define TMDS_PWDCTL_get_egip(data)                                    ((0x00000002&(data))>>1)
#define TMDS_PWDCTL_get_ebip(data)                                    (0x00000001&(data))

#define HDMI_SR_avmute_bg_shift                                       (7)
#define HDMI_SR_avmute_shift                                          (6)
#define HDMI_SR_vic_shift                                             (5)
#define HDMI_SR_spdiftype_shift                                       (4)
#define HDMI_SR_pllsts_shift                                          (3)
#define HDMI_SR_afifoof_shift                                         (2)
#define HDMI_SR_afifouf_shift                                         (1)
#define HDMI_SR_mode_shift                                            (0)
#define HDMI_SR_avmute_bg_mask                                        (0x00000080)
#define HDMI_SR_avmute_mask                                           (0x00000040)
#define HDMI_SR_vic_mask                                              (0x00000020)
#define HDMI_SR_spdiftype_mask                                        (0x00000010)
#define HDMI_SR_pllsts_mask                                           (0x00000008)
#define HDMI_SR_afifoof_mask                                          (0x00000004)
#define HDMI_SR_afifouf_mask                                          (0x00000002)
#define HDMI_SR_mode_mask                                             (0x00000001)
#define HDMI_SR_avmute_bg(data)                                       (0x00000080&((data)<<7))
#define HDMI_SR_avmute(data)                                          (0x00000040&((data)<<6))
#define HDMI_SR_vic(data)                                             (0x00000020&((data)<<5))
#define HDMI_SR_spdiftype(data)                                       (0x00000010&((data)<<4))
#define HDMI_SR_pllsts(data)                                          (0x00000008&((data)<<3))
#define HDMI_SR_afifoof(data)                                         (0x00000004&((data)<<2))
#define HDMI_SR_afifouf(data)                                         (0x00000002&((data)<<1))
#define HDMI_SR_mode(data)                                            (0x00000001&(data))
#define HDMI_SR_get_avmute_bg(data)                                   ((0x00000080&(data))>>7)
#define HDMI_SR_get_avmute(data)                                      ((0x00000040&(data))>>6)
#define HDMI_SR_get_vic(data)                                         ((0x00000020&(data))>>5)
#define HDMI_SR_get_spdiftype(data)                                   ((0x00000010&(data))>>4)
#define HDMI_SR_get_pllsts(data)                                      ((0x00000008&(data))>>3)
#define HDMI_SR_get_afifoof(data)                                     ((0x00000004&(data))>>2)
#define HDMI_SR_get_afifouf(data)                                     ((0x00000002&(data))>>1)
#define HDMI_SR_get_mode(data)                                        (0x00000001&(data))

#define TMDS_OUT_CTRL_tmds_bypass_shift                               (7)
#define TMDS_OUT_CTRL_dummy1800d030_6_0_shift                         (0)
#define TMDS_OUT_CTRL_tmds_bypass_mask                                (0x00000080)
#define TMDS_OUT_CTRL_dummy1800d030_6_0_mask                          (0x0000007F)
#define TMDS_OUT_CTRL_tmds_bypass(data)                               (0x00000080&((data)<<7))
#define TMDS_OUT_CTRL_dummy1800d030_6_0(data)                         (0x0000007F&(data))
#define TMDS_OUT_CTRL_get_tmds_bypass(data)                           ((0x00000080&(data))>>7)
#define TMDS_OUT_CTRL_get_dummy1800d030_6_0(data)                     (0x0000007F&(data))

#define HDCP_PCR_i2c_scl_dly_sel_shift                                (24)
#define HDCP_PCR_i2c_sda_dly_sel_shift                                (20)
#define HDCP_PCR_tune_up_down_shift                                   (17)
#define HDCP_PCR_tune_range_shift                                     (10)
#define HDCP_PCR_ddcdbnc_shift                                        (9)
#define HDCP_PCR_dummy1800d20c_8_shift                                (8)
#define HDCP_PCR_dbnc_level_sel_shift                                 (7)
#define HDCP_PCR_km_clk_sel_shift                                     (6)
#define HDCP_PCR_hdcp_vs_sel_shift                                    (5)
#define HDCP_PCR_enc_tog_shift                                        (4)
#define HDCP_PCR_avmute_dis_shift                                     (3)
#define HDCP_PCR_dummy1800d20c_2_1_shift                              (1)
#define HDCP_PCR_apai_shift                                           (0)
#define HDCP_PCR_i2c_scl_dly_sel_mask                                 (0x0F000000)
#define HDCP_PCR_i2c_sda_dly_sel_mask                                 (0x00F00000)
#define HDCP_PCR_tune_up_down_mask                                    (0x00020000)
#define HDCP_PCR_tune_range_mask                                      (0x0001FC00)
#define HDCP_PCR_ddcdbnc_mask                                         (0x00000200)
#define HDCP_PCR_dummy1800d20c_8_mask                                 (0x00000100)
#define HDCP_PCR_dbnc_level_sel_mask                                  (0x00000080)
#define HDCP_PCR_km_clk_sel_mask                                      (0x00000040)
#define HDCP_PCR_hdcp_vs_sel_mask                                     (0x00000020)
#define HDCP_PCR_enc_tog_mask                                         (0x00000010)
#define HDCP_PCR_avmute_dis_mask                                      (0x00000008)
#define HDCP_PCR_dummy1800d20c_2_1_mask                               (0x00000006)
#define HDCP_PCR_apai_mask                                            (0x00000001)
#define HDCP_PCR_i2c_scl_dly_sel(data)                                (0x0F000000&((data)<<24))
#define HDCP_PCR_i2c_sda_dly_sel(data)                                (0x00F00000&((data)<<20))
#define HDCP_PCR_tune_up_down(data)                                   (0x00020000&((data)<<17))
#define HDCP_PCR_tune_range(data)                                     (0x0001FC00&((data)<<10))
#define HDCP_PCR_ddcdbnc(data)                                        (0x00000200&((data)<<9))
#define HDCP_PCR_dummy1800d20c_8(data)                                (0x00000100&((data)<<8))
#define HDCP_PCR_dbnc_level_sel(data)                                 (0x00000080&((data)<<7))
#define HDCP_PCR_km_clk_sel(data)                                     (0x00000040&((data)<<6))
#define HDCP_PCR_hdcp_vs_sel(data)                                    (0x00000020&((data)<<5))
#define HDCP_PCR_enc_tog(data)                                        (0x00000010&((data)<<4))
#define HDCP_PCR_avmute_dis(data)                                     (0x00000008&((data)<<3))
#define HDCP_PCR_dummy1800d20c_2_1(data)                              (0x00000006&((data)<<1))
#define HDCP_PCR_apai(data)                                           (0x00000001&(data))
#define HDCP_PCR_get_i2c_scl_dly_sel(data)                            ((0x0F000000&(data))>>24)
#define HDCP_PCR_get_i2c_sda_dly_sel(data)                            ((0x00F00000&(data))>>20)
#define HDCP_PCR_get_tune_up_down(data)                               ((0x00020000&(data))>>17)
#define HDCP_PCR_get_tune_range(data)                                 ((0x0001FC00&(data))>>10)
#define HDCP_PCR_get_ddcdbnc(data)                                    ((0x00000200&(data))>>9)
#define HDCP_PCR_get_dummy1800d20c_8(data)                            ((0x00000100&(data))>>8)
#define HDCP_PCR_get_dbnc_level_sel(data)                             ((0x00000080&(data))>>7)
#define HDCP_PCR_get_km_clk_sel(data)                                 ((0x00000040&(data))>>6)
#define HDCP_PCR_get_hdcp_vs_sel(data)                                ((0x00000020&(data))>>5)
#define HDCP_PCR_get_enc_tog(data)                                    ((0x00000010&(data))>>4)
#define HDCP_PCR_get_avmute_dis(data)                                 ((0x00000008&(data))>>3)
#define HDCP_PCR_get_dummy1800d20c_2_1(data)                          ((0x00000006&(data))>>1)
#define HDCP_PCR_get_apai(data)                                       (0x00000001&(data))

#define TMDS_Z0CC_hde_shift                                           (0)
#define TMDS_Z0CC_hde_mask                                            (0x00000001)
#define TMDS_Z0CC_hde(data)                                           (0x00000001&(data))
#define TMDS_Z0CC_get_hde(data)                                       (0x00000001&(data))

#define HDMI_GPVS_gmps_v_shift                                        (13)
#define HDMI_GPVS_vsps_v_shift                                        (12)
#define HDMI_GPVS_gmps_shift                                          (11)
#define HDMI_GPVS_vsps_shift                                          (10)
#define HDMI_GPVS_nps_shift                                           (9)
#define HDMI_GPVS_pis_8_shift                                         (8)
#define HDMI_GPVS_pis_7_shift                                         (7)
#define HDMI_GPVS_pis_6_shift                                         (6)
#define HDMI_GPVS_pis_5_shift                                         (5)
#define HDMI_GPVS_pvs_4_shift                                         (4)
#define HDMI_GPVS_pvs_3_shift                                         (3)
#define HDMI_GPVS_pvs_2_shift                                         (2)
#define HDMI_GPVS_pvs_1_shift                                         (1)
#define HDMI_GPVS_pvs_0_shift                                         (0)
#define HDMI_GPVS_gmps_v_mask                                         (0x00002000)
#define HDMI_GPVS_vsps_v_mask                                         (0x00001000)
#define HDMI_GPVS_gmps_mask                                           (0x00000800)
#define HDMI_GPVS_vsps_mask                                           (0x00000400)
#define HDMI_GPVS_nps_mask                                            (0x00000200)
#define HDMI_GPVS_pis_8_mask                                          (0x00000100)
#define HDMI_GPVS_pis_7_mask                                          (0x00000080)
#define HDMI_GPVS_pis_6_mask                                          (0x00000040)
#define HDMI_GPVS_pis_5_mask                                          (0x00000020)
#define HDMI_GPVS_pvs_4_mask                                          (0x00000010)
#define HDMI_GPVS_pvs_3_mask                                          (0x00000008)
#define HDMI_GPVS_pvs_2_mask                                          (0x00000004)
#define HDMI_GPVS_pvs_1_mask                                          (0x00000002)
#define HDMI_GPVS_pvs_0_mask                                          (0x00000001)
#define HDMI_GPVS_gmps_v(data)                                        (0x00002000&((data)<<13))
#define HDMI_GPVS_vsps_v(data)                                        (0x00001000&((data)<<12))
#define HDMI_GPVS_gmps(data)                                          (0x00000800&((data)<<11))
#define HDMI_GPVS_vsps(data)                                          (0x00000400&((data)<<10))
#define HDMI_GPVS_nps(data)                                           (0x00000200&((data)<<9))
#define HDMI_GPVS_pis_8(data)                                         (0x00000100&((data)<<8))
#define HDMI_GPVS_pis_7(data)                                         (0x00000080&((data)<<7))
#define HDMI_GPVS_pis_6(data)                                         (0x00000040&((data)<<6))
#define HDMI_GPVS_pis_5(data)                                         (0x00000020&((data)<<5))
#define HDMI_GPVS_pvs_4(data)                                         (0x00000010&((data)<<4))
#define HDMI_GPVS_pvs_3(data)                                         (0x00000008&((data)<<3))
#define HDMI_GPVS_pvs_2(data)                                         (0x00000004&((data)<<2))
#define HDMI_GPVS_pvs_1(data)                                         (0x00000002&((data)<<1))
#define HDMI_GPVS_pvs_0(data)                                         (0x00000001&(data))
#define HDMI_GPVS_get_gmps_v(data)                                    ((0x00002000&(data))>>13)
#define HDMI_GPVS_get_vsps_v(data)                                    ((0x00001000&(data))>>12)
#define HDMI_GPVS_get_gmps(data)                                      ((0x00000800&(data))>>11)
#define HDMI_GPVS_get_vsps(data)                                      ((0x00000400&(data))>>10)
#define HDMI_GPVS_get_nps(data)                                       ((0x00000200&(data))>>9)
#define HDMI_GPVS_get_pis_8(data)                                     ((0x00000100&(data))>>8)
#define HDMI_GPVS_get_pis_7(data)                                     ((0x00000080&(data))>>7)
#define HDMI_GPVS_get_pis_6(data)                                     ((0x00000040&(data))>>6)
#define HDMI_GPVS_get_pis_5(data)                                     ((0x00000020&(data))>>5)
#define HDMI_GPVS_get_pvs_4(data)                                     ((0x00000010&(data))>>4)
#define HDMI_GPVS_get_pvs_3(data)                                     ((0x00000008&(data))>>3)
#define HDMI_GPVS_get_pvs_2(data)                                     ((0x00000004&(data))>>2)
#define HDMI_GPVS_get_pvs_1(data)                                     ((0x00000002&(data))>>1)
#define HDMI_GPVS_get_pvs_0(data)                                     (0x00000001&(data))

#define HDMI_VIDEO_FORMAT_hvf_shift                                   (8)
#define HDMI_VIDEO_FORMAT_hdmi_vic_shift                              (0)
#define HDMI_VIDEO_FORMAT_hvf_mask                                    (0x00000700)
#define HDMI_VIDEO_FORMAT_hdmi_vic_mask                               (0x000000FF)
#define HDMI_VIDEO_FORMAT_hvf(data)                                   (0x00000700&((data)<<8))
#define HDMI_VIDEO_FORMAT_hdmi_vic(data)                              (0x000000FF&(data))
#define HDMI_VIDEO_FORMAT_get_hvf(data)                               ((0x00000700&(data))>>8)
#define HDMI_VIDEO_FORMAT_get_hdmi_vic(data)                          (0x000000FF&(data))

#define HDMI_3D_FORMAT_3d_ext_data_shift                              (12)
#define HDMI_3D_FORMAT_3d_metadata_type_shift                         (9)
#define HDMI_3D_FORMAT_3d_structure_shift                             (4)
#define HDMI_3D_FORMAT_3d_meta_present_shift                          (3)
#define HDMI_3D_FORMAT_3d_ext_data_mask                               (0x0000F000)
#define HDMI_3D_FORMAT_3d_metadata_type_mask                          (0x00000E00)
#define HDMI_3D_FORMAT_3d_structure_mask                              (0x000000F0)
#define HDMI_3D_FORMAT_3d_meta_present_mask                           (0x00000008)
#define HDMI_3D_FORMAT_3d_ext_data(data)                              (0x0000F000&((data)<<12))
#define HDMI_3D_FORMAT_3d_metadata_type(data)                         (0x00000E00&((data)<<9))
#define HDMI_3D_FORMAT_3d_structure(data)                             (0x000000F0&((data)<<4))
#define HDMI_3D_FORMAT_3d_meta_present(data)                          (0x00000008&((data)<<3))
#define HDMI_3D_FORMAT_get_3d_ext_data(data)                          ((0x0000F000&(data))>>12)
#define HDMI_3D_FORMAT_get_3d_metadata_type(data)                     ((0x00000E00&(data))>>9)
#define HDMI_3D_FORMAT_get_3d_structure(data)                         ((0x000000F0&(data))>>4)
#define HDMI_3D_FORMAT_get_3d_meta_present(data)                      ((0x00000008&(data))>>3)

#define TMDS_DPC0_dpc_pp_valid_shift                                  (9)
#define TMDS_DPC0_dpc_default_ph_shift                                (8)
#define TMDS_DPC0_dpc_pp_shift                                        (4)
#define TMDS_DPC0_dpc_cd_shift                                        (0)
#define TMDS_DPC0_dpc_pp_valid_mask                                   (0x00000200)
#define TMDS_DPC0_dpc_default_ph_mask                                 (0x00000100)
#define TMDS_DPC0_dpc_pp_mask                                         (0x000000F0)
#define TMDS_DPC0_dpc_cd_mask                                         (0x0000000F)
#define TMDS_DPC0_dpc_pp_valid(data)                                  (0x00000200&((data)<<9))
#define TMDS_DPC0_dpc_default_ph(data)                                (0x00000100&((data)<<8))
#define TMDS_DPC0_dpc_pp(data)                                        (0x000000F0&((data)<<4))
#define TMDS_DPC0_dpc_cd(data)                                        (0x0000000F&(data))
#define TMDS_DPC0_get_dpc_pp_valid(data)                              ((0x00000200&(data))>>9)
#define TMDS_DPC0_get_dpc_default_ph(data)                            ((0x00000100&(data))>>8)
#define TMDS_DPC0_get_dpc_pp(data)                                    ((0x000000F0&(data))>>4)
#define TMDS_DPC0_get_dpc_cd(data)                                    (0x0000000F&(data))

#define TMDS_CRCC_crc_done_shift                                      (4)
#define TMDS_CRCC_crc_nonstable_shift                                 (3)
#define TMDS_CRCC_crcts_shift                                         (1)
#define TMDS_CRCC_crcc_shift                                          (0)
#define TMDS_CRCC_crc_done_mask                                       (0x00000010)
#define TMDS_CRCC_crc_nonstable_mask                                  (0x00000008)
#define TMDS_CRCC_crcts_mask                                          (0x00000006)
#define TMDS_CRCC_crcc_mask                                           (0x00000001)
#define TMDS_CRCC_crc_done(data)                                      (0x00000010&((data)<<4))
#define TMDS_CRCC_crc_nonstable(data)                                 (0x00000008&((data)<<3))
#define TMDS_CRCC_crcts(data)                                         (0x00000006&((data)<<1))
#define TMDS_CRCC_crcc(data)                                          (0x00000001&(data))
#define TMDS_CRCC_get_crc_done(data)                                  ((0x00000010&(data))>>4)
#define TMDS_CRCC_get_crc_nonstable(data)                             ((0x00000008&(data))>>3)
#define TMDS_CRCC_get_crcts(data)                                     ((0x00000006&(data))>>1)
#define TMDS_CRCC_get_crcc(data)                                      (0x00000001&(data))

#define TMDS_CTRL_bcd_shift                                           (7)
#define TMDS_CTRL_gcd_shift                                           (6)
#define TMDS_CTRL_rcd_shift                                           (5)
#define TMDS_CTRL_ho_shift                                            (4)
#define TMDS_CTRL_yo_shift                                            (3)
#define TMDS_CTRL_dummy1800d014_2_0_shift                             (0)
#define TMDS_CTRL_bcd_mask                                            (0x00000080)
#define TMDS_CTRL_gcd_mask                                            (0x00000040)
#define TMDS_CTRL_rcd_mask                                            (0x00000020)
#define TMDS_CTRL_ho_mask                                             (0x00000010)
#define TMDS_CTRL_yo_mask                                             (0x00000008)
#define TMDS_CTRL_dummy1800d014_2_0_mask                              (0x00000007)
#define TMDS_CTRL_bcd(data)                                           (0x00000080&((data)<<7))
#define TMDS_CTRL_gcd(data)                                           (0x00000040&((data)<<6))
#define TMDS_CTRL_rcd(data)                                           (0x00000020&((data)<<5))
#define TMDS_CTRL_ho(data)                                            (0x00000010&((data)<<4))
#define TMDS_CTRL_yo(data)                                            (0x00000008&((data)<<3))
#define TMDS_CTRL_dummy1800d014_2_0(data)                             (0x00000007&(data))
#define TMDS_CTRL_get_bcd(data)                                       ((0x00000080&(data))>>7)
#define TMDS_CTRL_get_gcd(data)                                       ((0x00000040&(data))>>6)
#define TMDS_CTRL_get_rcd(data)                                       ((0x00000020&(data))>>5)
#define TMDS_CTRL_get_ho(data)                                        ((0x00000010&(data))>>4)
#define TMDS_CTRL_get_yo(data)                                        ((0x00000008&(data))>>3)
#define TMDS_CTRL_get_dummy1800d014_2_0(data)                         (0x00000007&(data))

#define HDCP_FLAG1_wr_aksv_flag_shift                                 (4)
#define HDCP_FLAG1_rd_ri_flag_shift                                   (3)
#define HDCP_FLAG1_rd_bksv_flag_shift                                 (2)
#define HDCP_FLAG1_dummy1800d210_1_0_shift                            (0)
#define HDCP_FLAG1_wr_aksv_flag_mask                                  (0x00000010)
#define HDCP_FLAG1_rd_ri_flag_mask                                    (0x00000008)
#define HDCP_FLAG1_rd_bksv_flag_mask                                  (0x00000004)
#define HDCP_FLAG1_dummy1800d210_1_0_mask                             (0x00000003)
#define HDCP_FLAG1_wr_aksv_flag(data)                                 (0x00000010&((data)<<4))
#define HDCP_FLAG1_rd_ri_flag(data)                                   (0x00000008&((data)<<3))
#define HDCP_FLAG1_rd_bksv_flag(data)                                 (0x00000004&((data)<<2))
#define HDCP_FLAG1_dummy1800d210_1_0(data)                            (0x00000003&(data))
#define HDCP_FLAG1_get_wr_aksv_flag(data)                             ((0x00000010&(data))>>4)
#define HDCP_FLAG1_get_rd_ri_flag(data)                               ((0x00000008&(data))>>3)
#define HDCP_FLAG1_get_rd_bksv_flag(data)                             ((0x00000004&(data))>>2)
#define HDCP_FLAG1_get_dummy1800d210_1_0(data)                        (0x00000003&(data))

#define HDMI_LEADING_GB_CMP_CTRL_cmp_err_flag_shift                   (30)
#define HDMI_LEADING_GB_CMP_CTRL_cmp_err_wd_en_shift                  (29)
#define HDMI_LEADING_GB_CMP_CTRL_cmp_err_int_en_shift                 (28)
#define HDMI_LEADING_GB_CMP_CTRL_preamble_shift                       (24)
#define HDMI_LEADING_GB_CMP_CTRL_cmp_value_shift                      (8)
#define HDMI_LEADING_GB_CMP_CTRL_dvi_mode_sel_shift                   (4)
#define HDMI_LEADING_GB_CMP_CTRL_channel_sel_shift                    (2)
#define HDMI_LEADING_GB_CMP_CTRL_lgb_cal_conti_shift                  (1)
#define HDMI_LEADING_GB_CMP_CTRL_lgb_cal_en_shift                     (0)
#define HDMI_LEADING_GB_CMP_CTRL_cmp_err_flag_mask                    (0x40000000)
#define HDMI_LEADING_GB_CMP_CTRL_cmp_err_wd_en_mask                   (0x20000000)
#define HDMI_LEADING_GB_CMP_CTRL_cmp_err_int_en_mask                  (0x10000000)
#define HDMI_LEADING_GB_CMP_CTRL_preamble_mask                        (0x0F000000)
#define HDMI_LEADING_GB_CMP_CTRL_cmp_value_mask                       (0x0003FF00)
#define HDMI_LEADING_GB_CMP_CTRL_dvi_mode_sel_mask                    (0x00000010)
#define HDMI_LEADING_GB_CMP_CTRL_channel_sel_mask                     (0x0000000C)
#define HDMI_LEADING_GB_CMP_CTRL_lgb_cal_conti_mask                   (0x00000002)
#define HDMI_LEADING_GB_CMP_CTRL_lgb_cal_en_mask                      (0x00000001)
#define HDMI_LEADING_GB_CMP_CTRL_cmp_err_flag(data)                   (0x40000000&((data)<<30))
#define HDMI_LEADING_GB_CMP_CTRL_cmp_err_wd_en(data)                  (0x20000000&((data)<<29))
#define HDMI_LEADING_GB_CMP_CTRL_cmp_err_int_en(data)                 (0x10000000&((data)<<28))
#define HDMI_LEADING_GB_CMP_CTRL_preamble(data)                       (0x0F000000&((data)<<24))
#define HDMI_LEADING_GB_CMP_CTRL_cmp_value(data)                      (0x0003FF00&((data)<<8))
#define HDMI_LEADING_GB_CMP_CTRL_dvi_mode_sel(data)                   (0x00000010&((data)<<4))
#define HDMI_LEADING_GB_CMP_CTRL_channel_sel(data)                    (0x0000000C&((data)<<2))
#define HDMI_LEADING_GB_CMP_CTRL_lgb_cal_conti(data)                  (0x00000002&((data)<<1))
#define HDMI_LEADING_GB_CMP_CTRL_lgb_cal_en(data)                     (0x00000001&(data))
#define HDMI_LEADING_GB_CMP_CTRL_get_cmp_err_flag(data)               ((0x40000000&(data))>>30)
#define HDMI_LEADING_GB_CMP_CTRL_get_cmp_err_wd_en(data)              ((0x20000000&(data))>>29)
#define HDMI_LEADING_GB_CMP_CTRL_get_cmp_err_int_en(data)             ((0x10000000&(data))>>28)
#define HDMI_LEADING_GB_CMP_CTRL_get_preamble(data)                   ((0x0F000000&(data))>>24)
#define HDMI_LEADING_GB_CMP_CTRL_get_cmp_value(data)                  ((0x0003FF00&(data))>>8)
#define HDMI_LEADING_GB_CMP_CTRL_get_dvi_mode_sel(data)               ((0x00000010&(data))>>4)
#define HDMI_LEADING_GB_CMP_CTRL_get_channel_sel(data)                ((0x0000000C&(data))>>2)
#define HDMI_LEADING_GB_CMP_CTRL_get_lgb_cal_conti(data)              ((0x00000002&(data))>>1)
#define HDMI_LEADING_GB_CMP_CTRL_get_lgb_cal_en(data)                 (0x00000001&(data))

#define HDMI_LEADING_GB_CMP_TIMES_cmp_err_cnt_shift                   (16)
#define HDMI_LEADING_GB_CMP_TIMES_cmp_times_shift                     (0)
#define HDMI_LEADING_GB_CMP_TIMES_cmp_err_cnt_mask                    (0xFFFF0000)
#define HDMI_LEADING_GB_CMP_TIMES_cmp_times_mask                      (0x0000FFFF)
#define HDMI_LEADING_GB_CMP_TIMES_cmp_err_cnt(data)                   (0xFFFF0000&((data)<<16))
#define HDMI_LEADING_GB_CMP_TIMES_cmp_times(data)                     (0x0000FFFF&(data))
#define HDMI_LEADING_GB_CMP_TIMES_get_cmp_err_cnt(data)               ((0xFFFF0000&(data))>>16)
#define HDMI_LEADING_GB_CMP_TIMES_get_cmp_times(data)                 (0x0000FFFF&(data))

#define HDMI_LEADING_GB_CMP_CNT_preamble_cmp_cnt_shift                (16)
#define HDMI_LEADING_GB_CMP_CNT_preamble_cmp_cnt_by_frame_shift       (0)
#define HDMI_LEADING_GB_CMP_CNT_preamble_cmp_cnt_mask                 (0xFFFF0000)
#define HDMI_LEADING_GB_CMP_CNT_preamble_cmp_cnt_by_frame_mask        (0x0000FFFF)
#define HDMI_LEADING_GB_CMP_CNT_preamble_cmp_cnt(data)                (0xFFFF0000&((data)<<16))
#define HDMI_LEADING_GB_CMP_CNT_preamble_cmp_cnt_by_frame(data)       (0x0000FFFF&(data))
#define HDMI_LEADING_GB_CMP_CNT_get_preamble_cmp_cnt(data)            ((0xFFFF0000&(data))>>16)
#define HDMI_LEADING_GB_CMP_CNT_get_preamble_cmp_cnt_by_frame(data)   (0x0000FFFF&(data))

#define MHL_HDMI_MAC_CTRL_pp_mode_output_shift                        (12)
#define MHL_HDMI_MAC_CTRL_packet_mhl_en_shift                         (8)
#define MHL_HDMI_MAC_CTRL_xor_pixel_sel_shift                         (5)
#define MHL_HDMI_MAC_CTRL_cal_pixel_sel_shift                         (4)
#define MHL_HDMI_MAC_CTRL_ch_dec_pp_mode_en_shift                     (0)
#define MHL_HDMI_MAC_CTRL_pp_mode_output_mask                         (0x00001000)
#define MHL_HDMI_MAC_CTRL_packet_mhl_en_mask                          (0x00000100)
#define MHL_HDMI_MAC_CTRL_xor_pixel_sel_mask                          (0x000000E0)
#define MHL_HDMI_MAC_CTRL_cal_pixel_sel_mask                          (0x00000010)
#define MHL_HDMI_MAC_CTRL_ch_dec_pp_mode_en_mask                      (0x00000001)
#define MHL_HDMI_MAC_CTRL_pp_mode_output(data)                        (0x00001000&((data)<<12))
#define MHL_HDMI_MAC_CTRL_packet_mhl_en(data)                         (0x00000100&((data)<<8))
#define MHL_HDMI_MAC_CTRL_xor_pixel_sel(data)                         (0x000000E0&((data)<<5))
#define MHL_HDMI_MAC_CTRL_cal_pixel_sel(data)                         (0x00000010&((data)<<4))
#define MHL_HDMI_MAC_CTRL_ch_dec_pp_mode_en(data)                     (0x00000001&(data))
#define MHL_HDMI_MAC_CTRL_get_pp_mode_output(data)                    ((0x00001000&(data))>>12)
#define MHL_HDMI_MAC_CTRL_get_packet_mhl_en(data)                     ((0x00000100&(data))>>8)
#define MHL_HDMI_MAC_CTRL_get_xor_pixel_sel(data)                     ((0x000000E0&(data))>>5)
#define MHL_HDMI_MAC_CTRL_get_cal_pixel_sel(data)                     ((0x00000010&(data))>>4)
#define MHL_HDMI_MAC_CTRL_get_ch_dec_pp_mode_en(data)                 (0x00000001&(data))

#define TMDS_ERRC_nl_mask                                             (0x00000007)
#define TMDS_ERRC_nl(data)                                            (0x00000007&(data))
#define TMDS_ERRC_get_nl(data)                                        (0x00000007&(data))

#define HDMI_BCHCR_enrwe_mask                                         (0x00000010)
#define HDMI_BCHCR_bche_mask                                          (0x00000008)
#define HDMI_BCHCR_enrwe(data)                                        (0x00000010&((data)<<4))
#define HDMI_BCHCR_bche(data)                                         (0x00000008&((data)<<3))

#define HDMI_SCR_nval_mask                                            (0x0000FF00)
#define HDMI_SCR_dvi_reset_ds_cm_en_mask                              (0x00000020)
#define HDMI_SCR_packet_ignore_mask                                   (0x00000010)
#define HDMI_SCR_mode_mask                                            (0x00000008)
#define HDMI_SCR_msmode_mask                                          (0x00000004)
#define HDMI_SCR_cabs_mask                                            (0x00000002)
#define HDMI_SCR_fcddip_mask                                          (0x00000001)
#define HDMI_SCR_nval(data)                                           (0x0000FF00&((data)<<8))
#define HDMI_SCR_dvi_reset_ds_cm_en(data)                             (0x00000020&((data)<<5))
#define HDMI_SCR_packet_ignore(data)                                  (0x00000010&((data)<<4))
#define HDMI_SCR_mode(data)                                           (0x00000008&((data)<<3))
#define HDMI_SCR_msmode(data)                                         (0x00000004&((data)<<2))
#define HDMI_SCR_cabs(data)                                           (0x00000002&((data)<<1))
#define HDMI_SCR_fcddip(data)                                         (0x00000001&(data))
#define HDMI_SCR_get_nval(data)                                       ((0x0000FF00&(data))>>8)
#define HDMI_SCR_get_dvi_reset_ds_cm_en(data)                         ((0x00000020&(data))>>5)
#define HDMI_SCR_get_packet_ignore(data)                              ((0x00000010&(data))>>4)
#define HDMI_SCR_get_mode(data)                                       ((0x00000008&(data))>>3)
#define HDMI_SCR_get_msmode(data)                                     ((0x00000004&(data))>>2)
#define HDMI_SCR_get_cabs(data)                                       ((0x00000002&(data))>>1)
#define HDMI_SCR_get_fcddip(data)                                     (0x00000001&(data))
#endif
