#ifndef _HDMI_RX_MHL_CBUS_MSC_REG_H
#define  _HDMI_RX_MHL_CBUS_MSC_REG_H
// ===============================================
// HDMI CBSU_MSC(HDMI_RX_MHL_CBUS_MSC)
// HDMI Register Address base 0x1800f260

#define CBUS_MSC_00                                                   0x00
#define CBUS_MSC_00_reg_addr                                          "0x00"
#define CBUS_MSC_00_reg                                               0x00
#define CBUS_MSC_00_inst_addr                                         "0x0098"
#define CBUS_MSC_00_inst                                              0x0098
#define CBUS_MSC_00_mcumsc_en_shift                                   (5)
#define CBUS_MSC_00_msc_wait_arb_shift                                (4)
#define CBUS_MSC_00_ctrl_28_resv_shift                                (0)
#define CBUS_MSC_00_mcumsc_en_mask                                    (0x00000020)
#define CBUS_MSC_00_msc_wait_arb_mask                                 (0x00000010)
#define CBUS_MSC_00_ctrl_28_resv_mask                                 (0x0000000F)
#define CBUS_MSC_00_mcumsc_en(data)                                   (0x00000020&((data)<<5))
#define CBUS_MSC_00_msc_wait_arb(data)                                (0x00000010&((data)<<4))
#define CBUS_MSC_00_ctrl_28_resv(data)                                (0x0000000F&(data))
#define CBUS_MSC_00_get_mcumsc_en(data)                               ((0x00000020&(data))>>5)
#define CBUS_MSC_00_get_msc_wait_arb(data)                            ((0x00000010&(data))>>4)
#define CBUS_MSC_00_get_ctrl_28_resv(data)                            (0x0000000F&(data))


#define CBUS_MSC_01                                                   0x04
#define CBUS_MSC_01_reg_addr                                          "0x04"
#define CBUS_MSC_01_reg                                               0x04
#define CBUS_MSC_01_inst_addr                                         "0x0099"
#define CBUS_MSC_01_inst                                              0x0099
#define CBUS_MSC_01_na_msc_cmd_shift                                  (0)
#define CBUS_MSC_01_na_msc_cmd_mask                                   (0x000000FF)
#define CBUS_MSC_01_na_msc_cmd(data)                                  (0x000000FF&(data))
#define CBUS_MSC_01_get_na_msc_cmd(data)                              (0x000000FF&(data))


#define CBUS_MSC_02                                                   0x08
#define CBUS_MSC_02_reg_addr                                          "0x08"
#define CBUS_MSC_02_reg                                               0x08
#define CBUS_MSC_02_inst_addr                                         "0x009A"
#define CBUS_MSC_02_inst                                              0x009A
#define CBUS_MSC_02_na_msc_offset_shift                               (0)
#define CBUS_MSC_02_na_msc_offset_mask                                (0x000000FF)
#define CBUS_MSC_02_na_msc_offset(data)                               (0x000000FF&(data))
#define CBUS_MSC_02_get_na_msc_offset(data)                           (0x000000FF&(data))


#define CBUS_MSC_03                                                   0x0c
#define CBUS_MSC_03_reg_addr                                          "0x0c"
#define CBUS_MSC_03_reg                                               0x0c
#define CBUS_MSC_03_inst_addr                                         "0x009B"
#define CBUS_MSC_03_inst                                              0x009B
#define CBUS_MSC_03_rx_fifo_full_shift                                (7)
#define CBUS_MSC_03_rx_fifo_empty_shift                               (6)
#define CBUS_MSC_03_rx_fifo_clr_shift                                 (5)
#define CBUS_MSC_03_na_rx_len_shift                                   (0)
#define CBUS_MSC_03_rx_fifo_full_mask                                 (0x00000080)
#define CBUS_MSC_03_rx_fifo_empty_mask                                (0x00000040)
#define CBUS_MSC_03_rx_fifo_clr_mask                                  (0x00000020)
#define CBUS_MSC_03_na_rx_len_mask                                    (0x0000001F)
#define CBUS_MSC_03_rx_fifo_full(data)                                (0x00000080&((data)<<7))
#define CBUS_MSC_03_rx_fifo_empty(data)                               (0x00000040&((data)<<6))
#define CBUS_MSC_03_rx_fifo_clr(data)                                 (0x00000020&((data)<<5))
#define CBUS_MSC_03_na_rx_len(data)                                   (0x0000001F&(data))
#define CBUS_MSC_03_get_rx_fifo_full(data)                            ((0x00000080&(data))>>7)
#define CBUS_MSC_03_get_rx_fifo_empty(data)                           ((0x00000040&(data))>>6)
#define CBUS_MSC_03_get_rx_fifo_clr(data)                             ((0x00000020&(data))>>5)
#define CBUS_MSC_03_get_na_rx_len(data)                               (0x0000001F&(data))


#define CBUS_MSC_04                                                   0x10
#define CBUS_MSC_04_reg_addr                                          "0x10"
#define CBUS_MSC_04_reg                                               0x10
#define CBUS_MSC_04_inst_addr                                         "0x009C"
#define CBUS_MSC_04_inst                                              0x009C
#define CBUS_MSC_04_rx_fifo_data_shift                                (0)
#define CBUS_MSC_04_rx_fifo_data_mask                                 (0x000000FF)
#define CBUS_MSC_04_rx_fifo_data(data)                                (0x000000FF&(data))
#define CBUS_MSC_04_get_rx_fifo_data(data)                            (0x000000FF&(data))


#define CBUS_MSC_05                                                   0x14
#define CBUS_MSC_05_reg_addr                                          "0x14"
#define CBUS_MSC_05_reg                                               0x14
#define CBUS_MSC_05_inst_addr                                         "0x009D"
#define CBUS_MSC_05_inst                                              0x009D
#define CBUS_MSC_05_fwdef_cmd_rev_shift                               (0)
#define CBUS_MSC_05_fwdef_cmd_rev_mask                                (0x000000FF)
#define CBUS_MSC_05_fwdef_cmd_rev(data)                               (0x000000FF&(data))
#define CBUS_MSC_05_get_fwdef_cmd_rev(data)                           (0x000000FF&(data))


#define CBUS_MSC_06                                                   0x18
#define CBUS_MSC_06_reg_addr                                          "0x18"
#define CBUS_MSC_06_reg                                               0x18
#define CBUS_MSC_06_inst_addr                                         "0x009E"
#define CBUS_MSC_06_inst                                              0x009E
#define CBUS_MSC_06_ucp_irq_shift                                     (28)
#define CBUS_MSC_06_ucpk_irq_shift                                    (27)
#define CBUS_MSC_06_ucpe_irq_shift                                    (26)
#define CBUS_MSC_06_dcap_rdy_chg_shift                                (25)
#define CBUS_MSC_06_muted_chg_shift                                   (24)
#define CBUS_MSC_06_path_en_chg_shift                                 (23)
#define CBUS_MSC_06_clk_mode_chg_shift                                (22)
#define CBUS_MSC_06_msge_irq_shift                                    (21)
#define CBUS_MSC_06_rcp_irq_shift                                     (20)
#define CBUS_MSC_06_rcpk_irq_shift                                    (19)
#define CBUS_MSC_06_rcpe_irq_shift                                    (18)
#define CBUS_MSC_06_rap_irq_shift                                     (17)
#define CBUS_MSC_06_rapk_irq_shift                                    (16)
#define CBUS_MSC_06_msg_sub_irq_shift                                 (15)
#define CBUS_MSC_06_wr_stat_irq_shift                                 (14)
#define CBUS_MSC_06_rd_devcap_irq_shift                               (13)
#define CBUS_MSC_06_get_stat_irq_shift                                (12)
#define CBUS_MSC_06_get_id_irq_shift                                  (11)
#define CBUS_MSC_06_get_msg_irq_shift                                 (10)
#define CBUS_MSC_06_sc1_err_irq_shift                                 (9)
#define CBUS_MSC_06_ddc_err_irq_shift                                 (8)
#define CBUS_MSC_06_msc_err_irq_shift                                 (7)
#define CBUS_MSC_06_wr_burst_irq_shift                                (6)
#define CBUS_MSC_06_sc3_err_irq_shift                                 (5)
#define CBUS_MSC_06_fwdef_cmd_irq_shift                               (4)
#define CBUS_MSC_06_allmsc_cmd_irq_shift                              (3)
#define CBUS_MSC_06_abort_res_irq_shift                               (2)
#define CBUS_MSC_06_abort_req_irq_shift                               (1)
#define CBUS_MSC_06_ddc_abort_irq_shift                               (0)
#define CBUS_MSC_06_ucp_irq_mask                                      (0x10000000)
#define CBUS_MSC_06_ucpk_irq_mask                                     (0x08000000)
#define CBUS_MSC_06_ucpe_irq_mask                                     (0x04000000)
#define CBUS_MSC_06_dcap_rdy_chg_mask                                 (0x02000000)
#define CBUS_MSC_06_muted_chg_mask                                    (0x01000000)
#define CBUS_MSC_06_path_en_chg_mask                                  (0x00800000)
#define CBUS_MSC_06_clk_mode_chg_mask                                 (0x00400000)
#define CBUS_MSC_06_msge_irq_mask                                     (0x00200000)
#define CBUS_MSC_06_rcp_irq_mask                                      (0x00100000)
#define CBUS_MSC_06_rcpk_irq_mask                                     (0x00080000)
#define CBUS_MSC_06_rcpe_irq_mask                                     (0x00040000)
#define CBUS_MSC_06_rap_irq_mask                                      (0x00020000)
#define CBUS_MSC_06_rapk_irq_mask                                     (0x00010000)
#define CBUS_MSC_06_msg_sub_irq_mask                                  (0x00008000)
#define CBUS_MSC_06_wr_stat_irq_mask                                  (0x00004000)
#define CBUS_MSC_06_rd_devcap_irq_mask                                (0x00002000)
#define CBUS_MSC_06_get_stat_irq_mask                                 (0x00001000)
#define CBUS_MSC_06_get_id_irq_mask                                   (0x00000800)
#define CBUS_MSC_06_get_msg_irq_mask                                  (0x00000400)
#define CBUS_MSC_06_sc1_err_irq_mask                                  (0x00000200)
#define CBUS_MSC_06_ddc_err_irq_mask                                  (0x00000100)
#define CBUS_MSC_06_msc_err_irq_mask                                  (0x00000080)
#define CBUS_MSC_06_wr_burst_irq_mask                                 (0x00000040)
#define CBUS_MSC_06_sc3_err_irq_mask                                  (0x00000020)
#define CBUS_MSC_06_fwdef_cmd_irq_mask                                (0x00000010)
#define CBUS_MSC_06_allmsc_cmd_irq_mask                               (0x00000008)
#define CBUS_MSC_06_abort_res_irq_mask                                (0x00000004)
#define CBUS_MSC_06_abort_req_irq_mask                                (0x00000002)
#define CBUS_MSC_06_ddc_abort_irq_mask                                (0x00000001)
#define CBUS_MSC_06_ucp_irq(data)                                     (0x10000000&((data)<<28))
#define CBUS_MSC_06_ucpk_irq(data)                                    (0x08000000&((data)<<27))
#define CBUS_MSC_06_ucpe_irq(data)                                    (0x04000000&((data)<<26))
#define CBUS_MSC_06_dcap_rdy_chg(data)                                (0x02000000&((data)<<25))
#define CBUS_MSC_06_muted_chg(data)                                   (0x01000000&((data)<<24))
#define CBUS_MSC_06_path_en_chg(data)                                 (0x00800000&((data)<<23))
#define CBUS_MSC_06_clk_mode_chg(data)                                (0x00400000&((data)<<22))
#define CBUS_MSC_06_msge_irq(data)                                    (0x00200000&((data)<<21))
#define CBUS_MSC_06_rcp_irq(data)                                     (0x00100000&((data)<<20))
#define CBUS_MSC_06_rcpk_irq(data)                                    (0x00080000&((data)<<19))
#define CBUS_MSC_06_rcpe_irq(data)                                    (0x00040000&((data)<<18))
#define CBUS_MSC_06_rap_irq(data)                                     (0x00020000&((data)<<17))
#define CBUS_MSC_06_rapk_irq(data)                                    (0x00010000&((data)<<16))
#define CBUS_MSC_06_msg_sub_irq(data)                                 (0x00008000&((data)<<15))
#define CBUS_MSC_06_wr_stat_irq(data)                                 (0x00004000&((data)<<14))
#define CBUS_MSC_06_rd_devcap_irq(data)                               (0x00002000&((data)<<13))
#define CBUS_MSC_06_get_stat_irq(data)                                (0x00001000&((data)<<12))
#define CBUS_MSC_06_get_id_irq(data)                                  (0x00000800&((data)<<11))
#define CBUS_MSC_06_get_msg_irq(data)                                 (0x00000400&((data)<<10))
#define CBUS_MSC_06_sc1_err_irq(data)                                 (0x00000200&((data)<<9))
#define CBUS_MSC_06_ddc_err_irq(data)                                 (0x00000100&((data)<<8))
#define CBUS_MSC_06_msc_err_irq(data)                                 (0x00000080&((data)<<7))
#define CBUS_MSC_06_wr_burst_irq(data)                                (0x00000040&((data)<<6))
#define CBUS_MSC_06_sc3_err_irq(data)                                 (0x00000020&((data)<<5))
#define CBUS_MSC_06_fwdef_cmd_irq(data)                               (0x00000010&((data)<<4))
#define CBUS_MSC_06_allmsc_cmd_irq(data)                              (0x00000008&((data)<<3))
#define CBUS_MSC_06_abort_res_irq(data)                               (0x00000004&((data)<<2))
#define CBUS_MSC_06_abort_req_irq(data)                               (0x00000002&((data)<<1))
#define CBUS_MSC_06_ddc_abort_irq(data)                               (0x00000001&(data))
#define CBUS_MSC_06_get_ucp_irq(data)                                 ((0x10000000&(data))>>28)
#define CBUS_MSC_06_get_ucpk_irq(data)                                ((0x08000000&(data))>>27)
#define CBUS_MSC_06_get_ucpe_irq(data)                                ((0x04000000&(data))>>26)
#define CBUS_MSC_06_get_dcap_rdy_chg(data)                            ((0x02000000&(data))>>25)
#define CBUS_MSC_06_get_muted_chg(data)                               ((0x01000000&(data))>>24)
#define CBUS_MSC_06_get_path_en_chg(data)                             ((0x00800000&(data))>>23)
#define CBUS_MSC_06_get_clk_mode_chg(data)                            ((0x00400000&(data))>>22)
#define CBUS_MSC_06_get_msge_irq(data)                                ((0x00200000&(data))>>21)
#define CBUS_MSC_06_get_rcp_irq(data)                                 ((0x00100000&(data))>>20)
#define CBUS_MSC_06_get_rcpk_irq(data)                                ((0x00080000&(data))>>19)
#define CBUS_MSC_06_get_rcpe_irq(data)                                ((0x00040000&(data))>>18)
#define CBUS_MSC_06_get_rap_irq(data)                                 ((0x00020000&(data))>>17)
#define CBUS_MSC_06_get_rapk_irq(data)                                ((0x00010000&(data))>>16)
#define CBUS_MSC_06_get_msg_sub_irq(data)                             ((0x00008000&(data))>>15)
#define CBUS_MSC_06_get_wr_stat_irq(data)                             ((0x00004000&(data))>>14)
#define CBUS_MSC_06_get_rd_devcap_irq(data)                           ((0x00002000&(data))>>13)
#define CBUS_MSC_06_get_get_stat_irq(data)                            ((0x00001000&(data))>>12)
#define CBUS_MSC_06_get_get_id_irq(data)                              ((0x00000800&(data))>>11)
#define CBUS_MSC_06_get_get_msg_irq(data)                             ((0x00000400&(data))>>10)
#define CBUS_MSC_06_get_sc1_err_irq(data)                             ((0x00000200&(data))>>9)
#define CBUS_MSC_06_get_ddc_err_irq(data)                             ((0x00000100&(data))>>8)
#define CBUS_MSC_06_get_msc_err_irq(data)                             ((0x00000080&(data))>>7)
#define CBUS_MSC_06_get_wr_burst_irq(data)                            ((0x00000040&(data))>>6)
#define CBUS_MSC_06_get_sc3_err_irq(data)                             ((0x00000020&(data))>>5)
#define CBUS_MSC_06_get_fwdef_cmd_irq(data)                           ((0x00000010&(data))>>4)
#define CBUS_MSC_06_get_allmsc_cmd_irq(data)                          ((0x00000008&(data))>>3)
#define CBUS_MSC_06_get_abort_res_irq(data)                           ((0x00000004&(data))>>2)
#define CBUS_MSC_06_get_abort_req_irq(data)                           ((0x00000002&(data))>>1)
#define CBUS_MSC_06_get_ddc_abort_irq(data)                           (0x00000001&(data))


#define CBUS_MSC_07                                                   0x1c
#define CBUS_MSC_07_reg_addr                                          "0x1c"
#define CBUS_MSC_07_reg                                               0x1c
#define CBUS_MSC_07_inst_addr                                         "0x009F"
#define CBUS_MSC_07_inst                                              0x009F
#define CBUS_MSC_07_ucp_irq_en_shift                                  (28)
#define CBUS_MSC_07_ucpk_irq_en_shift                                 (27)
#define CBUS_MSC_07_ucpe_irq_en_shift                                 (26)
#define CBUS_MSC_07_dcap_rdy_irq_en_shift                             (25)
#define CBUS_MSC_07_muted_chg_irq_en_shift                            (24)
#define CBUS_MSC_07_path_en_irq_en_shift                              (23)
#define CBUS_MSC_07_clk_mode_irq_en_shift                             (22)
#define CBUS_MSC_07_msge_irq_en_shift                                 (21)
#define CBUS_MSC_07_rcp_irq_en_shift                                  (20)
#define CBUS_MSC_07_rcpk_irq_en_shift                                 (19)
#define CBUS_MSC_07_rcpe_irq_en_shift                                 (18)
#define CBUS_MSC_07_rap_irq_en_shift                                  (17)
#define CBUS_MSC_07_rapk_irq_en_shift                                 (16)
#define CBUS_MSC_07_msg_sub_irq_en_shift                              (15)
#define CBUS_MSC_07_wr_stat_irq_en_shift                              (14)
#define CBUS_MSC_07_rd_devcap_irq_en_shift                            (13)
#define CBUS_MSC_07_get_stat_irq_en_shift                             (12)
#define CBUS_MSC_07_get_id_irq_en_shift                               (11)
#define CBUS_MSC_07_get_msg_irq_en_shift                              (10)
#define CBUS_MSC_07_sc1_err_irq_en_shift                              (9)
#define CBUS_MSC_07_ddc_err_irq_en_shift                              (8)
#define CBUS_MSC_07_msc_err_irq_en_shift                              (7)
#define CBUS_MSC_07_wr_burst_irq_en_shift                             (6)
#define CBUS_MSC_07_sc3_err_irq_en_shift                              (5)
#define CBUS_MSC_07_fwdef_cmd_irq_en_shift                            (4)
#define CBUS_MSC_07_allmsc_cmd_irq_en_shift                           (3)
#define CBUS_MSC_07_abort_res_irq_en_shift                            (2)
#define CBUS_MSC_07_abort_req_irq_en_shift                            (1)
#define CBUS_MSC_07_ddc_abort_irq_en_shift                            (0)
#define CBUS_MSC_07_ucp_irq_en_mask                                   (0x10000000)
#define CBUS_MSC_07_ucpk_irq_en_mask                                  (0x08000000)
#define CBUS_MSC_07_ucpe_irq_en_mask                                  (0x04000000)
#define CBUS_MSC_07_dcap_rdy_irq_en_mask                              (0x02000000)
#define CBUS_MSC_07_muted_chg_irq_en_mask                             (0x01000000)
#define CBUS_MSC_07_path_en_irq_en_mask                               (0x00800000)
#define CBUS_MSC_07_clk_mode_irq_en_mask                              (0x00400000)
#define CBUS_MSC_07_msge_irq_en_mask                                  (0x00200000)
#define CBUS_MSC_07_rcp_irq_en_mask                                   (0x00100000)
#define CBUS_MSC_07_rcpk_irq_en_mask                                  (0x00080000)
#define CBUS_MSC_07_rcpe_irq_en_mask                                  (0x00040000)
#define CBUS_MSC_07_rap_irq_en_mask                                   (0x00020000)
#define CBUS_MSC_07_rapk_irq_en_mask                                  (0x00010000)
#define CBUS_MSC_07_msg_sub_irq_en_mask                               (0x00008000)
#define CBUS_MSC_07_wr_stat_irq_en_mask                               (0x00004000)
#define CBUS_MSC_07_rd_devcap_irq_en_mask                             (0x00002000)
#define CBUS_MSC_07_get_stat_irq_en_mask                              (0x00001000)
#define CBUS_MSC_07_get_id_irq_en_mask                                (0x00000800)
#define CBUS_MSC_07_get_msg_irq_en_mask                               (0x00000400)
#define CBUS_MSC_07_sc1_err_irq_en_mask                               (0x00000200)
#define CBUS_MSC_07_ddc_err_irq_en_mask                               (0x00000100)
#define CBUS_MSC_07_msc_err_irq_en_mask                               (0x00000080)
#define CBUS_MSC_07_wr_burst_irq_en_mask                              (0x00000040)
#define CBUS_MSC_07_sc3_err_irq_en_mask                               (0x00000020)
#define CBUS_MSC_07_fwdef_cmd_irq_en_mask                             (0x00000010)
#define CBUS_MSC_07_allmsc_cmd_irq_en_mask                            (0x00000008)
#define CBUS_MSC_07_abort_res_irq_en_mask                             (0x00000004)
#define CBUS_MSC_07_abort_req_irq_en_mask                             (0x00000002)
#define CBUS_MSC_07_ddc_abort_irq_en_mask                             (0x00000001)
#define CBUS_MSC_07_ucp_irq_en(data)                                  (0x10000000&((data)<<28))
#define CBUS_MSC_07_ucpk_irq_en(data)                                 (0x08000000&((data)<<27))
#define CBUS_MSC_07_ucpe_irq_en(data)                                 (0x04000000&((data)<<26))
#define CBUS_MSC_07_dcap_rdy_irq_en(data)                             (0x02000000&((data)<<25))
#define CBUS_MSC_07_muted_chg_irq_en(data)                            (0x01000000&((data)<<24))
#define CBUS_MSC_07_path_en_irq_en(data)                              (0x00800000&((data)<<23))
#define CBUS_MSC_07_clk_mode_irq_en(data)                             (0x00400000&((data)<<22))
#define CBUS_MSC_07_msge_irq_en(data)                                 (0x00200000&((data)<<21))
#define CBUS_MSC_07_rcp_irq_en(data)                                  (0x00100000&((data)<<20))
#define CBUS_MSC_07_rcpk_irq_en(data)                                 (0x00080000&((data)<<19))
#define CBUS_MSC_07_rcpe_irq_en(data)                                 (0x00040000&((data)<<18))
#define CBUS_MSC_07_rap_irq_en(data)                                  (0x00020000&((data)<<17))
#define CBUS_MSC_07_rapk_irq_en(data)                                 (0x00010000&((data)<<16))
#define CBUS_MSC_07_msg_sub_irq_en(data)                              (0x00008000&((data)<<15))
#define CBUS_MSC_07_wr_stat_irq_en(data)                              (0x00004000&((data)<<14))
#define CBUS_MSC_07_rd_devcap_irq_en(data)                            (0x00002000&((data)<<13))
#define CBUS_MSC_07_get_stat_irq_en(data)                             (0x00001000&((data)<<12))
#define CBUS_MSC_07_get_id_irq_en(data)                               (0x00000800&((data)<<11))
#define CBUS_MSC_07_get_msg_irq_en(data)                              (0x00000400&((data)<<10))
#define CBUS_MSC_07_sc1_err_irq_en(data)                              (0x00000200&((data)<<9))
#define CBUS_MSC_07_ddc_err_irq_en(data)                              (0x00000100&((data)<<8))
#define CBUS_MSC_07_msc_err_irq_en(data)                              (0x00000080&((data)<<7))
#define CBUS_MSC_07_wr_burst_irq_en(data)                             (0x00000040&((data)<<6))
#define CBUS_MSC_07_sc3_err_irq_en(data)                              (0x00000020&((data)<<5))
#define CBUS_MSC_07_fwdef_cmd_irq_en(data)                            (0x00000010&((data)<<4))
#define CBUS_MSC_07_allmsc_cmd_irq_en(data)                           (0x00000008&((data)<<3))
#define CBUS_MSC_07_abort_res_irq_en(data)                            (0x00000004&((data)<<2))
#define CBUS_MSC_07_abort_req_irq_en(data)                            (0x00000002&((data)<<1))
#define CBUS_MSC_07_ddc_abort_irq_en(data)                            (0x00000001&(data))
#define CBUS_MSC_07_get_ucp_irq_en(data)                              ((0x10000000&(data))>>28)
#define CBUS_MSC_07_get_ucpk_irq_en(data)                             ((0x08000000&(data))>>27)
#define CBUS_MSC_07_get_ucpe_irq_en(data)                             ((0x04000000&(data))>>26)
#define CBUS_MSC_07_get_dcap_rdy_irq_en(data)                         ((0x02000000&(data))>>25)
#define CBUS_MSC_07_get_muted_chg_irq_en(data)                        ((0x01000000&(data))>>24)
#define CBUS_MSC_07_get_path_en_irq_en(data)                          ((0x00800000&(data))>>23)
#define CBUS_MSC_07_get_clk_mode_irq_en(data)                         ((0x00400000&(data))>>22)
#define CBUS_MSC_07_get_msge_irq_en(data)                             ((0x00200000&(data))>>21)
#define CBUS_MSC_07_get_rcp_irq_en(data)                              ((0x00100000&(data))>>20)
#define CBUS_MSC_07_get_rcpk_irq_en(data)                             ((0x00080000&(data))>>19)
#define CBUS_MSC_07_get_rcpe_irq_en(data)                             ((0x00040000&(data))>>18)
#define CBUS_MSC_07_get_rap_irq_en(data)                              ((0x00020000&(data))>>17)
#define CBUS_MSC_07_get_rapk_irq_en(data)                             ((0x00010000&(data))>>16)
#define CBUS_MSC_07_get_msg_sub_irq_en(data)                          ((0x00008000&(data))>>15)
#define CBUS_MSC_07_get_wr_stat_irq_en(data)                          ((0x00004000&(data))>>14)
#define CBUS_MSC_07_get_rd_devcap_irq_en(data)                        ((0x00002000&(data))>>13)
#define CBUS_MSC_07_get_get_stat_irq_en(data)                         ((0x00001000&(data))>>12)
#define CBUS_MSC_07_get_get_id_irq_en(data)                           ((0x00000800&(data))>>11)
#define CBUS_MSC_07_get_get_msg_irq_en(data)                          ((0x00000400&(data))>>10)
#define CBUS_MSC_07_get_sc1_err_irq_en(data)                          ((0x00000200&(data))>>9)
#define CBUS_MSC_07_get_ddc_err_irq_en(data)                          ((0x00000100&(data))>>8)
#define CBUS_MSC_07_get_msc_err_irq_en(data)                          ((0x00000080&(data))>>7)
#define CBUS_MSC_07_get_wr_burst_irq_en(data)                         ((0x00000040&(data))>>6)
#define CBUS_MSC_07_get_sc3_err_irq_en(data)                          ((0x00000020&(data))>>5)
#define CBUS_MSC_07_get_fwdef_cmd_irq_en(data)                        ((0x00000010&(data))>>4)
#define CBUS_MSC_07_get_allmsc_cmd_irq_en(data)                       ((0x00000008&(data))>>3)
#define CBUS_MSC_07_get_abort_res_irq_en(data)                        ((0x00000004&(data))>>2)
#define CBUS_MSC_07_get_abort_req_irq_en(data)                        ((0x00000002&(data))>>1)
#define CBUS_MSC_07_get_ddc_abort_irq_en(data)                        (0x00000001&(data))


#define CBUS_MSC_08                                                   0x20
#define CBUS_MSC_08_reg_addr                                          "0x20"
#define CBUS_MSC_08_reg                                               0x20
#define CBUS_MSC_08_inst_addr                                         "0x00A0"
#define CBUS_MSC_08_inst                                              0x00A0
#define CBUS_MSC_08_rchg_irq_en_shift                                 (29)
#define CBUS_MSC_08_cbus_3d_req_irq_en_shift                          (28)
#define CBUS_MSC_08_grt_irq_en_shift                                  (27)
#define CBUS_MSC_08_req_irq_en_shift                                  (26)
#define CBUS_MSC_08_dscr_irq_en_shift                                 (25)
#define CBUS_MSC_08_dcap_irq_en_shift                                 (24)
#define CBUS_MSC_08_dchg_bit7_irq_en_shift                            (23)
#define CBUS_MSC_08_dchg_bit6_irq_en_shift                            (22)
#define CBUS_MSC_08_dchg_bit5_irq_en_shift                            (21)
#define CBUS_MSC_08_dchg_bit4_irq_en_shift                            (20)
#define CBUS_MSC_08_dchg_bit3_irq_en_shift                            (19)
#define CBUS_MSC_08_dchg_bit2_irq_en_shift                            (18)
#define CBUS_MSC_08_edid_irq_en_shift                                 (17)
#define CBUS_MSC_08_dchg_bit0_irq_en_shift                            (16)
#define CBUS_MSC_08_chg22_irq_en_shift                                (8)
#define CBUS_MSC_08_chg23_irq_en_shift                                (0)
#define CBUS_MSC_08_rchg_irq_en_mask                                  (0xE0000000)
#define CBUS_MSC_08_cbus_3d_req_irq_en_mask                           (0x10000000)
#define CBUS_MSC_08_grt_irq_en_mask                                   (0x08000000)
#define CBUS_MSC_08_req_irq_en_mask                                   (0x04000000)
#define CBUS_MSC_08_dscr_irq_en_mask                                  (0x02000000)
#define CBUS_MSC_08_dcap_irq_en_mask                                  (0x01000000)
#define CBUS_MSC_08_dchg_bit7_irq_en_mask                             (0x00800000)
#define CBUS_MSC_08_dchg_bit6_irq_en_mask                             (0x00400000)
#define CBUS_MSC_08_dchg_bit5_irq_en_mask                             (0x00200000)
#define CBUS_MSC_08_dchg_bit4_irq_en_mask                             (0x00100000)
#define CBUS_MSC_08_dchg_bit3_irq_en_mask                             (0x00080000)
#define CBUS_MSC_08_dchg_bit2_irq_en_mask                             (0x00040000)
#define CBUS_MSC_08_edid_irq_en_mask                                  (0x00020000)
#define CBUS_MSC_08_dchg_bit0_irq_en_mask                             (0x00010000)
#define CBUS_MSC_08_chg22_irq_en_mask                                 (0x0000FF00)
#define CBUS_MSC_08_chg23_irq_en_mask                                 (0x000000FF)
#define CBUS_MSC_08_rchg_irq_en(data)                                 (0xE0000000&((data)<<29))
#define CBUS_MSC_08_cbus_3d_req_irq_en(data)                          (0x10000000&((data)<<28))
#define CBUS_MSC_08_grt_irq_en(data)                                  (0x08000000&((data)<<27))
#define CBUS_MSC_08_req_irq_en(data)                                  (0x04000000&((data)<<26))
#define CBUS_MSC_08_dscr_irq_en(data)                                 (0x02000000&((data)<<25))
#define CBUS_MSC_08_dcap_irq_en(data)                                 (0x01000000&((data)<<24))
#define CBUS_MSC_08_dchg_bit7_irq_en(data)                            (0x00800000&((data)<<23))
#define CBUS_MSC_08_dchg_bit6_irq_en(data)                            (0x00400000&((data)<<22))
#define CBUS_MSC_08_dchg_bit5_irq_en(data)                            (0x00200000&((data)<<21))
#define CBUS_MSC_08_dchg_bit4_irq_en(data)                            (0x00100000&((data)<<20))
#define CBUS_MSC_08_dchg_bit3_irq_en(data)                            (0x00080000&((data)<<19))
#define CBUS_MSC_08_dchg_bit2_irq_en(data)                            (0x00040000&((data)<<18))
#define CBUS_MSC_08_edid_irq_en(data)                                 (0x00020000&((data)<<17))
#define CBUS_MSC_08_dchg_bit0_irq_en(data)                            (0x00010000&((data)<<16))
#define CBUS_MSC_08_chg22_irq_en(data)                                (0x0000FF00&((data)<<8))
#define CBUS_MSC_08_chg23_irq_en(data)                                (0x000000FF&(data))
#define CBUS_MSC_08_get_rchg_irq_en(data)                             ((0xE0000000&(data))>>29)
#define CBUS_MSC_08_get_cbus_3d_req_irq_en(data)                      ((0x10000000&(data))>>28)
#define CBUS_MSC_08_get_grt_irq_en(data)                              ((0x08000000&(data))>>27)
#define CBUS_MSC_08_get_req_irq_en(data)                              ((0x04000000&(data))>>26)
#define CBUS_MSC_08_get_dscr_irq_en(data)                             ((0x02000000&(data))>>25)
#define CBUS_MSC_08_get_dcap_irq_en(data)                             ((0x01000000&(data))>>24)
#define CBUS_MSC_08_get_dchg_bit7_irq_en(data)                        ((0x00800000&(data))>>23)
#define CBUS_MSC_08_get_dchg_bit6_irq_en(data)                        ((0x00400000&(data))>>22)
#define CBUS_MSC_08_get_dchg_bit5_irq_en(data)                        ((0x00200000&(data))>>21)
#define CBUS_MSC_08_get_dchg_bit4_irq_en(data)                        ((0x00100000&(data))>>20)
#define CBUS_MSC_08_get_dchg_bit3_irq_en(data)                        ((0x00080000&(data))>>19)
#define CBUS_MSC_08_get_dchg_bit2_irq_en(data)                        ((0x00040000&(data))>>18)
#define CBUS_MSC_08_get_edid_irq_en(data)                             ((0x00020000&(data))>>17)
#define CBUS_MSC_08_get_dchg_bit0_irq_en(data)                        ((0x00010000&(data))>>16)
#define CBUS_MSC_08_get_chg22_irq_en(data)                            ((0x0000FF00&(data))>>8)
#define CBUS_MSC_08_get_chg23_irq_en(data)                            (0x000000FF&(data))


#define CBUS_MSC_09                                                   0x24
#define CBUS_MSC_09_reg_addr                                          "0x24"
#define CBUS_MSC_09_reg                                               0x24
#define CBUS_MSC_09_inst_addr                                         "0x00A1"
#define CBUS_MSC_09_inst                                              0x00A1
#define CBUS_MSC_09_chg24_irq_en_shift                                (24)
#define CBUS_MSC_09_chg25_irq_en_shift                                (16)
#define CBUS_MSC_09_chg26_irq_en_shift                                (8)
#define CBUS_MSC_09_chg27_irq_en_shift                                (0)
#define CBUS_MSC_09_chg24_irq_en_mask                                 (0xFF000000)
#define CBUS_MSC_09_chg25_irq_en_mask                                 (0x00FF0000)
#define CBUS_MSC_09_chg26_irq_en_mask                                 (0x0000FF00)
#define CBUS_MSC_09_chg27_irq_en_mask                                 (0x000000FF)
#define CBUS_MSC_09_chg24_irq_en(data)                                (0xFF000000&((data)<<24))
#define CBUS_MSC_09_chg25_irq_en(data)                                (0x00FF0000&((data)<<16))
#define CBUS_MSC_09_chg26_irq_en(data)                                (0x0000FF00&((data)<<8))
#define CBUS_MSC_09_chg27_irq_en(data)                                (0x000000FF&(data))
#define CBUS_MSC_09_get_chg24_irq_en(data)                            ((0xFF000000&(data))>>24)
#define CBUS_MSC_09_get_chg25_irq_en(data)                            ((0x00FF0000&(data))>>16)
#define CBUS_MSC_09_get_chg26_irq_en(data)                            ((0x0000FF00&(data))>>8)
#define CBUS_MSC_09_get_chg27_irq_en(data)                            (0x000000FF&(data))


#define CBUS_MSC_0A                                                   0x28
#define CBUS_MSC_0A_reg_addr                                          "0x28"
#define CBUS_MSC_0A_reg                                               0x28
#define CBUS_MSC_0A_inst_addr                                         "0x00A2"
#define CBUS_MSC_0A_inst                                              0x00A2
#define CBUS_MSC_0A_msc_err_code_shift                                (0)
#define CBUS_MSC_0A_msc_err_code_mask                                 (0x000000FF)
#define CBUS_MSC_0A_msc_err_code(data)                                (0x000000FF&(data))
#define CBUS_MSC_0A_get_msc_err_code(data)                            (0x000000FF&(data))


#define CBUS_MSC_0B                                                   0x2c
#define CBUS_MSC_0B_reg_addr                                          "0x2c"
#define CBUS_MSC_0B_reg                                               0x2c
#define CBUS_MSC_0B_inst_addr                                         "0x00A3"
#define CBUS_MSC_0B_inst                                              0x00A3
#define CBUS_MSC_0B_rcp_reply_abort_shift                             (9)
#define CBUS_MSC_0B_rcp_reply_nack_shift                              (8)
#define CBUS_MSC_0B_vendor_id_shift                                   (0)
#define CBUS_MSC_0B_rcp_reply_abort_mask                              (0x00000200)
#define CBUS_MSC_0B_rcp_reply_nack_mask                               (0x00000100)
#define CBUS_MSC_0B_vendor_id_mask                                    (0x000000FF)
#define CBUS_MSC_0B_rcp_reply_abort(data)                             (0x00000200&((data)<<9))
#define CBUS_MSC_0B_rcp_reply_nack(data)                              (0x00000100&((data)<<8))
#define CBUS_MSC_0B_vendor_id(data)                                   (0x000000FF&(data))
#define CBUS_MSC_0B_get_rcp_reply_abort(data)                         ((0x00000200&(data))>>9)
#define CBUS_MSC_0B_get_rcp_reply_nack(data)                          ((0x00000100&(data))>>8)
#define CBUS_MSC_0B_get_vendor_id(data)                               (0x000000FF&(data))


#define CBUS_MSC_0C                                                   0x30
#define CBUS_MSC_0C_reg_addr                                          "0x30"
#define CBUS_MSC_0C_reg                                               0x30
#define CBUS_MSC_0C_inst_addr                                         "0x00A4"
#define CBUS_MSC_0C_inst                                              0x00A4
#define CBUS_MSC_0C_msg_cmd_shift                                     (0)
#define CBUS_MSC_0C_msg_cmd_mask                                      (0x000000FF)
#define CBUS_MSC_0C_msg_cmd(data)                                     (0x000000FF&(data))
#define CBUS_MSC_0C_get_msg_cmd(data)                                 (0x000000FF&(data))


#define CBUS_MSC_0D                                                   0x34
#define CBUS_MSC_0D_reg_addr                                          "0x34"
#define CBUS_MSC_0D_reg                                               0x34
#define CBUS_MSC_0D_inst_addr                                         "0x00A5"
#define CBUS_MSC_0D_inst                                              0x00A5
#define CBUS_MSC_0D_msg_dat_shift                                     (0)
#define CBUS_MSC_0D_msg_dat_mask                                      (0x000000FF)
#define CBUS_MSC_0D_msg_dat(data)                                     (0x000000FF&(data))
#define CBUS_MSC_0D_get_msg_dat(data)                                 (0x000000FF&(data))


#define CBUS_MSC_0E                                                   0x38
#define CBUS_MSC_0E_reg_addr                                          "0x38"
#define CBUS_MSC_0E_reg                                               0x38
#define CBUS_MSC_0E_inst_addr                                         "0x00A6"
#define CBUS_MSC_0E_inst                                              0x00A6
#define CBUS_MSC_0E_msge_rcv_shift                                    (0)
#define CBUS_MSC_0E_msge_rcv_mask                                     (0x000000FF)
#define CBUS_MSC_0E_msge_rcv(data)                                    (0x000000FF&(data))
#define CBUS_MSC_0E_get_msge_rcv(data)                                (0x000000FF&(data))


#define CBUS_MSC_0F                                                   0x3c
#define CBUS_MSC_0F_reg_addr                                          "0x3c"
#define CBUS_MSC_0F_reg                                               0x3c
#define CBUS_MSC_0F_inst_addr                                         "0x00A7"
#define CBUS_MSC_0F_inst                                              0x00A7
#define CBUS_MSC_0F_rcp_rcv_shift                                     (0)
#define CBUS_MSC_0F_rcp_rcv_mask                                      (0x000000FF)
#define CBUS_MSC_0F_rcp_rcv(data)                                     (0x000000FF&(data))
#define CBUS_MSC_0F_get_rcp_rcv(data)                                 (0x000000FF&(data))


#define CBUS_MSC_10                                                   0x40
#define CBUS_MSC_10_reg_addr                                          "0x40"
#define CBUS_MSC_10_reg                                               0x40
#define CBUS_MSC_10_inst_addr                                         "0x00A8"
#define CBUS_MSC_10_inst                                              0x00A8
#define CBUS_MSC_10_rcpk_rcv_shift                                    (0)
#define CBUS_MSC_10_rcpk_rcv_mask                                     (0x000000FF)
#define CBUS_MSC_10_rcpk_rcv(data)                                    (0x000000FF&(data))
#define CBUS_MSC_10_get_rcpk_rcv(data)                                (0x000000FF&(data))


#define CBUS_MSC_11                                                   0x44
#define CBUS_MSC_11_reg_addr                                          "0x44"
#define CBUS_MSC_11_reg                                               0x44
#define CBUS_MSC_11_inst_addr                                         "0x00A9"
#define CBUS_MSC_11_inst                                              0x00A9
#define CBUS_MSC_11_rcpe_rcv_shift                                    (0)
#define CBUS_MSC_11_rcpe_rcv_mask                                     (0x000000FF)
#define CBUS_MSC_11_rcpe_rcv(data)                                    (0x000000FF&(data))
#define CBUS_MSC_11_get_rcpe_rcv(data)                                (0x000000FF&(data))


#define CBUS_MSC_12                                                   0x48
#define CBUS_MSC_12_reg_addr                                          "0x48"
#define CBUS_MSC_12_reg                                               0x48
#define CBUS_MSC_12_inst_addr                                         "0x00AA"
#define CBUS_MSC_12_inst                                              0x00AA
#define CBUS_MSC_12_rap_rcv_shift                                     (0)
#define CBUS_MSC_12_rap_rcv_mask                                      (0x000000FF)
#define CBUS_MSC_12_rap_rcv(data)                                     (0x000000FF&(data))
#define CBUS_MSC_12_get_rap_rcv(data)                                 (0x000000FF&(data))


#define CBUS_MSC_13                                                   0x4c
#define CBUS_MSC_13_reg_addr                                          "0x4c"
#define CBUS_MSC_13_reg                                               0x4c
#define CBUS_MSC_13_inst_addr                                         "0x00AB"
#define CBUS_MSC_13_inst                                              0x00AB
#define CBUS_MSC_13_rapk_rcv_shift                                    (0)
#define CBUS_MSC_13_rapk_rcv_mask                                     (0x000000FF)
#define CBUS_MSC_13_rapk_rcv(data)                                    (0x000000FF&(data))
#define CBUS_MSC_13_get_rapk_rcv(data)                                (0x000000FF&(data))


#define CBUS_MSC_14                                                   0x50
#define CBUS_MSC_14_reg_addr                                          "0x50"
#define CBUS_MSC_14_reg                                               0x50
#define CBUS_MSC_14_inst_addr                                         "0x00AC"
#define CBUS_MSC_14_inst                                              0x00AC
#define CBUS_MSC_14_burst_timeout_shift                               (5)
#define CBUS_MSC_14_wb_id_chk_shift                                   (4)
#define CBUS_MSC_14_burst_wait_shift                                  (0)
#define CBUS_MSC_14_burst_timeout_mask                                (0x00000020)
#define CBUS_MSC_14_wb_id_chk_mask                                    (0x00000010)
#define CBUS_MSC_14_burst_wait_mask                                   (0x0000000F)
#define CBUS_MSC_14_burst_timeout(data)                               (0x00000020&((data)<<5))
#define CBUS_MSC_14_wb_id_chk(data)                                   (0x00000010&((data)<<4))
#define CBUS_MSC_14_burst_wait(data)                                  (0x0000000F&(data))
#define CBUS_MSC_14_get_burst_timeout(data)                           ((0x00000020&(data))>>5)
#define CBUS_MSC_14_get_wb_id_chk(data)                               ((0x00000010&(data))>>4)
#define CBUS_MSC_14_get_burst_wait(data)                              (0x0000000F&(data))


#define CBUS_MSC_15                                                   0x54
#define CBUS_MSC_15_reg_addr                                          "0x54"
#define CBUS_MSC_15_reg                                               0x54
#define CBUS_MSC_15_inst_addr                                         "0x00AD"
#define CBUS_MSC_15_inst                                              0x00AD
#define CBUS_MSC_15_adop_idh_rcv_shift                                (8)
#define CBUS_MSC_15_adop_idl_rcv_shift                                (0)
#define CBUS_MSC_15_adop_idh_rcv_mask                                 (0x0000FF00)
#define CBUS_MSC_15_adop_idl_rcv_mask                                 (0x000000FF)
#define CBUS_MSC_15_adop_idh_rcv(data)                                (0x0000FF00&((data)<<8))
#define CBUS_MSC_15_adop_idl_rcv(data)                                (0x000000FF&(data))
#define CBUS_MSC_15_get_adop_idh_rcv(data)                            ((0x0000FF00&(data))>>8)
#define CBUS_MSC_15_get_adop_idl_rcv(data)                            (0x000000FF&(data))


#define CBUS_MSC_16                                                   0x58
#define CBUS_MSC_16_reg_addr                                          "0x58"
#define CBUS_MSC_16_reg                                               0x58
#define CBUS_MSC_16_inst_addr                                         "0x00AE"
#define CBUS_MSC_16_inst                                              0x00AE
#define CBUS_MSC_16_auto_handshake_shift                              (29)
#define CBUS_MSC_16_insert_id_shift                                   (28)
#define CBUS_MSC_16_wb_byte_num0_shift                                (22)
#define CBUS_MSC_16_wb_byte_num1_shift                                (16)
#define CBUS_MSC_16_adop_txid_h_shift                                 (8)
#define CBUS_MSC_16_adop_txid_l_shift                                 (0)
#define CBUS_MSC_16_auto_handshake_mask                               (0x20000000)
#define CBUS_MSC_16_insert_id_mask                                    (0x10000000)
#define CBUS_MSC_16_wb_byte_num0_mask                                 (0x0FC00000)
#define CBUS_MSC_16_wb_byte_num1_mask                                 (0x003F0000)
#define CBUS_MSC_16_adop_txid_h_mask                                  (0x0000FF00)
#define CBUS_MSC_16_adop_txid_l_mask                                  (0x000000FF)
#define CBUS_MSC_16_auto_handshake(data)                              (0x20000000&((data)<<29))
#define CBUS_MSC_16_insert_id(data)                                   (0x10000000&((data)<<28))
#define CBUS_MSC_16_wb_byte_num0(data)                                (0x0FC00000&((data)<<22))
#define CBUS_MSC_16_wb_byte_num1(data)                                (0x003F0000&((data)<<16))
#define CBUS_MSC_16_adop_txid_h(data)                                 (0x0000FF00&((data)<<8))
#define CBUS_MSC_16_adop_txid_l(data)                                 (0x000000FF&(data))
#define CBUS_MSC_16_get_auto_handshake(data)                          ((0x20000000&(data))>>29)
#define CBUS_MSC_16_get_insert_id(data)                               ((0x10000000&(data))>>28)
#define CBUS_MSC_16_get_wb_byte_num0(data)                            ((0x0FC00000&(data))>>22)
#define CBUS_MSC_16_get_wb_byte_num1(data)                            ((0x003F0000&(data))>>16)
#define CBUS_MSC_16_get_adop_txid_h(data)                             ((0x0000FF00&(data))>>8)
#define CBUS_MSC_16_get_adop_txid_l(data)                             (0x000000FF&(data))


#define CBUS_MSC_17                                                   0x5c
#define CBUS_MSC_17_reg_addr                                          "0x5c"
#define CBUS_MSC_17_reg                                               0x5c
#define CBUS_MSC_17_inst_addr                                         "0x00AF"
#define CBUS_MSC_17_inst                                              0x00AF
#define CBUS_MSC_17_que_fsm_clr_shift                                 (2)
#define CBUS_MSC_17_sch_fsm_clr_shift                                 (1)
#define CBUS_MSC_17_spi_fsm_clr_shift                                 (0)
#define CBUS_MSC_17_que_fsm_clr_mask                                  (0x00000004)
#define CBUS_MSC_17_sch_fsm_clr_mask                                  (0x00000002)
#define CBUS_MSC_17_spi_fsm_clr_mask                                  (0x00000001)
#define CBUS_MSC_17_que_fsm_clr(data)                                 (0x00000004&((data)<<2))
#define CBUS_MSC_17_sch_fsm_clr(data)                                 (0x00000002&((data)<<1))
#define CBUS_MSC_17_spi_fsm_clr(data)                                 (0x00000001&(data))
#define CBUS_MSC_17_get_que_fsm_clr(data)                             ((0x00000004&(data))>>2)
#define CBUS_MSC_17_get_sch_fsm_clr(data)                             ((0x00000002&(data))>>1)
#define CBUS_MSC_17_get_spi_fsm_clr(data)                             (0x00000001&(data))


#define CBUS_MSC_18                                                   0x60
#define CBUS_MSC_18_reg_addr                                          "0x60"
#define CBUS_MSC_18_reg                                               0x60
#define CBUS_MSC_18_inst_addr                                         "0x00B0"
#define CBUS_MSC_18_inst                                              0x00B0
#define CBUS_MSC_18_que_fsm_shift                                     (8)
#define CBUS_MSC_18_sch_fsm_shift                                     (4)
#define CBUS_MSC_18_spi_fsm_shift                                     (0)
#define CBUS_MSC_18_que_fsm_mask                                      (0x00000F00)
#define CBUS_MSC_18_sch_fsm_mask                                      (0x000000F0)
#define CBUS_MSC_18_spi_fsm_mask                                      (0x0000000F)
#define CBUS_MSC_18_que_fsm(data)                                     (0x00000F00&((data)<<8))
#define CBUS_MSC_18_sch_fsm(data)                                     (0x000000F0&((data)<<4))
#define CBUS_MSC_18_spi_fsm(data)                                     (0x0000000F&(data))
#define CBUS_MSC_18_get_que_fsm(data)                                 ((0x00000F00&(data))>>8)
#define CBUS_MSC_18_get_sch_fsm(data)                                 ((0x000000F0&(data))>>4)
#define CBUS_MSC_18_get_spi_fsm(data)                                 (0x0000000F&(data))


#define CBUS_MSC_19                                                   0x64
#define CBUS_MSC_19_reg_addr                                          "0x64"
#define CBUS_MSC_19_reg                                               0x64
#define CBUS_MSC_19_inst_addr                                         "0x00B1"
#define CBUS_MSC_19_inst                                              0x00B1
#define CBUS_MSC_19_cap_offset_shift                                  (0)
#define CBUS_MSC_19_cap_offset_mask                                   (0x000000FF)
#define CBUS_MSC_19_cap_offset(data)                                  (0x000000FF&(data))
#define CBUS_MSC_19_get_cap_offset(data)                              (0x000000FF&(data))


#define CBUS_MSC_1A                                                   0x68
#define CBUS_MSC_1A_reg_addr                                          "0x68"
#define CBUS_MSC_1A_reg                                               0x68
#define CBUS_MSC_1A_inst_addr                                         "0x00B2"
#define CBUS_MSC_1A_inst                                              0x00B2
#define CBUS_MSC_1A_int_offset_shift                                  (0)
#define CBUS_MSC_1A_int_offset_mask                                   (0x000000FF)
#define CBUS_MSC_1A_int_offset(data)                                  (0x000000FF&(data))
#define CBUS_MSC_1A_get_int_offset(data)                              (0x000000FF&(data))


#define CBUS_MSC_1B                                                   0x6c
#define CBUS_MSC_1B_reg_addr                                          "0x6c"
#define CBUS_MSC_1B_reg                                               0x6c
#define CBUS_MSC_1B_inst_addr                                         "0x00B3"
#define CBUS_MSC_1B_inst                                              0x00B3
#define CBUS_MSC_1B_sta_offset_shift                                  (0)
#define CBUS_MSC_1B_sta_offset_mask                                   (0x000000FF)
#define CBUS_MSC_1B_sta_offset(data)                                  (0x000000FF&(data))
#define CBUS_MSC_1B_get_sta_offset(data)                              (0x000000FF&(data))


#define CBUS_MSC_1C                                                   0x70
#define CBUS_MSC_1C_reg_addr                                          "0x70"
#define CBUS_MSC_1C_reg                                               0x70
#define CBUS_MSC_1C_inst_addr                                         "0x00B4"
#define CBUS_MSC_1C_inst                                              0x00B4
#define CBUS_MSC_1C_scr_offset_shift                                  (0)
#define CBUS_MSC_1C_scr_offset_mask                                   (0x000000FF)
#define CBUS_MSC_1C_scr_offset(data)                                  (0x000000FF&(data))
#define CBUS_MSC_1C_get_scr_offset(data)                              (0x000000FF&(data))


#define CBUS_MSC_1D                                                   0x74
#define CBUS_MSC_1D_reg_addr                                          "0x74"
#define CBUS_MSC_1D_reg                                               0x74
#define CBUS_MSC_1D_inst_addr                                         "0x00B5"
#define CBUS_MSC_1D_inst                                              0x00B5
#define CBUS_MSC_1D_ddc_err_force_shift                               (1)
#define CBUS_MSC_1D_msc_err_force_shift                               (0)
#define CBUS_MSC_1D_ddc_err_force_mask                                (0x00000002)
#define CBUS_MSC_1D_msc_err_force_mask                                (0x00000001)
#define CBUS_MSC_1D_ddc_err_force(data)                               (0x00000002&((data)<<1))
#define CBUS_MSC_1D_msc_err_force(data)                               (0x00000001&(data))
#define CBUS_MSC_1D_get_ddc_err_force(data)                           ((0x00000002&(data))>>1)
#define CBUS_MSC_1D_get_msc_err_force(data)                           (0x00000001&(data))


#define CBUS_MSC_1E                                                   0x78
#define CBUS_MSC_1E_reg_addr                                          "0x78"
#define CBUS_MSC_1E_reg                                               0x78
#define CBUS_MSC_1E_inst_addr                                         "0x00B6"
#define CBUS_MSC_1E_inst                                              0x00B6
#define CBUS_MSC_1E_ddc_err_fw_shift                                  (0)
#define CBUS_MSC_1E_ddc_err_fw_mask                                   (0x000000FF)
#define CBUS_MSC_1E_ddc_err_fw(data)                                  (0x000000FF&(data))
#define CBUS_MSC_1E_get_ddc_err_fw(data)                              (0x000000FF&(data))


#define CBUS_MSC_1F                                                   0x7c
#define CBUS_MSC_1F_reg_addr                                          "0x7c"
#define CBUS_MSC_1F_reg                                               0x7c
#define CBUS_MSC_1F_inst_addr                                         "0x00B7"
#define CBUS_MSC_1F_inst                                              0x00B7
#define CBUS_MSC_1F_msc_err_fw_shift                                  (0)
#define CBUS_MSC_1F_msc_err_fw_mask                                   (0x000000FF)
#define CBUS_MSC_1F_msc_err_fw(data)                                  (0x000000FF&(data))
#define CBUS_MSC_1F_get_msc_err_fw(data)                              (0x000000FF&(data))


#define CBUS_MSC_20                                                   0x80
#define CBUS_MSC_20_reg_addr                                          "0x80"
#define CBUS_MSC_20_reg                                               0x80
#define CBUS_MSC_20_inst_addr                                         "0x00B8"
#define CBUS_MSC_20_inst                                              0x00B8
#define CBUS_MSC_20_ucp_rcv_shift                                     (0)
#define CBUS_MSC_20_ucp_rcv_mask                                      (0x000000FF)
#define CBUS_MSC_20_ucp_rcv(data)                                     (0x000000FF&(data))
#define CBUS_MSC_20_get_ucp_rcv(data)                                 (0x000000FF&(data))


#define CBUS_MSC_21                                                   0x84
#define CBUS_MSC_21_reg_addr                                          "0x84"
#define CBUS_MSC_21_reg                                               0x84
#define CBUS_MSC_21_inst_addr                                         "0x00B9"
#define CBUS_MSC_21_inst                                              0x00B9
#define CBUS_MSC_21_ucpk_rcv_shift                                    (0)
#define CBUS_MSC_21_ucpk_rcv_mask                                     (0x000000FF)
#define CBUS_MSC_21_ucpk_rcv(data)                                    (0x000000FF&(data))
#define CBUS_MSC_21_get_ucpk_rcv(data)                                (0x000000FF&(data))


#define CBUS_MSC_22                                                   0x88
#define CBUS_MSC_22_reg_addr                                          "0x88"
#define CBUS_MSC_22_reg                                               0x88
#define CBUS_MSC_22_inst_addr                                         "0x00BA"
#define CBUS_MSC_22_inst                                              0x00BA
#define CBUS_MSC_22_ucpe_rcv_shift                                    (0)
#define CBUS_MSC_22_ucpe_rcv_mask                                     (0x000000FF)
#define CBUS_MSC_22_ucpe_rcv(data)                                    (0x000000FF&(data))
#define CBUS_MSC_22_get_ucpe_rcv(data)                                (0x000000FF&(data))

#endif // _HDMI_RX_MHL_CBUS_MSC_REG_H
