#ifndef _HDMI_RX_MHL_CBUS_SB_REG_H
#define _HDMI_RX_MHL_CBUS_SB_REG_H

// ===============================================
// HDMI CBSU_STANDBY(HDMI_RX_MHL_CBUS_STANDBY)
// HDMI Register Address base 0x18037400
#define CBUS_STANDBY_00                                               0x000
#define CBUS_STANDBY_00_reg_addr                                      "0x000"
#define CBUS_STANDBY_00_reg                                           0x000
#define CBUS_STANDBY_00_inst_addr                                     "0x02C0"
#define CBUS_STANDBY_00_inst                                          0x02C0
#define CBUS_STANDBY_00_wake_pulse_det_shift                          (3)
#define CBUS_STANDBY_00_dis_pulse_det_shift                           (2)
#define CBUS_STANDBY_00_wake_irq_en_shift                             (1)
#define CBUS_STANDBY_00_dis_irq_en_shift                              (0)
#define CBUS_STANDBY_00_wake_pulse_det_mask                           (0x00000008)
#define CBUS_STANDBY_00_dis_pulse_det_mask                            (0x00000004)
#define CBUS_STANDBY_00_wake_irq_en_mask                              (0x00000002)
#define CBUS_STANDBY_00_dis_irq_en_mask                               (0x00000001)
#define CBUS_STANDBY_00_wake_pulse_det(data)                          (0x00000008&((data)<<3))
#define CBUS_STANDBY_00_dis_pulse_det(data)                           (0x00000004&((data)<<2))
#define CBUS_STANDBY_00_wake_irq_en(data)                             (0x00000002&((data)<<1))
#define CBUS_STANDBY_00_dis_irq_en(data)                              (0x00000001&(data))
#define CBUS_STANDBY_00_get_wake_pulse_det(data)                      ((0x00000008&(data))>>3)
#define CBUS_STANDBY_00_get_dis_pulse_det(data)                       ((0x00000004&(data))>>2)
#define CBUS_STANDBY_00_get_wake_irq_en(data)                         ((0x00000002&(data))>>1)
#define CBUS_STANDBY_00_get_dis_irq_en(data)                          (0x00000001&(data))


#define CBUS_STANDBY_01                                               0x004
#define CBUS_STANDBY_01_reg_addr                                      "0x004"
#define CBUS_STANDBY_01_reg                                           0x004
#define CBUS_STANDBY_01_inst_addr                                     "0x02C1"
#define CBUS_STANDBY_01_inst                                          0x02C1
#define CBUS_STANDBY_01_clk_1m_div_shift                              (10)
#define CBUS_STANDBY_01_clk_1k_div_shift                              (0)
#define CBUS_STANDBY_01_clk_1m_div_mask                               (0x00003C00)
#define CBUS_STANDBY_01_clk_1k_div_mask                               (0x000003FF)
#define CBUS_STANDBY_01_clk_1m_div(data)                              (0x00003C00&((data)<<10))
#define CBUS_STANDBY_01_clk_1k_div(data)                              (0x000003FF&(data))
#define CBUS_STANDBY_01_get_clk_1m_div(data)                          ((0x00003C00&(data))>>10)
#define CBUS_STANDBY_01_get_clk_1k_div(data)                          (0x000003FF&(data))


#define CBUS_STANDBY_02                                               0x008
#define CBUS_STANDBY_02_reg_addr                                      "0x008"
#define CBUS_STANDBY_02_reg                                           0x008
#define CBUS_STANDBY_02_inst_addr                                     "0x02C2"
#define CBUS_STANDBY_02_inst                                          0x02C2
#define CBUS_STANDBY_02_dis_deb_lv_shift                              (5)
#define CBUS_STANDBY_02_deb_lv_shift                                  (2)
#define CBUS_STANDBY_02_disconn_shift                                 (0)
#define CBUS_STANDBY_02_dis_deb_lv_mask                               (0x000000E0)
#define CBUS_STANDBY_02_deb_lv_mask                                   (0x0000001C)
#define CBUS_STANDBY_02_disconn_mask                                  (0x00000003)
#define CBUS_STANDBY_02_dis_deb_lv(data)                              (0x000000E0&((data)<<5))
#define CBUS_STANDBY_02_deb_lv(data)                                  (0x0000001C&((data)<<2))
#define CBUS_STANDBY_02_disconn(data)                                 (0x00000003&(data))
#define CBUS_STANDBY_02_get_dis_deb_lv(data)                          ((0x000000E0&(data))>>5)
#define CBUS_STANDBY_02_get_deb_lv(data)                              ((0x0000001C&(data))>>2)
#define CBUS_STANDBY_02_get_disconn(data)                             (0x00000003&(data))


#define CBUS_STANDBY_04                                               0x010
#define CBUS_STANDBY_04_reg_addr                                      "0x010"
#define CBUS_STANDBY_04_reg                                           0x010
#define CBUS_STANDBY_04_inst_addr                                     "0x02C4"
#define CBUS_STANDBY_04_inst                                          0x02C4
#define CBUS_STANDBY_04_wake_cnt_shift                                (5)
#define CBUS_STANDBY_04_wake_offset_shift                             (2)
#define CBUS_STANDBY_04_cbus_disconn_shift                            (1)
#define CBUS_STANDBY_04_disconn_irq_en_shift                          (0)
#define CBUS_STANDBY_04_wake_cnt_mask                                 (0x000000E0)
#define CBUS_STANDBY_04_wake_offset_mask                              (0x0000001C)
#define CBUS_STANDBY_04_cbus_disconn_mask                             (0x00000002)
#define CBUS_STANDBY_04_disconn_irq_en_mask                           (0x00000001)
#define CBUS_STANDBY_04_wake_cnt(data)                                (0x000000E0&((data)<<5))
#define CBUS_STANDBY_04_wake_offset(data)                             (0x0000001C&((data)<<2))
#define CBUS_STANDBY_04_cbus_disconn(data)                            (0x00000002&((data)<<1))
#define CBUS_STANDBY_04_disconn_irq_en(data)                          (0x00000001&(data))
#define CBUS_STANDBY_04_get_wake_cnt(data)                            ((0x000000E0&(data))>>5)
#define CBUS_STANDBY_04_get_wake_offset(data)                         ((0x0000001C&(data))>>2)
#define CBUS_STANDBY_04_get_cbus_disconn(data)                        ((0x00000002&(data))>>1)
#define CBUS_STANDBY_04_get_disconn_irq_en(data)                      (0x00000001&(data))


#define CBUS_STANDBY_05                                               0x014
#define CBUS_STANDBY_05_reg_addr                                      "0x014"
#define CBUS_STANDBY_05_reg                                           0x014
#define CBUS_STANDBY_05_inst_addr                                     "0x02C5"
#define CBUS_STANDBY_05_inst                                          0x02C5
#define CBUS_STANDBY_05_dis_upper_shift                               (4)
#define CBUS_STANDBY_05_dis_lower_shift                               (1)
#define CBUS_STANDBY_05_wake_eco_en_shift                             (0)
#define CBUS_STANDBY_05_dis_upper_mask                                (0x000000F0)
#define CBUS_STANDBY_05_dis_lower_mask                                (0x0000000E)
#define CBUS_STANDBY_05_wake_eco_en_mask                              (0x00000001)
#define CBUS_STANDBY_05_dis_upper(data)                               (0x000000F0&((data)<<4))
#define CBUS_STANDBY_05_dis_lower(data)                               (0x0000000E&((data)<<1))
#define CBUS_STANDBY_05_wake_eco_en(data)                             (0x00000001&(data))
#define CBUS_STANDBY_05_get_dis_upper(data)                           ((0x000000F0&(data))>>4)
#define CBUS_STANDBY_05_get_dis_lower(data)                           ((0x0000000E&(data))>>1)
#define CBUS_STANDBY_05_get_wake_eco_en(data)                         (0x00000001&(data))


#define CBUS_STANDBY_06                                               0x018
#define CBUS_STANDBY_06_reg_addr                                      "0x018"
#define CBUS_STANDBY_06_reg                                           0x018
#define CBUS_STANDBY_06_inst_addr                                     "0x02C6"
#define CBUS_STANDBY_06_inst                                          0x02C6
#define CBUS_STANDBY_06_wake_num_shift                                (5)
#define CBUS_STANDBY_06_dis_num_shift                                 (0)
#define CBUS_STANDBY_06_wake_num_mask                                 (0x000000E0)
#define CBUS_STANDBY_06_dis_num_mask                                  (0x0000001F)
#define CBUS_STANDBY_06_wake_num(data)                                (0x000000E0&((data)<<5))
#define CBUS_STANDBY_06_dis_num(data)                                 (0x0000001F&(data))
#define CBUS_STANDBY_06_get_wake_num(data)                            ((0x000000E0&(data))>>5)
#define CBUS_STANDBY_06_get_dis_num(data)                             (0x0000001F&(data))


#define CBUS_STANDBY_07                                               0x01c
#define CBUS_STANDBY_07_reg_addr                                      "0x01c"
#define CBUS_STANDBY_07_reg                                           0x01c
#define CBUS_STANDBY_07_inst_addr                                     "0x02C7"
#define CBUS_STANDBY_07_inst                                          0x02C7
#define CBUS_STANDBY_07_cbus_imp_auto_shift                           (7)
#define CBUS_STANDBY_07_bypass_mode_shift                             (6)
#define CBUS_STANDBY_07_sink_fsm_st_shift                             (3)
#define CBUS_STANDBY_07_cbus_100k_en_shift                            (2)
#define CBUS_STANDBY_07_cbus_1k_en_shift                              (1)
#define CBUS_STANDBY_07_cbus_in_sig_shift                             (0)
#define CBUS_STANDBY_07_cbus_imp_auto_mask                            (0x00000080)
#define CBUS_STANDBY_07_bypass_mode_mask                              (0x00000040)
#define CBUS_STANDBY_07_sink_fsm_st_mask                              (0x00000038)
#define CBUS_STANDBY_07_cbus_100k_en_mask                             (0x00000004)
#define CBUS_STANDBY_07_cbus_1k_en_mask                               (0x00000002)
#define CBUS_STANDBY_07_cbus_in_sig_mask                              (0x00000001)
#define CBUS_STANDBY_07_cbus_imp_auto(data)                           (0x00000080&((data)<<7))
#define CBUS_STANDBY_07_bypass_mode(data)                             (0x00000040&((data)<<6))
#define CBUS_STANDBY_07_sink_fsm_st(data)                             (0x00000038&((data)<<3))
#define CBUS_STANDBY_07_cbus_100k_en(data)                            (0x00000004&((data)<<2))
#define CBUS_STANDBY_07_cbus_1k_en(data)                              (0x00000002&((data)<<1))
#define CBUS_STANDBY_07_cbus_in_sig(data)                             (0x00000001&(data))
#define CBUS_STANDBY_07_get_cbus_imp_auto(data)                       ((0x00000080&(data))>>7)
#define CBUS_STANDBY_07_get_bypass_mode(data)                         ((0x00000040&(data))>>6)
#define CBUS_STANDBY_07_get_sink_fsm_st(data)                         ((0x00000038&(data))>>3)
#define CBUS_STANDBY_07_get_cbus_100k_en(data)                        ((0x00000004&(data))>>2)
#define CBUS_STANDBY_07_get_cbus_1k_en(data)                          ((0x00000002&(data))>>1)
#define CBUS_STANDBY_07_get_cbus_in_sig(data)                         (0x00000001&(data))


#define CBUS_STANDBY_08                                               0x020
#define CBUS_STANDBY_08_reg_addr                                      "0x020"
#define CBUS_STANDBY_08_reg                                           0x020
#define CBUS_STANDBY_08_inst_addr                                     "0x02C8"
#define CBUS_STANDBY_08_inst                                          0x02C8
#define CBUS_STANDBY_08_goto_sink1_pos_shift                          (5)
#define CBUS_STANDBY_08_goto_float_shift                              (4)
#define CBUS_STANDBY_08_goto_sink1_shift                              (3)
#define CBUS_STANDBY_08_cable_det_shift                               (2)
#define CBUS_STANDBY_08_cbus_err_shift                                (1)
#define CBUS_STANDBY_08_dbg_sel_phy_shift                             (0)
#define CBUS_STANDBY_08_goto_sink1_pos_mask                           (0x00000020)
#define CBUS_STANDBY_08_goto_float_mask                               (0x00000010)
#define CBUS_STANDBY_08_goto_sink1_mask                               (0x00000008)
#define CBUS_STANDBY_08_cable_det_mask                                (0x00000004)
#define CBUS_STANDBY_08_cbus_err_mask                                 (0x00000002)
#define CBUS_STANDBY_08_dbg_sel_phy_mask                              (0x00000001)
#define CBUS_STANDBY_08_goto_sink1_pos(data)                          (0x00000020&((data)<<5))
#define CBUS_STANDBY_08_goto_float(data)                              (0x00000010&((data)<<4))
#define CBUS_STANDBY_08_goto_sink1(data)                              (0x00000008&((data)<<3))
#define CBUS_STANDBY_08_cable_det(data)                               (0x00000004&((data)<<2))
#define CBUS_STANDBY_08_cbus_err(data)                                (0x00000002&((data)<<1))
#define CBUS_STANDBY_08_dbg_sel_phy(data)                             (0x00000001&(data))
#define CBUS_STANDBY_08_get_goto_sink1_pos(data)                      ((0x00000020&(data))>>5)
#define CBUS_STANDBY_08_get_goto_float(data)                          ((0x00000010&(data))>>4)
#define CBUS_STANDBY_08_get_goto_sink1(data)                          ((0x00000008&(data))>>3)
#define CBUS_STANDBY_08_get_cable_det(data)                           ((0x00000004&(data))>>2)
#define CBUS_STANDBY_08_get_cbus_err(data)                            ((0x00000002&(data))>>1)
#define CBUS_STANDBY_08_get_dbg_sel_phy(data)                         (0x00000001&(data))


#define CBUS_STANDBY_09                                               0x024
#define CBUS_STANDBY_09_reg_addr                                      "0x024"
#define CBUS_STANDBY_09_reg                                           0x024
#define CBUS_STANDBY_09_inst_addr                                     "0x02C9"
#define CBUS_STANDBY_09_inst                                          0x02C9
#define CBUS_STANDBY_09_ctrl_09_resv_shift                            (0)
#define CBUS_STANDBY_09_ctrl_09_resv_mask                             (0xFFFFFFFF)
#define CBUS_STANDBY_09_ctrl_09_resv(data)                            (0xFFFFFFFF&(data))
#define CBUS_STANDBY_09_get_ctrl_09_resv(data)                        (0xFFFFFFFF&(data))


#define CBUS_PHY_0                                                    0x030
#define CBUS_PHY_0_reg_addr                                           "0x030"
#define CBUS_PHY_0_reg                                                0x030
#define CBUS_PHY_0_inst_addr                                          "0x02CC"
#define CBUS_PHY_0_inst                                               0x02CC
#define CBUS_PHY_0_cbus_sr_shift                                      (6)
#define CBUS_PHY_0_cbus_smt_shift                                     (5)
#define CBUS_PHY_0_cbus_pu_shift                                      (4)
#define CBUS_PHY_0_cbus_pd_shift                                      (3)
#define CBUS_PHY_0_cbus_i_shift                                       (2)
#define CBUS_PHY_0_cbus_e2_shift                                      (1)
#define CBUS_PHY_0_cbus_e_shift                                       (0)
#define CBUS_PHY_0_cbus_sr_mask                                       (0x00000040)
#define CBUS_PHY_0_cbus_smt_mask                                      (0x00000020)
#define CBUS_PHY_0_cbus_pu_mask                                       (0x00000010)
#define CBUS_PHY_0_cbus_pd_mask                                       (0x00000008)
#define CBUS_PHY_0_cbus_i_mask                                        (0x00000004)
#define CBUS_PHY_0_cbus_e2_mask                                       (0x00000002)
#define CBUS_PHY_0_cbus_e_mask                                        (0x00000001)
#define CBUS_PHY_0_cbus_sr(data)                                      (0x00000040&((data)<<6))
#define CBUS_PHY_0_cbus_smt(data)                                     (0x00000020&((data)<<5))
#define CBUS_PHY_0_cbus_pu(data)                                      (0x00000010&((data)<<4))
#define CBUS_PHY_0_cbus_pd(data)                                      (0x00000008&((data)<<3))
#define CBUS_PHY_0_cbus_i(data)                                       (0x00000004&((data)<<2))
#define CBUS_PHY_0_cbus_e2(data)                                      (0x00000002&((data)<<1))
#define CBUS_PHY_0_cbus_e(data)                                       (0x00000001&(data))
#define CBUS_PHY_0_get_cbus_sr(data)                                  ((0x00000040&(data))>>6)
#define CBUS_PHY_0_get_cbus_smt(data)                                 ((0x00000020&(data))>>5)
#define CBUS_PHY_0_get_cbus_pu(data)                                  ((0x00000010&(data))>>4)
#define CBUS_PHY_0_get_cbus_pd(data)                                  ((0x00000008&(data))>>3)
#define CBUS_PHY_0_get_cbus_i(data)                                   ((0x00000004&(data))>>2)
#define CBUS_PHY_0_get_cbus_e2(data)                                  ((0x00000002&(data))>>1)
#define CBUS_PHY_0_get_cbus_e(data)                                   (0x00000001&(data))


#define CBUS_PHY_1                                                    0x034
#define CBUS_PHY_1_reg_addr                                           "0x034"
#define CBUS_PHY_1_reg                                                0x034
#define CBUS_PHY_1_inst_addr                                          "0x02CD"
#define CBUS_PHY_1_inst                                               0x02CD
#define CBUS_PHY_1_adjr_1k_shift                                      (27)
#define CBUS_PHY_1_adjr_100k_shift                                    (23)
#define CBUS_PHY_1_auto_k_1k_shift                                    (22)
#define CBUS_PHY_1_auto_k_100k_shift                                  (21)
#define CBUS_PHY_1_en_res_cal_cbus_shift                              (20)
#define CBUS_PHY_1_sel_cbus0_input_high_shift                         (18)
#define CBUS_PHY_1_sel_cbus0_input_low_shift                          (16)
#define CBUS_PHY_1_sel_cbus_0_driving_shift                           (13)
#define CBUS_PHY_1_sel_vref_ldo_shift                                 (11)
#define CBUS_PHY_1_trim_ldo_cbus_shift                                (7)
#define CBUS_PHY_1_triming_mode_shift                                 (6)
#define CBUS_PHY_1_en_cbus_shift                                      (5)
#define CBUS_PHY_1_en_cmp_cbus_shift                                  (4)
#define CBUS_PHY_1_en_driver_cbus_shift                               (3)
#define CBUS_PHY_1_en_ldo_cbus_shift                                  (2)
#define CBUS_PHY_1_psm_cbus_shift                                     (1)
#define CBUS_PHY_1_sel_cbusb_gpio_shift                               (0)
#define CBUS_PHY_1_adjr_1k_mask                                       (0x78000000)
#define CBUS_PHY_1_adjr_100k_mask                                     (0x07800000)
#define CBUS_PHY_1_auto_k_1k_mask                                     (0x00400000)
#define CBUS_PHY_1_auto_k_100k_mask                                   (0x00200000)
#define CBUS_PHY_1_en_res_cal_cbus_mask                               (0x00100000)
#define CBUS_PHY_1_sel_cbus0_input_high_mask                          (0x000C0000)
#define CBUS_PHY_1_sel_cbus0_input_low_mask                           (0x00030000)
#define CBUS_PHY_1_sel_cbus_0_driving_mask                            (0x0000E000)
#define CBUS_PHY_1_sel_vref_ldo_mask                                  (0x00001800)
#define CBUS_PHY_1_trim_ldo_cbus_mask                                 (0x00000780)
#define CBUS_PHY_1_triming_mode_mask                                  (0x00000040)
#define CBUS_PHY_1_en_cbus_mask                                       (0x00000020)
#define CBUS_PHY_1_en_cmp_cbus_mask                                   (0x00000010)
#define CBUS_PHY_1_en_driver_cbus_mask                                (0x00000008)
#define CBUS_PHY_1_en_ldo_cbus_mask                                   (0x00000004)
#define CBUS_PHY_1_psm_cbus_mask                                      (0x00000002)
#define CBUS_PHY_1_sel_cbusb_gpio_mask                                (0x00000001)
#define CBUS_PHY_1_adjr_1k(data)                                      (0x78000000&((data)<<27))
#define CBUS_PHY_1_adjr_100k(data)                                    (0x07800000&((data)<<23))
#define CBUS_PHY_1_auto_k_1k(data)                                    (0x00400000&((data)<<22))
#define CBUS_PHY_1_auto_k_100k(data)                                  (0x00200000&((data)<<21))
#define CBUS_PHY_1_en_res_cal_cbus(data)                              (0x00100000&((data)<<20))
#define CBUS_PHY_1_sel_cbus0_input_high(data)                         (0x000C0000&((data)<<18))
#define CBUS_PHY_1_sel_cbus0_input_low(data)                          (0x00030000&((data)<<16))
#define CBUS_PHY_1_sel_cbus_0_driving(data)                           (0x0000E000&((data)<<13))
#define CBUS_PHY_1_sel_vref_ldo(data)                                 (0x00001800&((data)<<11))
#define CBUS_PHY_1_trim_ldo_cbus(data)                                (0x00000780&((data)<<7))
#define CBUS_PHY_1_triming_mode(data)                                 (0x00000040&((data)<<6))
#define CBUS_PHY_1_en_cbus(data)                                      (0x00000020&((data)<<5))
#define CBUS_PHY_1_en_cmp_cbus(data)                                  (0x00000010&((data)<<4))
#define CBUS_PHY_1_en_driver_cbus(data)                               (0x00000008&((data)<<3))
#define CBUS_PHY_1_en_ldo_cbus(data)                                  (0x00000004&((data)<<2))
#define CBUS_PHY_1_psm_cbus(data)                                     (0x00000002&((data)<<1))
#define CBUS_PHY_1_sel_cbusb_gpio(data)                               (0x00000001&(data))
#define CBUS_PHY_1_get_adjr_1k(data)                                  ((0x78000000&(data))>>27)
#define CBUS_PHY_1_get_adjr_100k(data)                                ((0x07800000&(data))>>23)
#define CBUS_PHY_1_get_auto_k_1k(data)                                ((0x00400000&(data))>>22)
#define CBUS_PHY_1_get_auto_k_100k(data)                              ((0x00200000&(data))>>21)
#define CBUS_PHY_1_get_en_res_cal_cbus(data)                          ((0x00100000&(data))>>20)
#define CBUS_PHY_1_get_sel_cbus0_input_high(data)                     ((0x000C0000&(data))>>18)
#define CBUS_PHY_1_get_sel_cbus0_input_low(data)                      ((0x00030000&(data))>>16)
#define CBUS_PHY_1_get_sel_cbus_0_driving(data)                       ((0x0000E000&(data))>>13)
#define CBUS_PHY_1_get_sel_vref_ldo(data)                             ((0x00001800&(data))>>11)
#define CBUS_PHY_1_get_trim_ldo_cbus(data)                            ((0x00000780&(data))>>7)
#define CBUS_PHY_1_get_triming_mode(data)                             ((0x00000040&(data))>>6)
#define CBUS_PHY_1_get_en_cbus(data)                                  ((0x00000020&(data))>>5)
#define CBUS_PHY_1_get_en_cmp_cbus(data)                              ((0x00000010&(data))>>4)
#define CBUS_PHY_1_get_en_driver_cbus(data)                           ((0x00000008&(data))>>3)
#define CBUS_PHY_1_get_en_ldo_cbus(data)                              ((0x00000004&(data))>>2)
#define CBUS_PHY_1_get_psm_cbus(data)                                 ((0x00000002&(data))>>1)
#define CBUS_PHY_1_get_sel_cbusb_gpio(data)                           (0x00000001&(data))


#define CBUS_PHY_2                                                    0x038
#define CBUS_PHY_2_reg_addr                                           "0x038"
#define CBUS_PHY_2_reg                                                0x038
#define CBUS_PHY_2_inst_addr                                          "0x02CE"
#define CBUS_PHY_2_inst                                               0x02CE
#define CBUS_PHY_2_cbus_o_shift                                       (0)
#define CBUS_PHY_2_cbus_o_mask                                        (0x00000001)
#define CBUS_PHY_2_cbus_o(data)                                       (0x00000001&(data))
#define CBUS_PHY_2_get_cbus_o(data)                                   (0x00000001&(data))


#define CBUS_PHY_3                                                    0x03c
#define CBUS_PHY_3_reg_addr                                           "0x03c"
#define CBUS_PHY_3_reg                                                0x03c
#define CBUS_PHY_3_inst_addr                                          "0x02CF"
#define CBUS_PHY_3_inst                                               0x02CF
#define CBUS_PHY_3_sel_ldo_trim_efuseb_shift                          (11)
#define CBUS_PHY_3_cbus_res_tst_shift                                 (1)
#define CBUS_PHY_3_res_ok_shift                                       (0)
#define CBUS_PHY_3_sel_ldo_trim_efuseb_mask                           (0x00000800)
#define CBUS_PHY_3_cbus_res_tst_mask                                  (0x000007FE)
#define CBUS_PHY_3_res_ok_mask                                        (0x00000001)
#define CBUS_PHY_3_sel_ldo_trim_efuseb(data)                          (0x00000800&((data)<<11))
#define CBUS_PHY_3_cbus_res_tst(data)                                 (0x000007FE&((data)<<1))
#define CBUS_PHY_3_res_ok(data)                                       (0x00000001&(data))
#define CBUS_PHY_3_get_sel_ldo_trim_efuseb(data)                      ((0x00000800&(data))>>11)
#define CBUS_PHY_3_get_cbus_res_tst(data)                             ((0x000007FE&(data))>>1)
#define CBUS_PHY_3_get_res_ok(data)                                   (0x00000001&(data))

#endif
