#ifndef PHOENIX_HDMI_HW_PHY_H
#define PHOENIX_HDMI_HW_PHY_H

// HDMI PHY
// HDMI Register Address base 0x1800FB00
#define  _Check_HDMI_CRC  _BIT0      

#define HDMIPHY_REG_CK_1_4                                                    0x0000
#define HDMIPHY_REG_CK_5_8                                                    0x0004
#define HDMIPHY_REG_CK_9_12                                                   0x0008
#define HDMIPHY_REG_CK_RESULT                                                 0x000c
#define HDMIPHY_REG_R_1_4                                                     0x0010
#define HDMIPHY_REG_R_5_8                                                     0x0014
#define HDMIPHY_REG_R_9_12                                                    0x0018
#define HDMIPHY_REG_R_RESULT                                                  0x001c
#define HDMIPHY_REG_G_1_4                                                     0x0020
#define HDMIPHY_REG_G_5_8                                                     0x0024
#define HDMIPHY_REG_G_9_12                                                    0x0028
#define HDMIPHY_REG_G_RESULT                                                  0x002c
#define HDMIPHY_REG_B_1_4                                                     0x0030
#define HDMIPHY_REG_B_5_8                                                     0x0034
#define HDMIPHY_REG_B_9_12                                                    0x0038
#define HDMIPHY_REG_B_RESULT                                                  0x003c
#define HDMIPHY_REG_BANDGAP_Z0                                                0x0040
#define HDMIPHY_REG_PHY_CTL                                                   0x0044
#define HDMIPHY_REG_RGB_KOFF_SEL                                              0x0048
#define HDMIPHY_REG_BANDGAP_Z0_CTRL                                           0x004c
#define HDMIPHY_REG_BANDGAP_Z0_CTRL_2               0x0050
#define HDMIPHY_DPLL_CTRL                                           0x006c
#define REG_DIG_R_1                                                   0x00a0
#define REG_DIG_R_2                                                   0x00a4
#define REG_DIG_R_3                                                   0x00a8
#define REG_DIG_R_4                                                   0x00ac
#define REG_DIG_R_5                                                   0x00b0
#define REG_DIG_G_1                                                   0x00b4
#define REG_DIG_G_2                                                   0x00b8
#define REG_DIG_G_3                                                   0x00bc
#define REG_DIG_G_4                                                   0x00c0
#define REG_DIG_G_5                                                   0x00c4
#define REG_DIG_B_1                                                   0x00c8
#define REG_DIG_B_2                                                   0x00cc
#define REG_DIG_B_3                                                   0x00d0
#define REG_DIG_B_4                                                   0x00d4
#define REG_DIG_B_5                                                   0x00d8
#define REG_CK_MD                                                     0x00dc
#define REG_MHL_CTRL                                                  0x00e0
#define HDMIPHY_REG_DIG_PHY_CTRL_NEW_1                                        0x00e4
#define HDMIPHY_REG_DIG_PHY_CTRL_NEW_2                                        0x00e8
// End of PHY

#define HDMIPHY_REG_CK_1_4_reg_ck_4_shift                                     (24)
#define HDMIPHY_REG_CK_1_4_reg_ck_3_shift                                     (16)
#define HDMIPHY_REG_CK_1_4_reg_ck_2_shift                                     (8)
#define HDMIPHY_REG_CK_1_4_reg_ck_1_shift                                     (0)
#define HDMIPHY_REG_CK_1_4_reg_ck_4_mask                                      (0xFF000000)
#define HDMIPHY_REG_CK_1_4_reg_ck_3_mask                                      (0x00FF0000)
#define HDMIPHY_REG_CK_1_4_reg_ck_2_mask                                      (0x0000FF00)
#define HDMIPHY_REG_CK_1_4_reg_ck_1_mask                                      (0x000000FF)
#define HDMIPHY_REG_CK_1_4_reg_ck_4(data)                                     (0xFF000000&((data)<<24))
#define HDMIPHY_REG_CK_1_4_reg_ck_3(data)                                     (0x00FF0000&((data)<<16))
#define HDMIPHY_REG_CK_1_4_reg_ck_2(data)                                     (0x0000FF00&((data)<<8))
#define HDMIPHY_REG_CK_1_4_reg_ck_1(data)                                     (0x000000FF&(data))
#define HDMIPHY_REG_CK_1_4_get_reg_ck_4(data)                                 ((0xFF000000&(data))>>24)
#define HDMIPHY_REG_CK_1_4_get_reg_ck_3(data)                                 ((0x00FF0000&(data))>>16)
#define HDMIPHY_REG_CK_1_4_get_reg_ck_2(data)                                 ((0x0000FF00&(data))>>8)
#define HDMIPHY_REG_CK_1_4_get_reg_ck_1(data)                                 (0x000000FF&(data))
#define CKAFE_hysterisis (1<<26)
#define Clock_Hysteresis ((1<<26)& hdmi_rx_reg_read32(HDMIPHY_REG_CK_9_12,HDMI_RX_PHY))

#define HDMIPHY_REG_CK_1_4_CK_PLLPOW                                             (1<<29)
#define HDMIPHY_REG_CK_1_4_CK_KOFF_AUTO                                        (1<<30)
#define HDMIPHY_REG_CK_1_4_CK_EQ_BOOSTER_OFF                               (1<<14)
#define HDMIPHY_REG_CK_1_4_CK_AFE_FORW_POW1                                (1<<1)
#define HDMIPHY_REG_CK_1_4_get_reg_ck_PMM_CLK_BYPASS                 ((1<<4))

#define HDMIPHY_REG_CK_1_4_CK_SCHR2                                               (1<<5)
#define HDMIPHY_REG_CK_1_4_CK_SCHR1                                               (1<<6)
#define HDMIPHY_REG_CK_1_4_CK_SCHR0                                               (1<<7)
#define HDMIPHY_REG_CK_1_4_CK_SELCS_MASK                                      ((1<<26)|(1<<25)|(1<<24))
#define HDMIPHY_REG_CK_1_4_CK_SELCS_shift                                        (24)
#define HDMIPHY_REG_CK_1_4_CK_KOFF_RANG_MASK                                  ((1<<31)|(1<<0))
#define HDMIPHY_REG_CK_1_4_CK_KOFF_RANG_X4                                      ((1<<31)|(1<<0))
#define HDMIPHY_REG_CK_1_4_CK_KOFF_EN                                               (1<<20)
#define HDMIPHY_REG_CK_1_4_CK_DIVN_MASK                                           ( (1<<23)|(1<<22)|(1<<21))
#define HDMIPHY_REG_CK_1_4_CK_DIVN_shift                                             (21)
#define HDMIPHY_REG_CK_1_4_CK_DIVM_MASK                                            ( (1<<13)|(1<<12)|(1<<11)|(1<<10)|(1<<9)|(1<<8))
#define HDMIPHY_REG_CK_1_4_CK_DIVM_shift                                             (8)
#define HDMIPHY_REG_CK_1_4_CK_DIVN_BYPASS                                        (1<<2)
#define HDMIPHY_REG_CK_1_4_CK_DIVN_BYPASS_shift                                 (2)
#define HDMIPHY_REG_CK_1_4_CK_CKSEL_PMM_CK                                      (1<<15)

#define HDMIPHY_REG_CK_5_8_reg_ck_8_shift                                     (24)
#define HDMIPHY_REG_CK_5_8_reg_ck_7_shift                                     (16)
#define HDMIPHY_REG_CK_5_8_reg_ck_6_shift                                     (8)
#define HDMIPHY_REG_CK_5_8_reg_ck_5_shift                                     (0)
#define HDMIPHY_REG_CK_5_8_reg_ck_8_mask                                      (0xFF000000)
#define HDMIPHY_REG_CK_5_8_reg_ck_7_mask                                      (0x00FF0000)
#define HDMIPHY_REG_CK_5_8_reg_ck_6_mask                                      (0x0000FF00)
#define HDMIPHY_REG_CK_5_8_reg_ck_5_mask                                      (0x000000FF)
#define HDMIPHY_REG_CK_5_8_reg_ck_8(data)                                     (0xFF000000&((data)<<24))
#define HDMIPHY_REG_CK_5_8_reg_ck_7(data)                                     (0x00FF0000&((data)<<16))
#define HDMIPHY_REG_CK_5_8_reg_ck_6(data)                                     (0x0000FF00&((data)<<8))
#define HDMIPHY_REG_CK_5_8_reg_ck_5(data)                                     (0x000000FF&(data))
#define HDMIPHY_REG_CK_5_8_get_reg_ck_8(data)                                 ((0xFF000000&(data))>>24)
#define HDMIPHY_REG_CK_5_8_get_reg_ck_7(data)                                 ((0x00FF0000&(data))>>16)
#define HDMIPHY_REG_CK_5_8_get_reg_ck_6(data)                                 ((0x0000FF00&(data))>>8)
#define HDMIPHY_REG_CK_5_8_get_reg_ck_5(data)                                 (0x000000FF&(data))
#define HDMIPHY_REG_CK_5_8_CK_INOFF                                               (1<<24)
#define HDMIPHY_REG_CK_5_8_CK_SEL_LDOD                                         ((1<<31)|(1<<30)|(1<<29))
#define HDMIPHY_REG_CK_5_8_CK_IBHN20U_Current_mask                     ((1<<28)|(1<<27))
#define HDMIPHY_REG_CK_5_8_CK_IBN20U_Current_mask                        ((1<<26)|(1<<25))
#define HDMIPHY_REG_CK_5_8_CK_SEL_LDOD_shift                                     (29)
#define HDMIPHY_REG_CK_5_8_CK_RS                                                        ((1<<4)|(1<<3))
#define HDMIPHY_REG_CK_5_8_CK_RS_shift                                                (3)
#define HDMIPHY_REG_CK_5_8_CK_ICP                                                        ((1<<7)|(1<<6)|(1<<5))
#define HDMIPHY_REG_CK_5_8_CK_ICP_shift                                                (5)
#define CK_PLL_LDO_SET_mask                                      ((1<<23)|(1<<22))
#define CK_PLL_LDO_SET(data)  						(CK_PLL_LDO_SET_mask&((data)<<22))
#define CCO_Band_mask	((1<<1)|0x1)
#define CCO_Band(data)	(CCO_Band_mask&(data))

#define HDMIPHY_REG_CK_9_12_reg_ck_12_shift                                   (24)
#define HDMIPHY_REG_CK_9_12_reg_ck_11_shift                                   (16)
#define HDMIPHY_REG_CK_9_12_reg_ck_10_shift                                   (8)
#define HDMIPHY_REG_CK_9_12_reg_ck_9_shift                                    (0)
#define HDMIPHY_REG_CK_9_12_reg_ck_12_mask                                    (0xFF000000)
#define HDMIPHY_REG_CK_9_12_reg_ck_11_mask                                    (0x00FF0000)
#define HDMIPHY_REG_CK_9_12_reg_ck_10_mask                                    (0x0000FF00)
#define HDMIPHY_REG_CK_9_12_reg_ck_9_mask                                     (0x000000FF)
#define HDMIPHY_REG_CK_9_12_reg_ck_12(data)                                   (0xFF000000&((data)<<24))
#define HDMIPHY_REG_CK_9_12_reg_ck_11(data)                                   (0x00FF0000&((data)<<16))
#define HDMIPHY_REG_CK_9_12_reg_ck_10(data)                                   (0x0000FF00&((data)<<8))
#define HDMIPHY_REG_CK_9_12_reg_ck_9(data)                                    (0x000000FF&(data))
#define HDMIPHY_REG_CK_9_12_get_reg_ck_12(data)                               ((0xFF000000&(data))>>24)
#define HDMIPHY_REG_CK_9_12_get_reg_ck_11(data)                               ((0x00FF0000&(data))>>16)
#define HDMIPHY_REG_CK_9_12_get_reg_ck_10(data)                               ((0x0000FF00&(data))>>8)
#define HDMIPHY_REG_CK_9_12_get_reg_ck_9(data)                                (0x000000FF&(data))
#define MHL_Z100K ((1<<5)|(1<<4)|(1<<3))

//change a lot
#define HDMIPHY_REG_CK_RESULT_ck_koffok_shift                                 (17)
#define HDMIPHY_REG_CK_RESULT_ck_koff_bound_shift                             (16)
#define HDMIPHY_REG_CK_RESULT_ck_koff_sel_shift                               (11)
#define HDMIPHY_REG_CK_RESULT_ck_wdo_shift                                    (1)
#define HDMIPHY_REG_CK_RESULT_ck_koffok_mask                                  (0x00020000)
#define HDMIPHY_REG_CK_RESULT_ck_koff_bound_mask                              (0x00010000)
#define HDMIPHY_REG_CK_RESULT_ck_koff_sel_mask                                (0x0000F800)
#define HDMIPHY_REG_CK_RESULT_ck_wdo_mask                                     (0x00000002)
#define REG_CK_RESULT_ck_md_ok_mask                                   (0x00000001)
#define HDMIPHY_REG_CK_RESULT_ck_koffok(data)                                 (0x00020000&((data)<<17))
#define HDMIPHY_REG_CK_RESULT_ck_koff_bound(data)                             (0x00010000&((data)<<16))
#define HDMIPHY_REG_CK_RESULT_ck_koff_sel(data)                               (0x0000F800&((data)<<11))
#define HDMIPHY_REG_CK_RESULT_ck_wdo(data)                                    (0x00000002&((data)<<1))
#define HDMIPHY_REG_CK_RESULT_get_ck_koffok(data)                             ((0x00020000&(data))>>17)
#define HDMIPHY_REG_CK_RESULT_get_ck_koff_bound(data)                         ((0x00010000&(data))>>16)
#define HDMIPHY_REG_CK_RESULT_get_ck_koff_sel(data)                           ((0x0000F800&(data))>>11)
#define HDMIPHY_REG_CK_RESULT_get_ck_wdo(data)                                ((0x00000002&(data))>>1)
#define REG_CK_RESULT_ck_md_ok(data)                                  (0x00000001&(data))
#define REG_CK_RESULT_get_ck_md_ok(data)                              (0x00000001&(data))
#define REG_CK_RESULT_get_ck_md_count(data)                           ((0xFFF00000&(data))>>20)
#define REG_CK_RESULT_get_ck_rate(data)                               ((0x00000380&(data))>>7)
#define REG_CK_RESULT_get_ck_wdo(data)                                ((0x00000002&(data))>>1)
#define REG_CK_RESULT_get_ck_md_ok(data)                              (0x00000001&(data))

#define HDMIPHY_REG_R_1_4_reg_r_4_shift                                       (24)
#define HDMIPHY_REG_R_1_4_reg_r_3_shift                                       (16)
#define HDMIPHY_REG_R_1_4_reg_r_2_shift                                       (8)
#define HDMIPHY_REG_R_1_4_reg_r_1_shift                                       (0)
#define HDMIPHY_REG_R_1_4_reg_r_4_mask                                        (0xFF000000)
#define HDMIPHY_REG_R_1_4_reg_r_3_mask                                        (0x00FF0000)
#define HDMIPHY_REG_R_1_4_reg_r_2_mask                                        (0x0000FF00)
#define HDMIPHY_REG_R_1_4_reg_r_1_mask                                        (0x000000FF)
#define HDMIPHY_REG_R_1_4_reg_r_4(data)                                       (0xFF000000&((data)<<24))
#define HDMIPHY_REG_R_1_4_reg_r_3(data)                                       (0x00FF0000&((data)<<16))
#define HDMIPHY_REG_R_1_4_reg_r_2(data)                                       (0x0000FF00&((data)<<8))
#define HDMIPHY_REG_R_1_4_reg_r_1(data)                                       (0x000000FF&(data))
#define HDMIPHY_REG_R_1_4_get_reg_r_4(data)                                   ((0xFF000000&(data))>>24)
#define HDMIPHY_REG_R_1_4_get_reg_r_3(data)                                   ((0x00FF0000&(data))>>16)
#define HDMIPHY_REG_R_1_4_get_reg_r_2(data)                                   ((0x0000FF00&(data))>>8)
#define HDMIPHY_REG_R_1_4_get_reg_r_1(data)                                   (0x000000FF&(data))
#define HDMIPHY_REG_R_1_4_R_EQFBPOW                                          (1<<3)
#define HDMIPHY_REG_R_1_4_R_EQPOW1                                            (1<<4)
#define HDMIPHY_REG_R_1_4_R_SCHR2                                               (1<<5)
#define HDMIPHY_REG_R_1_4_R_SCHR1                                               (1<<6)
#define HDMIPHY_REG_R_1_4_R_SCHR0                                               (1<<7)
#define HDMIPHY_REG_R_1_4_R_KOFF_EN                                            (1<<8)
#define R_DFEPOW (1<<9)
#define HDMIPHY_REG_R_1_4_R_DAPOW                                              (1<<10)
#define R_EQ_OUTPUT_SHORT_DISABLE	    (1<<11)
#define HDMIPHY_REG_R_1_4_R_KOFF_RANG                                       ( (1<<22)|(1<<23))
#define R_KOFF_FG_Range(data)                                       (HDMIPHY_REG_R_1_4_R_KOFF_RANG&((data)<<22))
#define R_KOFF_BG_Range_mask                                                                ((1<<27)|(1<<26))
#define R_KOFF_BG_Range(data)                                                                (R_KOFF_BG_Range_mask&((data)<<26))
#define HDMIPHY_REG_R_1_4_R_KOFF_STUNE                                        (1<<31)
#define R_KOFF_Fore_mode (1<<29)
#define R_KOFF_FG_Manual_mode_mask                           ((1<<16)|(1<<17)|(1<<18)|(1<<19)|(1<<20))
#define R_KOFF_FG_Manual(data)                                       (R_KOFF_FG_Manual_mode_mask&((data)<<16))
#define R_EQ_back_koff_en               (1<<10)

#define HDMIPHY_REG_R_5_8_reg_r_8_shift                                       (24)
#define HDMIPHY_REG_R_5_8_reg_r_7_shift                                       (16)
#define HDMIPHY_REG_R_5_8_reg_r_6_shift                                       (8)
#define HDMIPHY_REG_R_5_8_reg_r_5_shift                                       (0)
#define HDMIPHY_REG_R_5_8_reg_r_8_mask                                        (0xFF000000)
#define HDMIPHY_REG_R_5_8_reg_r_7_mask                                        (0x00FF0000)
#define HDMIPHY_REG_R_5_8_reg_r_6_mask                                        (0x0000FF00)
#define HDMIPHY_REG_R_5_8_reg_r_5_mask                                        (0x000000FF)
#define HDMIPHY_REG_R_5_8_reg_r_8(data)                                       (0xFF000000&((data)<<24))
#define HDMIPHY_REG_R_5_8_reg_r_7(data)                                       (0x00FF0000&((data)<<16))
#define HDMIPHY_REG_R_5_8_reg_r_6(data)                                       (0x0000FF00&((data)<<8))
#define HDMIPHY_REG_R_5_8_reg_r_5(data)                                       (0x000000FF&(data))
#define HDMIPHY_REG_R_5_8_get_reg_r_8(data)                                   ((0xFF000000&(data))>>24)
#define HDMIPHY_REG_R_5_8_get_reg_r_7(data)                                   ((0x00FF0000&(data))>>16)
#define HDMIPHY_REG_R_5_8_get_reg_r_6(data)                                   ((0x0000FF00&(data))>>8)
#define HDMIPHY_REG_R_5_8_get_reg_r_5(data)                                   (0x000000FF&(data))
#define HDMIPHY_REG_R_5_8_reg_r_Booster_OFF                                 (1<<21)
#define HDMIPHY_REG_R_5_8_reg_r_EQ_SBIAS_MASK                            ((1<<28)|(1<<27))
#define HDMIPHY_REG_R_5_8_reg_r_EQ_SBIAS_shift                              (27)
#define HDMIPHY_REG_R_5_8_reg_r_EQ_SBIAS_1                                  (1<<27)
#define HDMIPHY_REG_R_5_8_reg_r_RATE_SEL_MASK                            ((1<<31)|(1<<30)|(1<<29))
#define R_CDR_Rate(data)                                       (HDMIPHY_REG_R_5_8_reg_r_RATE_SEL_MASK&((data)<<29))
#define HDMIPHY_REG_R_5_8_reg_r_8_shift_RATE_SEL                          (29)
#define HDMIPHY_REG_R_5_8_reg_r_8_REGHOLD_SEL                                   ((1<<0)|(1<<1))
#define R_Rhase_Routator_Resistor	(1<<26)
#define R_EQ_bias_current_mask	                                ((1<<28)|(1<<27)|(1<<24))
#define R_EQ_bias_current(data)                                       (R_EQ_bias_current_mask&(((data)<<26)|((data)<<24)))
#define R_EQ_HBR	((1<<19)|(1<<18)|(1<<17)|(1<<16))
#define HDMIPHY_REG_R_5_8_enbuffer3_mask					(0x00200000)
#define HDMIPHY_REG_R_5_8_enbuffer3(data)					(0x00200000&((data)<<21))
#define R_S_BIAS_DFE				(1<<25)
#define R_RL_SELB					(1<<20)

#define HDMIPHY_REG_R_9_12_reg_r_12_shift                                     (24)
#define HDMIPHY_REG_R_9_12_reg_r_11_shift                                     (16)
#define HDMIPHY_REG_R_9_12_reg_r_9_shift                                      (8)
#define HDMIPHY_REG_R_9_12_reg_r_10_shift                                     (0)
#define HDMIPHY_REG_R_9_12_reg_r_12_mask                                      (0xFF000000)
#define HDMIPHY_REG_R_9_12_reg_r_11_mask                                      (0x00FF0000)
#define HDMIPHY_REG_R_9_12_reg_r_9_mask                                       (0x0000FF00)
#define HDMIPHY_REG_R_9_12_reg_r_10_mask                                      (0x000000FF)
#define HDMIPHY_REG_R_9_12_reg_r_12(data)                                     (0xFF000000&((data)<<24))
#define HDMIPHY_REG_R_9_12_tap0_bias_cur_mask				(0x00060000)
#define HDMIPHY_REG_R_9_12_tap0_bias_cur(data)				(0x00060000&((data)<<17))
#define HDMIPHY_REG_R_9_12_reg_r_11(data)                                     (0x00FF0000&((data)<<16))
#define HDMIPHY_REG_R_9_12_reg_r_9(data)                                      (0x0000FF00&((data)<<8))
#define HDMIPHY_REG_R_9_12_reg_r_10(data)                                     (0x000000FF&(data))
#define HDMIPHY_REG_R_9_12_get_reg_r_12(data)                                 ((0xFF000000&(data))>>24)
#define HDMIPHY_REG_R_9_12_get_reg_r_11(data)                                 ((0x00FF0000&(data))>>16)
#define HDMIPHY_REG_R_9_12_get_reg_r_9(data)                                  ((0x0000FF00&(data))>>8)
#define HDMIPHY_REG_R_9_12_get_reg_r_10(data)                                 (0x000000FF&(data))
#define HDMIPHY_REG_R_9_12_reg_R_INOFF                                           (1<<23)
#define HDMIPHY_REG_R_9_12_reg_R_CDR_SBIAS_MASK                          ((1<<20)|(1<<19))
#define HDMIPHY_REG_R_9_12_reg_R_CDR_SBIAS_shift                            (19)
#define R_DFE_ADAPT_EN  (1<<7)
#define R_divider_after_PR_mask	((1<<28)|(1<<27))
#define R_divider_after_PR(data)                                     (R_divider_after_PR_mask&((data)<<27))
#define R_InOff  (1<<23)
#define R_Xtal_for_Koffset_enable	(1<<22)
#define R_DFE_TAPEN4321 ((1<<4)|(1<<3)|(1<<2)|(1<<1))
#define R_DFE_TAPEN1 (1<<1)

#define HDMIPHY_REG_R_RESULT_r_koffok_shift                                   (28)
#define HDMIPHY_REG_R_RESULT_r_koff_bound_shift                               (27)
#define HDMIPHY_REG_R_RESULT_r_koffok_mask                                    (0x10000000)
#define HDMIPHY_REG_R_RESULT_r_koff_bound_mask                                (0x08000000)
#define HDMIPHY_REG_R_RESULT_r_koffok(data)                                   (0x10000000&((data)<<28))
#define HDMIPHY_REG_R_RESULT_r_koff_bound(data)                               (0x08000000&((data)<<27))
#define HDMIPHY_REG_R_RESULT_get_r_koffok(data)                               ((0x10000000&(data))>>28)
#define HDMIPHY_REG_R_RESULT_get_r_koff_bound(data)                           ((0x08000000&(data))>>27)

#define HDMIPHY_REG_G_1_4_reg_g_4_shift                                       (24)
#define HDMIPHY_REG_G_1_4_reg_g_3_shift                                       (16)
#define HDMIPHY_REG_G_1_4_reg_g_2_shift                                       (8)
#define HDMIPHY_REG_G_1_4_reg_g_1_shift                                       (0)
#define HDMIPHY_REG_G_1_4_reg_g_4_mask                                        (0xFF000000)
#define HDMIPHY_REG_G_1_4_reg_g_3_mask                                        (0x00FF0000)
#define HDMIPHY_REG_G_1_4_reg_g_2_mask                                        (0x0000FF00)
#define HDMIPHY_REG_G_1_4_reg_g_1_mask                                        (0x000000FF)
#define HDMIPHY_REG_G_1_4_reg_g_4(data)                                       (0xFF000000&((data)<<24))
#define HDMIPHY_REG_G_1_4_reg_g_3(data)                                       (0x00FF0000&((data)<<16))
#define HDMIPHY_REG_G_1_4_reg_g_2(data)                                       (0x0000FF00&((data)<<8))
#define HDMIPHY_REG_G_1_4_reg_g_1(data)                                       (0x000000FF&(data))
#define HDMIPHY_REG_G_1_4_get_reg_g_4(data)                                   ((0xFF000000&(data))>>24)
#define HDMIPHY_REG_G_1_4_get_reg_g_3(data)                                   ((0x00FF0000&(data))>>16)
#define HDMIPHY_REG_G_1_4_get_reg_g_2(data)                                   ((0x0000FF00&(data))>>8)
#define HDMIPHY_REG_G_1_4_get_reg_g_1(data)                                   (0x000000FF&(data))
#define HDMIPHY_REG_G_1_4_G_EQFBPOW                                          (1<<3)
#define HDMIPHY_REG_G_1_4_G_EQPOW1                                            (1<<4)
#define HDMIPHY_REG_G_1_4_G_SCHR2                                               (1<<5)
#define HDMIPHY_REG_G_1_4_G_SCHR1                                               (1<<6)
#define HDMIPHY_REG_G_1_4_G_SCHR0                                               (1<<7)
#define HDMIPHY_REG_G_1_4_G_KOFF_EN                                            (1<<8)
#define G_DFEPOW (1<<9)
#define HDMIPHY_REG_G_1_4_G_DAPOW                                              (1<<10)
#define G_EQ_OUTPUT_SHORT_DISABLE	(1<<11)
#define HDMIPHY_REG_G_1_4_G_KOFF_RANG                                       ( (1<<22)|(1<<23))
#define G_KOFF_FG_Range(data)                                       (HDMIPHY_REG_G_1_4_G_KOFF_RANG&((data)<<22))
#define G_KOFF_BG_Range_mask                                                                    ((1<<27)|(1<<26))
#define G_KOFF_BG_Range(data)                                                                (G_KOFF_BG_Range_mask&((data)<<26))
#define HDMIPHY_REG_G_1_4_G_KOFF_AUTO                                        (1<<31)
#define G_KOFF_Fore_mode (1<<29)
#define G_KOFF_FG_Manual_mode_mask                           ((1<<16)|(1<<17)|(1<<18)|(1<<19)|(1<<20))
#define G_KOFF_FG_Manual(data)                                       (G_KOFF_FG_Manual_mode_mask&((data)<<16))
#define G_EQ_back_koff_en  (1<<10)

#define HDMIPHY_REG_G_5_8_reg_g_8_shift                                       (24)
#define HDMIPHY_REG_G_5_8_reg_g_7_shift                                       (16)
#define HDMIPHY_REG_G_5_8_reg_g_6_shift                                       (8)
#define HDMIPHY_REG_G_5_8_reg_g_5_shift                                       (0)
#define HDMIPHY_REG_G_5_8_reg_g_8_mask                                        (0xFF000000)
#define HDMIPHY_REG_G_5_8_reg_g_7_mask                                        (0x00FF0000)
#define HDMIPHY_REG_G_5_8_reg_g_6_mask                                        (0x0000FF00)
#define HDMIPHY_REG_G_5_8_reg_g_5_mask                                        (0x000000FF)
#define HDMIPHY_REG_G_5_8_reg_g_8(data)                                       (0xFF000000&((data)<<24))
#define HDMIPHY_REG_G_5_8_reg_g_7(data)                                       (0x00FF0000&((data)<<16))
#define HDMIPHY_REG_G_5_8_reg_g_6(data)                                       (0x0000FF00&((data)<<8))
#define HDMIPHY_REG_G_5_8_reg_g_5(data)                                       (0x000000FF&(data))
#define HDMIPHY_REG_G_5_8_get_reg_g_8(data)                                   ((0xFF000000&(data))>>24)
#define HDMIPHY_REG_G_5_8_get_reg_g_7(data)                                   ((0x00FF0000&(data))>>16)
#define HDMIPHY_REG_G_5_8_get_reg_g_6(data)                                   ((0x0000FF00&(data))>>8)
#define HDMIPHY_REG_G_5_8_get_reg_g_5(data)                                   (0x000000FF&(data))
#define HDMIPHY_REG_G_5_8_reg_g_Booster_OFF                                 (1<<21)
#define HDMIPHY_REG_G_5_8_reg_g_EQ_SBIAS_MASK                            ((1<<28)|(1<<27))
#define HDMIPHY_REG_G_5_8_reg_g_EQ_SBIAS_1                                  (1<<27)
#define HDMIPHY_REG_G_5_8_reg_g_EQ_SBIAS_shift                              (27)
#define HDMIPHY_REG_G_5_8_reg_g_RATE_SEL_MASK                            ((1<<31)|(1<<30)|(1<<29))
#define G_CDR_Rate(data)                                       (HDMIPHY_REG_G_5_8_reg_g_RATE_SEL_MASK&((data)<<29))
#define HDMIPHY_REG_G_5_8_reg_g_8_shift_RATE_SEL                          (29)
#define HDMIPHY_REG_R_5_8_reg_g_8_REGHOLD_SEL                                   ((1<<0)|(1<<1))
#define G_Rhase_Routator_Resistor	(1<<26)
#define G_EQ_bias_current_mask	((1<<28)|(1<<27)|(1<<24))
#define G_EQ_bias_current(data)                                       (G_EQ_bias_current_mask&(((data)<<26)|((data)<<24)))
#define G_EQ_HBR	((1<<19)|(1<<18)|(1<<17)|(1<<16))
#define HDMIPHY_REG_G_5_8_enbuffer3_mask					(0x00200000)
#define HDMIPHY_REG_G_5_8_enbuffer3(data)					(0x00200000&((data)<<21))
#define G_RL_SELB					(1<<20)
#define G_S_BIAS_DFE				(1<<25)

#define HDMIPHY_REG_G_9_12_reg_g_12_shift                                     (24)
#define HDMIPHY_REG_G_9_12_reg_g_11_shift                                     (16)
#define HDMIPHY_REG_G_9_12_reg_g_9_shift                                      (8)
#define HDMIPHY_REG_G_9_12_reg_g_10_shift                                     (0)
#define HDMIPHY_REG_G_9_12_reg_g_12_mask                                      (0xFF000000)
#define HDMIPHY_REG_G_9_12_reg_g_11_mask                                      (0x00FF0000)
#define HDMIPHY_REG_G_9_12_reg_g_9_mask                                       (0x0000FF00)
#define HDMIPHY_REG_G_9_12_reg_g_10_mask                                      (0x000000FF)
#define HDMIPHY_REG_G_9_12_reg_g_12(data)                                     (0xFF000000&((data)<<24))
#define HDMIPHY_REG_G_9_12_tap0_bias_cur_mask				(0x00060000)
#define HDMIPHY_REG_G_9_12_tap0_bias_cur(data)				(0x00060000&((data)<<17))
#define HDMIPHY_REG_G_9_12_reg_g_11(data)                                     (0x00FF0000&((data)<<16))
#define HDMIPHY_REG_G_9_12_reg_g_9(data)                                      (0x0000FF00&((data)<<8))
#define HDMIPHY_REG_G_9_12_reg_g_10(data)                                     (0x000000FF&(data))
#define HDMIPHY_REG_G_9_12_get_reg_g_12(data)                                 ((0xFF000000&(data))>>24)
#define HDMIPHY_REG_G_9_12_get_reg_g_11(data)                                 ((0x00FF0000&(data))>>16)
#define HDMIPHY_REG_G_9_12_get_reg_g_9(data)                                  ((0x0000FF00&(data))>>8)
#define HDMIPHY_REG_G_9_12_get_reg_g_10(data)                                 (0x000000FF&(data))
#define HDMIPHY_REG_G_9_12_reg_G_INOFF                                            (1<<23)
#define G_Xtal_for_Koffset_enable	(1<<22)
#define HDMIPHY_REG_G_9_12_reg_G_CDR_SBIAS_MASK                          ((1<<20)|(1<<19))
#define HDMIPHY_REG_G_9_12_reg_G_CDR_SBIAS_shift                            (19)
#define G_DFE_ADAPT_EN (1<<7)
#define G_divider_after_PR_mask	((1<<28)|(1<<27))
#define G_divider_after_PR(data)                                     (G_divider_after_PR_mask&((data)<<27))
#define G_DFE_TAPEN4321 ((1<<4)|(1<<3)|(1<<2)|(1<<1))
#define G_DFE_TAPEN1 (1<<1)

#define HDMIPHY_REG_G_RESULT_g_koffok_shift                                   (28)
#define HDMIPHY_REG_G_RESULT_g_koff_bound_shift                               (27)
#define HDMIPHY_REG_G_RESULT_g_koffok_mask                                    (0x10000000)
#define HDMIPHY_REG_G_RESULT_g_koff_bound_mask                                (0x08000000)
#define HDMIPHY_REG_G_RESULT_g_koffok(data)                                   (0x10000000&((data)<<28))
#define HDMIPHY_REG_G_RESULT_g_koff_bound(data)                               (0x08000000&((data)<<27))
#define HDMIPHY_REG_G_RESULT_get_g_koffok(data)                               ((0x10000000&(data))>>28)
#define HDMIPHY_REG_G_RESULT_get_g_koff_bound(data)                           ((0x08000000&(data))>>27)

#define HDMIPHY_REG_B_1_4_reg_b_4_shift                                       (24)
#define HDMIPHY_REG_B_1_4_reg_b_3_shift                                       (16)
#define HDMIPHY_REG_B_1_4_reg_b_2_shift                                       (8)
#define HDMIPHY_REG_B_1_4_reg_b_1_shift                                       (0)
#define HDMIPHY_REG_B_1_4_reg_b_4_mask                                        (0xFF000000)
#define HDMIPHY_REG_B_1_4_reg_b_3_mask                                        (0x00FF0000)
#define HDMIPHY_REG_B_1_4_reg_b_2_mask                                        (0x0000FF00)
#define HDMIPHY_REG_B_1_4_reg_b_1_mask                                        (0x000000FF)
#define HDMIPHY_REG_B_1_4_reg_b_4(data)                                       (0xFF000000&((data)<<24))
#define HDMIPHY_REG_B_1_4_reg_b_3(data)                                       (0x00FF0000&((data)<<16))
#define HDMIPHY_REG_B_1_4_reg_b_2(data)                                       (0x0000FF00&((data)<<8))
#define HDMIPHY_REG_B_1_4_reg_b_1(data)                                       (0x000000FF&(data))
#define HDMIPHY_REG_B_1_4_get_reg_b_4(data)                                   ((0xFF000000&(data))>>24)
#define HDMIPHY_REG_B_1_4_get_reg_b_3(data)                                   ((0x00FF0000&(data))>>16)
#define HDMIPHY_REG_B_1_4_get_reg_b_2(data)                                   ((0x0000FF00&(data))>>8)
#define HDMIPHY_REG_B_1_4_get_reg_b_1(data)                                   (0x000000FF&(data))
#define HDMIPHY_REG_B_1_4_B_KOFF_AUTO                                         (1<<31)
#define B_KOFF_Fore_mode (1<<29)
#define HDMIPHY_REG_B_1_4_B_MHL_ClockSelMask                                  ((1<<27)|(1<<26)|(1<<25))
#define HDMIPHY_REG_B_1_4_B_MHL_ClockSel(data)                                ((1<<25)<<(data))
#define HDMIPHY_REG_B_1_4_B_KOFF_RANG                                         ((1<<22)|(1<<23))
#define B_KOFF_FG_Range(data)                                       (HDMIPHY_REG_B_1_4_B_KOFF_RANG&((data)<<22))
#define HDMIPHY_REG_B_1_4_B_EQ_CON_500M                                       (1<<21)
#define B_EQ_OUTPUT_SHORT_DISABLE	(1<<11)
#define HDMIPHY_REG_B_1_4_B_DAPOW                                             (1<<10)
#define B_DFEPOW (1<<9)
#define HDMIPHY_REG_B_1_4_B_KOFF_EN                                           (1<<8)
#define HDMIPHY_REG_B_1_4_B_SCHR0                                             (1<<7)
#define HDMIPHY_REG_B_1_4_B_SCHR1                                             (1<<6)
#define HDMIPHY_REG_B_1_4_B_SCHR2                                             (1<<5)
#define HDMIPHY_REG_B_1_4_B_EQPOW1                                            (1<<4)
#define HDMIPHY_REG_B_1_4_B_EQFBPOW                                           (1<<3)
#define B_KOFF_BG_Range_mask                                                                ((1<<27)|(1<<26))
#define B_KOFF_BG_Range(data)                                                                (B_KOFF_BG_Range_mask&((data)<<26))
#define B_KOFF_FG_Manual_mode_mask                            ((1<<16)|(1<<17)|(1<<18)|(1<<19)|(1<<20))
#define B_KOFF_FG_Manual(data)                                       (B_KOFF_FG_Manual_mode_mask&((data)<<16))
#define B_EQ_back_koff_en    (1<<10)

#define HDMIPHY_REG_B_5_8_reg_b_8_shift                                       (24)
#define HDMIPHY_REG_B_5_8_reg_b_7_shift                                       (16)
#define HDMIPHY_REG_B_5_8_reg_b_6_shift                                       (8)
#define HDMIPHY_REG_B_5_8_reg_b_5_shift                                       (0)
#define HDMIPHY_REG_B_5_8_reg_b_8_mask                                        (0xFF000000)
#define HDMIPHY_REG_B_5_8_reg_b_7_mask                                        (0x00FF0000)
#define HDMIPHY_REG_B_5_8_reg_b_6_mask                                        (0x0000FF00)
#define HDMIPHY_REG_B_5_8_reg_b_5_mask                                        (0x000000FF)
#define HDMIPHY_REG_B_5_8_reg_b_8(data)                                       (0xFF000000&((data)<<24))
#define HDMIPHY_REG_B_5_8_reg_b_7(data)                                       (0x00FF0000&((data)<<16))
#define HDMIPHY_REG_B_5_8_reg_b_6(data)                                       (0x0000FF00&((data)<<8))
#define HDMIPHY_REG_B_5_8_reg_b_5(data)                                       (0x000000FF&(data))
#define HDMIPHY_REG_B_5_8_get_reg_b_8(data)                                   ((0xFF000000&(data))>>24)
#define HDMIPHY_REG_B_5_8_get_reg_b_7(data)                                   ((0x00FF0000&(data))>>16)
#define HDMIPHY_REG_B_5_8_get_reg_b_6(data)                                   ((0x0000FF00&(data))>>8)
#define HDMIPHY_REG_B_5_8_get_reg_b_5(data)                                   (0x000000FF&(data))
#define HDMIPHY_REG_B_5_8_reg_b_Booster_OFF                                 (1<<21)
#define HDMIPHY_REG_B_5_8_reg_b_EQ_SBIAS_MASK                            ((1<<28)|(1<<27))
#define HDMIPHY_REG_B_5_8_reg_b_EQ_SBIAS_1                                  (1<<27)
#define HDMIPHY_REG_B_5_8_reg_b_EQ_SBIAS_shift                              (27)
#define HDMIPHY_REG_B_5_8_reg_b_Phase_Rotator_Cap			(1<<25)
#define HDMIPHY_REG_B_5_8_reg_b_RATE_SEL_MASK                            ((1<<31)|(1<<30)|(1<<29))
#define B_CDR_Rate(data)                                       (HDMIPHY_REG_B_5_8_reg_b_RATE_SEL_MASK&((data)<<29))
#define HDMIPHY_REG_B_5_8_reg_b_8_shift_RATE_SEL                          (29)
#define HDMIPHY_REG_R_5_8_reg_b_8_REGHOLD_SEL                                   ((1<<0)|(1<<1))
#define B_Rhase_Routator_Resistor	(1<<26)
#define B_EQ_bias_current_mask	((1<<28)|(1<<27)|(1<<24))
#define B_EQ_bias_current(data)                                       (B_EQ_bias_current_mask&(((data)<<26)|((data)<<24)))
#define B_EQ_HBR	((1<<19)|(1<<18)|(1<<17)|(1<<16))
#define HDMIPHY_REG_B_5_8_enbuffer3_mask					(0x00200000)
#define HDMIPHY_REG_B_5_8_enbuffer3(data)					(0x00200000&((data)<<21))
#define B_RL_SELB					(1<<20)
#define B_S_BIAS_DFE				(1<<25)

#define HDMIPHY_REG_B_9_12_reg_b_12_shift                                     (24)
#define HDMIPHY_REG_B_9_12_reg_b_11_shift                                     (16)
#define HDMIPHY_REG_B_9_12_reg_b_9_shift                                      (8)
#define HDMIPHY_REG_B_9_12_reg_b_10_shift                                     (0)
#define HDMIPHY_REG_B_9_12_reg_b_12_mask                                      (0xFF000000)
#define HDMIPHY_REG_B_9_12_reg_b_11_mask                                      (0x00FF0000)
#define HDMIPHY_REG_B_9_12_reg_b_9_mask                                       (0x0000FF00)
#define HDMIPHY_REG_B_9_12_reg_b_10_mask                                      (0x000000FF)
#define HDMIPHY_REG_B_9_12_reg_b_12(data)                                     (0xFF000000&((data)<<24))
#define HDMIPHY_REG_B_9_12_tap0_bias_cur_mask				(0x00060000)
#define HDMIPHY_REG_B_9_12_tap0_bias_cur(data)				(0x00060000&((data)<<17))
#define HDMIPHY_REG_B_9_12_reg_b_11(data)                                     (0x00FF0000&((data)<<16))
#define HDMIPHY_REG_B_9_12_reg_b_9(data)                                      (0x0000FF00&((data)<<8))
#define HDMIPHY_REG_B_9_12_reg_b_10(data)                                     (0x000000FF&(data))
#define HDMIPHY_REG_B_9_12_get_reg_b_12(data)                                 ((0xFF000000&(data))>>24)
#define HDMIPHY_REG_B_9_12_get_reg_b_11(data)                                 ((0x00FF0000&(data))>>16)
#define HDMIPHY_REG_B_9_12_get_reg_b_9(data)                                  ((0x0000FF00&(data))>>8)
#define HDMIPHY_REG_B_9_12_get_reg_b_10(data)                                 (0x000000FF&(data))
#define HDMIPHY_REG_B_9_12_reg_B_INOFF                                            (1<<23)
#define B_Xtal_for_Koffset_enable	(1<<22)
#define HDMIPHY_REG_B_9_12_reg_B_CDR_SBIAS_MASK                          ((1<<20)|(1<<19))
#define HDMIPHY_REG_B_9_12_reg_B_CDR_SBIAS_shift                            (19)
#define B_DFE_ADAPT_EN (1<<7)
#define B_divider_after_PR_mask	((1<<28)|(1<<27))
#define B_divider_after_PR(data)                                     (B_divider_after_PR_mask&((data)<<27))
#define B_DFE_TAPEN4321 ((1<<4)|(1<<3)|(1<<2)|(1<<1))
#define B_DFE_TAPEN1 (1<<1)

#define HDMIPHY_REG_B_RESULT_b_koffok_shift                                   (28)
#define HDMIPHY_REG_B_RESULT_b_koff_bound_shift                               (27)
#define HDMIPHY_REG_B_RESULT_b_koffok_mask                                    (0x10000000)
#define HDMIPHY_REG_B_RESULT_b_koff_bound_mask                                (0x08000000)
#define HDMIPHY_REG_B_RESULT_b_koffok(data)                                   (0x10000000&((data)<<28))
#define HDMIPHY_REG_B_RESULT_b_koff_bound(data)                               (0x08000000&((data)<<27))
#define HDMIPHY_REG_B_RESULT_get_b_koffok(data)                               ((0x10000000&(data))>>28)
#define HDMIPHY_REG_B_RESULT_get_b_koff_bound(data)                           ((0x08000000&(data))>>27)

#define HDMIPHY_REG_BANDGAP_Z0_bgpow_shift                                    (25)
#define HDMIPHY_REG_BANDGAP_Z0_sbg_shift                                      (23)
#define HDMIPHY_REG_BANDGAP_Z0_z0pow_shift                                    (22)
//#define HDMIPHY_REG_BANDGAP_Z0_adjr_shift                                     (18)    //change postion
#define HDMIPHY_REG_BANDGAP_Z0_entst_z0_shift                                 (17)
#define HDMIPHY_REG_BANDGAP_Z0_z0tune_shift                                   (16)
#define HDMIPHY_REG_BANDGAP_Z0_spad_shift                                     (15)
#define HDMIPHY_REG_BANDGAP_Z0_stst_shift                                     (11)
#define HDMIPHY_REG_BANDGAP_Z0_hspow_shift                                    (10)
#define HDMIPHY_REG_BANDGAP_Z0_z0_res_shift                                   (6)
#define HDMIPHY_REG_BANDGAP_Z0_z0tst_shift                                    (2)
#define HDMIPHY_REG_BANDGAP_Z0_z0_ok_shift                                    (1)
#define HDMIPHY_REG_BANDGAP_Z0_z0_bound_shift                                 (0)
#define HDMIPHY_REG_BANDGAP_Z0_bgpow_mask                                     (0x02000000)
#define HDMIPHY_REG_BANDGAP_Z0_sbg_mask                                       (0x01800000)
#define HDMIPHY_REG_BANDGAP_Z0_z0pow_mask                                     (0x00400000)
//#define HDMIPHY_REG_BANDGAP_Z0_adjr_mask                                      (0x003C0000)   //change postion
#define HDMIPHY_REG_BANDGAP_Z0_entst_z0_mask                                  (0x00040000)
#define HDMIPHY_REG_BANDGAP_Z0_z0tune_mask                                    (0x00020000)
#define HDMIPHY_REG_BANDGAP_Z0_spad_mask                                      (0x00010000)
#define HDMIPHY_REG_BANDGAP_Z0_stst_mask                                      (0x0000F000)
#define HDMIPHY_REG_BANDGAP_Z0_hspow_mask                                     (0x00000800)
#define HDMIPHY_REG_BANDGAP_Z0_z0_res_mask                                    (0x000007C0)
#define HDMIPHY_REG_BANDGAP_Z0_z0tst_mask                                     (0x0000003C)
#define HDMIPHY_REG_BANDGAP_Z0_z0_ok_mask                                     (0x00000002)
#define HDMIPHY_REG_BANDGAP_Z0_z0_bound_mask                                  (0x00000001)
#define HDMIPHY_REG_BANDGAP_Z0_bgpow(data)                                    (0x02000000&((data)<<25))
#define HDMIPHY_REG_BANDGAP_Z0_sbg(data)                                      (0x01800000&((data)<<23))
#define HDMIPHY_REG_BANDGAP_Z0_z0pow(data)                                    (0x00400000&((data)<<22))
//#define HDMIPHY_REG_BANDGAP_Z0_adjr(data)                                     (0x003C0000&((data)<<18))  //change postion
#define HDMIPHY_REG_BANDGAP_Z0_entst_z0(data)                                 (0x00040000&((data)<<18))
#define HDMIPHY_REG_BANDGAP_Z0_z0tune(data)                                   (0x00020000&((data)<<17))
#define HDMIPHY_REG_BANDGAP_Z0_spad(data)                                     (0x00010000&((data)<<16))
#define HDMIPHY_REG_BANDGAP_Z0_stst(data)                                     (0x0000F000&((data)<<12))
#define HDMIPHY_REG_BANDGAP_Z0_hspow(data)                                    (0x00000800&((data)<<11))
#define HDMIPHY_REG_BANDGAP_Z0_z0_res(data)                                   (0x000007C0&((data)<<6))
#define HDMIPHY_REG_BANDGAP_Z0_z0tst(data)                                    (0x0000003C&((data)<<2))
#define HDMIPHY_REG_BANDGAP_Z0_z0_ok(data)                                    (0x00000002&((data)<<1))
#define HDMIPHY_REG_BANDGAP_Z0_z0_bound(data)                                 (0x00000001&(data))
#define HDMIPHY_REG_BANDGAP_Z0_get_bgpow(data)                                ((0x02000000&(data))>>25)
#define HDMIPHY_REG_BANDGAP_Z0_get_sbg(data)                                  ((0x01800000&(data))>>23)
#define HDMIPHY_REG_BANDGAP_Z0_get_z0pow(data)                                ((0x00400000&(data))>>22)
//#define HDMIPHY_REG_BANDGAP_Z0_get_adjr(data)                                 ((0x003C0000&(data))>>18)   //change postion
#define HDMIPHY_REG_BANDGAP_Z0_get_entst_z0(data)                             ((0x00020000&(data))>>17)
#define HDMIPHY_REG_BANDGAP_Z0_get_z0tune(data)                               ((0x00010000&(data))>>16)
#define HDMIPHY_REG_BANDGAP_Z0_get_spad(data)                                 ((0x00008000&(data))>>15)
#define HDMIPHY_REG_BANDGAP_Z0_get_stst(data)                                 ((0x00007800&(data))>>11)
#define HDMIPHY_REG_BANDGAP_Z0_get_hspow(data)                                ((0x00000400&(data))>>10)
#define HDMIPHY_REG_BANDGAP_Z0_get_z0_res(data)                               ((0x000003C0&(data))>>6)
#define HDMIPHY_REG_BANDGAP_Z0_get_z0tst(data)                                ((0x0000003C&(data))>>2)
#define HDMIPHY_REG_BANDGAP_Z0_get_z0_ok(data)                                ((0x00000002&(data))>>1)
#define HDMIPHY_REG_BANDGAP_Z0_get_z0_bound(data)                             (0x00000001&(data))
#define HDMIPHY_REG_BANDGAP_Z0_sbg_Voltag_1                                      (1<<24)

#define HDMIPHY_REG_PHY_CTL_dummy1800da44_31_21_shift                         (21)
#define HDMIPHY_REG_PHY_CTL_phy_g_rst_n_shift                                 (20)
#define HDMIPHY_REG_PHY_CTL_phy_r_rst_n_shift                                 (19)
#define HDMIPHY_REG_PHY_CTL_phy_b_rst_n_shift                                 (18)
#define HDMIPHY_REG_PHY_CTL_phy_ck_pll_rst_n_shift                            (17)
#define HDMIPHY_REG_PHY_CTL_phy_ck_rst_n_shift                                (16)
#define HDMIPHY_REG_PHY_CTL_reg_top_shift                                     (8)
#define HDMIPHY_REG_PHY_CTL_dummy1800da44_7_6_shift                           (6)
#define HDMIPHY_REG_PHY_CTL_reg_ckcmp_shift                                   (5)
#define HDMIPHY_REG_PHY_CTL_reg_ckdet_shift                                   (2)
#define HDMIPHY_REG_PHY_CTL_reg_cklatch_shift                                 (1)
#define HDMIPHY_REG_PHY_CTL_debug_select_shift                                (0)
#define HDMIPHY_REG_PHY_CTL_dummy1800da44_31_21_mask                          (0xFFE00000)
#define HDMIPHY_REG_PHY_CTL_dfe_rstn_n_mask                                   (0x40000000)
#define HDMIPHY_REG_PHY_CTL_b_dig_cdr_rstb_mask                               (0x20000000)
#define HDMIPHY_REG_PHY_CTL_b_dig_rstb_mask                                   (0x10000000)
#define HDMIPHY_REG_PHY_CTL_g_dig_cdr_rstb_mask                               (0x08000000)
#define HDMIPHY_REG_PHY_CTL_g_dig_rstb_mask                                   (0x04000000)
#define HDMIPHY_REG_PHY_CTL_r_dig_cdr_rstb_mask                               (0x02000000)
#define HDMIPHY_REG_PHY_CTL_r_dig_rstb_mask                                   (0x01000000)
#define HDMIPHY_REG_PHY_CTL_ck_vcorstb_mask                                   (0x00400000)
#define HDMIPHY_REG_PHY_CTL_ck_pllrstb_mask                                   (0x00200000)
#define HDMIPHY_REG_PHY_CTL_ck_md_rstb_mask                                   (0x00100000)
#define HDMIPHY_REG_PHY_CTL_phy_g_rst_n_mask                                  (0x00100000)
#define HDMIPHY_REG_PHY_CTL_phy_r_rst_n_mask                                  (0x00080000)
#define HDMIPHY_REG_PHY_CTL_phy_b_rst_n_mask                                  (0x00040000)
#define HDMIPHY_REG_PHY_CTL_phy_ck_pll_rst_n_mask                             (0x00020000)
#define HDMIPHY_REG_PHY_CTL_phy_ck_rst_n_mask                                 (0x00010000)
#define HDMIPHY_REG_PHY_CTL_reg_top_mask                                      (0x0000FF00)
#define HDMIPHY_REG_PHY_CTL_dummy1800da44_7_6_mask                            (0x000000C0)
#define HDMIPHY_REG_PHY_CTL_reg_ckcmp_mask                                    (0x00000020)
#define HDMIPHY_REG_PHY_CTL_reg_ckdet_mask                                    (0x0000001C)
#define HDMIPHY_REG_PHY_CTL_reg_cklatch_mask                                  (0x00000002)
#define HDMIPHY_REG_PHY_CTL_debug_select_mask                                 (0x00000001)
#define HDMIPHY_REG_PHY_CTL_dummy1800da44_31_21(data)                         (0xFFE00000&((data)<<21))
#define HDMIPHY_REG_PHY_CTL_phy_g_rst_n(data)                                 (0x00100000&((data)<<20))
#define HDMIPHY_REG_PHY_CTL_phy_r_rst_n(data)                                 (0x00080000&((data)<<19))
#define HDMIPHY_REG_PHY_CTL_phy_b_rst_n(data)                                 (0x00040000&((data)<<18))
#define HDMIPHY_REG_PHY_CTL_phy_ck_pll_rst_n(data)                            (0x00020000&((data)<<17))
#define HDMIPHY_REG_PHY_CTL_phy_ck_rst_n(data)                                (0x00010000&((data)<<16))
#define HDMIPHY_REG_PHY_CTL_reg_top(data)                                     (0x0000FF00&((data)<<8))
#define HDMIPHY_REG_PHY_CTL_dummy1800da44_7_6(data)                           (0x000000C0&((data)<<6))
#define HDMIPHY_REG_PHY_CTL_reg_ckcmp(data)                                   (0x00000020&((data)<<5))
#define HDMIPHY_REG_PHY_CTL_reg_ckdet(data)                                   (0x0000001C&((data)<<2))
#define HDMIPHY_REG_PHY_CTL_reg_cklatch(data)                                 (0x00000002&((data)<<1))
#define HDMIPHY_REG_PHY_CTL_debug_select(data)                                (0x00000001&(data))
#define HDMIPHY_REG_PHY_CTL_get_dummy1800da44_31_21(data)                     ((0xFFE00000&(data))>>21)
#define HDMIPHY_REG_PHY_CTL_get_phy_g_rst_n(data)                             ((0x00100000&(data))>>20)
#define HDMIPHY_REG_PHY_CTL_get_phy_r_rst_n(data)                             ((0x00080000&(data))>>19)
#define HDMIPHY_REG_PHY_CTL_get_phy_b_rst_n(data)                             ((0x00040000&(data))>>18)
#define HDMIPHY_REG_PHY_CTL_get_phy_ck_pll_rst_n(data)                        ((0x00020000&(data))>>17)
#define HDMIPHY_REG_PHY_CTL_get_phy_ck_rst_n(data)                            ((0x00010000&(data))>>16)
#define HDMIPHY_REG_PHY_CTL_get_reg_top(data)                                 ((0x0000FF00&(data))>>8)
#define HDMIPHY_REG_PHY_CTL_get_dummy1800da44_7_6(data)                       ((0x000000C0&(data))>>6)
#define HDMIPHY_REG_PHY_CTL_get_reg_ckcmp(data)                               ((0x00000020&(data))>>5)
#define HDMIPHY_REG_PHY_CTL_get_reg_ckdet(data)                               ((0x0000001C&(data))>>2)
#define HDMIPHY_REG_PHY_CTL_get_reg_cklatch(data)                             ((0x00000002&(data))>>1)
#define HDMIPHY_REG_PHY_CTL_get_debug_select(data)                            (0x00000001&(data))
#define HDMIPHY_REG_PHY_CTL_CK_MHL_Bias(data)				         (0x00000C00&((data)<<10))
#define HDMIPHY_REG_PHY_CTL_CK_P0_ON                                                    (1<<2)
#define HDMIPHY_REG_PHY_CTL_CK_P1_ON                                                    (1<<3)
#define HDMIPHY_REG_PHY_CTL_CK_P2_ON                                                    (1<<4)
#define HDMIPHY_REG_PHY_CTL_CK_MHL_BiasMask                                   ((1<<11)|(1<<10))
/*
#define HDMIPHY_REG_RGB_KOFF_SEL_reg                                          0xb800fb48
#define HDMIPHY_REG_RG_EQCON_reg                                              0xb800fb4c
#define HDMIPHY_REG_B_EQCON_reg                                               0xb800fb50
#define HDMIPHY_REG_R_13_14_reg                                               0xb800fb54
#define HDMIPHY_REG_G_13_14_reg                                               0xb800fb58
#define HDMIPHY_REG_B_13_14_reg                                               0xb800fb5c
*/
#define HDMIPHY_REG_RGB_KOFF_SEL_reg_top_out_shift                            (24)
#define HDMIPHY_REG_RGB_KOFF_SEL_r_koff_sel_shift                             (16)
#define HDMIPHY_REG_RGB_KOFF_SEL_g_koff_sel_shift                             (8)
#define HDMIPHY_REG_RGB_KOFF_SEL_b_koff_sel_shift                             (0)
#define HDMIPHY_REG_RGB_KOFF_SEL_reg_top_out_mask                             (0xFF000000)
#define HDMIPHY_REG_RGB_KOFF_SEL_r_koff_sel_mask                              (0x001F0000)
#define HDMIPHY_REG_RGB_KOFF_SEL_g_koff_sel_mask                              (0x00001F00)
#define HDMIPHY_REG_RGB_KOFF_SEL_b_koff_sel_mask                              (0x0000001F)
#define HDMIPHY_REG_RGB_KOFF_SEL_reg_top_out(data)                            (0xFF000000&((data)<<24))
#define HDMIPHY_REG_RGB_KOFF_SEL_r_koff_sel(data)                             (0x001F0000&((data)<<16))
#define HDMIPHY_REG_RGB_KOFF_SEL_g_koff_sel(data)                             (0x00001F00&((data)<<8))
#define HDMIPHY_REG_RGB_KOFF_SEL_b_koff_sel(data)                             (0x0000001F&(data))
#define HDMIPHY_REG_RGB_KOFF_SEL_get_reg_top_out(data)                        ((0xFF000000&(data))>>24)
#define HDMIPHY_REG_RGB_KOFF_SEL_get_r_koff_sel(data)                         ((0x001F0000&(data))>>16)
#define HDMIPHY_REG_RGB_KOFF_SEL_get_g_koff_sel(data)                         ((0x00001F00&(data))>>8)
#define HDMIPHY_REG_RGB_KOFF_SEL_get_b_koff_sel(data)                         (0x0000001F&(data))


#define HDMIPHY_REG_BANDGAP_Z0_CTRL_adjr_0_shift                              (16)
#define HDMIPHY_REG_BANDGAP_Z0_CTRL_adjr_1_shift                              (8)
#define HDMIPHY_REG_BANDGAP_Z0_CTRL_adjr_2_shift                              (0)
#define HDMIPHY_REG_BANDGAP_Z0_CTRL_adjr_0_mask                               (0x001F0000)    
#define HDMIPHY_REG_BANDGAP_Z0_CTRL_adjr_1_mask                               (0x00001F00)	
#define HDMIPHY_REG_BANDGAP_Z0_CTRL_adjr_2_mask                               (0x0000001F)	
#define HDMIPHY_REG_BANDGAP_Z0_CTRL_adjr_0(data)                              (0x001F0000&((data)<<16))
#define HDMIPHY_REG_BANDGAP_Z0_CTRL_adjr_1(data)                              (0x00001F00&((data)<<8))
#define HDMIPHY_REG_BANDGAP_Z0_CTRL_adjr_2(data)                              (0x0000001F&(data))
#define HDMIPHY_REG_BANDGAP_Z0_CTRL_get_adjr_0(data)                          ((0x001F0000&(data))>>16)
#define HDMIPHY_REG_BANDGAP_Z0_CTRL_get_adjr_1(data)                          ((0x00001F00&(data))>>8)
#define HDMIPHY_REG_BANDGAP_Z0_CTRL_get_adjr_2(data)                          (0x0000001F&(data))


#define REG_DIG_R_1_r_reg_dr_slow_shift                               (30)
#define REG_DIG_R_1_r_reg_eq_thr_shift                                (26)
#define REG_DIG_R_1_r_reg_eq_stable_chk_en_shift                      (25)
#define REG_DIG_R_1_r_reg_eq_slicer_en_shift                          (24)
#define REG_DIG_R_1_r_reg_filter_out_shift                            (17)
#define REG_DIG_R_1_r_reg_eq_selreg_shift                             (16)
#define REG_DIG_R_1_r_reg_eq_gain_shift                               (14)
#define REG_DIG_R_1_r_reg_bypass_sdm_int_shift                        (13)
#define REG_DIG_R_1_r_reg_cdr_ki_shift                                (10)
#define REG_DIG_R_1_r_reg_cdr_kd_shift                                (9)
#define REG_DIG_R_1_r_reg_cdr_kp2_shift                               (6)
#define REG_DIG_R_1_r_reg_cdr_kp1_shift                               (3)
#define REG_DIG_R_1_r_reg_rate_sel_shift                              (0)
#define REG_DIG_R_1_r_reg_dr_slow_mask                                (0x40000000)
#define REG_DIG_R_1_r_reg_eq_thr_mask                                 (0x3C000000)
#define REG_DIG_R_1_r_reg_eq_stable_chk_en_mask                       (0x02000000)
#define REG_DIG_R_1_r_reg_eq_slicer_en_mask                           (0x01000000)
#define REG_DIG_R_1_r_reg_filter_out_mask                             (0x00FE0000)
#define REG_DIG_R_1_r_reg_eq_selreg_mask                              (0x00010000)
#define REG_DIG_R_1_r_reg_eq_gain_mask                                (0x0000C000)
#define REG_DIG_R_1_r_reg_bypass_sdm_int_mask                         (0x00002000)
#define REG_DIG_R_1_r_reg_cdr_ki_mask                                 (0x00001C00)
#define REG_DIG_R_1_r_reg_cdr_kd_mask                                 (0x00000200)
#define REG_DIG_R_1_r_reg_cdr_kp2_mask                                (0x000001C0)
#define REG_DIG_R_1_r_reg_cdr_kp1_mask                                (0x00000038)
#define REG_DIG_R_1_r_reg_rate_sel_mask                               (0x00000007)
#define REG_DIG_R_1_r_reg_dr_slow(data)                               (0x40000000&((data)<<30))
#define REG_DIG_R_1_r_reg_eq_thr(data)                                (0x3C000000&((data)<<26))
#define REG_DIG_R_1_r_reg_eq_stable_chk_en(data)                      (0x02000000&((data)<<25))
#define REG_DIG_R_1_r_reg_eq_slicer_en(data)                          (0x01000000&((data)<<24))
#define REG_DIG_R_1_r_reg_filter_out(data)                            (0x00FE0000&((data)<<17))
#define REG_DIG_R_1_r_reg_eq_selreg(data)                             (0x00010000&((data)<<16))
#define REG_DIG_R_1_r_reg_eq_gain(data)                               (0x0000C000&((data)<<14))
#define REG_DIG_R_1_r_reg_bypass_sdm_int(data)                        (0x00002000&((data)<<13))
#define REG_DIG_R_1_r_reg_cdr_ki(data)                                (0x00001C00&((data)<<10))
#define REG_DIG_R_1_r_reg_cdr_kd(data)                                (0x00000200&((data)<<9))
#define REG_DIG_R_1_r_reg_cdr_kp2(data)                               (0x000001C0&((data)<<6))
#define REG_DIG_R_1_r_reg_cdr_kp1(data)                               (0x00000038&((data)<<3))
#define REG_DIG_R_1_r_reg_rate_sel(data)                              (0x00000007&(data))
#define REG_DIG_R_1_get_r_reg_dr_slow(data)                           ((0x40000000&(data))>>30)
#define REG_DIG_R_1_get_r_reg_eq_thr(data)                            ((0x3C000000&(data))>>26)
#define REG_DIG_R_1_get_r_reg_eq_stable_chk_en(data)                  ((0x02000000&(data))>>25)
#define REG_DIG_R_1_get_r_reg_eq_slicer_en(data)                      ((0x01000000&(data))>>24)
#define REG_DIG_R_1_get_r_reg_filter_out(data)                        ((0x00FE0000&(data))>>17)
#define REG_DIG_R_1_get_r_reg_eq_selreg(data)                         ((0x00010000&(data))>>16)
#define REG_DIG_R_1_get_r_reg_eq_gain(data)                           ((0x0000C000&(data))>>14)
#define REG_DIG_R_1_get_r_reg_bypass_sdm_int(data)                    ((0x00002000&(data))>>13)
#define REG_DIG_R_1_get_r_reg_cdr_ki(data)                            ((0x00001C00&(data))>>10)
#define REG_DIG_R_1_get_r_reg_cdr_kd(data)                            ((0x00000200&(data))>>9)
#define REG_DIG_R_1_get_r_reg_cdr_kp2(data)                           ((0x000001C0&(data))>>6)
#define REG_DIG_R_1_get_r_reg_cdr_kp1(data)                           ((0x00000038&(data))>>3)
#define REG_DIG_R_1_get_r_reg_rate_sel(data)                          (0x00000007&(data))


#define REG_DIG_R_2_r_reg_pr_msb_shift                                (20)
#define REG_DIG_R_2_r_reg_pr_lsb_shift                                (12)
#define REG_DIG_R_2_r_reg_pr_auto_shift                               (10)
#define REG_DIG_R_2_r_reg_eq_average_shift                            (8)
#define REG_DIG_R_2_r_reg_eq_hold_shift                               (7)
#define REG_DIG_R_2_r_reg_timer_eq_shift                              (2)
#define REG_DIG_R_2_r_reg_testout_sel_shift                           (0)
#define REG_DIG_R_2_r_reg_pr_msb_mask                                 (0x0FF00000)
#define REG_DIG_R_2_r_reg_pr_lsb_mask                                 (0x000FF000)
#define REG_DIG_R_2_r_reg_pr_auto_mask                                (0x00000400)
#define REG_DIG_R_2_r_reg_eq_average_mask                             (0x00000300)
#define REG_DIG_R_2_r_reg_eq_hold_mask                                (0x00000080)
#define REG_DIG_R_2_r_reg_timer_eq_mask                               (0x0000007C)
#define REG_DIG_R_2_r_reg_testout_sel_mask                            (0x00000003)
#define REG_DIG_R_2_r_reg_pr_msb(data)                                (0x0FF00000&((data)<<20))
#define REG_DIG_R_2_r_reg_pr_lsb(data)                                (0x000FF000&((data)<<12))
#define REG_DIG_R_2_r_reg_pr_auto(data)                               (0x00000400&((data)<<10))
#define REG_DIG_R_2_r_reg_eq_average(data)                            (0x00000300&((data)<<8))
#define REG_DIG_R_2_r_reg_eq_hold(data)                               (0x00000080&((data)<<7))
#define REG_DIG_R_2_r_reg_timer_eq(data)                              (0x0000007C&((data)<<2))
#define REG_DIG_R_2_r_reg_testout_sel(data)                           (0x00000003&(data))
#define REG_DIG_R_2_get_r_reg_pr_msb(data)                            ((0x0FF00000&(data))>>20)
#define REG_DIG_R_2_get_r_reg_pr_lsb(data)                            ((0x000FF000&(data))>>12)
#define REG_DIG_R_2_get_r_reg_pr_auto(data)                           ((0x00000400&(data))>>10)
#define REG_DIG_R_2_get_r_reg_eq_average(data)                        ((0x00000300&(data))>>8)
#define REG_DIG_R_2_get_r_reg_eq_hold(data)                           ((0x00000080&(data))>>7)
#define REG_DIG_R_2_get_r_reg_timer_eq(data)                          ((0x0000007C&(data))>>2)
#define REG_DIG_R_2_get_r_reg_testout_sel(data)                       (0x00000003&(data))


#define REG_DIG_R_3_r_filter_out_eq_shift                             (16)
#define REG_DIG_R_3_r_en_shift                                        (8)
#define REG_DIG_R_3_r_st_shift                                        (0)
#define REG_DIG_R_3_r_filter_out_eq_mask                              (0x007F0000)
#define REG_DIG_R_3_r_en_mask                                         (0x0000FF00)
#define REG_DIG_R_3_r_st_mask                                         (0x000000FF)
#define REG_DIG_R_3_r_filter_out_eq(data)                             (0x007F0000&((data)<<16))
#define REG_DIG_R_3_r_en(data)                                        (0x0000FF00&((data)<<8))
#define REG_DIG_R_3_r_st(data)                                        (0x000000FF&(data))
#define REG_DIG_R_3_get_r_filter_out_eq(data)                         ((0x007F0000&(data))>>16)
#define REG_DIG_R_3_get_r_en(data)                                    ((0x0000FF00&(data))>>8)
#define REG_DIG_R_3_get_r_st(data)                                    (0x000000FF&(data))


#define REG_DIG_R_4_r_thermal_out_eq_shift                            (0)
#define REG_DIG_R_4_r_thermal_out_eq_mask                             (0x7FFFFFFF)
#define REG_DIG_R_4_r_thermal_out_eq(data)                            (0x7FFFFFFF&(data))
#define REG_DIG_R_4_get_r_thermal_out_eq(data)                        (0x7FFFFFFF&(data))


#define REG_DIG_R_5_r_eq_unstable_shift                               (16)
#define REG_DIG_R_5_r_eq_bin_max_shift                                (8)
#define REG_DIG_R_5_r_eq_bin_min_shift                                (0)
#define REG_DIG_R_5_r_eq_unstable_mask                                (0x00010000)
#define REG_DIG_R_5_r_eq_bin_max_mask                                 (0x00001F00)
#define REG_DIG_R_5_r_eq_bin_min_mask                                 (0x0000001F)
#define REG_DIG_R_5_r_eq_unstable(data)                               (0x00010000&((data)<<16))
#define REG_DIG_R_5_r_eq_bin_max(data)                                (0x00001F00&((data)<<8))
#define REG_DIG_R_5_r_eq_bin_min(data)                                (0x0000001F&(data))
#define REG_DIG_R_5_get_r_eq_unstable(data)                           ((0x00010000&(data))>>16)
#define REG_DIG_R_5_get_r_eq_bin_max(data)                            ((0x00001F00&(data))>>8)
#define REG_DIG_R_5_get_r_eq_bin_min(data)                            (0x0000001F&(data))


#define REG_DIG_G_1_g_reg_dr_slow_shift                               (30)
#define REG_DIG_G_1_g_reg_eq_thr_shift                                (26)
#define REG_DIG_G_1_g_reg_eq_stable_chk_en_shift                      (25)
#define REG_DIG_G_1_g_reg_eq_slicer_en_shift                          (24)
#define REG_DIG_G_1_g_reg_filter_out_shift                            (17)
#define REG_DIG_G_1_g_reg_eq_selreg_shift                             (16)
#define REG_DIG_G_1_g_reg_eq_gain_shift                               (14)
#define REG_DIG_G_1_g_reg_bypass_sdm_int_shift                        (13)
#define REG_DIG_G_1_g_reg_cdr_ki_shift                                (10)
#define REG_DIG_G_1_g_reg_cdr_kd_shift                                (9)
#define REG_DIG_G_1_g_reg_cdr_kp2_shift                               (6)
#define REG_DIG_G_1_g_reg_cdr_kp1_shift                               (3)
#define REG_DIG_G_1_g_reg_rate_sel_shift                              (0)
#define REG_DIG_G_1_g_reg_dr_slow_mask                                (0x40000000)
#define REG_DIG_G_1_g_reg_eq_thr_mask                                 (0x3C000000)
#define REG_DIG_G_1_g_reg_eq_stable_chk_en_mask                       (0x02000000)
#define REG_DIG_G_1_g_reg_eq_slicer_en_mask                           (0x01000000)
#define REG_DIG_G_1_g_reg_filter_out_mask                             (0x00FE0000)
#define REG_DIG_G_1_g_reg_eq_selreg_mask                              (0x00010000)
#define REG_DIG_G_1_g_reg_eq_gain_mask                                (0x0000C000)
#define REG_DIG_G_1_g_reg_bypass_sdm_int_mask                         (0x00002000)
#define REG_DIG_G_1_g_reg_cdr_ki_mask                                 (0x00001C00)
#define REG_DIG_G_1_g_reg_cdr_kd_mask                                 (0x00000200)
#define REG_DIG_G_1_g_reg_cdr_kp2_mask                                (0x000001C0)
#define REG_DIG_G_1_g_reg_cdr_kp1_mask                                (0x00000038)
#define REG_DIG_G_1_g_reg_rate_sel_mask                               (0x00000007)
#define REG_DIG_G_1_g_reg_dr_slow(data)                               (0x40000000&((data)<<30))
#define REG_DIG_G_1_g_reg_eq_thr(data)                                (0x3C000000&((data)<<26))
#define REG_DIG_G_1_g_reg_eq_stable_chk_en(data)                      (0x02000000&((data)<<25))
#define REG_DIG_G_1_g_reg_eq_slicer_en(data)                          (0x01000000&((data)<<24))
#define REG_DIG_G_1_g_reg_filter_out(data)                            (0x00FE0000&((data)<<17))
#define REG_DIG_G_1_g_reg_eq_selreg(data)                             (0x00010000&((data)<<16))
#define REG_DIG_G_1_g_reg_eq_gain(data)                               (0x0000C000&((data)<<14))
#define REG_DIG_G_1_g_reg_bypass_sdm_int(data)                        (0x00002000&((data)<<13))
#define REG_DIG_G_1_g_reg_cdr_ki(data)                                (0x00001C00&((data)<<10))
#define REG_DIG_G_1_g_reg_cdr_kd(data)                                (0x00000200&((data)<<9))
#define REG_DIG_G_1_g_reg_cdr_kp2(data)                               (0x000001C0&((data)<<6))
#define REG_DIG_G_1_g_reg_cdr_kp1(data)                               (0x00000038&((data)<<3))
#define REG_DIG_G_1_g_reg_rate_sel(data)                              (0x00000007&(data))
#define REG_DIG_G_1_get_g_reg_dr_slow(data)                           ((0x40000000&(data))>>30)
#define REG_DIG_G_1_get_g_reg_eq_thr(data)                            ((0x3C000000&(data))>>26)
#define REG_DIG_G_1_get_g_reg_eq_stable_chk_en(data)                  ((0x02000000&(data))>>25)
#define REG_DIG_G_1_get_g_reg_eq_slicer_en(data)                      ((0x01000000&(data))>>24)
#define REG_DIG_G_1_get_g_reg_filter_out(data)                        ((0x00FE0000&(data))>>17)
#define REG_DIG_G_1_get_g_reg_eq_selreg(data)                         ((0x00010000&(data))>>16)
#define REG_DIG_G_1_get_g_reg_eq_gain(data)                           ((0x0000C000&(data))>>14)
#define REG_DIG_G_1_get_g_reg_bypass_sdm_int(data)                    ((0x00002000&(data))>>13)
#define REG_DIG_G_1_get_g_reg_cdr_ki(data)                            ((0x00001C00&(data))>>10)
#define REG_DIG_G_1_get_g_reg_cdr_kd(data)                            ((0x00000200&(data))>>9)
#define REG_DIG_G_1_get_g_reg_cdr_kp2(data)                           ((0x000001C0&(data))>>6)
#define REG_DIG_G_1_get_g_reg_cdr_kp1(data)                           ((0x00000038&(data))>>3)
#define REG_DIG_G_1_get_g_reg_rate_sel(data)                          (0x00000007&(data))


#define REG_DIG_G_2_g_reg_pr_msb_shift                                (20)
#define REG_DIG_G_2_g_reg_pr_lsb_shift                                (12)
#define REG_DIG_G_2_g_reg_pr_auto_shift                               (10)
#define REG_DIG_G_2_g_reg_eq_average_shift                            (8)
#define REG_DIG_G_2_g_reg_eq_hold_shift                               (7)
#define REG_DIG_G_2_g_reg_timer_eq_shift                              (2)
#define REG_DIG_G_2_g_reg_testout_sel_shift                           (0)
#define REG_DIG_G_2_g_reg_pr_msb_mask                                 (0x0FF00000)
#define REG_DIG_G_2_g_reg_pr_lsb_mask                                 (0x000FF000)
#define REG_DIG_G_2_g_reg_pr_auto_mask                                (0x00000400)
#define REG_DIG_G_2_g_reg_eq_average_mask                             (0x00000300)
#define REG_DIG_G_2_g_reg_eq_hold_mask                                (0x00000080)
#define REG_DIG_G_2_g_reg_timer_eq_mask                               (0x0000007C)
#define REG_DIG_G_2_g_reg_testout_sel_mask                            (0x00000003)
#define REG_DIG_G_2_g_reg_pr_msb(data)                                (0x0FF00000&((data)<<20))
#define REG_DIG_G_2_g_reg_pr_lsb(data)                                (0x000FF000&((data)<<12))
#define REG_DIG_G_2_g_reg_pr_auto(data)                               (0x00000400&((data)<<10))
#define REG_DIG_G_2_g_reg_eq_average(data)                            (0x00000300&((data)<<8))
#define REG_DIG_G_2_g_reg_eq_hold(data)                               (0x00000080&((data)<<7))
#define REG_DIG_G_2_g_reg_timer_eq(data)                              (0x0000007C&((data)<<2))
#define REG_DIG_G_2_g_reg_testout_sel(data)                           (0x00000003&(data))
#define REG_DIG_G_2_get_g_reg_pr_msb(data)                            ((0x0FF00000&(data))>>20)
#define REG_DIG_G_2_get_g_reg_pr_lsb(data)                            ((0x000FF000&(data))>>12)
#define REG_DIG_G_2_get_g_reg_pr_auto(data)                           ((0x00000400&(data))>>10)
#define REG_DIG_G_2_get_g_reg_eq_average(data)                        ((0x00000300&(data))>>8)
#define REG_DIG_G_2_get_g_reg_eq_hold(data)                           ((0x00000080&(data))>>7)
#define REG_DIG_G_2_get_g_reg_timer_eq(data)                          ((0x0000007C&(data))>>2)
#define REG_DIG_G_2_get_g_reg_testout_sel(data)                       (0x00000003&(data))


#define REG_DIG_G_3_g_filter_out_eq_shift                             (16)
#define REG_DIG_G_3_g_en_shift                                        (8)
#define REG_DIG_G_3_g_st_shift                                        (0)
#define REG_DIG_G_3_g_filter_out_eq_mask                              (0x007F0000)
#define REG_DIG_G_3_g_en_mask                                         (0x0000FF00)
#define REG_DIG_G_3_g_st_mask                                         (0x000000FF)
#define REG_DIG_G_3_g_filter_out_eq(data)                             (0x007F0000&((data)<<16))
#define REG_DIG_G_3_g_en(data)                                        (0x0000FF00&((data)<<8))
#define REG_DIG_G_3_g_st(data)                                        (0x000000FF&(data))
#define REG_DIG_G_3_get_g_filter_out_eq(data)                         ((0x007F0000&(data))>>16)
#define REG_DIG_G_3_get_g_en(data)                                    ((0x0000FF00&(data))>>8)
#define REG_DIG_G_3_get_g_st(data)                                    (0x000000FF&(data))


#define REG_DIG_G_4_g_thermal_out_eq_shift                            (0)
#define REG_DIG_G_4_g_thermal_out_eq_mask                             (0x7FFFFFFF)
#define REG_DIG_G_4_g_thermal_out_eq(data)                            (0x7FFFFFFF&(data))
#define REG_DIG_G_4_get_g_thermal_out_eq(data)                        (0x7FFFFFFF&(data))


#define REG_DIG_G_5_g_eq_unstable_shift                               (16)
#define REG_DIG_G_5_g_eq_bin_max_shift                                (8)
#define REG_DIG_G_5_g_eq_bin_min_shift                                (0)
#define REG_DIG_G_5_g_eq_unstable_mask                                (0x00010000)
#define REG_DIG_G_5_g_eq_bin_max_mask                                 (0x00001F00)
#define REG_DIG_G_5_g_eq_bin_min_mask                                 (0x0000001F)
#define REG_DIG_G_5_g_eq_unstable(data)                               (0x00010000&((data)<<16))
#define REG_DIG_G_5_g_eq_bin_max(data)                                (0x00001F00&((data)<<8))
#define REG_DIG_G_5_g_eq_bin_min(data)                                (0x0000001F&(data))
#define REG_DIG_G_5_get_g_eq_unstable(data)                           ((0x00010000&(data))>>16)
#define REG_DIG_G_5_get_g_eq_bin_max(data)                            ((0x00001F00&(data))>>8)
#define REG_DIG_G_5_get_g_eq_bin_min(data)                            (0x0000001F&(data))


#define REG_DIG_B_1_b_reg_dr_slow_shift                               (30)
#define REG_DIG_B_1_b_reg_eq_thr_shift                                (26)
#define REG_DIG_B_1_b_reg_eq_stable_chk_en_shift                      (25)
#define REG_DIG_B_1_b_reg_eq_slicer_en_shift                          (24)
#define REG_DIG_B_1_b_reg_filter_out_shift                            (17)
#define REG_DIG_B_1_b_reg_eq_selreg_shift                             (16)
#define REG_DIG_B_1_b_reg_eq_gain_shift                               (14)
#define REG_DIG_B_1_b_reg_bypass_sdm_int_shift                        (13)
#define REG_DIG_B_1_b_reg_cdr_ki_shift                                (10)
#define REG_DIG_B_1_b_reg_cdr_kd_shift                                (9)
#define REG_DIG_B_1_b_reg_cdr_kp2_shift                               (6)
#define REG_DIG_B_1_b_reg_cdr_kp1_shift                               (3)
#define REG_DIG_B_1_b_reg_rate_sel_shift                              (0)
#define REG_DIG_B_1_b_reg_dr_slow_mask                                (0x40000000)
#define REG_DIG_B_1_b_reg_eq_thr_mask                                 (0x3C000000)
#define REG_DIG_B_1_b_reg_eq_stable_chk_en_mask                       (0x02000000)
#define REG_DIG_B_1_b_reg_eq_slicer_en_mask                           (0x01000000)
#define REG_DIG_B_1_b_reg_filter_out_mask                             (0x00FE0000)
#define REG_DIG_B_1_b_reg_eq_selreg_mask                              (0x00010000)
#define REG_DIG_B_1_b_reg_eq_gain_mask                                (0x0000C000)
#define REG_DIG_B_1_b_reg_bypass_sdm_int_mask                         (0x00002000)
#define REG_DIG_B_1_b_reg_cdr_ki_mask                                 (0x00001C00)
#define REG_DIG_B_1_b_reg_cdr_kd_mask                                 (0x00000200)
#define REG_DIG_B_1_b_reg_cdr_kp2_mask                                (0x000001C0)
#define REG_DIG_B_1_b_reg_cdr_kp1_mask                                (0x00000038)
#define REG_DIG_B_1_b_reg_rate_sel_mask                               (0x00000007)
#define REG_DIG_B_1_b_reg_dr_slow(data)                               (0x40000000&((data)<<30))
#define REG_DIG_B_1_b_reg_eq_thr(data)                                (0x3C000000&((data)<<26))
#define REG_DIG_B_1_b_reg_eq_stable_chk_en(data)                      (0x02000000&((data)<<25))
#define REG_DIG_B_1_b_reg_eq_slicer_en(data)                          (0x01000000&((data)<<24))
#define REG_DIG_B_1_b_reg_filter_out(data)                            (0x00FE0000&((data)<<17))
#define REG_DIG_B_1_b_reg_eq_selreg(data)                             (0x00010000&((data)<<16))
#define REG_DIG_B_1_b_reg_eq_gain(data)                               (0x0000C000&((data)<<14))
#define REG_DIG_B_1_b_reg_bypass_sdm_int(data)                        (0x00002000&((data)<<13))
#define REG_DIG_B_1_b_reg_cdr_ki(data)                                (0x00001C00&((data)<<10))
#define REG_DIG_B_1_b_reg_cdr_kd(data)                                (0x00000200&((data)<<9))
#define REG_DIG_B_1_b_reg_cdr_kp2(data)                               (0x000001C0&((data)<<6))
#define REG_DIG_B_1_b_reg_cdr_kp1(data)                               (0x00000038&((data)<<3))
#define REG_DIG_B_1_b_reg_rate_sel(data)                              (0x00000007&(data))
#define REG_DIG_B_1_get_b_reg_dr_slow(data)                           ((0x40000000&(data))>>30)
#define REG_DIG_B_1_get_b_reg_eq_thr(data)                            ((0x3C000000&(data))>>26)
#define REG_DIG_B_1_get_b_reg_eq_stable_chk_en(data)                  ((0x02000000&(data))>>25)
#define REG_DIG_B_1_get_b_reg_eq_slicer_en(data)                      ((0x01000000&(data))>>24)
#define REG_DIG_B_1_get_b_reg_filter_out(data)                        ((0x00FE0000&(data))>>17)
#define REG_DIG_B_1_get_b_reg_eq_selreg(data)                         ((0x00010000&(data))>>16)
#define REG_DIG_B_1_get_b_reg_eq_gain(data)                           ((0x0000C000&(data))>>14)
#define REG_DIG_B_1_get_b_reg_bypass_sdm_int(data)                    ((0x00002000&(data))>>13)
#define REG_DIG_B_1_get_b_reg_cdr_ki(data)                            ((0x00001C00&(data))>>10)
#define REG_DIG_B_1_get_b_reg_cdr_kd(data)                            ((0x00000200&(data))>>9)
#define REG_DIG_B_1_get_b_reg_cdr_kp2(data)                           ((0x000001C0&(data))>>6)
#define REG_DIG_B_1_get_b_reg_cdr_kp1(data)                           ((0x00000038&(data))>>3)
#define REG_DIG_B_1_get_b_reg_rate_sel(data)                          (0x00000007&(data))


#define REG_DIG_B_2_b_reg_pr_msb_shift                                (20)
#define REG_DIG_B_2_b_reg_pr_lsb_shift                                (12)
#define REG_DIG_B_2_b_reg_pr_auto_shift                               (10)
#define REG_DIG_B_2_b_reg_eq_average_shift                            (8)
#define REG_DIG_B_2_b_reg_eq_hold_shift                               (7)
#define REG_DIG_B_2_b_reg_timer_eq_shift                              (2)
#define REG_DIG_B_2_b_reg_testout_sel_shift                           (0)
#define REG_DIG_B_2_b_reg_pr_msb_mask                                 (0x0FF00000)
#define REG_DIG_B_2_b_reg_pr_lsb_mask                                 (0x000FF000)
#define REG_DIG_B_2_b_reg_pr_auto_mask                                (0x00000400)
#define REG_DIG_B_2_b_reg_eq_average_mask                             (0x00000300)
#define REG_DIG_B_2_b_reg_eq_hold_mask                                (0x00000080)
#define REG_DIG_B_2_b_reg_timer_eq_mask                               (0x0000007C)
#define REG_DIG_B_2_b_reg_testout_sel_mask                            (0x00000003)
#define REG_DIG_B_2_b_reg_pr_msb(data)                                (0x0FF00000&((data)<<20))
#define REG_DIG_B_2_b_reg_pr_lsb(data)                                (0x000FF000&((data)<<12))
#define REG_DIG_B_2_b_reg_pr_auto(data)                               (0x00000400&((data)<<10))
#define REG_DIG_B_2_b_reg_eq_average(data)                            (0x00000300&((data)<<8))
#define REG_DIG_B_2_b_reg_eq_hold(data)                               (0x00000080&((data)<<7))
#define REG_DIG_B_2_b_reg_timer_eq(data)                              (0x0000007C&((data)<<2))
#define REG_DIG_B_2_b_reg_testout_sel(data)                           (0x00000003&(data))
#define REG_DIG_B_2_get_b_reg_pr_msb(data)                            ((0x0FF00000&(data))>>20)
#define REG_DIG_B_2_get_b_reg_pr_lsb(data)                            ((0x000FF000&(data))>>12)
#define REG_DIG_B_2_get_b_reg_pr_auto(data)                           ((0x00000400&(data))>>10)
#define REG_DIG_B_2_get_b_reg_eq_average(data)                        ((0x00000300&(data))>>8)
#define REG_DIG_B_2_get_b_reg_eq_hold(data)                           ((0x00000080&(data))>>7)
#define REG_DIG_B_2_get_b_reg_timer_eq(data)                          ((0x0000007C&(data))>>2)
#define REG_DIG_B_2_get_b_reg_testout_sel(data)                       (0x00000003&(data))


#define REG_DIG_B_3_b_filter_out_eq_shift                             (16)
#define REG_DIG_B_3_b_en_shift                                        (8)
#define REG_DIG_B_3_b_st_shift                                        (0)
#define REG_DIG_B_3_b_filter_out_eq_mask                              (0x007F0000)
#define REG_DIG_B_3_b_en_mask                                         (0x0000FF00)
#define REG_DIG_B_3_b_st_mask                                         (0x000000FF)
#define REG_DIG_B_3_b_filter_out_eq(data)                             (0x007F0000&((data)<<16))
#define REG_DIG_B_3_b_en(data)                                        (0x0000FF00&((data)<<8))
#define REG_DIG_B_3_b_st(data)                                        (0x000000FF&(data))
#define REG_DIG_B_3_get_b_filter_out_eq(data)                         ((0x007F0000&(data))>>16)
#define REG_DIG_B_3_get_b_en(data)                                    ((0x0000FF00&(data))>>8)
#define REG_DIG_B_3_get_b_st(data)                                    (0x000000FF&(data))


#define REG_DIG_B_4_b_thermal_out_eq_shift                            (0)
#define REG_DIG_B_4_b_thermal_out_eq_mask                             (0x7FFFFFFF)
#define REG_DIG_B_4_b_thermal_out_eq(data)                            (0x7FFFFFFF&(data))
#define REG_DIG_B_4_get_b_thermal_out_eq(data)                        (0x7FFFFFFF&(data))


#define REG_DIG_B_5_b_eq_unstable_shift                               (16)
#define REG_DIG_B_5_b_eq_bin_max_shift                                (8)
#define REG_DIG_B_5_b_eq_bin_min_shift                                (0)
#define REG_DIG_B_5_b_eq_unstable_mask                                (0x00010000)
#define REG_DIG_B_5_b_eq_bin_max_mask                                 (0x00001F00)
#define REG_DIG_B_5_b_eq_bin_min_mask                                 (0x0000001F)
#define REG_DIG_B_5_b_eq_unstable(data)                               (0x00010000&((data)<<16))
#define REG_DIG_B_5_b_eq_bin_max(data)                                (0x00001F00&((data)<<8))
#define REG_DIG_B_5_b_eq_bin_min(data)                                (0x0000001F&(data))
#define REG_DIG_B_5_get_b_eq_unstable(data)                           ((0x00010000&(data))>>16)
#define REG_DIG_B_5_get_b_eq_bin_max(data)                            ((0x00001F00&(data))>>8)
#define REG_DIG_B_5_get_b_eq_bin_min(data)                            (0x0000001F&(data))


#define REG_CK_MD_ck_mod_sel_shift                                    (24)
#define REG_CK_MD_ck_md_count_shift                                   (9)
#define REG_CK_MD_ck_rate_shift                                       (5)
#define REG_CK_MD_ck_md_ok_shift                                      (4)
#define REG_CK_MD_ck_md_adj_shift                                     (1)
#define REG_CK_MD_ck_md_auto_shift                                    (0)
#define REG_CK_MD_ck_mod_sel_mask                                     (0x03000000)
#define REG_CK_MD_ck_md_count_mask                                    (0x001FFE00)
#define REG_CK_MD_ck_rate_mask                                        (0x000001E0)
#define REG_CK_MD_ck_md_ok_mask                                       (0x00000010)
#define REG_CK_MD_ck_md_adj_mask                                      (0x0000000E)
#define REG_CK_MD_ck_md_auto_mask                                     (0x00000001)
#define REG_CK_MD_ck_mod_sel(data)                                    (0x03000000&((data)<<24))
#define REG_CK_MD_ck_md_count(data)                                   (0x001FFE00&((data)<<9))
#define REG_CK_MD_ck_rate(data)                                       (0x000001E0&((data)<<5))
#define REG_CK_MD_ck_md_ok(data)                                      (0x00000010&((data)<<4))
#define REG_CK_MD_ck_md_adj(data)                                     (0x0000000E&((data)<<1))
#define REG_CK_MD_ck_md_auto(data)                                    (0x00000001&(data))
#define REG_CK_MD_get_ck_mod_sel(data)                                ((0x03000000&(data))>>24)
#define REG_CK_MD_get_ck_md_count(data)                               ((0x001FFE00&(data))>>9)
#define REG_CK_MD_get_ck_rate(data)                                   ((0x000001E0&(data))>>5)
#define REG_CK_MD_get_ck_md_ok(data)                                  ((0x00000010&(data))>>4)
#define REG_CK_MD_get_ck_md_adj(data)                                 ((0x0000000E&(data))>>1)
#define REG_CK_MD_get_ck_md_auto(data)                                (0x00000001&(data))


#define REG_MHL_CTRL_reg_phy_sel_shift                                (31)
#define REG_MHL_CTRL_reg_z300_sel_2_shift                             (6)
#define REG_MHL_CTRL_reg_z300_sel_1_shift                             (5)
#define REG_MHL_CTRL_reg_z300_sel_0_shift                             (4)
#define REG_MHL_CTRL_reg_enddc_shift                                  (3)
#define REG_MHL_CTRL_reg_mhlpow_shift                                 (2)
#define REG_MHL_CTRL_reg_mhl_hdmisel_shift                            (1)
#define REG_MHL_CTRL_reg_z100k_enb_shift                              (0)
#define REG_MHL_CTRL_reg_phy_sel_mask                                 (0x80000000)
#define REG_MHL_CTRL_reg_z300pow_mask                                 (0x00000700)
#define REG_MHL_CTRL_reg_z300_sel_2_mask                              (0x00000040)
#define REG_MHL_CTRL_reg_z300_sel_1_mask                              (0x00000020)
#define REG_MHL_CTRL_reg_z300_sel_0_mask                              (0x00000010)
#define REG_MHL_CTRL_reg_enddc_mask                                   (0x00000008)
#define REG_MHL_CTRL_reg_mhlpow_mask                                  (0x00000004)
#define REG_MHL_CTRL_reg_mhl_hdmisel_mask                             (0x00000002)
#define REG_MHL_CTRL_reg_z100k_enb_mask                               (0x00000001)
#define REG_MHL_CTRL_reg_phy_sel(data)                                (0x80000000&((data)<<31))
#define REG_MHL_CTRL_reg_z300pow(data)                                (0x00000700&((data)<<8))
#define REG_MHL_CTRL_reg_z300_sel_2(data)                             (0x00000040&((data)<<6))
#define REG_MHL_CTRL_reg_z300_sel_1(data)                             (0x00000020&((data)<<5))
#define REG_MHL_CTRL_reg_z300_sel_0(data)                             (0x00000010&((data)<<4))
#define REG_MHL_CTRL_reg_enddc(data)                                  (0x00000008&((data)<<3))
#define REG_MHL_CTRL_reg_mhlpow(data)                                 (0x00000004&((data)<<2))
#define REG_MHL_CTRL_reg_mhl_hdmisel(data)                            (0x00000002&((data)<<1))
#define REG_MHL_CTRL_reg_z100k_enb(data)                              (0x00000001&(data))
#define REG_MHL_CTRL_get_reg_phy_sel(data)                            ((0x80000000&(data))>>31)
#define REG_MHL_CTRL_get_reg_z300_sel_2(data)                         ((0x00000040&(data))>>6)
#define REG_MHL_CTRL_get_reg_z300_sel_1(data)                         ((0x00000020&(data))>>5)
#define REG_MHL_CTRL_get_reg_z300_sel_0(data)                         ((0x00000010&(data))>>4)
#define REG_MHL_CTRL_get_reg_enddc(data)                              ((0x00000008&(data))>>3)
#define REG_MHL_CTRL_get_reg_mhlpow(data)                             ((0x00000004&(data))>>2)
#define REG_MHL_CTRL_get_reg_mhl_hdmisel(data)                        ((0x00000002&(data))>>1)
#define REG_MHL_CTRL_get_reg_z100k_enb(data)                          (0x00000001&(data))

#define HDMIPHY_DPLL_CTRL_reg_dpll_pow_mask                                   (0x00000008)
#define HDMIPHY_DPLL_CTRL_pow_ldo_mask                                        (0x00000001)
#define HDMIPHY_DPLL_CTRL_reg_dpll_pow(data)                                  (0x00000008&((data)<<3))
#define HDMIPHY_DPLL_CTRL_pow_ldo(data)                                       (0x00000001&(data))

#define HDMIPHY_REG_BANDGAP_Z0_CTRL_2_reg_z0_ibxadj_shift                     (20)
#define HDMIPHY_REG_BANDGAP_Z0_CTRL_2_reg_ck_z0pow_shift                      (16)
#define HDMIPHY_REG_BANDGAP_Z0_CTRL_2_reg_b_z0pow_shift                       (12)
#define HDMIPHY_REG_BANDGAP_Z0_CTRL_2_reg_g_z0pow_shift                       (8)
#define HDMIPHY_REG_BANDGAP_Z0_CTRL_2_reg_r_z0pow_shift                       (4)
#define HDMIPHY_REG_BANDGAP_Z0_CTRL_2_z0pow_0_shift                           (2)
#define HDMIPHY_REG_BANDGAP_Z0_CTRL_2_z0pow_1_shift                           (1)
#define HDMIPHY_REG_BANDGAP_Z0_CTRL_2_z0pow_2_shift                           (0)
#define HDMIPHY_REG_BANDGAP_Z0_CTRL_2_reg_z0_ibxadj_mask                      (0x00300000)
#define HDMIPHY_REG_BANDGAP_Z0_CTRL_2_reg_ck_z0pow_mask                       (0x00070000)
#define HDMIPHY_REG_BANDGAP_Z0_CTRL_2_reg_b_z0pow_mask                        (0x00007000)
#define HDMIPHY_REG_BANDGAP_Z0_CTRL_2_reg_g_z0pow_mask                        (0x00000700)
#define HDMIPHY_REG_BANDGAP_Z0_CTRL_2_reg_r_z0pow_mask                        (0x00000070)
#define HDMIPHY_REG_BANDGAP_Z0_CTRL_2_z0pow_0_mask                            (0x00000004)
#define HDMIPHY_REG_BANDGAP_Z0_CTRL_2_z0pow_1_mask                            (0x00000002)
#define HDMIPHY_REG_BANDGAP_Z0_CTRL_2_z0pow_2_mask                            (0x00000001)
#define HDMIPHY_REG_BANDGAP_Z0_CTRL_2_reg_z0_ibxadj(data)                     (0x00300000&((data)<<20))
#define HDMIPHY_REG_BANDGAP_Z0_CTRL_2_reg_ck_z0pow(data)                      (0x00070000&((data)<<16))
#define HDMIPHY_REG_BANDGAP_Z0_CTRL_2_reg_b_z0pow(data)                       (0x00007000&((data)<<12))
#define HDMIPHY_REG_BANDGAP_Z0_CTRL_2_reg_g_z0pow(data)                       (0x00000700&((data)<<8))
#define HDMIPHY_REG_BANDGAP_Z0_CTRL_2_reg_r_z0pow(data)                       (0x00000070&((data)<<4))
#define HDMIPHY_REG_BANDGAP_Z0_CTRL_2_z0pow_0(data)                           (0x00000004&((data)<<2))
#define HDMIPHY_REG_BANDGAP_Z0_CTRL_2_z0pow_1(data)                           (0x00000002&((data)<<1))
#define HDMIPHY_REG_BANDGAP_Z0_CTRL_2_z0pow_2(data)                           (0x00000001&(data))
#define HDMIPHY_REG_BANDGAP_Z0_CTRL_2_get_reg_z0_ibxadj(data)                 ((0x00300000&(data))>>20)
#define HDMIPHY_REG_BANDGAP_Z0_CTRL_2_get_reg_ck_z0pow(data)                  ((0x00070000&(data))>>16)
#define HDMIPHY_REG_BANDGAP_Z0_CTRL_2_get_reg_b_z0pow(data)                   ((0x00007000&(data))>>12)
#define HDMIPHY_REG_BANDGAP_Z0_CTRL_2_get_reg_g_z0pow(data)                   ((0x00000700&(data))>>8)
#define HDMIPHY_REG_BANDGAP_Z0_CTRL_2_get_reg_r_z0pow(data)                   ((0x00000070&(data))>>4)
#define HDMIPHY_REG_BANDGAP_Z0_CTRL_2_get_z0pow_0(data)                       ((0x00000004&(data))>>2)
#define HDMIPHY_REG_BANDGAP_Z0_CTRL_2_get_z0pow_1(data)                       ((0x00000002&(data))>>1)
#define HDMIPHY_REG_BANDGAP_Z0_CTRL_2_get_z0pow_2(data)                       (0x00000001&(data))
#define HDMIPHY_REG_BANDGAP_Z0_CTRL_2_reg_ck_z0pow_2_mask                       (0x00040000)
#define HDMIPHY_REG_BANDGAP_Z0_CTRL_2_reg_ck_z0pow_1_mask                       (0x00020000)
#define HDMIPHY_REG_BANDGAP_Z0_CTRL_2_reg_ck_z0pow_0_mask                       (0x00010000)
#define HDMIPHY_REG_BANDGAP_Z0_CTRL_2_reg_b_z0pow_2_mask                        (0x00004000)
#define HDMIPHY_REG_BANDGAP_Z0_CTRL_2_reg_b_z0pow_1_mask                        (0x00002000)
#define HDMIPHY_REG_BANDGAP_Z0_CTRL_2_reg_b_z0pow_0_mask                        (0x00001000)
#define HDMIPHY_REG_BANDGAP_Z0_CTRL_2_reg_g_z0pow_2_mask                        (0x00000400)
#define HDMIPHY_REG_BANDGAP_Z0_CTRL_2_reg_g_z0pow_1_mask                        (0x00000200)
#define HDMIPHY_REG_BANDGAP_Z0_CTRL_2_reg_g_z0pow_0_mask                        (0x00000100)
#define HDMIPHY_REG_BANDGAP_Z0_CTRL_2_reg_r_z0pow_2_mask                        (0x00000040)
#define HDMIPHY_REG_BANDGAP_Z0_CTRL_2_reg_r_z0pow_1_mask                        (0x00000020)
#define HDMIPHY_REG_BANDGAP_Z0_CTRL_2_reg_r_z0pow_0_mask                        (0x00000010)

#define HDMIPHY_REG_DIG_PHY_CTRL_NEW_1_reg_mod_sel_mask                       (0x0C000000)
#define HDMIPHY_REG_DIG_PHY_CTRL_NEW_1_reg_ldo_sel_mask                       (0x03000000)
#define HDMIPHY_REG_DIG_PHY_CTRL_NEW_1_reg_cdr_rate_sel_mask                  (0x00E00000)
#define HDMIPHY_REG_DIG_PHY_CTRL_NEW_1_reg_infifo_cnt_mask                    (0x001C0000)
#define HDMIPHY_REG_DIG_PHY_CTRL_NEW_1_reg_pi_m_mode_mask                     (0x00020000)
#define HDMIPHY_REG_DIG_PHY_CTRL_NEW_1_reg_kd_mask                            (0x00010000)
#define HDMIPHY_REG_DIG_PHY_CTRL_NEW_1_reg_ercnt_en_mask                      (0x00008000)
#define HDMIPHY_REG_DIG_PHY_CTRL_NEW_1_reg_edge_out_mask                      (0x00004000)
#define HDMIPHY_REG_DIG_PHY_CTRL_NEW_1_reg_data_order_mask                    (0x00002000)
#define HDMIPHY_REG_DIG_PHY_CTRL_NEW_1_reg_cdr_ckinv_mask                     (0x00001000)
#define HDMIPHY_REG_DIG_PHY_CTRL_NEW_1_reg_bypass_sdm_int_mask                (0x00000800)
#define HDMIPHY_REG_DIG_PHY_CTRL_NEW_1_reg_acc2_manual_mask                   (0x00000400)
#define HDMIPHY_REG_DIG_PHY_CTRL_NEW_1_reg_acc2_period_mask                   (0x000003FF)
#define HDMIPHY_REG_DIG_PHY_CTRL_NEW_1_reg_mod_sel(data)                      (0x0C000000&((data)<<26))
#define HDMIPHY_REG_DIG_PHY_CTRL_NEW_1_reg_ldo_sel(data)                      (0x03000000&((data)<<24))
#define HDMIPHY_REG_DIG_PHY_CTRL_NEW_1_reg_cdr_rate_sel(data)                 (0x00E00000&((data)<<21))
#define HDMIPHY_REG_DIG_PHY_CTRL_NEW_1_reg_infifo_cnt(data)                   (0x001C0000&((data)<<18))
#define HDMIPHY_REG_DIG_PHY_CTRL_NEW_1_reg_pi_m_mode(data)                    (0x00020000&((data)<<17))
#define HDMIPHY_REG_DIG_PHY_CTRL_NEW_1_reg_kd(data)                           (0x00010000&((data)<<16))
#define HDMIPHY_REG_DIG_PHY_CTRL_NEW_1_reg_ercnt_en(data)                     (0x00008000&((data)<<15))
#define HDMIPHY_REG_DIG_PHY_CTRL_NEW_1_reg_edge_out(data)                     (0x00004000&((data)<<14))
#define HDMIPHY_REG_DIG_PHY_CTRL_NEW_1_reg_data_order(data)                   (0x00002000&((data)<<13))
#define HDMIPHY_REG_DIG_PHY_CTRL_NEW_1_reg_cdr_ckinv(data)                    (0x00001000&((data)<<12))
#define HDMIPHY_REG_DIG_PHY_CTRL_NEW_1_reg_bypass_sdm_int(data)               (0x00000800&((data)<<11))
#define HDMIPHY_REG_DIG_PHY_CTRL_NEW_1_reg_acc2_manual(data)                  (0x00000400&((data)<<10))
#define HDMIPHY_REG_DIG_PHY_CTRL_NEW_1_reg_acc2_period(data)                  (0x000003FF&(data))
#define HDMIPHY_REG_DIG_PHY_CTRL_NEW_1_get_reg_mod_sel(data)                  ((0x0C000000&(data))>>26)
#define HDMIPHY_REG_DIG_PHY_CTRL_NEW_1_get_reg_ldo_sel(data)                  ((0x03000000&(data))>>24)
#define HDMIPHY_REG_DIG_PHY_CTRL_NEW_1_get_reg_cdr_rate_sel(data)             ((0x00E00000&(data))>>21)
#define HDMIPHY_REG_DIG_PHY_CTRL_NEW_1_get_reg_infifo_cnt(data)               ((0x001C0000&(data))>>18)
#define HDMIPHY_REG_DIG_PHY_CTRL_NEW_1_get_reg_pi_m_mode(data)                ((0x00020000&(data))>>17)
#define HDMIPHY_REG_DIG_PHY_CTRL_NEW_1_get_reg_kd(data)                       ((0x00010000&(data))>>16)
#define HDMIPHY_REG_DIG_PHY_CTRL_NEW_1_get_reg_ercnt_en(data)                 ((0x00008000&(data))>>15)
#define HDMIPHY_REG_DIG_PHY_CTRL_NEW_1_get_reg_edge_out(data)                 ((0x00004000&(data))>>14)
#define HDMIPHY_REG_DIG_PHY_CTRL_NEW_1_get_reg_data_order(data)               ((0x00002000&(data))>>13)
#define HDMIPHY_REG_DIG_PHY_CTRL_NEW_1_get_reg_cdr_ckinv(data)                ((0x00001000&(data))>>12)
#define HDMIPHY_REG_DIG_PHY_CTRL_NEW_1_get_reg_bypass_sdm_int(data)           ((0x00000800&(data))>>11)
#define HDMIPHY_REG_DIG_PHY_CTRL_NEW_1_get_reg_acc2_manual(data)              ((0x00000400&(data))>>10)
#define HDMIPHY_REG_DIG_PHY_CTRL_NEW_1_get_reg_acc2_period(data)              (0x000003FF&(data))
#define CK_MOD_SEL_mask                                                 (_BIT27|_BIT26)
#define CK_MOD_SEL(data)                                                 (CK_MOD_SEL_mask&((data)<<HDMIPHY_REG_CK_MD_ck_mod_sel_shift))
#define HDMIPHY_REG_CK_MD_ck_mod_sel_shift                                       (26)

#define HDMIPHY_REG_DIG_PHY_CTRL_NEW_2_reg_squ_tri_shift                      (28)
#define HDMIPHY_REG_DIG_PHY_CTRL_NEW_2_reg_st_m_value_shift                   (20)
#define HDMIPHY_REG_DIG_PHY_CTRL_NEW_2_reg_ki_shift                           (16)
#define HDMIPHY_REG_DIG_PHY_CTRL_NEW_2_reg_kp_shift                           (8)
#define HDMIPHY_REG_DIG_PHY_CTRL_NEW_2_reg_en_m_value_shift                   (0)
#define HDMIPHY_REG_DIG_PHY_CTRL_NEW_2_reg_squ_tri_mask                       (0x10000000)
#define HDMIPHY_REG_DIG_PHY_CTRL_NEW_2_reg_st_m_value_mask                    (0x01F00000)
#define HDMIPHY_REG_DIG_PHY_CTRL_NEW_2_reg_ki_mask                            (0x00070000)
#define HDMIPHY_REG_DIG_PHY_CTRL_NEW_2_reg_kp_mask                            (0x0000FF00)
#define HDMIPHY_REG_DIG_PHY_CTRL_NEW_2_reg_en_m_value_mask                    (0x000000FF)
#define HDMIPHY_REG_DIG_PHY_CTRL_NEW_2_reg_squ_tri(data)                      (0x10000000&((data)<<28))
#define HDMIPHY_REG_DIG_PHY_CTRL_NEW_2_reg_st_m_value(data)                   (0x01F00000&((data)<<20))
#define HDMIPHY_REG_DIG_PHY_CTRL_NEW_2_reg_ki(data)                           (0x00070000&((data)<<16))
#define HDMIPHY_REG_DIG_PHY_CTRL_NEW_2_reg_kp(data)                           (0x0000FF00&((data)<<8))
#define HDMIPHY_REG_DIG_PHY_CTRL_NEW_2_reg_en_m_value(data)                   (0x000000FF&(data))
#define HDMIPHY_REG_DIG_PHY_CTRL_NEW_2_get_reg_squ_tri(data)                  ((0x10000000&(data))>>28)
#define HDMIPHY_REG_DIG_PHY_CTRL_NEW_2_get_reg_st_m_value(data)               ((0x01F00000&(data))>>20)
#define HDMIPHY_REG_DIG_PHY_CTRL_NEW_2_get_reg_ki(data)                       ((0x00070000&(data))>>16)
#define HDMIPHY_REG_DIG_PHY_CTRL_NEW_2_get_reg_kp(data)                       ((0x0000FF00&(data))>>8)
#define HDMIPHY_REG_DIG_PHY_CTRL_NEW_2_get_reg_en_m_value(data)               (0x000000FF&(data))

#endif //PHOENIX_HDMI_HW_PHY_H
