#include "v4l2_hdmi_dev.h"
#include "phoenix_mipi_wrapper.h"
#include "phoenix_hdmiHWReg.h"
#include "phoenix_hdmiInternal.h"
#include "hdmirx_rpc.h"
#include "sd_test.h"
#include "sd_test_hdmi_reg.h"
#include "sd_test_vo_reg.h"
#include "phoenix_mipi_i2c_ctl.h"

#include <linux/ratelimit.h>
#include <linux/printk.h>
#include <linux/string.h>
#include <linux/wait.h>
#include <linux/kthread.h>
//#include <asm-generic/io.h>
//#include <asm/io.h>
//#include <../arch/arm/include/asm/memory.h>
#include <asm/memory.h>
extern wait_queue_head_t HDMIRX_WAIT_OSD_COMPLETE;

int hdmi_interlace_polarity_check = 0;
int hdmi_isr_count = 0;
extern int hdmi_stream_on;
extern int mipi_delay_counter;
//extern int mipi_output_size;

#define CAMERA_4_LANE 1

void stop_mipi_process(void)
{
    //unsigned int reg_val = hdmi_rx_reg_read32(MIPI_WRAPPER_MIPI_reg, HDMI_RX_MIPI);
    //hdmi_rx_reg_write32(MIPI_WRAPPER_MIPI_reg, (reg_val & 0xFFFFFFFE), HDMI_RX_MIPI);

    //Reset MIPI, MIPI will be disabled and all MIPI register set to defalut value
    Wreg32(0x18000000, Rreg32(0x18000000)&0xBFFFFFFF);//set MIPI reset bit

    atomic_set(&hdmi_sw_buf_ctl.read_index, 0);
    atomic_set(&hdmi_sw_buf_ctl.write_index, 0);
    atomic_set(&hdmi_sw_buf_ctl.fill_index, 0);
    hdmi_sw_buf_ctl.pre_frame_done = -1;
#if TEST_VO_THREAD
    atomic_set(&hdmi_hw_buf_avalible_num, HDMI_HW_BUF_NUM);
#else
    atomic_set(&hdmi_hw_buf_avalible_num, 0);
#endif
    hdmi_sw_buf_ctl.use_v4l2_buffer = 0;
    hdmi_stream_on = 0;
    mipi_top.mipi_init = 0;
}

void set_mipi_env(void)
{
    pr_info("In set_mipi_env\n");
    Wreg32(0x18000000, Rreg32(0x18000000)|BIT(30));	// release MIPI reset bit
    HDMI_DELAYMS(1);
    Wreg32(0x1800000c, Rreg32(0x1800000c)|BIT(27));	// enable MIPI clock
    HDMI_DELAYMS(1);
    Wreg32(0x18000044, 0x5);
/*       copy form Alan
    hdmi_rx_reg_write32(MIPI_WRAPPER_INDEX0_reg, 0x00, HDMI_RX_MIPI);
    hdmi_rx_reg_write32(MIPI_WRAPPER_APHY_REG19_reg, 0x00000080, HDMI_RX_MIPI_PHY); // read-only???
    hdmi_rx_reg_write32(MIPI_WRAPPER_DPHY_REG4_reg, 0x00000079, HDMI_RX_MIPI_PHY); // Lane0~1: MIPI_DATA2_PIN, Lane2~3: MIPI_DATA0_PIN
    hdmi_rx_reg_write32(MIPI_WRAPPER_DPHY_REG4_reg, 0x00000078, HDMI_RX_MIPI_PHY); // Lane0: MIPI_DATA3_PIN, Lane0: MIPI_DATA2_PIN, Lane2~3: MIPI_DATA0_PIN
    hdmi_rx_reg_write32(MIPI_WRAPPER_DPHY_REG1_reg, 0x00000003, HDMI_RX_MIPI_PHY); // enable ECC; disable CRC16
    hdmi_rx_reg_write32(MIPI_WRAPPER_DPHY_PWDB_reg, 0x0000000f, HDMI_RX_MIPI_PHY); // disable data lane0~3 power down
    hdmi_rx_reg_write32(MIPI_WRAPPER_DPHY_REG0_reg, 0x0000004f, HDMI_RX_MIPI_PHY); // MIPI data type
    hdmi_rx_reg_write32(MIPI_WRAPPER_DPHY_REG8_reg, 0x00000072, HDMI_RX_MIPI_PHY); // number of ECC errors in the last frame
    hdmi_rx_reg_write32(MIPI_WRAPPER_DPHY_REG6_reg, 0x00000000, HDMI_RX_MIPI_PHY); // disalbe interrupts
    hdmi_rx_reg_write32(MIPI_WRAPPER_DPHY_REG2_reg, 0x00000024, HDMI_RX_MIPI_PHY);
    hdmi_rx_reg_write32(MIPI_WRAPPER_DPHY_REG7_reg, 0x00000000, HDMI_RX_MIPI_PHY); // interrupt flags
    hdmi_rx_reg_write32(MIPI_WRAPPER_APHY_REG15_reg, 0x00000001, HDMI_RX_MIPI_PHY); // DEMUX dividor
*/
        // on 1195
        hdmi_rx_reg_write32(MIPI_WRAPPER_APHY_REG15_reg, SEL_DIV_RG(DEMUX16), HDMI_RX_MIPI_PHY);//SEL_DIV_RG
        hdmi_rx_reg_write32(MIPI_WRAPPER_DPHY_REG4_reg, SL_RG(fourlane) | Sw_rst(disable), HDMI_RX_MIPI_PHY);//Lane mux sel & soft reset
#if CAMERA_4_LANE
        // 4 lane
        hdmi_rx_reg_write32(MIPI_WRAPPER_DPHY_PWDB_reg, L3(enable) | L2(enable) | L1(enable) | L0(enable), HDMI_RX_MIPI_PHY);//Lane1 & Lane2 power on
        hdmi_rx_reg_write32(MIPI_WRAPPER_DPHY_REG0_reg, Div_sel(div_bit_16) | Lane3(enable) | Lane2(enable) | Lane1(enable) | Lane0(enable), HDMI_RX_MIPI_PHY);//16bit data width, Lane1 & Lane2 enable
#else
        // 2 lane
        hdmi_rx_reg_write32(MIPI_WRAPPER_DPHY_PWDB_reg, L1(enable) | L0(enable), HDMI_RX_MIPI_PHY);//Lane1 & Lane2 power on
        hdmi_rx_reg_write32(MIPI_WRAPPER_DPHY_REG0_reg, Div_sel(div_bit_16) | Lane1(enable) | Lane0(enable), HDMI_RX_MIPI_PHY);//16bit data width, Lane1 & Lane2 enable
#endif
        hdmi_rx_reg_write32(MIPI_WRAPPER_DPHY_REG9_reg, Lane3_clk_edge(posedge) | Lane2_clk_edge(posedge) |
                                 Lane1_clk_edge(posedge) | Lane0_clk_edge(posedge), HDMI_RX_MIPI_PHY);//Lane CLK edge
        //hdmi_rx_reg_write32(MIPI_WRAPPER_DPHY_REG8_reg, Lane3_sel(MIPI_DATA0) | Lane2_sel(MIPI_DATA3) | Lane1_sel(MIPI_DATA1) | Lane0_sel(MIPI_DATA2), HDMI_RX_MIPI_PHY);//Lane remap, only FPGA
#if CAMERA_4_LANE
        if(hdmi.mipi_camera_type == MIPI_CAMERA_RTS5845)
            hdmi_rx_reg_write32(MIPI_WRAPPER_DPHY_REG1_reg, yuv_src_sel(SEL_UYVY) | dec_format(YUV422_dec_format), HDMI_RX_MIPI_PHY);// SEL_UYVY //SEL_YUYV & Dec data format for YUV422
        else
            hdmi_rx_reg_write32(MIPI_WRAPPER_DPHY_REG1_reg, yuv_src_sel(SEL_YUYV) | dec_format(YUV422_dec_format), HDMI_RX_MIPI_PHY);// SEL_UYVY //SEL_YUYV & Dec data format for YUV422
#else
        hdmi_rx_reg_write32(MIPI_WRAPPER_DPHY_REG1_reg, yuv_src_sel(SEL_YUYV) | dec_format(YUV422_dec_format), HDMI_RX_MIPI_PHY);// SEL_UYVY //SEL_YUYV & Dec data format for YUV422
#endif
        hdmi_rx_reg_write32(MIPI_WRAPPER_DPHY_REG2_reg, D_type(DTYPE_YUY8), HDMI_RX_MIPI_PHY);//MIPI data type YUV422 8bit

    //MIPI DPHY modify
    //Wreg32(mipi_dphy_reg6  , DVld_Lane1(0x3) | DVld_Lane0(0x3));                                                                //For SONY IUS014F-Z
    //  2 below only for 4 lane ---- 20140227,Irene
#if CAMERA_4_LANE
    if(hdmi.mipi_camera_type == MIPI_CAMERA_RTS5845)
    {
        hdmi_rx_reg_write32(MIPI_WRAPPER_DPHY_REG6_reg  , DVld_Lane1(0x6) | DVld_Lane0(0x6), HDMI_RX_MIPI_PHY);        // 0x6
        hdmi_rx_reg_write32(MIPI_WRAPPER_DPHY_REG7_reg  , DVld_Lane3(0x6) | DVld_Lane2(0x6), HDMI_RX_MIPI_PHY);
    }
    else if(hdmi.mipi_camera_type == MIPI_CAMERA_RLE0551C)
    {
        hdmi_rx_reg_write32(MIPI_WRAPPER_DPHY_REG6_reg  , DVld_Lane1(0x5) | DVld_Lane0(0x5), HDMI_RX_MIPI_PHY);
        hdmi_rx_reg_write32(MIPI_WRAPPER_DPHY_REG7_reg  , DVld_Lane3(0x5) | DVld_Lane2(0x5), HDMI_RX_MIPI_PHY);
    }
#endif
}

void set_video_DDR_start_addr(struct v4l2_hdmi_dev *dev)
{
    unsigned int addr1y, addr1uv, addr2y, addr2uv;
    unsigned int offset;
    unsigned long flags = 0;
    struct hdmi_buffer *buf = NULL;
    struct hdmi_dmaqueue *hdmidq = &dev->hdmidq;
    if(mipi_top.src_sel == 1)
    {
        offset = roundup16(hdmi.tx_timing.pitch) * roundup16(hdmi.tx_timing.output_v);
        pr_info("pitch=%x,output_v=%x,offset=%x\n",hdmi.tx_timing.pitch,hdmi.tx_timing.output_v,offset);
    }
    else
        offset = roundup16(mipi_csi.pitch) * roundup16(mipi_csi.v_output_len);
#if TEST_VO_THREAD
    addr1y = (unsigned int)((hdmi_ddr_ptr[0]));
    addr1uv = (unsigned int)((hdmi_ddr_ptr[0] + offset));
    addr2y = (unsigned int)((hdmi_ddr_ptr[1]));
    addr2uv = (unsigned int)((hdmi_ddr_ptr[1] + offset));
#else
    spin_lock_irqsave(&dev->slock, flags);
    hdmidq->hwbuf[0] = list_entry(hdmidq->active.next, struct hdmi_buffer, list);
    list_del(&hdmidq->hwbuf[0]->list);
    //pr_info("%s: del buf[%d] from queue\n", __func__, hdmidq->hwbuf[0]->vb.v4l2_buf.index);
    hdmidq->hwbuf[1] = list_entry(hdmidq->active.next, struct hdmi_buffer, list);
    list_del(&hdmidq->hwbuf[1]->list);
    //pr_info("%s: del buf[%d] from queue\n", __func__, hdmidq->hwbuf[1]->vb.v4l2_buf.index);
    atomic_sub(2, &hdmidq->qcnt);
    spin_unlock_irqrestore(&dev->slock, flags);

    addr1y = hdmidq->hwbuf[0]->phys;
    addr1uv = hdmidq->hwbuf[0]->phys + offset;
    addr2y = hdmidq->hwbuf[1]->phys;
    addr2uv = hdmidq->hwbuf[1]->phys + offset;
#endif
    //pr_info("[wrapper ISR,addr1y=%x, addr1uv=%x,addr2y=%x, addr2uv=%x,%x]\n",addr1y,addr1uv,addr2y,addr2uv,atomic_read(&hdmi_hw_buf_avalible_num));
    set_video_dest_addr(addr1y, addr1uv, addr2y, addr2uv);
    atomic_sub(2, &hdmi_hw_buf_avalible_num);
}

void set_mipi_type(unsigned int type)
{
    unsigned int reg_val;

    reg_val = hdmi_rx_reg_read32(MIPI_WRAPPER_TYPE_reg, HDMI_RX_MIPI);

    reg_val = reg_val & (MIPI_TYPE_MASK ^ 0xFFFFFFFF);
    reg_val = reg_val | MIPI_WRAPPER_TYPE_SET(type);

    hdmi_rx_reg_write32(MIPI_WRAPPER_TYPE_reg, reg_val, HDMI_RX_MIPI);
}

void set_pic_dest_addr(int addry, int addruv)
{
    if(addry >= 0)
    {
        hdmi_rx_reg_write32(MIPI_WRAPPER_SA2_reg, addry, HDMI_RX_MIPI);
    }
    if(addruv >= 0)
    {
        hdmi_rx_reg_write32(MIPI_WRAPPER_SA2_UV_reg, addruv, HDMI_RX_MIPI);
    }
}

void set_pic_dest_size(unsigned int dst_width, unsigned int pitch)
{
    unsigned int reg_val;

    reg_val = ((dst_width & 0x1FFF) << 16) | (pitch & 0xFFFF);
    hdmi_rx_reg_write32(MIPI_WRAPPER_MIPI_SIZE1_reg, reg_val, HDMI_RX_MIPI);
}

void set_pic_src_size(unsigned int src_width)
{
    unsigned int reg_val;

    reg_val = hdmi_rx_reg_read32(MIPI_WRAPPER_MIPI_SIZE2_reg, HDMI_RX_MIPI);
    reg_val = reg_val & (SRC_WIDTH_PIC_MASK ^ 0xFFFFFFFF);
    reg_val = reg_val | (src_width << 16);
    hdmi_rx_reg_write32(MIPI_WRAPPER_MIPI_SIZE2_reg, reg_val, HDMI_RX_MIPI);
}

void set_video_dest_addr(int addr1y, int addr1uv, int addr2y, int addr2uv)
{
    if(addr1y >= 0)
    {
        hdmi_rx_reg_write32(MIPI_WRAPPER_MIPI_SA0_reg, addr1y, HDMI_RX_MIPI);
    }
    //pr_info("[4104=%x]\n",hdmi_rx_reg_read32(MIPI_WRAPPER_MIPI_SA0_reg,HDMI_RX_MIPI));
    if(addr1uv >= 0)
    {
        hdmi_rx_reg_write32(MIPI_WRAPPER_MIPI_SA0_UV_reg, addr1uv, HDMI_RX_MIPI);
    }
    if(addr2y >= 0)
    {
        hdmi_rx_reg_write32(MIPI_WRAPPER_MIPI_SA1_reg, addr2y, HDMI_RX_MIPI);
    }
    if(addr2uv >= 0)
    {
        hdmi_rx_reg_write32(MIPI_WRAPPER_MIPI_SA1_UV_reg, addr2uv, HDMI_RX_MIPI);
    }
}

void set_video_dest_size(unsigned int dst_width, unsigned int pitch)
{
    unsigned int reg_val;

    reg_val = ((dst_width & 0x1FFF) << 16) | (pitch & 0xFFFF);
    hdmi_rx_reg_write32(MIPI_WRAPPER_MIPI_SIZE0_reg, reg_val, HDMI_RX_MIPI);
}

void set_video_src_size(unsigned int src_width)
{
    unsigned int reg_val;

    reg_val = hdmi_rx_reg_read32(MIPI_WRAPPER_MIPI_SIZE2_reg, HDMI_RX_MIPI);
    reg_val = reg_val & (SRC_WIDTH_VIDEO_MASK ^ 0xFFFFFFFF);
    reg_val = reg_val | src_width;
    hdmi_rx_reg_write32(MIPI_WRAPPER_MIPI_SIZE2_reg, reg_val, HDMI_RX_MIPI);
}

void set_init_mipi_value(MIPI_REG *mipi_reg)
{
    unsigned int reg_val = 0;

    reg_val = (mipi_reg->dst_fmt << 27) |
                    (mipi_reg->src_fmt << 25) |
                    (mipi_reg->src_sel << 24) |
                    (mipi_reg->seq_en << 23) |
                    (mipi_reg->vs << 22) |
                    (mipi_reg->vs_near << 21) |
                    (mipi_reg->vs_yodd << 20) |
                    (mipi_reg->vs_codd << 19) |
                    (mipi_reg->hs << 18) |
                    (mipi_reg->hs_yodd << 17) |
                    (mipi_reg->hs_codd << 16) |
                    (mipi_reg->yuv_to_rgb << 12) |
                    (mipi_reg->chroma_ds_mode << 11) |
                    (mipi_reg->chroma_ds_en << 10) |
                    (mipi_reg->chroma_us_mode << 9) |
                    (mipi_reg->chroma_us_en << 8) |
                    (mipi_reg->hdmirx_interlace_en << 7) |
                    (mipi_reg->hdmirx_interlace_polarity << 6) |
                    (mipi_reg->int_en4 << 5) |
                    (mipi_reg->int_en3 << 4) |
                    (mipi_reg->int_en2 << 3) |
                    (mipi_reg->int_en1 << 2) |
                    (mipi_reg->int_en0 << 1) |
                    (mipi_reg->en);

    hdmi_rx_reg_write32(MIPI_WRAPPER_MIPI_reg, reg_val, HDMI_RX_MIPI);
    pr_info("MIPI_WRAPPER_MIPI_reg=%x\n",reg_val);
}

void set_hs_scaler(unsigned int hsi_offset, unsigned int hsi_phase, unsigned int hsd_out, unsigned int hsd_delta)
{
    unsigned int reg_val;

    reg_val = ((hsi_offset & 0x07FF)<<16) | ((hsi_phase &0x3FFF)<<2) ;
    hdmi_rx_reg_write32(MIPI_WRAPPER_SCALER_HSI_reg, reg_val, HDMI_RX_MIPI);

    reg_val = ((hsd_out & 0x07FF)<<20) | (hsd_delta &0x7FFFF) ;
    hdmi_rx_reg_write32(MIPI_WRAPPER_SCALER_HSD_reg, reg_val, HDMI_RX_MIPI);
    pr_info("hsd_out=%x,hsd_delta=%x\n",hsd_out,hsd_delta);
}

void set_hs_coeff(void)
{
    unsigned int reg_val;

    //for Y
    reg_val = (0x400<<16) | 0x400 ;
    hdmi_rx_reg_write32(MIPI_WRAPPER_SCALER_HSYNC0_reg, reg_val, HDMI_RX_MIPI);
    hdmi_rx_reg_write32(MIPI_WRAPPER_SCALER_HSYNC1_reg, reg_val, HDMI_RX_MIPI);
    hdmi_rx_reg_write32(MIPI_WRAPPER_SCALER_HSYNC2_reg, reg_val, HDMI_RX_MIPI);
    hdmi_rx_reg_write32(MIPI_WRAPPER_SCALER_HSYNC3_reg, reg_val, HDMI_RX_MIPI);
    hdmi_rx_reg_write32(MIPI_WRAPPER_SCALER_HSYNC4_reg, reg_val, HDMI_RX_MIPI);
    hdmi_rx_reg_write32(MIPI_WRAPPER_SCALER_HSYNC5_reg, reg_val, HDMI_RX_MIPI);
    hdmi_rx_reg_write32(MIPI_WRAPPER_SCALER_HSYNC6_reg, reg_val, HDMI_RX_MIPI);
    hdmi_rx_reg_write32(MIPI_WRAPPER_SCALER_HSYNC7_reg, reg_val, HDMI_RX_MIPI);

    //for U,V
    hdmi_rx_reg_write32(MIPI_WRAPPER_SCALER_HSCC0_reg, reg_val, HDMI_RX_MIPI);
    hdmi_rx_reg_write32(MIPI_WRAPPER_SCALER_HSCC1_reg, reg_val, HDMI_RX_MIPI);
    hdmi_rx_reg_write32(MIPI_WRAPPER_SCALER_HSCC2_reg, reg_val, HDMI_RX_MIPI);
    hdmi_rx_reg_write32(MIPI_WRAPPER_SCALER_HSCC3_reg, reg_val, HDMI_RX_MIPI);
    hdmi_rx_reg_write32(MIPI_WRAPPER_SCALER_HSCC4_reg, reg_val, HDMI_RX_MIPI);
    hdmi_rx_reg_write32(MIPI_WRAPPER_SCALER_HSCC5_reg, reg_val, HDMI_RX_MIPI);
    hdmi_rx_reg_write32(MIPI_WRAPPER_SCALER_HSCC6_reg, reg_val, HDMI_RX_MIPI);
    hdmi_rx_reg_write32(MIPI_WRAPPER_SCALER_HSCC7_reg, reg_val, HDMI_RX_MIPI);
}

void set_vs_scaler(unsigned int vsi_offset, unsigned int vsi_phase, unsigned int vsd_out, unsigned int vsd_delta)
{
    unsigned int reg_val;

    reg_val = ((vsi_offset & 0x0FFF)<<16) | ((vsi_phase &0x3FFF)<<2) ;
    hdmi_rx_reg_write32(MIPI_WRAPPER_SCALER_VSI_reg, reg_val, HDMI_RX_MIPI);

    reg_val = ((vsd_out & 0x07FF)<<20) | (vsd_delta &0x7FFFF) ;
    hdmi_rx_reg_write32(MIPI_WRAPPER_SCALER_VSD_reg, reg_val, HDMI_RX_MIPI);
    pr_info("vsd_out=%x,vsd_delta=%x\n",vsd_out,vsd_delta);
}

void set_vs_coeff(void)
{
    unsigned int reg_val;

/* setting for magellan
    //for Y / UV
    reg_val = (0x248<<16) | 0x0 ;
    hdmi_rx_reg_write32(MIPI_WRAPPER_SCALER_VSYC0_reg, reg_val, HDMI_RX_MIPI);
    hdmi_rx_reg_write32(MIPI_WRAPPER_SCALER_VSCC0_reg, reg_val, HDMI_RX_MIPI);
    reg_val = (0x800<<16) | 0x6db ;
    hdmi_rx_reg_write32(MIPI_WRAPPER_SCALER_VSYC1_reg, reg_val, HDMI_RX_MIPI);
    hdmi_rx_reg_write32(MIPI_WRAPPER_SCALER_VSCC1_reg, reg_val, HDMI_RX_MIPI);
    reg_val = (0xb6e<<16) | 0x925 ;
    hdmi_rx_reg_write32(MIPI_WRAPPER_SCALER_VSYC2_reg, reg_val, HDMI_RX_MIPI);
    hdmi_rx_reg_write32(MIPI_WRAPPER_SCALER_VSCC2_reg, reg_val, HDMI_RX_MIPI);
    reg_val = (0x1000<<16) | 0xdb8 ;
    hdmi_rx_reg_write32(MIPI_WRAPPER_SCALER_VSYC3_reg, reg_val, HDMI_RX_MIPI);
    hdmi_rx_reg_write32(MIPI_WRAPPER_SCALER_VSCC3_reg, reg_val, HDMI_RX_MIPI);
*/
    reg_val = (0x800<<16) | 0x800 ;
    hdmi_rx_reg_write32(MIPI_WRAPPER_SCALER_VSYC0_reg, reg_val, HDMI_RX_MIPI);
    hdmi_rx_reg_write32(MIPI_WRAPPER_SCALER_VSCC0_reg, reg_val, HDMI_RX_MIPI);
    hdmi_rx_reg_write32(MIPI_WRAPPER_SCALER_VSYC1_reg, reg_val, HDMI_RX_MIPI);
    hdmi_rx_reg_write32(MIPI_WRAPPER_SCALER_VSCC1_reg, reg_val, HDMI_RX_MIPI);
    hdmi_rx_reg_write32(MIPI_WRAPPER_SCALER_VSYC2_reg, reg_val, HDMI_RX_MIPI);
    hdmi_rx_reg_write32(MIPI_WRAPPER_SCALER_VSCC2_reg, reg_val, HDMI_RX_MIPI);
    hdmi_rx_reg_write32(MIPI_WRAPPER_SCALER_VSYC3_reg, reg_val, HDMI_RX_MIPI);
    hdmi_rx_reg_write32(MIPI_WRAPPER_SCALER_VSCC3_reg, reg_val, HDMI_RX_MIPI);
}

void set_alpha(unsigned int alpha)
{
    unsigned int reg_val;

    reg_val = alpha & 0x0FF;
    hdmi_rx_reg_write32(MIPI_WRAPPER_CONSTANT_ALPHA_reg, reg_val, HDMI_RX_MIPI);
}

void set_YUV2RGB_coeff(void)
{
    hdmi_rx_reg_write32(MIPI_WRAPPER_CS_TRANS0_reg,  0x04a80, HDMI_RX_MIPI);
    hdmi_rx_reg_write32(MIPI_WRAPPER_CS_TRANS1_reg,  0x00000, HDMI_RX_MIPI);
    hdmi_rx_reg_write32(MIPI_WRAPPER_CS_TRANS2_reg,  0x072c0, HDMI_RX_MIPI);
    hdmi_rx_reg_write32(MIPI_WRAPPER_CS_TRANS3_reg,  0x04a80, HDMI_RX_MIPI);
    hdmi_rx_reg_write32(MIPI_WRAPPER_CS_TRANS4_reg,  0x1f260, HDMI_RX_MIPI);
    hdmi_rx_reg_write32(MIPI_WRAPPER_CS_TRANS5_reg,  0x1ddd0, HDMI_RX_MIPI);
    hdmi_rx_reg_write32(MIPI_WRAPPER_CS_TRANS6_reg,  0x04a80, HDMI_RX_MIPI);
    hdmi_rx_reg_write32(MIPI_WRAPPER_CS_TRANS7_reg,  0x08760, HDMI_RX_MIPI);
    hdmi_rx_reg_write32(MIPI_WRAPPER_CS_TRANS8_reg,  0x00000, HDMI_RX_MIPI);
    hdmi_rx_reg_write32(MIPI_WRAPPER_CS_TRANS9_reg,  0x0fc20, HDMI_RX_MIPI);
    hdmi_rx_reg_write32(MIPI_WRAPPER_CS_TRANS10_reg, 0x00134, HDMI_RX_MIPI);
    hdmi_rx_reg_write32(MIPI_WRAPPER_CS_TRANS11_reg, 0x0fb7c, HDMI_RX_MIPI);
}

void phoenix_mipi_format_transform(void)
{
    //set RGB
    set_alpha(0xff);
}

void phoenix_mipi_scale_down(unsigned int src_width,unsigned int src_height,unsigned int dst_width,unsigned int dst_height)
{
    unsigned int delta_num, delta_den, offset, phase;

    if(hdmi_rx_reg_read32(HDMI_HDMI_VCR_VADDR, HDMI_RX_MAC) & _BIT6) // interlace mode
       dst_height = (dst_height>>1);

    if(src_width > dst_width)
    {
        //set hs_scaler
        offset = 0;
        phase = 0;
        delta_num = (src_width / dst_width) << 14;
        delta_den = ((src_width % dst_width)*0x4000) / dst_width ;
        set_hs_scaler(offset,phase,dst_width, (delta_num | delta_den));//offset,phase,out,delta
        set_hs_coeff();
    }
    if(src_height > dst_height)
    {
        //set vs_scaler
        offset = 0;
        phase = 0;
        delta_num = (src_height / dst_height) << 14;
        delta_den = ((src_height % dst_height)*0x4000) / dst_height ;
        set_vs_scaler(offset,phase,dst_height, (delta_num | delta_den));//offset,phase,out,delta
        set_vs_coeff();
    }
}

int hdmi_hw_buf_is_full(void)
{
    int ret_value = 0;
#if TEST_VO_THREAD
    if(atomic_read(&hdmi_hw_buf_avalible_num) == 0)
        ret_value = 1;
    //pr_info("hdmi_hw_buf_is_full  %d,%d,%d,%d\n",ret_value,atomic_read(&hdmi_hw_buf_avalible_num),hdmi_stream_on,mipi_top.mipi_init);
#else
    if((atomic_read(&hdmi_hw_buf_avalible_num) == HDMI_HW_BUF_NUM)  //0
        ||(mipi_top.mipi_init == 0)
        )
        ret_value = 1;
#endif
    return ret_value;
}

int hdmi_hw_buf_is_empty(void)
{
    int ret_value = 0;
#if TEST_VO_THREAD
    if(atomic_read(&hdmi_hw_buf_avalible_num) == HDMI_HW_BUF_NUM) //HDMI_HW_BUF_NUM
        ret_value = 1;
    //pr_info("hdmi_hw_buf_is_empty  %d,%d,%d,%d\n",ret_value,atomic_read(&hdmi_hw_buf_avalible_num),hdmi_stream_on,mipi_top.mipi_init);
#else
    if((atomic_read(&hdmi_hw_buf_avalible_num) == 0) //HDMI_HW_BUF_NUM
        ||(mipi_top.mipi_init == 0)
        )
    {
//        pr_info("[HW empty %d,%d]\n",atomic_read(&hdmi_hw_buf_avalible_num),mipi_top.mipi_init);
        ret_value = 1;
    }
#if 0
    // 20140530 , IRENE Add: for swich output resolution, skip first N frames to avoid green screen, but not work
    if((mipi_delay_counter) && (mipi_delay_counter < 100))
    {
        mipi_delay_counter ++;
        ret_value = 1;
        pr_info("[wait]\n");
    }
    else
        mipi_delay_counter = 0;
#endif

#endif
    return ret_value;
}

int hdmirx_inband_format_type_select(void)
{
    if(hdmi.tx_timing.output_color == OUT_RAW8)
        return INBAND_CMD_GRAPHIC_FORMAT_8BIT;
    else if(hdmi.tx_timing.output_color == OUT_YUV422)
        return INBAND_CMD_GRAPHIC_FORMAT_422;
    else if(hdmi.tx_timing.output_color == OUT_YUV420)
        return INBAND_CMD_GRAPHIC_FORMAT_420;
    else if((hdmi.tx_timing.output_color >= OUT_ARGB)&&(hdmi.tx_timing.output_color <= OUT_ABGR))
        return INBAND_CMD_GRAPHIC_FORMAT_ARGB8888;
    else if((hdmi.tx_timing.output_color >= OUT_RGBA)&&(hdmi.tx_timing.output_color <= OUT_BGRA))
        return INBAND_CMD_GRAPHIC_FORMAT_RGBA8888;
    else
        return INBAND_CMD_GRAPHIC_FORMAT_Reserved0 ;// VO not support
}

INBAND_CMD_GRAPHIC_3D_MODE hdmirx_inband_3D_mode_select(void)
{
    int sd_struct = Hdmi_Get3DInfo(HDMI_MS_MODE_ONESHOT);

    if(sd_struct == HDMI3D_SIDE_BY_SIDE_FULL)
        return INBAND_CMD_GRAPHIC_SIDE_BY_SIDE;
    else if(sd_struct == HDMI3D_TOP_AND_BOTTOM)
        return INBAND_CMD_GRAPHIC_TOP_AND_BOTTOM;
    else if(sd_struct == HDMI3D_FRAME_PACKING)
        return INBAND_CMD_GRAPHIC_FRAME_PACKING;
    else //if(sd_struct == HDMI3D_2D_ONLY)
        return INBAND_CMD_GRAPHIC_2D_MODE;
}

int hdmi_to_vo_thread(void *data)
{
    for (;;)
    {
        if((hdmi.RING_HEADER != NULL)&&(hdmi_isr_count))
        {
            VIDEO_GRAPHIC_PICTURE_OBJECT obj ;
            HDMI_TIMING_T *timing = &hdmi.tx_timing;

            if(hdmi_isr_count != 1)
                pr_err("[error~~ hdmi_isr_count = %d]\n",hdmi_isr_count);
            hdmi_isr_count = 0;
            // WRITE CMD TO VOUT RING BUFFER
            obj.header.type         = VIDEO_GRAPHIC_INBAND_CMD_TYPE_PICTURE_OBJECT ;
            obj.header.size         = sizeof(VIDEO_GRAPHIC_PICTURE_OBJECT);
            obj.context             = ++hdmi.CTX ;
            obj.PTSH                = 0;//pdc_info->PTS>>32;
            obj.PTSL                = 0;//pdc_info->PTS;
            obj.colorkey            = -1 ;
            obj.alpha               = 0 ;
            obj.x                   = 0 ;
            obj.y                   = 0 ;
            obj.format              = hdmirx_inband_format_type_select();
            obj.width               = timing->output_h;
            obj.height              = timing->output_v;
            obj.pitch               = timing->pitch;
            obj.address             = hdmi.tx_timing.phyAddr;
            obj.address_right       = 0 ;
            obj.pitch_right         = 0;
            obj.picLayout           = hdmirx_inband_3D_mode_select();
            obj.dataByte1           = 0;
            obj.dataByte2           = 0;
            obj.dataByte3           = 0;
            if( HDMIRX_ICQ_WriteCmd(&obj, hdmi.RING_HEADER) != 0)
            {
                pr_err("[%s %d]ERROR!! Write CMD Error!\n",__FUNCTION__,__LINE__);
                return 0;
            }
            // WAIT BUFFER COMPLETE
            {
                {
                    long timeout;
                    ++hdmi_sw_buf_ctl.ISR_FLIP;
    HDMIRX_RESLEEP:
                    timeout = sleep_on_timeout(&HDMIRX_WAIT_OSD_COMPLETE,  10000);
                    if(timeout == 0) {
                        pr_info("[%s %d] tOut:%lu %d\n", __func__, __LINE__, hdmi.CTX, hdmi_sw_buf_ctl.ISR_FLIP);
                    }else {
                        unsigned long ipc_read_ulong;
                        unsigned int context;
                        ipc_read_ulong=hdmirx_pli_IPCReadULONG((BYTE*)&hdmi.REF_CLK->videoContext);
                        context = obj.context;
                        if(context ==  ipc_read_ulong) goto HDMIRX_NORMAL;
                        if(context <  ipc_read_ulong){
                            pr_err("Error: pdc_info->CTX <  ipc_read_ulong\n");
                            goto HDMIRX_NORMAL;
                        }
                        if((context -  ipc_read_ulong) > HDMIRX_NOHW_MAX_BACKBUFFERS){
                            pr_err("Error: Too much   pdc_info->CTX = %ld  videoContext = %ld\n",hdmi.CTX,ipc_read_ulong);
                            goto HDMIRX_NORMAL;
                        }
                        goto HDMIRX_RESLEEP;
                    }
HDMIRX_NORMAL:
                    --hdmi_sw_buf_ctl.ISR_FLIP;
                }
            }
        }
        if (kthread_should_stop())
            break;
    }
    return 0;
}

void mipi_clear_v4l2_queue(struct v4l2_hdmi_dev *dev);

void update_mipi_hw_buffer(int src_index, struct v4l2_hdmi_dev *dev)
{
    unsigned int addry, addruv, offset;
    unsigned long flags = 0;
    struct hdmi_buffer *buf = NULL;
    struct hdmi_dmaqueue *hdmidq = &dev->hdmidq;
#if TEST_VO_THREAD
    unsigned int loop_index[3]={2, 0, 1};
    unsigned int write_index = loop_index[atomic_read(&hdmi_sw_buf_ctl.write_index)];

    if(mipi_top.src_sel == 1)
        offset = roundup16(hdmi.tx_timing.pitch) * roundup16(hdmi.tx_timing.output_v);
    else
        offset = roundup16(mipi_csi.pitch) * roundup16(mipi_csi.v_output_len);
    addry = (unsigned int)((hdmi_ddr_ptr[write_index]));
    addruv = (unsigned int)((hdmi_ddr_ptr[write_index] + offset));

    //pr_info("[W %d:%d,%x,%x,%x]\n",src_index,write_index,addry,addruv,atomic_read(&hdmi_hw_buf_avalible_num));
    //HDMI_DELAYMS(1);
    if(src_index == 0)
        set_video_dest_addr(addry, addruv, -1, -1);
    else
        set_video_dest_addr(-1, -1, addry, addruv);

    //sd_test_print();
    hdmi.tx_timing.phyAddr = (unsigned int)((hdmi_ddr_ptr[atomic_read(&hdmi_sw_buf_ctl.write_index)]));
    atomic_inc(&hdmi_sw_buf_ctl.write_index);
    atomic_dec(&hdmi_hw_buf_avalible_num);
    if(atomic_read(&hdmi_sw_buf_ctl.write_index) == HDMI_SW_BUF_NUM)
        atomic_set(&hdmi_sw_buf_ctl.write_index, 0);
#else
    //unsigned int write_index = atomic_read(&hdmi_sw_buf_ctl.write_index);

    if(mipi_top.src_sel == 1)
        offset = roundup16(hdmi.tx_timing.pitch) * roundup16(hdmi.tx_timing.output_v);
    else
        offset = roundup16(mipi_csi.pitch) * roundup16(mipi_csi.v_output_len);
    spin_lock_irqsave(&dev->slock, flags);
    vb2_buffer_done(&hdmidq->hwbuf[src_index]->vb,VB2_BUF_STATE_DONE);
    atomic_inc(&hdmidq->rcnt);
    //pr_info("hwbuf[%d] buf[%d] %lx is done\n", src_index, hdmidq->hwbuf[src_index]->vb.v4l2_buf.index,  hdmidq->hwbuf[src_index]->phys);
    hdmidq->hwbuf[src_index] = list_entry(hdmidq->active.next, struct hdmi_buffer, list);
    list_del(&hdmidq->hwbuf[src_index]->list);
    atomic_dec(&hdmidq->qcnt);
    //pr_info("%s: del buf[%d] from queue\n", __func__, hdmidq->hwbuf[src_index]->vb.v4l2_buf.index);
    spin_unlock_irqrestore(&dev->slock, flags);
    addry = hdmidq->hwbuf[src_index]->phys;
    addruv = hdmidq->hwbuf[src_index]->phys + offset;

    //pr_info("[W %d:%d,%x,%x,%x]\n",src_index,write_index,addry,addruv,atomic_read(&hdmi_hw_buf_avalible_num));
    //HDMI_DELAYMS(1);
    if(src_index == 0)
        set_video_dest_addr(addry, addruv, -1, -1);
    else
        set_video_dest_addr(-1, -1, addry, addruv);

    //sd_test_print();
    //hdmi.tx_timing.phyAddr = (unsigned int)((hdmi_ddr_ptr[atomic_read(&hdmi_sw_buf_ctl.write_index)]));
    //atomic_inc(&hdmi_sw_buf_ctl.write_index);
    //atomic_dec(&hdmi_hw_buf_avalible_num);
    //if(atomic_read(&hdmi_sw_buf_ctl.write_index) == HDMI_SW_BUF_NUM)
    //    atomic_set(&hdmi_sw_buf_ctl.write_index, 0);

    //mipi_clear_v4l2_queue(dev);
#endif
}

void hdmi_hw_buf_update(int src_index, struct v4l2_hdmi_dev *dev)
{
    static int skip_buffer_en = 0;
    static int skip_num = 0;
    static int total_num = 0;
    static unsigned long prev_jif = 0;
    int empty = 0;
    unsigned long flags = 0;
    struct hdmi_dmaqueue *hdmidq = &dev->hdmidq;

    if(hdmi_sw_buf_ctl.pre_frame_done == -1)
          hdmi_sw_buf_ctl.pre_frame_done = src_index;
    //hdmi_to_vo();
    hdmi_isr_count++;
    if((mipi_top.src_sel == 1) && (hdmi_interlace_polarity_check))
    {
        unsigned int reg_val = hdmi_rx_reg_read32(MIPI_WRAPPER_MIPI_reg, HDMI_RX_MIPI);

        pr_info("[hdmi_interlace_polarity_check !! drop frame]\n");
        hdmi_interlace_polarity_check = 0;
        reg_val = reg_val & 0xFFFFFFBF; // clear bit 6
        if(hdmi_rx_reg_read32(HDMI_HDMI_VCR_VADDR, HDMI_RX_MAC) & _BIT27)
            reg_val = reg_val | (1<<6);

        hdmi_rx_reg_write32(MIPI_WRAPPER_MIPI_reg, reg_val, HDMI_RX_MIPI);
        return;
    }
#if TEST_VO_THREAD
    if( !hdmi_hw_buf_is_full() )
    {
        update_mipi_hw_buffer(src_index, dev);
    }
    else if(( !hdmi_hw_buf_is_empty() )  && (src_index == hdmi_sw_buf_ctl.pre_frame_done))
    {
        update_mipi_hw_buffer(src_index, dev);
    }
    else
    {
        pr_info("[hdmi_hw_buf_is_full!!]\n");
    }
#else
    if ((hdmi_sw_buf_ctl.use_v4l2_buffer == 0)
        ||(mipi_top.mipi_init == 0))
    {
        //pr_info("[HW UPDATE R]\n");
        return;
    }

    if(unlikely((jiffies - prev_jif) >= (10 * HZ))){
        pr_info("hdmirx skip %d/%d in %lu jiffies\n", skip_num, total_num, jiffies - prev_jif);
        prev_jif = jiffies;
        total_num = 0;
        skip_num = 0;
    }
    total_num++;

    spin_lock_irqsave(&dev->slock, flags);
    empty = list_empty(&hdmidq->active);
    spin_unlock_irqrestore(&dev->slock, flags);
    if(empty){
        //pr_notice_ratelimited("No active queue to serve ?????? %d-2-%d\n", atomic_read(&hdmidq->rcnt), atomic_read(&hdmidq->qcnt));
        skip_num++;
        return;
    }
    update_mipi_hw_buffer(src_index, dev);
#endif
}

int hdmi_v4l2_buf_copy(void *vbuf , unsigned int bpp)
{
    int mipi_output_size;
    int copy_pitch,copy_h,copy_v,copy_type;
    int ret = 0;

    if(mipi_top.mipi_init == 0)
    {
        pr_notice("[MIPI not init yet~~]\n");
        //return ret;
    }

    if(mipi_top.src_sel == 1)
    {
        copy_type = hdmi.tx_timing.output_color;
        copy_pitch = hdmi.tx_timing.pitch;
        copy_h = hdmi.tx_timing.output_h;
        copy_v = hdmi.tx_timing.output_v;
    }
    else
    {
        copy_type = mipi_csi.output_color;
        copy_pitch = mipi_csi.pitch;
        copy_h = mipi_csi.h_output_len;
        copy_v = mipi_csi.v_output_len;
    }

    if(copy_type < OUT_ARGB) // YUV
        mipi_output_size = roundup16(copy_pitch) * roundup16(copy_v) * bpp / 8;
    else // RGB
        mipi_output_size = copy_h * copy_v * bpp / 8;

    if((mipi_delay_counter) && (mipi_delay_counter < 5))
    {
        mipi_delay_counter ++;
        atomic_set(&hdmi_sw_buf_ctl.read_index, atomic_read(&hdmi_sw_buf_ctl.write_index));
        atomic_set(&hdmi_hw_buf_avalible_num, HDMI_HW_BUF_NUM);
        pr_info("[wait]\n");
    }
    else
    //if( !hdmi_hw_buf_is_empty() )
    {
        mipi_delay_counter = 0;
        //pr_info("2.read_index=%d\n",atomic_read(&hdmi_sw_buf_ctl.read_index));
        //pr_info("[copy %d,dst=%x,src=%x]\n",mipi_output_size,(unsigned int)vbuf,(unsigned int)(__va(hdmi_ddr_ptr[(unsigned int)atomic_read(&hdmi_sw_buf_ctl.read_index)])));
        memcpy(vbuf, __va(hdmi_ddr_ptr[atomic_read(&hdmi_sw_buf_ctl.read_index)]), mipi_output_size);
        //memcpy(vbuf, __va(hdmi_ddr_ptr[atomic_read(&hdmi_sw_buf_ctl.read_index)] + (mipi_output_size>>1)), (mipi_output_size>>1));
        //memcpy(vbuf + (mipi_output_size>>1), __va(hdmi_ddr_ptr[atomic_read(&hdmi_sw_buf_ctl.read_index)]), (mipi_output_size>>1));
        pr_info("[R:%d]\n",atomic_read(&hdmi_sw_buf_ctl.read_index));
        atomic_inc(&hdmi_sw_buf_ctl.read_index);
        atomic_inc(&hdmi_hw_buf_avalible_num);
        if(atomic_read(&hdmi_sw_buf_ctl.read_index) == HDMI_SW_BUF_NUM)
            atomic_set(&hdmi_sw_buf_ctl.read_index, 0);
        ret = 1;
    }
//    else
    {
//        pr_info("[hdmi_hw_buf_is_empty!!]\n");
    }
    return ret;
}
extern void hdmirx_wrapper_isr(void);
irqreturn_t phoenix_mipi_isr(int irq, void* dev_id)
{
    unsigned int st_reg_val, reg_val;
    struct v4l2_hdmi_dev *dev = dev_id;
    st_reg_val = hdmi_rx_reg_read32(MIPI_WRAPPER_MIPI_INT_ST_reg, HDMI_RX_MIPI);
    //pr_info("%s: st_reg_val:%x\n", __func__, st_reg_val);
    //pr_info_ratelimited("%s: mipi_reg_val:%x\n", __func__, hdmi_rx_reg_read32(MIPI_WRAPPER_MIPI_reg, HDMI_RX_MIPI));
#if 0
    pr_info("[mipi = %x,sa0=%x,sa0_uv=%x,sa1=%x,sa1_uv=%x]\n"
        , hdmi_rx_reg_read32(MIPI_WRAPPER_MIPI_reg, HDMI_RX_MIPI)
        , hdmi_rx_reg_read32(MIPI_WRAPPER_MIPI_SA0_reg, HDMI_RX_MIPI)
        , hdmi_rx_reg_read32(MIPI_WRAPPER_MIPI_SA0_UV_reg, HDMI_RX_MIPI)
        , hdmi_rx_reg_read32(MIPI_WRAPPER_MIPI_SA1_reg, HDMI_RX_MIPI)
        , hdmi_rx_reg_read32(MIPI_WRAPPER_MIPI_SA1_UV_reg, HDMI_RX_MIPI));
    pr_info("[sz0 = %x,sz1=%x,sz2=%x]\n"
        , hdmi_rx_reg_read32(MIPI_WRAPPER_MIPI_SIZE0_reg, HDMI_RX_MIPI)
        , hdmi_rx_reg_read32(MIPI_WRAPPER_MIPI_SIZE1_reg, HDMI_RX_MIPI)
        , hdmi_rx_reg_read32(MIPI_WRAPPER_MIPI_SIZE2_reg, HDMI_RX_MIPI));
    st_reg_val = hdmi_rx_reg_read32(MIPI_WRAPPER_MIPI_INT_ST_reg, HDMI_RX_MIPI);
    pr_info("[aphy15 = %x,dphy4=%x,pwdb=%x,dphy0=%x,dphy9=%x]\n"
        , hdmi_rx_reg_read32(MIPI_WRAPPER_APHY_REG15_reg, HDMI_RX_MIPI_PHY)
        , hdmi_rx_reg_read32(MIPI_WRAPPER_DPHY_REG4_reg, HDMI_RX_MIPI_PHY)
        , hdmi_rx_reg_read32(MIPI_WRAPPER_DPHY_PWDB_reg, HDMI_RX_MIPI_PHY)
        , hdmi_rx_reg_read32(MIPI_WRAPPER_DPHY_REG0_reg, HDMI_RX_MIPI_PHY)
        , hdmi_rx_reg_read32(MIPI_WRAPPER_DPHY_REG9_reg, HDMI_RX_MIPI_PHY));
    pr_info("[dphy1 = %x,dphy2=%x,dphy6=%x,dphy7=%x]\n"
        , hdmi_rx_reg_read32(MIPI_WRAPPER_DPHY_REG1_reg, HDMI_RX_MIPI_PHY)
        , hdmi_rx_reg_read32(MIPI_WRAPPER_DPHY_REG2_reg, HDMI_RX_MIPI_PHY)
        , hdmi_rx_reg_read32(MIPI_WRAPPER_DPHY_REG6_reg, HDMI_RX_MIPI_PHY)
        , hdmi_rx_reg_read32(MIPI_WRAPPER_DPHY_REG7_reg, HDMI_RX_MIPI_PHY));
#endif
    // if overflow happen, reset mipi
    if(st_reg_val & 0x30) // Buffer is overflow or one frame is dropped
    {
        //if(st_reg_val & 0x10) pr_info("drop one frame\n"); //FIXME: is reset mipi required on one frame dropped?
        //if(st_reg_val & 0x20) pr_info("buffer overflow\n");

        //clear interrupt status
        hdmi_rx_reg_write32(MIPI_WRAPPER_MIPI_INT_ST_reg, st_reg_val, HDMI_RX_MIPI);

        hdmi_rx_reg_write32(MIPI_WRAPPER_MIPI_RESET_reg, 1, HDMI_RX_MIPI);
        hdmi_rx_reg_write32(MIPI_WRAPPER_MIPI_RESET_reg, 0, HDMI_RX_MIPI);

        return IRQ_HANDLED;
    }

    reg_val = hdmi_rx_reg_read32(MIPI_WRAPPER_TYPE_reg, HDMI_RX_MIPI);

//    pr_info("[mipi_isr reg_val = %x,st_reg_val=%x]\n", reg_val,st_reg_val);
//    HDMI_DELAYMS(1);
    if(reg_val & 0x01) // Picture mode
    {
        if(st_reg_val & 0x08) // fm_done2:One image is written to mipi_sa2
        {
            //clear interrupt status
            hdmi_rx_reg_write32(MIPI_WRAPPER_MIPI_INT_ST_reg, st_reg_val, HDMI_RX_MIPI);

            // can process img
        }
    }
    else // Preview or video mode
    {
#if MIPI_TEST
        static int pre_state = 0;
#endif

        //clear interrupt status
        hdmi_rx_reg_write32(MIPI_WRAPPER_MIPI_INT_ST_reg, st_reg_val, HDMI_RX_MIPI);
        if((st_reg_val & 0x02)
#if MIPI_TEST
            && ((pre_state == 0)||(pre_state == 2))
#endif
            )// fm_done0:One image is written to mipi_index0/mipi_sa0
        {
            hdmi_hw_buf_update(0,dev);
#if MIPI_TEST
           pre_state = 1;
#endif
            // can process img
        }
        else if((st_reg_val & 0x04)
#if MIPI_TEST
                    && ((pre_state == 0)||(pre_state == 1))
#endif
                    )// fm_done1:One image is written to mipi_index1/mipi_sa1
        {
            hdmi_hw_buf_update(1,dev);
#if MIPI_TEST
            pre_state = 2;
#endif
            // can process img
        }
    }
    hdmirx_wrapper_isr();
    return IRQ_HANDLED;
}

