/*
 * $Id: hello.c,v 1.5 2004/10/26 03:32:21 corbet Exp $
 */
#include "phoenix_mipi_i2c_ctl.h"
#include "v4l2_hdmi_dev.h"
#include "phoenix_hdmiFun.h"
#include "phoenix_hdmiInternal.h"
#include "phoenix_mipi_wrapper.h"
#include "phoenix_hdmi_wrapper.h"
#include "sd_test.h"
#include <linux/of.h>
#include <linux/of_gpio.h>
#include <linux/gpio.h>
#include <linux/switch.h>
#include <linux/time.h>

#define MIPI_SCALE_DOWN_DIS 0   // 0: in != out ,so scale down   1: in==out
#define MIPI_CAMERA_IN_W 2592//2592
#define MIPI_CAMERA_IN_H 1944//1944

#define MAX_WIDTH 2592
#define MAX_HEIGHT 1944

#define FCC2ASCII(fmt)  ((char *)(&fmt))[0], ((char *)(&fmt))[1], ((char *)(&fmt))[2], ((char *)(&fmt))[3]

int mipi_delay_counter = 0;

//static unsigned int vid_limit = 16;
int hdmi_thread_exist = 0;
int hdmiport = 0;
#if TEST_VO_THREAD
int hdmi_stream_on = 1;
#else
int hdmi_stream_on = 0;
#endif

int rx_5v_state = 0;

extern char Hdmi_IsbReady(void);
extern int Hdmi_get_b_value(void);
#ifdef CRC_CHECK
extern int QC_CRCCheck(UINT8 type);
extern int HDMI_FormatDetect(void);
#endif

static struct platform_device *hdmirx_device;
void  rx5v_do_tasklet(unsigned long unused);
DECLARE_WAIT_QUEUE_HEAD(HDMIRX_WAIT_OSD_COMPLETE);
static DECLARE_TASKLET(rx5v_tasklet, rx5v_do_tasklet, 0);

static const struct of_device_id hdmirx_rtk_dt_ids[] = {
	{ .compatible = "Realtek,rtk119x-mipi-top", },
	{},
};
MODULE_DEVICE_TABLE(of, hdmirx_rtk_dt_ids);

#define RTK_HDMIRX_NAME "rtk-mipi-top"

MODULE_ALIAS("platform:" RTK_HDMIRX_NAME);

MODULE_LICENSE("Dual BSD/GPL");
static LIST_HEAD(hdmi_devlist);
extern void RLE0551C_patterngen_2048x1536(void);
extern void RTS5845(unsigned int h_input_len, unsigned int v_input_len);
/*
struct hdmi_rx_frame {
    __u16 wWidth;
    __u16 wHeight;
};

static struct hdmi_rx_frame hdmi_rx_frames[] = {
    {4096, 2160},
    {3840, 2160},
    {1920, 1080},
    {1280,  720},
    {  720,  480}
};

struct hdmi_rx_fps_t {
    __u16 support_num;
    __u16 fps[4];
};

static struct hdmi_rx_fps_t hdmi_rx_fps[] = {
    {1,{24, 0, 0, 0}},
    {3,{30, 25, 24, 0}},
    {4,{60, 50, 30, 24}}
};
*/

struct platform_driver hdmirx_rtk_driver = {
    .probe      = hdmirx_rtk_drv_probe,
    .remove     = hdmirx_rtk_drv_remove,
    .shutdown            = hdmi_platform_shutdown,
    .driver     = {
        .name   = RTK_HDMIRX_NAME,
        .owner  = THIS_MODULE,
        .of_match_table = of_match_ptr(hdmirx_rtk_dt_ids),
    },
};
#define	HDMIRX_PLATFORM_DRIVER		hdmirx_rtk_driver

struct fb_ops hdmirx_fb_ops = {
    .owner              = THIS_MODULE,
    .fb_open            = hdmirx_fb_open,
    .fb_release         = hdmirx_fb_release,
    .fb_check_var       = hdmirx_fb_check_var,
    .fb_set_par         = hdmirx_fb_set_par,
    .fb_ioctl           = hdmirx_fb_ioctl,
    .fb_pan_display     = hdmirx_fb_pan_display,
    .fb_setcolreg       = hdmirx_fb_setcolreg,
    .fb_mmap            = hdmirx_fb_mmap,
};

struct hdmirx_format_desc {
    char *name;
    __u32 fcc;
};
static struct hdmirx_format_desc hdmi_rx_fmts[] = {
    {
        .name       = "RAW8",
        .fcc        = V4L2_PIX_FMT_SGRBG8 ,
    },
    {
        .name       = "RAW10",
        .fcc        = V4L2_PIX_FMT_SGRBG10,
    },
    {
        .name       = "Y/CbCr 4:2:2",
        .fcc        = V4L2_PIX_FMT_NV16,
    },
    {
        .name       = "YUV 4:2:0 (NV12)",
        .fcc        = V4L2_PIX_FMT_NV12,
    },
    {
        .name       = "JPEG8",
        .fcc        = V4L2_PIX_FMT_MJPEG,
    },
    {
        .name       = "ARGB",
        .fcc        = V4L2_PIX_FMT_RGB32,
    },
    {
        .name       = "BGRA",
        .fcc        = V4L2_PIX_FMT_BGR32,
    }
};

/*************************************
        EDID DTS Definition
**************************************/
static const char *hdmi_rx_edid_tbl_node[] = {
     "Realtek,edid-tbl0",
     "Realtek,edid-tbl1",
     "Realtek,edid-tbl2",
     "Realtek,edid-tbl3",
     "Realtek,edid-tbl4",
     "Realtek,edid-tbl5",
     "Realtek,edid-tbl6",
     "Realtek,edid-tbl7",
     "Realtek,edid-tbl8",
     "Realtek,edid-tbl9",
     "Realtek,edid-tbl10",
     "Realtek,edid-tbl11",
     "Realtek,edid-tbl12",
     "Realtek,edid-tbl13",
     "Realtek,edid-tbl14",
     "Realtek,edid-tbl15",
     "Realtek,edid-tbl16",
     "Realtek,edid-tbl17",
     "Realtek,edid-tbl18",
     "Realtek,edid-tbl19",
     "Realtek,edid-tbl20",
     "Realtek,edid-tbl21",
     "Realtek,edid-tbl22",
     "Realtek,edid-tbl23",
     "Realtek,edid-tbl24",
     "Realtek,edid-tbl25",
     "Realtek,edid-tbl26",
     "Realtek,edid-tbl27",
     "Realtek,edid-tbl28",
     "Realtek,edid-tbl29",
     "Realtek,edid-tbl30",
     "Realtek,edid-tbl31"
};

u8 *hdmi_ddr_ptr[HDMI_HW_BUF_NUM];
//u8 *hdmi_secure_ddr_ptr[2];
//u8 *hdmi_ddr_ptr_virt[HDMI_HW_BUF_NUM];
//u8 *hdmi_sw_buf_ptr[HDMI_SW_BUF_NUM];
#if TEST_VO_THREAD
atomic_t hdmi_hw_buf_avalible_num = ATOMIC_INIT(HDMI_HW_BUF_NUM);
#else
atomic_t hdmi_hw_buf_avalible_num = ATOMIC_INIT(0);
#endif
HDMI_SW_BUF_CTL hdmi_sw_buf_ctl;
//int mipi_output_size;

static struct task_struct *hdmi_hw_tsk;
//static int hdmi_hw_data;
#if TEST_VO_THREAD
struct task_struct *vo_hw_tsk = NULL;
int vo_hw_data;
#endif
static int mipi_top_thread(void *arg);
static int hdmirx_fb_data;
//#define VIDEO_NUM_DEVICES  256
//static DEFINE_MUTEX(videodev_lock);
//static struct video_device *video_device[VIDEO_NUM_DEVICES];

//char * phoenix_hdmi_sa0;
//char * phoenix_hdmi_sa1;

int hdmirx_fb_open(struct fb_info *info, int user)
{
    hdmi.kthread_hdmi2vo = kthread_run(hdmi_to_vo_thread, &hdmirx_fb_data, "HDMIRX_FB");

    if (IS_ERR(hdmi.kthread_hdmi2vo)) {
        pr_err("kernel_thread(hdmi.kthread_hdmi2vo) failed\n");
        return PTR_ERR(hdmi.kthread_hdmi2vo);
    }

    if (user == -1)
    {
        pr_info("hdmirx_fb_open\n");
        return 0;
    }
    return 0;
}

int hdmirx_fb_set_par(struct fb_info *info)
{
    return 0;
}

int hdmirx_fb_release(struct fb_info *info, int user)
{
    return 0;
}

int hdmirx_fb_check_var(struct fb_var_screeninfo *var, struct fb_info *info)
{
    return 0;
}

void HDMIRX_Reset_OSD_param(void)
{
    REFCLOCK* clk = hdmi.REF_CLK;
    hdmirx_pli_IPCWriteULONGLONG( (BYTE*)&clk->videoSystemPTS, -1);
    hdmirx_pli_IPCWriteULONGLONG( (BYTE*)&clk->audioSystemPTS, -1);
    hdmirx_pli_IPCWriteULONGLONG( (BYTE*)&clk->videoRPTS,      -1);
    hdmirx_pli_IPCWriteULONGLONG((BYTE*)&clk->audioRPTS,  -1);
    hdmirx_pli_IPCWriteULONG((BYTE*)&clk->videoContext,(unsigned long)-1);
    hdmirx_pli_IPCWriteULONG((BYTE*)&clk->audioContext, (unsigned long)-1);
    hdmirx_pli_IPCWriteULONG((BYTE*)&clk->videoEndOfSegment, (long)-1);
}

int HDMIRX_Set_RPCAddr(HDMIRX_PARAM_RPC_ADDR* param)
{
    hdmi.REF_CLK = (REFCLOCK*) (param->refclockAddr | 0xa0000000);
    hdmi.RING_HEADER = (RINGBUFFER_HEADER*) (param->ringPhyAddr|0xa0000000);
    HDMIRX_Reset_OSD_param();
    return 0;
}

int hdmirx_fb_ioctl(struct fb_info *info, unsigned int cmd, unsigned long arg)
{
    int retval = 0;

    switch (cmd) {
        case HDMIRX_FB_SET_RING_INFO         :
            {
                HDMIRX_PARAM_RPC_ADDR param;
                if (copy_from_user(&param, (void *)arg, sizeof(param)) != 0)
                {
                    pr_err("ERROR! CMD = %u",cmd);
                    return -EFAULT;
                }
                retval = HDMIRX_Set_RPCAddr(&param);
                break;
            }
        default:
            retval = -EAGAIN;
    }

    return retval;
}

int hdmirx_fb_pan_display(struct fb_var_screeninfo *var, struct fb_info *info)
{
    return 0;
}

int hdmirx_fb_setcolreg(u_int regno, u_int red, u_int green, u_int blue, u_int transp, struct fb_info *info)
{
    return 0;
}

int hdmirx_fb_mmap(struct fb_info *info, struct vm_area_struct *vma)
{
    return 0;
}

int out_color_to_bpp(MIPI_OUT_COLOR_SPACE_T output_color)
{
    switch(output_color){
    case OUT_RAW8:      //V4L2_PIX_FMT_SGRBG8
        return 8;
    case OUT_RAW10:     //V4L2_PIX_FMT_SGRBG10
        return 10;
    case OUT_YUV420:    //V4L2_PIX_FMT_NV12
        return 12;
    case OUT_YUV422:    //
    case OUT_JPEG8:     //V4L2_PIX_FMT_MJPEG
        return 16;
    default:            //all other ARGB formats
        return 32;
    }
}

MIPI_OUT_COLOR_SPACE_T V4L2_format_parse(unsigned int pixelformat)
{
    switch(pixelformat){
        case V4L2_PIX_FMT_SGRBG8:
            return OUT_RAW8;
        case V4L2_PIX_FMT_SGRBG10:
            return OUT_RAW10;
        case V4L2_PIX_FMT_NV12:
            return OUT_YUV420;
        case V4L2_PIX_FMT_MJPEG:
            return OUT_JPEG8;
        case V4L2_PIX_FMT_RGB32:
            if((Rreg32(0x1801A200) & 0xFFFF) == 0x6329){ //for 1195 input 422 format, Y in G component, Cb/Cr in R component
                //return OUT_RBGA;    //YUV422 to YUYV workaround
                return OUT_ABRG;    //YUV422 to NV12 workaround, Y Cb x x  Y Cr x x  Y Cb x x  Y Cr x x
            }else{
                return OUT_BGRA;    // byte 0~3: ARGB
            }
        case V4L2_PIX_FMT_BGR32:
            return OUT_ARGB;    // byte 0~3: BGRA, for HAL_PIXEL_FORMAT_BGRA_8888
        case V4L2_PIX_FMT_YUYV:
            return OUT_YUV422;  //FIXME: YUYV => YUV422?
        default:
            pr_warn("Unsupported pixel format: %c%c%c%c\n", FCC2ASCII(pixelformat));
            return OUT_UNKNOW;
    }

    return  OUT_UNKNOW;
}

static int hdmirx_queue_init(struct v4l2_hdmi_dev *dev, struct vb2_queue *q, enum v4l2_memory memory)
{
    if(q->type == V4L2_BUF_TYPE_VIDEO_CAPTURE) //already initialized, release first
        vb2_queue_release(q);
    q->type = V4L2_BUF_TYPE_VIDEO_CAPTURE;
    q->io_modes = VB2_MMAP | VB2_USERPTR; //| VB2_DMABUF | VB2_READ;
    q->drv_priv = dev;
    q->buf_struct_size = sizeof(struct hdmi_buffer);
    q->ops = &hdmi_qops;
    q->timestamp_type = V4L2_BUF_FLAG_TIMESTAMP_MONOTONIC;

    if(memory == V4L2_MEMORY_USERPTR){
        q->mem_ops = &vb2_vmalloc_memops;
    }else if(memory == V4L2_MEMORY_MMAP){
        q->mem_ops = &vb2_dma_contig_memops;
    }else{
        pr_err("hdmirx_queue_init: invalid io mode:%d\n", memory);
        return -EINVAL;
    }

    return vb2_queue_init(q);
}

static long v4l2_hdmi_do_ioctl(struct file *file, unsigned int cmd, void *arg)
{
    long ret = 0;
    struct video_device *vdev = video_devdata(file);
    struct v4l2_hdmi_dev *dev = video_drvdata(file);

    switch (cmd) {
        case VIDIOC_QUERYCAP:
            {
                struct v4l2_capability *cap = arg;

                //pr_info("[HDMI RX] ioctl VIDIOC_QUERYCAP\n");
                memset(cap, 0, sizeof *cap);
                strlcpy(cap->driver, "v4l2_mipi_top", sizeof cap->driver);
                strlcpy(cap->card, vdev->name, sizeof cap->card);
                //usb_make_path(stream->dev->udev, cap->bus_info, sizeof(cap->bus_info));
                cap->version = LINUX_VERSION_CODE;
                cap->capabilities = V4L2_CAP_VIDEO_CAPTURE | V4L2_CAP_STREAMING;
                break;
            }
        case VIDIOC_CROPCAP:
            {
                struct v4l2_cropcap *ccap = arg;

                ccap->bounds.left = 0;
                ccap->bounds.top = 0;

                ccap->bounds.width = 1920;//stream->cur_frame->wWidth;
                ccap->bounds.height = 1080;//stream->cur_frame->wHeight;

                ccap->defrect = ccap->bounds;

                ccap->pixelaspect.numerator = 1;
                ccap->pixelaspect.denominator = 1;
                break;
            }
        case VIDIOC_G_CROP:
        case VIDIOC_S_CROP:
            {
                return -EINVAL;
            }
        case VIDIOC_ENUM_FMT:
            {
                struct v4l2_fmtdesc *fmt = arg;
                struct hdmirx_format_desc *format;
                enum v4l2_buf_type type = fmt->type;
                __u32 index = fmt->index;

                //pr_info("[HDMI RX] ioctl VIDIOC_ENUM_FMT\n");
                memset(fmt, 0, sizeof(*fmt));
                fmt->index = index;
                fmt->type = type;

                if (fmt->index >= V4L2_HDMI_RX_SUPPORT_FMT_NUM)
                    return -EINVAL;
                format = &hdmi_rx_fmts[fmt->index];
                fmt->flags = V4L2_FMT_FLAG_COMPRESSED;
                strlcpy(fmt->description, format->name,sizeof fmt->description);
                fmt->description[sizeof fmt->description - 1] = 0;
                fmt->pixelformat = format->fcc;
                break;
            }
        case VIDIOC_ENUM_FRAMESIZES:
            {
                struct v4l2_frmsizeenum *fsize = arg;
                int i=0;
                //struct hdmi_rx_frame *frame;

                //pr_info("[HDMI RX] ioctl VIDIOC_ENUM_FRAMESIZES\n");
                /* Look for the given pixel format */
                for(i=0; i<HDMI_MEASURE_RETRY_TIMES; i++)
                {
                    if(hdmi_ioctl_struct.measure_ready == 1)
                        break;
                    HDMI_DELAYMS(10);
                }
                if ((fsize->index != 0)||((hdmi_ioctl_struct.measure_ready == 0)&&(mipi_top.src_sel == 1)))
                    return -EINVAL;

                //frame = &hdmi_rx_frames[fsize->index];
                if(mipi_top.src_sel == 1)
                {
                    int v_len;

                    //if(hdmi_rx_reg_read32(HDMI_HDMI_VCR_VADDR, HDMI_RX_MAC) & _BIT6) // interlace mode
                    if(!hdmi.tx_timing.progressive)
                        v_len = (hdmi.tx_timing.v_act_len << 1);
                    else
                        v_len = (hdmi.tx_timing.v_act_len);

                    fsize->type = V4L2_FRMSIZE_TYPE_CONTINUOUS;
                    fsize->stepwise.min_width = (hdmi.tx_timing.h_act_len)/32;
                    fsize->stepwise.max_width = hdmi.tx_timing.h_act_len;
                    fsize->stepwise.step_width = 1;
                    fsize->stepwise.min_height = v_len/32;
                    fsize->stepwise.max_height = v_len;
                    fsize->stepwise.step_height = 1;
                    pr_info("[HDMI RX] Act_hor:%u,Act_ver:%u\n",hdmi.tx_timing.h_act_len,hdmi.tx_timing.v_act_len);
                }
                else
                {
                    fsize->type = V4L2_FRMSIZE_TYPE_CONTINUOUS;
                    fsize->stepwise.min_width = (mipi_csi.h_input_len)/32;
                    fsize->stepwise.max_width = mipi_csi.h_input_len;
                    fsize->stepwise.step_width = 1;
                    fsize->stepwise.min_height = (mipi_csi.v_input_len)/32;
                    fsize->stepwise.max_height = mipi_csi.v_input_len;
                    fsize->stepwise.step_height = 1;
                }
                break;
            }
        case VIDIOC_ENUM_FRAMEINTERVALS:
            {
                struct v4l2_frmivalenum *fival = arg;
//                unsigned int reg_val;

                if (fival->index != 0)
                    return -EINVAL;
/*
                struct hdmi_rx_fps_t *hdmi_fps = NULL;
                int i;

                for (i = 0; i < V4L2_HDMI_RX_FIX_FPS_NUM; i++)
                {
                    if (hdmi_rx_frames[i].wWidth == fival->width &&
                        hdmi_rx_frames[i].wHeight == fival->height)
                    {
                        hdmi_fps = &hdmi_rx_fps[i];
                        break;
                    }
                }
                if(i==V4L2_HDMI_RX_FIX_FPS_NUM)
                {
                    if (hdmi_rx_frames[i].wWidth >= fival->width &&
                        hdmi_rx_frames[i].wHeight >= fival->height)
                    {
                        hdmi_fps = &hdmi_rx_fps[i];
                        break;
                    }
                }
                if ((hdmi_fps == NULL)||(fival->index >= hdmi_fps->support_num))
                    return -EINVAL;
*/
                fival->type = V4L2_FRMIVAL_TYPE_DISCRETE;
                fival->discrete.numerator = 1;
                if(mipi_top.src_sel == 1)
                {
					unsigned int vic;
					vic = drvif_Hdmi_AVI_VIC();
					if(hdmi_vic_table[vic].interlace)
						fival->discrete.denominator = hdmi_vic_table[vic].fps/2;
					else
						fival->discrete.denominator = hdmi_vic_table[vic].fps;
                }
                else
                    fival->discrete.denominator = 60;
                break;
            }
        case VIDIOC_S_FMT:
            {
                struct v4l2_format *fmt = arg;
                int ret = 0;

                //pr_info("[HDMI RX] ioctl VIDIOC_S_FMT\n");
                dev->width = fmt->fmt.pix.width;
                dev->height = fmt->fmt.pix.height;
                dev->outfmt = V4L2_format_parse(fmt->fmt.pix.pixelformat);
                dev->bpp = out_color_to_bpp(dev->outfmt);
                pr_info("[HDMI RX] VIDIOC_S_FMT,%dx%d,color=0x%x\n", fmt->fmt.pix.width, fmt->fmt.pix.height, dev->outfmt);

                if(mipi_top.src_sel == 1)
                {
                    int v_len;

                    //if(hdmi_rx_reg_read32(HDMI_HDMI_VCR_VADDR, HDMI_RX_MAC) & _BIT6) // interlace mode
                    if(!hdmi.tx_timing.progressive)
                        v_len = (hdmi.tx_timing.v_act_len << 1);
                    else
                        v_len = (hdmi.tx_timing.v_act_len);

                    hdmi.tx_timing.output_h = fmt->fmt.pix.width;
                    hdmi.tx_timing.output_v = fmt->fmt.pix.height;
                    hdmi.tx_timing.output_color = dev->outfmt;
                    hdmi.tx_timing.pitch = rx_pitch_measurement(hdmi.tx_timing.output_h, hdmi.tx_timing.output_color);
                    mipi_top.mipi_init = 0;
                    if ((v_len) && (v_len < hdmi.tx_timing.output_v))
                    {
                        pr_err("[v_size error :%d<%d]\n", v_len, hdmi.tx_timing.output_v);
                        return -EINVAL;
                    }
                    if ((hdmi.tx_timing.h_act_len) && (hdmi.tx_timing.h_act_len < hdmi.tx_timing.output_h))
                    {
                        pr_err("[h_size error :%d<%d]\n", hdmi.tx_timing.h_act_len, hdmi.tx_timing.output_h);
                        return -EINVAL;
                    }
                }
                else
                {
                    mipi_csi.h_output_len = fmt->fmt.pix.width;
                    mipi_csi.v_output_len = fmt->fmt.pix.height;
                    mipi_csi.output_color = dev->outfmt;
                    mipi_csi.pitch = rx_pitch_measurement(mipi_csi.h_output_len, mipi_csi.output_color);
//                    mipi_csi.h_input_len = fmt->fmt.pix_mp.width;
//                    mipi_csi.v_input_len = fmt->fmt.pix_mp.height;

                    mipi_top.mipi_init = 0;
                    if ((mipi_csi.v_input_len) && (mipi_csi.v_input_len < mipi_csi.v_output_len))
                    {
                        pr_err("[v_size error :%d<%d]\n", mipi_csi.v_input_len, mipi_csi.v_output_len);
                        return -EINVAL;
                    }
                    if ((mipi_csi.h_input_len) && (mipi_csi.h_input_len < mipi_csi.h_output_len))
                    {
                        pr_err("[h_size error :%d<%d]\n", mipi_csi.h_input_len, mipi_csi.h_output_len);
                        return -EINVAL;
                    }
                }
                return ret;
            }
        case VIDIOC_S_PARM://Set USB camera frame rate, unused in RX
            {
                //pr_notice("[HDMI RX] Not support fps change\n");
                return 0;
            }
        /* Buffers & streaming */
        case VIDIOC_REQBUFS:
            {
                //pr_info("[HDMI RX] ioctl VIDIOC_REQBUFS\n");
                struct vb2_queue *vq ;//= &dev->vb_hdmidq;
                struct v4l2_requestbuffers *rb = (struct v4l2_requestbuffers *)arg;
                //pr_info("count=%d,type=%d,memory=%d\n",rb->count,rb->type,rb->memory);
                //mutex_lock(&dev->mutex);
                vq = &dev->vb_hdmidq;
                ret = hdmirx_queue_init(dev, vq, rb->memory);
                if(ret){
                    pr_err("hdmirx_queue_init failed: %ld\n", ret);
                    return ret;
                }
                ret = vb2_reqbufs(vq, rb);
                if(ret){
                    pr_err("vb2_reqbufs failed: %ld\n", ret);
                    return ret;
                }
                //mutex_unlock(&dev->mutex);
                return ret;
            }
        case VIDIOC_QUERYBUF:
            {
                struct v4l2_buffer *buf = arg;

                //pr_info("[HDMI RX] ioctl VIDIOC_QUERYBUF\n");
                //mutex_lock(&dev->mutex);
                ret = vb2_querybuf(&dev->vb_hdmidq, buf);
                //hdmi_buffer_queue(&dev->vb_hdmidq);
                //mutex_unlock(&dev->mutex);
                return ret;
            }
         case VIDIOC_QBUF:
            {
                struct v4l2_buffer *buf = arg;

                //pr_info("[HDMI RX] ioctl VIDIOC_QBUF\n");
                //mutex_lock(&dev->mutex);
                ret = vb2_qbuf(&dev->vb_hdmidq, buf);
                //mutex_unlock(&dev->mutex);
                return ret;
            }
        case VIDIOC_DQBUF:
            {
                struct v4l2_buffer *buf = arg;

                //pr_info("[HDMI RX] ioctl VIDIOC_DQBUF\n");
                //mutex_lock(&dev->mutex);
                //pr_info_ratelimited("dqbuf: %d-2-%d\n", atomic_read(&dev->hdmidq.rcnt), atomic_read(&dev->hdmidq.qcnt));
                ret = vb2_dqbuf(&dev->vb_hdmidq, buf, file->f_flags & O_NONBLOCK);
                if(ret == 0)
                    atomic_dec(&dev->hdmidq.rcnt);
                //hdmi_buffer_queue(&dev->vb_hdmidq);
                //mutex_unlock(&dev->mutex);
                if (Hdmi_IsbReady() == TRUE)
                {
                    UINT32 b;
                    b =  Hdmi_get_b_value();
                    if ((HDMI_ABS(b, hdmi_ioctl_struct.b_pre) > 50))
                    {
                        ret = -ENODEV;
                    }
                }

                //avoid userspace seeing broken frames on hotplug or switching tv system
                if(unlikely(ret == 0 && hdmi_stream_on == 0))
                    ret = -EINVAL;

                return ret;
            }
        case VIDIOC_STREAMON:
            {
                unsigned long tprev;
                //pr_info("[HDMI RX] ioctl VIDIOC_STREAMON E\n");
                vb2_streamon(&dev->vb_hdmidq, dev->vb_hdmidq.type);

                //block until mipi_init is done
                tprev = jiffies;
                while(mipi_top.mipi_init == 0 && hdmi_ioctl_struct.measure_ready == 1 && time_before(jiffies, tprev + HZ/2)){
                    //pr_cont(".");
                    usleep_range(1000, 2000);
                }
                if(time_after(jiffies, tprev + HZ/2))
                    pr_warn("STREAMON: wait for mipi_init failed. mipi_init:%d measure_ready:%d\n", mipi_top.mipi_init, hdmi_ioctl_struct.measure_ready);

                //pr_info("[HDMI RX] ioctl VIDIOC_STREAMON X\n");
                //hdmi_start_generating(dev);
                return 0;
            }
        case VIDIOC_STREAMOFF:
            {
                unsigned long tprev;
                //pr_info("[HDMI RX] ioctl VIDIOC_STREAMOFF E\n");
                vb2_streamoff(&dev->vb_hdmidq, dev->vb_hdmidq.type);

                //block until mipi_init is done
                tprev = jiffies;
                while(mipi_top.mipi_init == 0 && hdmi_ioctl_struct.measure_ready == 1 && time_before(jiffies, tprev + HZ/2)){
                    //pr_cont(".");
                    usleep_range(1000, 2000);
                }
                if(time_after(jiffies, tprev + HZ/2))
                    pr_warn("STREAMOFF: wait for mipi_init failed. mipi_init:%d measure_ready:%d\n", mipi_top.mipi_init, hdmi_ioctl_struct.measure_ready);

                //pr_info("[HDMI RX] ioctl VIDIOC_STREAMOFF X\n");
                return 0;
            }
        case VIDIOC_QUERY_MIPI_IN_TYPE:
            {
                struct v4l2_mipi_in_type *in_type = arg;

                pr_info("[HDMI RX] ioctl VIDIOC_MIPI_IN_TYPE\n");
                memset(in_type, 0, sizeof *in_type);
                in_type->input_type = mipi_top.src_sel;
                break;
            }
        case VIDIOC_SET_MIPI_IN_TYPE:
            {
                struct v4l2_mipi_in_type *in_type = arg;

                //pr_info("[HDMI RX] ioctl VIDIOC_SET_MIPI_IN_TYPE\n");
                if(mipi_top.src_sel != in_type->input_type)
                {
                    mipi_top.src_sel = in_type->input_type;
                    mipi_top.mipi_init = 0;
//                    mipi_top.camera_init = 0;
                    mipi_top.hdmi_rx_init = 0;
                }
                break;
            }
        case VIDIOC_SET_EDID_PHYSICAL_ADDR:
            {
                //For CTS 9-5 physical address, call from TX service
                pr_info("[HDMI RX] ioctl VIDIOC_SET_EDID_PHYSICAL_ADDR\n");
                int *phy_addr = arg;
                unsigned char byteMSB,byteLSB;
                byteMSB = ((*phy_addr)>>8)&0xFF;
                byteLSB = (*phy_addr)&0xFF;

                if(mipi_top.hdmi_rx_init)
                    drvif_Hdmi_HPD(0, 0);

                HdmiRx_change_edid_physical_addr(byteMSB, byteLSB);

                if(mipi_top.hdmi_rx_init)
                {
                    HDMI_DELAYMS(1000);
                    drvif_Hdmi_HPD(0, 1);
                }
                break;
            }
		case VIDIOC_ENABLE_RX_HDCP:
			{
				pr_info("[HDMI RX] ioctl VIDIOC_ENABLE_RX_HDCP\n");
				struct rx_hdcp_key *rx_key = arg;
				HdmiRx_enable_hdcp(rx_key->ksv, rx_key->private_key);
				break;
			}
        default:
            {
                pr_err("Unknown ioctl 0x%08x\n", cmd);
                return -ENOTTY;
            }
   }
    return ret;
}

long v4l2_hdmi_ioctl(struct file *file,
             unsigned int cmd, unsigned long arg)
{
    if(0)
    {
        pr_info("v4l2_hdmi_ioctl(");
        v4l_printk_ioctl(NULL, cmd);
        pr_info(")\n");
    }
    return video_usercopy(file, cmd, arg, v4l2_hdmi_do_ioctl);
}

int hdmi_queue_setup(struct vb2_queue *vq, const struct v4l2_format *fmt,
                unsigned int *nbuffers, unsigned int *nplanes,
                unsigned int sizes[], void *alloc_ctxs[])
{
    struct v4l2_hdmi_dev *dev = vb2_get_drv_priv(vq);
    struct hdmi_dmaqueue *dma_q = &dev->hdmidq;
    unsigned long size;

    atomic_set(&dma_q->qcnt, 0);
    atomic_set(&dma_q->rcnt, 0);

    if(dev->outfmt >= OUT_ARGB)
        size = dev->width * dev->height * dev->bpp / 8;
    else
        size = roundup16(dev->width) * roundup16(dev->height) * dev->bpp / 8;

    if (size == 0)
        return -EINVAL;

    if (0 == *nbuffers)
        *nbuffers = 32;

 //   while (size * *nbuffers > vid_limit * 1024 * 1024)
 //       (*nbuffers)--;

    *nplanes = 1;

    sizes[0] = size;

    /*
     * videobuf2-vmalloc allocator is context-less so no need to set
     * alloc_ctxs array.
     */
    if(vq->memory == V4L2_MEMORY_MMAP){
        void *ret = vb2_dma_contig_init_ctx(&dev->vdev.dev);
        if (IS_ERR(ret))
            return PTR_ERR(ret);
        alloc_ctxs[0] = ret;
    }

    pr_info("%s, count=%d, size=%ld\n", __func__, *nbuffers, size);
    return 0;
}

int hdmi_buffer_prepare(struct vb2_buffer *vb)
{
    struct vb2_queue *vq = vb->vb2_queue;
    struct v4l2_hdmi_dev *dev = vb2_get_drv_priv(vq);
    struct hdmi_buffer *buf = container_of(vb, struct hdmi_buffer, vb);
    unsigned long size;

    if (dev->width  < 48 || dev->width  > MAX_WIDTH ||
        dev->height < 32 || dev->height > MAX_HEIGHT)
        return -EINVAL;

    if(dev->outfmt >= OUT_ARGB)
        size = dev->width * dev->height * dev->bpp / 8;
    else
        size = roundup16(dev->width) * roundup16(dev->height) * dev->bpp / 8;

    if (vb2_plane_size(vb, 0) < size) {
        pr_err("%s data will not fit into plane (%lu < %lu)\n",
                __func__, vb2_plane_size(vb, 0), size);
        return -EINVAL;
    }

    vb2_set_plane_payload(&buf->vb, 0, size);

#if TEST_VO_THREAD

#else
    //atomic_inc(&hdmi_hw_buf_avalible_num);
    //if(atomic_read(&hdmi_hw_buf_avalible_num) >= HDMI_HW_BUF_NUM)
    //{
    //    atomic_set(&hdmi_hw_buf_avalible_num, HDMI_HW_BUF_NUM);
    //    //pr_warn("[V4L2 give over %x buffer !!!!!!!]\n",HDMI_HW_BUF_NUM);
    //}
    if(buf->phys == 0){
        if(vq->memory == V4L2_MEMORY_USERPTR){
            //void *vbuf = vb2_plane_vaddr(&buf->vb, 0);
            struct mipi_vb2_vmalloc_buf *vb2_buf =  vb->planes[0].mem_priv;
            unsigned long pfn;

            follow_pfn(vb2_buf->vma, vb->v4l2_planes[0].m.userptr, &pfn);
            buf->phys = __pfn_to_phys(pfn);
        }else if(vq->memory == V4L2_MEMORY_MMAP){
            dma_addr_t *addr = vb2_plane_cookie(vb, 0);
            buf->phys = *addr;
        }
        //pr_info("buf[%d] = %lx\n", vb->v4l2_buf.index, buf->phys);
    }
    hdmi_ddr_ptr[atomic_read(&hdmi_sw_buf_ctl.fill_index)] = (u8 *)buf->phys;
    //pr_info("hdmi_ddr_ptr[%d] = %p\n", atomic_read(&hdmi_sw_buf_ctl.fill_index), hdmi_ddr_ptr[atomic_read(&hdmi_sw_buf_ctl.fill_index)]);
    //pr_info("[BUF: %x:%x,%x]\n", atomic_read(&hdmi_sw_buf_ctl.fill_index), hdmi_ddr_ptr[atomic_read(&hdmi_sw_buf_ctl.fill_index)],atomic_read(&hdmi_hw_buf_avalible_num));
    //HDMI_DELAYMS(1);
    //atomic_inc(&hdmi_sw_buf_ctl.fill_index);
    //if(atomic_read(&hdmi_sw_buf_ctl.fill_index) == HDMI_HW_BUF_NUM)
    //    atomic_set(&hdmi_sw_buf_ctl.fill_index, 0);
#endif

    return 0;
}

int hdmi_buffer_finish(struct vb2_buffer *vb)
{
#if 0
    do_gettimeofday(&vb->v4l2_buf.timestamp);
#else
    struct timespec ts;
    ktime_get_ts(&ts);
    //ktime_get_real_ts(&ts);
    vb->v4l2_buf.timestamp.tv_sec = ts.tv_sec;
    vb->v4l2_buf.timestamp.tv_usec = ts.tv_nsec / 1000;
#endif
    //pr_info("time: %ld.%06ld\n", vb->v4l2_buf.timestamp.tv_sec, vb->v4l2_buf.timestamp.tv_usec);
    return 0;
}

void hdmi_buffer_queue(struct vb2_buffer *vb)
{
    struct v4l2_hdmi_dev *dev = vb2_get_drv_priv(vb->vb2_queue);
    struct hdmi_buffer *buf = container_of(vb, struct hdmi_buffer, vb);
    struct hdmi_dmaqueue *hdmidq = &dev->hdmidq;
    unsigned long flags = 0;

    //pr_info("hdmi_buffer_queue: add buf[%d] to queue\n", vb->v4l2_buf.index);
    spin_lock_irqsave(&dev->slock, flags);
    list_add_tail(&buf->list, &hdmidq->active);
    atomic_inc(&hdmidq->qcnt);
    spin_unlock_irqrestore(&dev->slock, flags);

    //initiate hw buffer addr then enable MIPI wrapper
    if((hdmi_sw_buf_ctl.use_v4l2_buffer == 0) && (atomic_read(&hdmidq->qcnt) >= 2))
    {
        //unsigned int current_offset = 0;
        static int ever_in = 0;
        unsigned int reg_val = hdmi_rx_reg_read32(MIPI_WRAPPER_MIPI_reg, HDMI_RX_MIPI);

        hdmi_rx_reg_write32(MIPI_WRAPPER_MIPI_reg, (reg_val & 0xFFFFFFFE), HDMI_RX_MIPI);//Disable MIPI
        //current_offset = roundup16(mipi_csi.pitch) * roundup16(mipi_csi.v_output_len);
        //pr_info("current_offset = %x\n", current_offset);
        hdmi_sw_buf_ctl.use_v4l2_buffer = 1;
        set_video_DDR_start_addr(dev);
        if(ever_in == 0)
        {
            atomic_add(2, &hdmi_sw_buf_ctl.write_index);
            //atomic_sub(2, &hdmi_hw_buf_avalible_num);
        }
        ever_in = 1;
        //hdmi_rx_reg_write32(MIPI_WRAPPER_MIPI_reg, (reg_val | 0x01), HDMI_RX_MIPI);
    }
}

void mipi_clear_v4l2_queue(struct v4l2_hdmi_dev *dev)
{
    struct hdmi_dmaqueue *dma_q = &dev->hdmidq;
    struct hdmi_buffer *buf;
    unsigned long flags = 0;

    spin_lock_irqsave(&dev->slock, flags);
    if (list_empty(&dma_q->active)) {
        pr_notice("No active queue to serve ??????\n");
        spin_unlock_irqrestore(&dev->slock, flags);
        return;
    }
    buf = list_entry(dma_q->active.next, struct hdmi_buffer, list);
    list_del(&buf->list);
    vb2_buffer_done(&buf->vb, VB2_BUF_STATE_DONE);
    //pr_info("[buffer done %x]\n",&buf->vb);
    spin_unlock_irqrestore(&dev->slock, flags);
}

#if TEST_VO_THREAD
static int hdmi_fillbuff(struct v4l2_hdmi_dev *dev, struct hdmi_buffer *buf)
{
//    int stride = dev->width * dev->pixelsize;
//    int hmax = dev->height;
    void *vbuf = vb2_plane_vaddr(&buf->vb, 0);
    int ret = 0;
//    int h;
//    int access_block = (rtd_inl(0xb8027224)&0x000000C0)>>6;
//    unsigned int nbytes;

    if (!vbuf)
        return ret;

//    if( access_block )
//    {
//        dev->hdmi_ddr_ptr = phoenix_hdmi_sa0;//(u8 *)(rtd_inl(0xb8027208));
//    }
//    else
//    {
//        dev->hdmi_ddr_ptr = phoenix_hdmi_sa1;//(u8 *)(rtd_inl(0xb8027214));
//    }
//    nbytes = stride*hmax;

//    memcpy(vbuf, dev->hdmi_ddr_ptr, nbytes);
    ret = hdmi_v4l2_buf_copy(vbuf, dev->bpp);

    return ret;
}

static void hdmi_thread_tick(struct v4l2_hdmi_dev *dev)
{
    struct hdmi_dmaqueue *dma_q = &dev->hdmidq;
    struct hdmi_buffer *buf;
    unsigned long flags = 0;

    spin_lock_irqsave(&dev->slock, flags);
    if (list_empty(&dma_q->active)) {
        //pr_notice("No active queue to serve\n");
        spin_unlock_irqrestore(&dev->slock, flags);
        return;
    }
    if( !hdmi_hw_buf_is_empty() )
    {
        buf = list_entry(dma_q->active.next, struct hdmi_buffer, list);
        if(hdmi_fillbuff(dev, buf))
        {
            list_del(&buf->list);
            vb2_buffer_done(&buf->vb, VB2_BUF_STATE_DONE);
        }
    }
    spin_unlock_irqrestore(&dev->slock, flags);

    //pr_info("Thread tick 3 \n");
    //v4l2_get_timestamp(&buf->vb.v4l2_buf.timestamp);

    //pr_info("filled buffer %p\n", buf);
    /* Fill buffer */
    //pr_info("[%p/%d] done\n", buf, buf->vb.v4l2_buf.index);
}

static void hdmi_sleep(struct v4l2_hdmi_dev *dev)
{
    struct hdmi_dmaqueue *dma_q = &dev->hdmidq;
    int timeout;
    DECLARE_WAITQUEUE(wait, current);

    //pr_info("%s dma_q=0x%08lx\n", __func__, (unsigned long)dma_q);

    add_wait_queue(&dma_q->wq_v4l2, &wait);
    if (kthread_should_stop())
        goto stop_task;

    /* Calculate time to wake up */
    timeout = msecs_to_jiffies(10);//33ms

    hdmi_thread_tick(dev);

    schedule_timeout_interruptible(timeout);

stop_task:
    remove_wait_queue(&dma_q->wq_v4l2, &wait);
    try_to_freeze();
}

static int hdmi_thread(void *data)
{
    struct v4l2_hdmi_dev *dev = data;

    pr_info("hdmi_thread started\n");

    set_freezable();

    for (;;) {
        hdmi_sleep(dev);

        if (kthread_should_stop())
            break;
    }
    pr_info("hdmi_thread: exit\n");
    return 0;
}
#endif

int hdmi_start_generating(struct v4l2_hdmi_dev *dev)
{
#if TEST_VO_THREAD
    struct hdmi_dmaqueue *dma_q = &dev->hdmidq;
#else
    unsigned int reg_val = hdmi_rx_reg_read32(MIPI_WRAPPER_MIPI_reg, HDMI_RX_MIPI);
    unsigned int st_reg_val = hdmi_rx_reg_read32(MIPI_WRAPPER_MIPI_INT_ST_reg, HDMI_RX_MIPI);
#endif
    pr_info("%s\n", __func__);

#if TEST_VO_THREAD
    dma_q->kthread_v4l2 = kthread_run(hdmi_thread, dev, dev->v4l2_dev.name);

    if (IS_ERR(dma_q->kthread_v4l2)) {
        v4l2_err(&dev->v4l2_dev, "kernel_thread() failed\n");
        return PTR_ERR(dma_q->kthread_v4l2);
    }
    /* Wakes thread */
    wake_up_interruptible(&dma_q->wq_v4l2);
#else
    hdmi_rx_reg_write32(MIPI_WRAPPER_MIPI_reg, (reg_val & 0xFFFFFFFE), HDMI_RX_MIPI);//Disable MIPI
    //clear interrupt status
    hdmi_rx_reg_write32(MIPI_WRAPPER_MIPI_INT_ST_reg, st_reg_val, HDMI_RX_MIPI);
    hdmi_sw_buf_ctl.pre_frame_done = -1;
//    set_video_DDR_start_addr();

	if(mipi_top.mipi_init == 1)//Enable MIPI if MIPI already init
	{
		reg_val = hdmi_rx_reg_read32(MIPI_WRAPPER_MIPI_reg, HDMI_RX_MIPI);
		hdmi_rx_reg_write32(MIPI_WRAPPER_MIPI_reg, (reg_val | 0x01), HDMI_RX_MIPI);
	}
#endif
    hdmi_stream_on = 1;
    pr_info("returning from %s\n", __func__);
    return 0;
}

int hdmi_start_streaming(struct vb2_queue *vq, unsigned int count)
{
    struct v4l2_hdmi_dev *dev = vb2_get_drv_priv(vq);
    pr_info("%s\n", __func__);
    return hdmi_start_generating(dev);
}

void hdmi_stop_generating(struct v4l2_hdmi_dev *dev)
{
    struct hdmi_dmaqueue *dma_q = &dev->hdmidq;

    pr_info("[hdmi_stop_generating]\n");

    /* shutdown control thread */
    if (dma_q->kthread_v4l2) {
        kthread_stop(dma_q->kthread_v4l2);
        dma_q->kthread_v4l2 = NULL;
    }

    /*
     * Typical driver might need to wait here until dma engine stops.
     * In this case we can abort imiedetly, so it's just a noop.
     */

    /* Release all active buffers */
    while (!list_empty(&dma_q->active)) {
        struct hdmi_buffer *buf;
        buf = list_entry(dma_q->active.next, struct hdmi_buffer, list);
        list_del(&buf->list);
        vb2_buffer_done(&buf->vb, VB2_BUF_STATE_ERROR);
        pr_info("[%p/%d] done\n", buf, buf->vb.v4l2_buf.index);
    }
    if(dma_q->hwbuf[0] != NULL){
        vb2_buffer_done(&dma_q->hwbuf[0]->vb, VB2_BUF_STATE_ERROR);
        dma_q->hwbuf[0] = NULL;
    }
    if(dma_q->hwbuf[1] != NULL){
        vb2_buffer_done(&dma_q->hwbuf[1]->vb, VB2_BUF_STATE_ERROR);
        dma_q->hwbuf[1] = NULL;
    }
}

int hdmi_stop_streaming(struct vb2_queue *vq)
{
    struct v4l2_hdmi_dev *dev = vb2_get_drv_priv(vq);
    pr_info("[hdmi_stop_streaming]\n");
    stop_mipi_process();
    hdmi_stop_generating(dev);
    return 0;
}

void hdmi_unlock(struct vb2_queue *vq)
{
    struct v4l2_hdmi_dev *dev = vb2_get_drv_priv(vq);
    mutex_unlock(&dev->mutex);
}

void hdmi_lock(struct vb2_queue *vq)
{
    struct v4l2_hdmi_dev *dev = vb2_get_drv_priv(vq);
    mutex_lock(&dev->mutex);
}

void hdmi_rx_process(void)
{
    int ret;
    static int state = 0;

    //pr_info("%s:%d\n", __func__, __LINE__);
    if(mipi_top.hdmi_rx_init == 0)
    {
        set_hdmirx_wrapper_control_0(-1,-1,-1,-1,-1,1);
        // hdmi rx init
        HdmiTable_Init();

        drvif_Hdmi_Release();

        drvif_Hdmi_Init();

        drvif_Hdmi_Release();

        drvif_Hdmi_InitSrc(hdmiport);

        mipi_top.hdmi_rx_init = 1;

        state = 0;
    }

#ifdef CRC_CHECK
    HDMI_FormatDetect();
    if(hdmi_ioctl_struct.b)
    {
        int result;

        result = QC_CRCCheck(0); // type=0: HDMI; type=1: MHL

        if(result)
            pr_info("CRC PASS\n");
        else
            pr_info("CRC FAIL!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!\n");
    }
#endif
    switch(state)
    {
        case 0:
            if (drvif_Hdmi_DetectMode() == PHOENIX_MODE_SUCCESS) {
                state++;
            }
            break;
        case 1:
            ret = drvif_Hdmi_CheckMode();
            if(ret > 0 && hdmi_ioctl_struct.detect_done)
            {
				pr_info("[HDMI RX] check mode is false, restart HDMI Rx wrapper detection ret(%d)\n",ret);
				state = 0;
				restartHdmiRxWrapperDetection();
            }
			else if(hdmi_ioctl_struct.detect_done == 0)
			{
				pr_info("[HDMI RX] check mode is fine, but detect_done=0 ret(%d)\n",ret);
				state =0;
			}
            break;
        default:
            state = 0;
            break;
    }
    if(hdmiport!=GET_HDMI_CHANNEL())
    {
		drvif_Hdmi_Release();
		drvif_Hdmi_InitSrc(hdmiport);
		state = 0;
    }

}

#if TEST_VO_THREAD
int vo_hw_thread(void *arg)
{
    //unsigned int timeout;
    //int *d = (int *) arg;

    pr_info("In vo_hw_thread \n");
    for(;;) {
        if (kthread_should_stop()) break;

#if 0
        do {
            set_current_state(TASK_INTERRUPTIBLE);

            timeout = schedule_timeout(1 * HZ);
            //pr_info("[here]\n");
        } while(timeout);
#endif
        //if(!hdmi_hw_buf_is_empty())
            sd_test_vo_detect();
    }
    pr_info("break\n");

    return 0;
}
#endif

void mipi_csi_process(void)
{
    MIPI_REG mipi_reg;
#if TEST_VO_THREAD
    unsigned int addr1y, addr1uv,offset;
    int ret;
#endif

    if(mipi_top.mipi_init == 1)
    {
        return;
    }
    // mipi csi init
    pr_info("In mipi_csi_process ,in:%d * %d, c:%d,out: %d * %d\n",mipi_csi.h_input_len, mipi_csi.v_input_len, mipi_csi.output_color, mipi_csi.h_output_len, mipi_csi.v_output_len);

    if(hdmi.mipi_camera_type == MIPI_CAMERA_RLE0551C)
        RLE0551C_patterngen_2048x1536();
    else if(hdmi.mipi_camera_type == MIPI_CAMERA_RTS5845)
        RTS5845(mipi_csi.h_input_len, mipi_csi.v_input_len);
    set_mipi_env();

#if 0
    mipi_csi.h_output_len = 1920;//720;//fmt->fmt.pix.width;
    mipi_csi.v_output_len = 1080;//480;//fmt->fmt.pix.height;
    mipi_csi.output_color = OUT_YUV420;//fmt->fmt.pix.pixelformat;

    mipi_csi.h_input_len = 2592;//2048;//2592;//1920;// 2592;
    mipi_csi.v_input_len = 1944;//1536;//1944;//1080;//1944;
    mipi_csi.pitch = rx_pitch_measurement(mipi_csi.h_output_len, mipi_csi.output_color);
#endif
    //pr_info("[%d,%d,%d,%d,%d]\n",mipi_csi.h_output_len,mipi_csi.v_output_len,mipi_csi.output_color,mipi_csi.h_input_len,mipi_csi.v_input_len);
    pr_info("pitch=%d,len=%d,color=%d\n",mipi_csi.pitch,mipi_csi.v_output_len,mipi_csi.output_color);
#if TEST_VO_THREAD
    {
        set_video_DDR_start_addr();
    }
#endif

    set_video_dest_size(mipi_csi.h_output_len, mipi_csi.pitch);    //width,pitch
    set_video_src_size(mipi_csi.h_input_len);
    //scale down
    phoenix_mipi_scale_down(mipi_csi.h_input_len, mipi_csi.v_input_len, mipi_csi.h_output_len, mipi_csi.v_output_len);

    hdmi_rx_reg_write32(MIPI_WRAPPER_DPHY_REG11_reg, Esc_lane3_flg(clear)|Esc_lane2_flg(clear)|Esc_lane2_flg(clear)|Esc_lane1_flg(clear)|
           Esc_lane0_flg(clear)|Clk_ulps_flg(clear)|Crc16_err_flg(clear)|Ecc_crt_flg(clear)|Ecc_err_flg(clear), HDMI_RX_MIPI_PHY);

    memset(&mipi_reg, 0, sizeof(MIPI_REG));
    mipi_reg.dst_fmt = mipi_csi.output_color;
    // camera only support YUV422
    mipi_reg.src_fmt = 0x02;  //YUV_FMT_YUV422
    mipi_reg.src_sel = 0;   //0:MIPI 1:HDMI_RX
    mipi_reg.seq_en = 1;    //0:blk 1:seq (for YUV)
    if(mipi_csi.v_input_len > mipi_csi.v_output_len)
        mipi_reg.vs = 1;
//    mipi_reg.vs_near = 0;
//    mipi_reg.vs_yodd = 0;
//    mipi_reg.vs_codd = 0;
    if(mipi_csi.h_input_len > mipi_csi.h_output_len)
        mipi_reg.hs = 1;
//    mipi_reg.hs_yodd = 0;
//    mipi_reg.hs_codd = 0;
    if(mipi_csi.output_color > OUT_JPEG8)
        mipi_reg.yuv_to_rgb = 1;
    if((mipi_reg.vs) || (mipi_reg.hs))
    {
        mipi_reg.chroma_us_mode = 0;    //0:repeat 1:avg
        mipi_reg.chroma_us_en = 1;
        if((mipi_reg.dst_fmt == OUT_YUV422)||(mipi_reg.dst_fmt == OUT_YUV420))
        {
            mipi_reg.chroma_ds_mode = 0;    //0:drop 1:avg
            mipi_reg.chroma_ds_en = 1;
        }
    }
    mipi_reg.int_en4 = 1;
    mipi_reg.int_en3 = 1;
    mipi_reg.int_en2 = 1;
    mipi_reg.int_en1 = 1;
    mipi_reg.int_en0 = 1;
#if TEST_VO_THREAD
    mipi_reg.en = 1;
#else
    if(hdmi_stream_on)
        mipi_reg.en = 1;
    else
        mipi_reg.en = 0;
#endif
    pr_info("set_init_mipi_value\n");
    set_init_mipi_value(&mipi_reg);

#if TEST_VO_THREAD
    //HDMI_DELAYMS(33);//33ms
    pr_info("In mipi_csi_process 1\n");
#if CAMERA_480_OUT
    test_HDMI_480p();
#else
    test_HDMI_1080p60();
#endif
    offset = roundup16(mipi_csi.pitch) * roundup16(mipi_csi.v_output_len);

    addr1y = (unsigned int)((hdmi_ddr_ptr[0]));
    addr1uv = (unsigned int)((hdmi_ddr_ptr[0] + offset));
    pr_info("In mipi_csi_process 2\n");

#if CAMERA_480_OUT
    test_VO_480p(addr1y, addr1uv);
#else
    test_VO_1080p(addr1y, addr1uv);
    //test_VO_1080p(addr1y, addr1uv);
#endif
    pr_info("In mipi_csi_process 3\n");
    Wreg32(0x180041f8 , 0x5);

    if(vo_hw_tsk == NULL)
    {
        vo_hw_tsk = kthread_create(vo_hw_thread, &vo_hw_data, "vo_hw_thread");
        if (IS_ERR(vo_hw_tsk)) {
            ret = PTR_ERR(vo_hw_tsk);
            vo_hw_tsk = NULL;
            pr_err("vo_hw_tsk thread fail\n");
            return;
        }
        wake_up_process(vo_hw_tsk);
    }

#endif

#if 0
    while(1)
    {
        HDMI_DELAYMS(33);//33ms
        tmp_mipi_isr();
    }
#endif
    mipi_top.mipi_init = 1;
    mipi_delay_counter = 1;
    pr_info("[MIPI INIT 1]\n");
}

static inline void update_hdmirx_switch_state(struct v4l2_hdmi_dev *dev)
{
    static int cnt = 0;
    if(hdmi_ioctl_struct.detect_done != switch_get_state(&dev->sdev)){
        cnt++;
        //pr_info("\033[0;33mdetect hdmi rx state change to %d, cnt:%d\033[m\n", hdmi_ioctl_struct.measure_ready, cnt);
        //if(cnt >= 2) //debounce
        {
            pr_err("\033[0;31mswitch hdmi rx state to %d\033[m\n", hdmi_ioctl_struct.detect_done);
            switch_set_state(&dev->sdev, hdmi_ioctl_struct.detect_done);
            cnt = 0;
        }
    }else{
        cnt = 0;
    }
}

static int mipi_top_thread(void *arg)
{
    unsigned int timeout;
	unsigned int i;
    struct v4l2_hdmi_dev *dev = arg;

//    int *d = (int *) arg;

    //pr_info("%s:%d\n", __func__, __LINE__);
    memset(&mipi_top, 0, sizeof(MIPI_TOP_INFO));
#if 0//HDMI_RX_IN
    mipi_top.src_sel = 1;
#endif
    mipi_top.src_sel = hdmi.mipi_input_type;
    mipi_top.p_hdmi = &hdmi;
    mipi_top.p_mipi_csi = &mipi_csi;

#if 0
    mipi_csi.h_output_len = 720;//720;//fmt->fmt.pix.width;
    mipi_csi.v_output_len = 480;//480;//fmt->fmt.pix.height;
    mipi_csi.output_color = OUT_YUV422;//fmt->fmt.pix.pixelformat;

    mipi_csi.h_input_len = 1920;
    mipi_csi.v_input_len = 1080;

#endif

    pr_devel("Enter mipi_top_thread \n");
    for(;;) {
        if (kthread_should_stop()) break;

        if (/*gpio_get_value(dev->gpio_hpd_ctrl_pin) &&*/ (mipi_top.src_sel == 1)){
			if(rx_5v_state)
			{
				hdmi_rx_process();
				for(i=0;i<3;i++)
				{
					update_hdmirx_switch_state(dev);
					usleep_range(70000, 75000);//70ms~75ms
					rtd_hdmiPhy_ISR();//Execute once every 10 msec(ideal case)
				}
			}
			else
			{
				if(switch_get_state(&dev->sdev))
				{
					pr_err("\033[0;31mswitch hdmi rx state to %d\033[m\n", hdmi_ioctl_struct.detect_done);
					switch_set_state(&dev->sdev, 0);
				}

				HDMI_DELAYMS(250);
			}
        }else{
            mipi_csi_process();
            //sd_test_while_loop();
			usleep_range(150000, 200000);
        }
    }
    pr_devel("Leave mipi_top_thread\n");

    return 0;
}

int v4l2_mipi_top_open(struct file *filp)
{
    struct video_device *vdev = video_devdata(filp);
    struct v4l2_fh *fh = kzalloc(sizeof(*fh), GFP_KERNEL);
//    int ret;

    filp->private_data = fh;
    if (fh == NULL)
        return -ENOMEM;
    v4l2_fh_init(fh, vdev);
    v4l2_fh_add(fh);

#if 0
    // add thread for HDMI RX
    // 20140307 move to hdmirx_rtk_drv_probe
    hdmi_hw_tsk = kthread_create(mipi_top_thread, &hdmi_hw_data, "hdmi_hw_thread");
    if (IS_ERR(hdmi_hw_tsk)) {
        ret = PTR_ERR(hdmi_hw_tsk);
        hdmi_hw_tsk = NULL;
        return -ENODEV;
    }
    wake_up_process(hdmi_hw_tsk);
#endif
    return 0;
}

void  rx5v_do_tasklet(unsigned long unused)
{
	int gpio_value;
	gpio_value = gpio_get_value(hdmi.gpio_rx_5v);

	if(!gpio_value && rx_5v_state)//RX unplugged
	{
		pr_info("[HDMI RX] RX unplugged\n");
		if(hdmi.power_saving)
		{
			if(mipi_top.hdmi_rx_init)
				drvif_Hdmi_Release();
			set_hdmirx_wrapper_control_0(-1,0,-1,-1,-1,0);//Turn off RX
			stop_mipi_process();
			mipi_top.hdmi_rx_init = 0;
			hdmi_ioctl_struct.measure_ready = 0;
			hdmi_ioctl_struct.detect_done = 0;
			SET_HDMI_VIDEO_FSM(MAIN_FSM_HDMI_SETUP_VEDIO_PLL);
			SET_HDMI_AUDIO_FSM(AUDIO_FSM_AUDIO_START);
			gpio_direction_input(hdmi.gpio_hpd_ctrl);
		}
		else
		{
			set_hdmirx_wrapper_control_0(-1, 0,-1,-1,-1,-1);//Stop DMA
			stop_mipi_process();
			hdmi_ioctl_struct.measure_ready = 0;
			hdmi_ioctl_struct.detect_done = 0;
			SET_HDMI_VIDEO_FSM(MAIN_FSM_HDMI_SETUP_VEDIO_PLL);
			SET_HDMI_AUDIO_FSM(AUDIO_FSM_AUDIO_START);
		}
		rx_5v_state = 0;
	}
	else if(gpio_value && !rx_5v_state)//RX plugged
	{
		if(hdmi.power_saving)
		{
			gpio_direction_output(hdmi.gpio_hpd_ctrl,1);
		}
		else
		{
			restartHdmiRxWrapperDetection();
		}
		rx_5v_state = 1;
		pr_info("[HDMI RX] RX Plugged\n");
	}

}

irqreturn_t hdmirx_hpd_handler(int irq, void *dev_id)
{
	tasklet_hi_schedule(&rx5v_tasklet);

	return IRQ_HANDLED;
}

irqreturn_t hdmi_irq_handler(int irq, void *dev_id)
{
    HDMI_SW_BUF_CTL * video_info = (HDMI_SW_BUF_CTL *)dev_id;
    irqreturn_t  retVal = IRQ_NONE;
    if(! HDMIRX_HAS_BIT(HDMIRX_VO_SYNC_ADDR, HDMIRX_VO_FEEDBACK_NOTIFY) )
        return IRQ_NONE;
    else
        HDMIRX_RESET_BIT(HDMIRX_VO_SYNC_ADDR,  HDMIRX_VO_FEEDBACK_NOTIFY) ;

    if( video_info->ISR_FLIP <=0 )
        goto HDMIRX_IRQ_END;

    wake_up(&HDMIRX_WAIT_OSD_COMPLETE);

HDMIRX_IRQ_END:

    retVal =  IRQ_HANDLED;

    return retVal;
}

static int __init hdmirx_init(void)
{
    int retval = 0;

//    retval = request_irq(HDMIRX_FB_IRQ, hdmi_irq_handler, IRQF_SHARED, "HDMIRX_FB_ISR", (void *) (&hdmi_sw_buf_ctl));
    if (0)//(retval)
    {
        pr_err("HDMIRX IRQ fail\n");
        return -EINVAL;
    }
//    HDMIRX_SET_BIT(HDMIRX_VO_SYNC_ADDR, HDMIRX_VO_SET_NOTIFY);
    pr_info("hdmirx_init 1\n");
    retval = platform_driver_register(&HDMIRX_PLATFORM_DRIVER);
    pr_info("hdmirx_init 2\n");

    if (0){//(!retval) {
        hdmirx_device = platform_device_alloc(RTK_HDMIRX_NAME, 0);

        if (hdmirx_device)
            retval = platform_device_add(hdmirx_device);
        else
            retval = -ENOMEM;

        if (retval) {
            platform_device_put(hdmirx_device);
            platform_driver_unregister(&HDMIRX_PLATFORM_DRIVER);
        } else {
        }
    }
//    mipi_csi_process();
    return retval;
}

void __iomem *hdmi_rx_base[HDMI_RX_REG_BLOCK_NUM]; // see define in HDMI_RX_REG_BASE_TYPE


int hdmirx_rtk_drv_remove(struct platform_device *pdev)
{
    struct fb_info *info = platform_get_drvdata(pdev);

    pr_info("hdmirx: removing..\n");
    if (info) {
        unregister_framebuffer(info);
        framebuffer_release(info);
    }
    return 0;
}

void hdmi_platform_shutdown(struct platform_device * p_dev)
{
    (void)p_dev;
}

static ssize_t show_hdmirx_bufcnt(struct device *cd, struct device_attribute *attr, char *buf)
{
	struct video_device *vfd = container_of(cd, struct video_device, dev);
	struct v4l2_hdmi_dev *dev = (struct v4l2_hdmi_dev *)video_get_drvdata(vfd);
	struct hdmi_dmaqueue *hdmidq = &dev->hdmidq;

	return sprintf(buf, "qcnt:%d rcnt:%d\n", atomic_read(&hdmidq->qcnt), atomic_read(&hdmidq->rcnt));
}

static ssize_t show_hdmirx_video_info(struct device *cd, struct device_attribute *attr, char *buf)
{
    char *type[] = { "MIPI", "HDMIRx" };
    char *stat[] = { "NotReady", "Ready" };
    char *cs[] = { "RGB", "YUV422", "YUV444", "YUV411" };
    char *sm[] = { "Interlaced", "Progressive" };

    int status = 0;
    int mode = 0;
    int color = 0;
	int fps = 0;
    int width = 0;
    int height = 0;
	unsigned int vic = 0;

    if(mipi_top.src_sel == 0){ //mipi camera
        status = 1;
        mode = 1;
        color = 0;
        fps = 60;
        width = mipi_csi.h_input_len;
        height = mipi_csi.v_input_len;
    }else if(mipi_top.src_sel == 1 && hdmi_ioctl_struct.detect_done){ //hdmi rx
        status = hdmi_ioctl_struct.detect_done;
        mode = hdmi.tx_timing.progressive;
        color = hdmi.tx_timing.color;
        width = hdmi.tx_timing.h_act_len;
        height = hdmi.tx_timing.v_act_len;
        if(mode == 0) //interlaced mode
            height *= 2;

		vic = drvif_Hdmi_AVI_VIC();
		fps = hdmi_vic_table[vic].fps;
    }

    //pr_info("%s: %d %d %d %dx%d %u %d\n", __func__, status, mode, color, width, height, vic, fps);
    return sprintf(buf, "Type:%s\nStatus:%s\nWidth:%u\nHeight:%u\nScanMode:%s\nColor:%s\nFps:%u\n",
        type[mipi_top.src_sel], stat[status], width, height, sm[mode], cs[color], fps);
}

static ssize_t show_hdmirx_audio_info(struct device *cd, struct device_attribute *attr, char *buf)
{
    return sprintf(buf, "Freq:%u\n", hdmi.tx_timing.spdif_freq);
}

static DEVICE_ATTR(hdmirx_bufcnt, S_IRUGO, show_hdmirx_bufcnt, NULL);
static DEVICE_ATTR(hdmirx_video_info, S_IRUGO, show_hdmirx_video_info, NULL);
static DEVICE_ATTR(hdmirx_audio_info, S_IRUGO, show_hdmirx_audio_info, NULL);

int hdmirx_rtk_drv_probe(struct platform_device *pdev)
{
    struct v4l2_hdmi_dev *dev;
    struct video_device *vfd;
    struct switch_dev *sdev;
//    struct v4l2_ctrl_handler *hdl;
    struct vb2_queue *q;
//    dev_t devno = MKDEV(140, 0);
//    dev_t dev = MKDEV(devone_major, 0);
    int ret, i;
    u32 irq;
    /*EDID Info*/
    unsigned int ddc_max_num;
    //unsigned int edid_table_mask;
    const u32 *edid_table_pro[32]; /*Maximum Support Table is 32bit wide*/
    int edid_cell_size, j;
    HDMIRX_DTS_EDID_TBL_T dts_edid_table[HDMI_MAX_CHANNEL];
 //   int mipi_drv_data;
    struct hdmi_fb_info *fbi = NULL;
	unsigned int hpd_irq;
	struct device_node *node_rx_5v;

    //initialize global variables
    memset(&mipi_top, 0, sizeof(mipi_top));
    memset(&hdmi, 0, sizeof(hdmi));
    memset(&mipi_csi, 0, sizeof(mipi_csi));
    memset(&hdmi_ioctl_struct, 0, sizeof(hdmi_ioctl_struct));

    if (WARN_ON(!(pdev->dev.of_node)))
    {
        pr_err("[HDMI RX] Error: No node\n");
        return -ENODEV;
    }
////////////////////////////////////////////////////////////////////////////////////////////
    fbi = (struct hdmi_fb_info *)framebuffer_alloc(sizeof(struct hdmi_fb_info) - sizeof(struct fb_info), &pdev->dev);
    if (!fbi) {
        pr_err("[HDMI RX] Error: framebuffer_alloc(%d) failed!\n", sizeof(struct hdmi_fb_info) - sizeof(struct fb_info));
        return -ENOMEM;
    }
    memset(fbi, 0, sizeof(struct hdmi_fb_info));
    fbi->dev = &pdev->dev;
    fbi->fb.flags = FBINFO_DEFAULT;
    fbi->fb.fbops = &hdmirx_fb_ops;
    ret = register_framebuffer(&fbi->fb);
    if (ret < 0)
    {
        framebuffer_release((struct fb_info *)fbi);
        return ret;
    }
    platform_set_drvdata(pdev, &fbi->fb);
////////////////////////////////////////////////////////////////////////////////////////////
    if (WARN_ON(!(pdev->dev.of_node)))
    {
        pr_err("[HDMI RX] Error: No node\n");
        return -ENODEV;
    }

    for (i=0; i < HDMI_RX_REG_BLOCK_NUM; i++)
    {
        hdmi_rx_base[i] = of_iomap(pdev->dev.of_node, i);
        WARN(!(hdmi_rx_base[i]), "unable to map HDMI RX base registers\n");
        pr_info("[HDMI RX] In hdmirx_rtk_drv_probe base %d = %x\n",i,(int)hdmi_rx_base[i]);
    }

    {
        of_property_read_u32(pdev->dev.of_node, "mipi_camera_type", &(hdmi.mipi_camera_type));
        of_property_read_u32(pdev->dev.of_node, "mipi_input_type", &(hdmi.mipi_input_type));
    }
    dev = kzalloc(sizeof(*dev), GFP_KERNEL);
    if (!dev)
        return -ENOMEM;
    snprintf(dev->v4l2_dev.name, sizeof(dev->v4l2_dev.name), "v4l2_mipi_top");
    ret = v4l2_device_register(NULL, &dev->v4l2_dev);
    if (ret)
        goto free_dev;

    /***********************************************

                   GPIO Settings

    ***********************************************/
    /*initial Hotplug GPIO*/
	//RX_HPD_CTRL GPIO
	hdmi.gpio_hpd_ctrl = of_get_named_gpio(pdev->dev.of_node, "gpio-rx-hpd-ctrl", 0);
	if (!gpio_is_valid(hdmi.gpio_hpd_ctrl))
		pr_err("[HDMI RX][%s] gpio %d is not valid\n",__FUNCTION__, hdmi.gpio_hpd_ctrl);
	if(!gpio_request(hdmi.gpio_hpd_ctrl, pdev->dev.of_node->name))
		gpio_direction_input(hdmi.gpio_hpd_ctrl);
	else
		pr_err("[HDMI RX][%s] could not request gpio, %d\n",__FUNCTION__, hdmi.gpio_hpd_ctrl);

	//HDMIRX_5V GPIO
	node_rx_5v = of_get_child_by_name(pdev->dev.of_node, "gpio-rx-5v-detect");
	if(!node_rx_5v)
		pr_err("[HDMI RX][%s] get node gpio-rx-5v-detect fail\n",__FUNCTION__);

	hdmi.gpio_rx_5v = of_get_gpio(node_rx_5v,0);
	if (!gpio_is_valid(hdmi.gpio_rx_5v))
		pr_err("[HDMI RX][%s] gpio %d is not valid\n",__FUNCTION__, hdmi.gpio_rx_5v);
	else
		pr_err("[HDMI RX][%s] gpio-rx-5v-detect = GPIO(%d) \n",__FUNCTION__, hdmi.gpio_rx_5v);

	if(gpio_request(hdmi.gpio_rx_5v, node_rx_5v->name))
		pr_err("[HDMI RX][%s] could not request gpio, %d\n",__FUNCTION__, hdmi.gpio_rx_5v);

	rx_5v_state = gpio_get_value(hdmi.gpio_rx_5v);

	if(rx_5v_state)
		gpio_direction_output(hdmi.gpio_hpd_ctrl,1);//RX_HPD_CTL => high, HDMIRX_HPD => low

	//RX 5V detect interrupt handle
	hpd_irq = irq_of_parse_and_map(node_rx_5v, 0);
	if (hpd_irq)
	{
		irq_set_irq_type(hpd_irq, IRQ_TYPE_EDGE_BOTH);

		if(request_irq(hpd_irq, hdmirx_hpd_handler, IRQF_SHARED, "RX_HPD_ISR", dev))
			pr_err("[HDMI RX][%s] hdmirx_hpd_handler request fail\n",__FUNCTION__);
	}
	else
		pr_err("[HDMI RX][%s] hpd_irq parse fail\n",__FUNCTION__);

	//RX power saving
	if(of_property_read_u32(pdev->dev.of_node, "power-saving", &hdmi.power_saving))
		hdmi.power_saving = 0;

    /***********************************************

                  EDID Table Settings

    ************************************************/
    if (of_property_read_u32(pdev->dev.of_node, "Realtek,ddc-max-num", &ddc_max_num))
    {
       pr_warn("[HDMI Rx][%s] Parsing MAx DDC channels failed\n", __FUNCTION__);
       ddc_max_num = 1;
    }
    /*To Simplify Driver Design. so, at this step, we don't think of edid-used-mask*/
    //if(of_property_read_u32(pdev->dev.of_node, "Realtek,edid-used-mask", &edid_table_mask))
    //{
    //	  pr_warn("[HDMI Rx][%s] Parsing EDID table msk failed\n", __FUNCTION__);
    //	  edid_table_mask = 0;
    //}

    //pr_info("[HDMI Rx] Get DDC Max Num: %d, EDID Table Mask: 0x%08X\n", ddc_max_num, edid_table_mask);
    pr_info("[HDMI Rx] Get DDC Max Num: %d\n", ddc_max_num);

    if(ddc_max_num > HDMI_MAX_CHANNEL)
    {
      ddc_max_num = HDMI_MAX_CHANNEL;
    }

    for(i = 0; i < ddc_max_num; i++)
    {

       edid_table_pro[i] = of_get_property(pdev->dev.of_node, hdmi_rx_edid_tbl_node[i], &edid_cell_size);
       pr_info("[HDMI Rx] Used EDID table: %s, Edid cell size: %d\n", hdmi_rx_edid_tbl_node[i], edid_cell_size);
       if(edid_table_pro[i])
       {
          edid_cell_size = edid_cell_size / 4;/*Each Read is 4bytes (1world), so divide it by 4*/
          for(j = 0; j < edid_cell_size; j++)
          {
             dts_edid_table[i].edid[j] = (unsigned char) of_read_number(edid_table_pro[i], 1 + j);
          }
       }
       else
       {
          pr_warn("[HDMI Rx][%s] Parsing EDID table content failed\n", __FUNCTION__);
       }
    }

    HdmiRx_Save_DTS_EDID_Table_Init(dts_edid_table, ddc_max_num);


////////////////////////////////////////////////////////////////////////////////////////////

    irq = irq_of_parse_and_map(pdev->dev.of_node, 0);
    WARN(!(irq), "can not map HDMI RX\n");
    if (request_irq(irq, phoenix_mipi_isr, IRQF_SHARED , "mipi",  dev))// dev  // (void*)(&mipi_drv_data)dev
    {
        pr_err("mipi: cannot register IRQ %d", irq);
    }
    else
    {
        pr_info("mipi irq OK~~~~ \n");
    }

////////////////////////////////////////////////////////////////////////////////////////////
    // set default value
    dev->width = 1920;
    dev->height = 1080;
    dev->bpp = 12; //OUT_YUV420

    /* initialize locks */
    spin_lock_init(&dev->slock);

    /* initialize queue */
    q = &dev->vb_hdmidq;
    memset(q, 0, sizeof(*q));
    ret = hdmirx_queue_init(dev, q, V4L2_MEMORY_USERPTR);
    if (ret)
        goto unreg_dev;
    mutex_init(&dev->mutex);

    /* init video dma queues */
    INIT_LIST_HEAD(&dev->hdmidq.active);

#if TEST_VO_THREAD
    init_waitqueue_head(&dev->hdmidq.wq_v4l2);
#endif

    vfd = &dev->vdev;
    *vfd = hdmi_template;
//    vfd->debug = debug;
    vfd->v4l2_dev = &dev->v4l2_dev;
    vfd->queue = q;
    //vfd->v4l2_dev->dev = MKDEV(140, 0);
    vfd->num = V4L2_FL_USE_FH_PRIO;
    set_bit(V4L2_FL_USE_FH_PRIO, &vfd->flags);
    dma_set_coherent_mask(&vfd->dev, DMA_BIT_MASK(32));
    /*
     * Provide a mutex to v4l2 core. It will be used to protect
     * all fops and v4l2 ioctls.
     */
    vfd->lock = &dev->mutex;
    video_set_drvdata(vfd, dev);
    ret = video_register_device(vfd, VFL_TYPE_GRABBER, 250);
    if (ret < 0)
        goto unreg_dev;

#if 0
    //register the device with sysfs
    //memset(&vfd->dev, 0, sizeof(vfd->dev));
    /* The memset above cleared the device's device_private, so
       put back the copy we made earlier. */
    //vfd->dev.p = priv;
    //vfd->dev.class = &video_class;
    vfd->dev.devt = MKDEV(140, 0);
    //if (vdev->parent)
    //        vdev->dev.parent = vdev->parent;
    dev_set_name(&vfd->dev, "%s%d", vfd->name, vfd->num);
    ret = device_register(&vfd->dev);
    if (ret < 0) {
            pr_err( "%s: device_register failed\n", __func__);
            goto unreg_dev;
    }
    //end register the device with sysfs
#endif

#if 1
	ret = device_create_file(&vfd->dev, &dev_attr_hdmirx_bufcnt);
	if(ret < 0)
		goto unreg_dev;
    ret = device_create_file(&vfd->dev, &dev_attr_hdmirx_video_info);
    if(ret < 0)
        goto unreg_dev;
    ret = device_create_file(&vfd->dev, &dev_attr_hdmirx_audio_info);
    if(ret < 0)
        goto unreg_dev;
#endif

#if 1
    sdev = &dev->sdev;
    memset(sdev, 0, sizeof(*sdev));
    sdev->name = "rx";
    ret = switch_dev_register(sdev);
    if(ret < 0)
        goto unreg_vdev;
    switch_set_state(&dev->sdev, hdmi_ioctl_struct.detect_done);
#endif

    /* Now that everything is fine, let's add it to device list */
    list_add_tail(&dev->hdmi_devlist, &hdmi_devlist);

    /*  // move to v4l2_hdmirx_open
    // add thread for HDMI RX
    hdmi_hw_tsk = kthread_create(mipi_top_thread, &hdmi_hw_data, "hdmi_hw_thread");
    if (IS_ERR(hdmi_hw_tsk)) {
        ret = PTR_ERR(hdmi_hw_tsk);
        hdmi_hw_tsk = NULL;
        goto unreg_dev;
    }
    wake_up_process(hdmi_hw_tsk);
    */
#if TEST_VO_THREAD
    // for mipi HW buffer
    for(i=0; i<HDMI_HW_BUF_NUM; i++)
    {
//        hdmi_ddr_ptr[i] = kmalloc(sizeof(u8)*HDMI_MAX_FRAME_SIZE, GFP_KERNEL);//HDMI_MAX_FRAME_SIZE//(u8*)(0x1500000 + i*0x1000000);//
//        pr_info("[hdmirx_init ,hdmi_ddr_ptr%d=%x]\n",i, (int)hdmi_ddr_ptr[i]);
        struct page *page;
        size_t size;

        size = sizeof(u8)*HDMI_MAX_FRAME_SIZE;
        page = dma_alloc_from_contiguous(&(pdev->dev), size>>PAGE_SHIFT, get_order(size));
        hdmi_ddr_ptr[i] = (u8*)page_to_phys(page);
//        hdmi_ddr_ptr_virt[i] = (u8*)page_to_virt(page);
        pr_info("[hdmirx_init ,hdmi_ddr_ptr%d=%x]\n",i, (int)hdmi_ddr_ptr[i]);
    }
#endif
    // for HDMI sw ctrl buffer
    atomic_set(&hdmi_sw_buf_ctl.read_index, 0);
    atomic_set(&hdmi_sw_buf_ctl.write_index, 0);
    atomic_set(&hdmi_sw_buf_ctl.fill_index, 0);
    hdmi_sw_buf_ctl.use_v4l2_buffer= 0;
//    for(i=0; i<HDMI_SW_BUF_NUM; i++)
//        hdmi_sw_buf_ptr[i] = kmalloc(HDMI_MAX_FRAME_SIZE, GFP_KERNEL);
    //scaler setting
    //magellan_scaler_setting();
    // for mipi sw ctrl variable
    {
#if CAMERA_480_OUT
        mipi_csi.h_output_len = 720;
        mipi_csi.v_output_len = 480;
        hdmi.tx_timing.output_h = 720;
        hdmi.tx_timing.output_v = 480;
#else
        mipi_csi.h_output_len = 1920;
        mipi_csi.v_output_len = 1080;
        hdmi.tx_timing.output_h = 1920;
        hdmi.tx_timing.output_v = 1080;
#endif
        if(hdmi.mipi_camera_type == MIPI_CAMERA_RLE0551C)
        {
            mipi_csi.h_input_len = 2048;
            mipi_csi.v_input_len = 1536;
        }
        else
        {
            mipi_csi.h_input_len = MIPI_CAMERA_IN_W;
            mipi_csi.v_input_len = MIPI_CAMERA_IN_H;
        }
#if MIPI_SCALE_DOWN_DIS
        mipi_csi.h_output_len = mipi_csi.h_input_len;//1920;
        mipi_csi.v_output_len = mipi_csi.v_input_len;//1080;
#endif
        mipi_csi.output_color = VO_OUTPUT_COLOR_FMT;
        hdmi.tx_timing.output_color = VO_OUTPUT_COLOR_FMT;
    }
    // add thread for HDMI RX
    hdmi_hw_tsk = kthread_create(mipi_top_thread, dev, "mipi_hw_thread");
    if (IS_ERR(hdmi_hw_tsk)) {
        ret = PTR_ERR(hdmi_hw_tsk);
        hdmi_hw_tsk = NULL;
        return -ENODEV;
    }
    wake_up_process(hdmi_hw_tsk);

    return 0;

unreg_sdev:
    switch_dev_unregister(&dev->sdev);
unreg_vdev:
    video_unregister_device(&dev->vdev);
unreg_dev:
//    v4l2_ctrl_handler_free(hdl);
    v4l2_device_unregister(&dev->v4l2_dev);
    /*Free Requested GPIO*/
    gpio_free(hdmi.gpio_hpd_ctrl);
    /*-------------------*/

free_dev:
    kfree(dev);
    return ret;
}

static int hdmi_release(void)
{
    struct v4l2_hdmi_dev *dev;
    struct list_head *list;

    while (!list_empty(&hdmi_devlist)) {
        list = hdmi_devlist.next;
        list_del(list);
        dev = list_entry(list, struct v4l2_hdmi_dev, hdmi_devlist);

#if 1
        switch_dev_unregister(&dev->sdev);
#endif
#if 1
        device_remove_file(&dev->vdev.dev, &dev_attr_hdmirx_video_info);
        device_remove_file(&dev->vdev.dev, &dev_attr_hdmirx_audio_info);
#endif
        video_unregister_device(&dev->vdev);
        v4l2_device_unregister(&dev->v4l2_dev);
        /*Free Requested GPIO*/
        gpio_free(hdmi.gpio_rx_5v);
        gpio_free(hdmi.gpio_hpd_ctrl);
        /*-------------------*/
        //v4l2_ctrl_handler_free(&dev->ctrl_handler);
        kfree(dev);
    }

    return 0;
}

static void __exit hdmi_exit(void)
{
#if 1
    hdmi_release();
#endif
    pr_info(KERN_ALERT "HDMI exit\n");
}

#if 0
static int __init hdmirx_test_init(void)
{
    int ret;
    pr_info("[hdmirx_test_init]\n");
    // add thread for HDMI RX
    hdmi_hw_tsk = kthread_create(mipi_top_thread, &hdmi_hw_data, "hdmi_hw_thread");
    if (IS_ERR(hdmi_hw_tsk)) {
        ret = PTR_ERR(hdmi_hw_tsk);
        hdmi_hw_tsk = NULL;
        pr_err("[kthread_create fail]\n");
        return 0;
    }
    //phoenix_hdmi_sa0 = kmalloc(0x400000, GFP_KERNEL);
    //phoenix_hdmi_sa1 = kmalloc(0x400000, GFP_KERNEL);

    wake_up_process(hdmi_hw_tsk);

//    pr_info("[hdmirx_test_init 2,sa0=%x, sa1=%x]\n",(int)phoenix_hdmi_sa0, (int)phoenix_hdmi_sa1);
    //scaler setting
    //magellan_scaler_setting();

    pr_info("[hdmirx_test_init 3]\n");
    return 1;
}
#endif
//module_init(hdmirx_test_init);
module_init(hdmirx_init);

module_exit(hdmi_exit);

