//Copyright (C) 2007-2013 Realtek Semiconductor Corporation.
#ifndef __MHLTX_CBUS_H__
#define __MHLTX_CBUS_H__

#include "mhltx.h"

int get_cbus_status(void);
void cbus_discovery_detect_1K(void);
void cbus_discovery_wakeup(void);
void cbus_HPD_handler(int HPD_event, int det_1k);
void cbus_ddc_get_data(struct cbus_adapter* p_this);
void cbus_ddc_read(int devaddr, int length);

void enable_cbus(void);
void cbus_enable_scpu_int(void);
struct cbus_adapter *cbus_get_adapter(void);
void cbus_reset_xfer_info(struct cbus_adapter *p_this);
int __cbus_transfer(struct cbus_adapter *adap, struct ddc_msg *msgs, int num);
void cbus_dump_ddc_msg(struct ddc_msg* msgs);

void CBUS_MSC_init_Rx_work(void);
bool CBUS_Send_MSC_Command(struct cbus_adapter *adap,struct msc_msg *pReq);
void mhltx_work_queue(struct work_struct *work);


void CBUS_send_MSC_GET_MSC_ERRORCODE(void);
void CBUS_send_MSC_SET_INT( unsigned char interrupt_registers , unsigned char mask);
void CBUS_send_MSC_WRITE_STAT( unsigned char status_registers, unsigned char value);
void CBUS_send_MSC_READ_DEVCAP( unsigned char capability_registers);
void CBUS_send_MSC_SET_HPD (void);
void CBUS_send_MSC_ABORT (void);

void CBUS_get_device_capability(void);
void CBUS_dump_device_capability(struct device_capability *devcap);
void CBUS_reset_device_capability(struct device_capability *devcap);

int cbus_force_rcp(void);

#endif  //__MHLTX_CBUS_H__
