//Copyright (C) 2007-2013 Realtek Semiconductor Corporation.
#ifndef __MHLTX_DEF_H__
#define __MHLTX_DEF_H__

#include "cbus_tx_reg.h"

#include <linux/wait.h>
#include <linux/timer.h>
/******************************************************
**  MSC channel: FW0_CMD_INF 
**
*******************************************************/


#define TX_TIMEOUT      (HZ<<2)

//FW0 Request Enable
typedef enum
{
     FW0_REQ_DISABLED 	 = 0x00
    ,FW0_REQ_ENABLED	 = 0x01    
    // this one must be last
    ,FW0_REQ_SIZE
}FW0_REQ;


typedef enum
{
     FW0_DATA_IRQ_DISABLED 	 = 0x00
    ,FW0_DATA_IRQ_ENABLED	 = 0x01    
}FW0_DATA_IRQ;

typedef enum
{
     FW0_CMD_IRQ_DISABLED 	 = 0x00
    ,FW0_CMD_IRQ_ENABLED	 = 0x01    
}FW0_CMD_IRQ;



//FW0 Request Case
typedef enum
{
     FW0_TX_CASE_DATA 				 = 0x00
    ,FW0_TX_CASE_CMD1	             = 0x01
    ,FW0_TX_CASE_CMD1_DATA      	 = 0x02
    ,FW0_TX_CASE_CMD1_OFF_DATA     	 = 0x03
	,FW0_TX_CASE_CMD1_OFF_DATA_CMD2  = 0x04
	,FW0_TX_CASE_CMD1_OFF			 = 0x05
    // this one must be last
    ,FW0_TX_CASE_SIZE
}FW0_TX_CASE;

//Wait Case For Reply
typedef enum
{
     FW0_WAIT_CASE_NO 		 = 0x00
    ,FW0_WAIT_CASE_CMD	     = 0x01
    ,FW0_WAIT_CASE_DATA      = 0x02
    ,FW0_WAIT_CASE_CMD_DATA  = 0x03
    // this one must be last
    ,FW0_WAIT_CASE_SIZE
}FW0_WAIT_CASE;

//FW0 Header
typedef enum
{
     FW0_HEADER_DDC_PACKET 				= 0x00
    ,FW0_HEADER_VENDOR_SPECIFIC_PACKET	= 0x01
    ,FW0_HEADER_MSC_PACKET      		= 0x02
    ,FW0_HEADER_RESERVERD     			= 0x03
    // this one must be last
    ,FW0_HEADER_SIZE
}FW0_Header;

/******************************************************
**
**
**
*******************************************************/
typedef enum
{
	SINK  	  = 0x1
	,SOURCE     = 0x2
	,DONGLE     = 0x3
}DevType;


typedef enum
{
     DEVCAP_OFFSET_DEV_STATE 		= 0x00
    ,DEVCAP_OFFSET_MHL_VERSION		= 0x01
    ,DEVCAP_OFFSET_DEV_CAT          = 0x02
    ,DEVCAP_OFFSET_ADOPTER_ID_H     = 0x03
    ,DEVCAP_OFFSET_ADOPTER_ID_L     = 0x04
    ,DEVCAP_OFFSET_VID_LINK_MODE    = 0x05
    ,DEVCAP_OFFSET_AUD_LINK_MODE    = 0x06
    ,DEVCAP_OFFSET_VIDEO_TYPE       = 0x07
    ,DEVCAP_OFFSET_LOG_DEV_MAP      = 0x08
    ,DEVCAP_OFFSET_BANDWIDTH        = 0x09
    ,DEVCAP_OFFSET_FEATURE_FLAG     = 0x0A
    ,DEVCAP_OFFSET_DEVICE_ID_H      = 0x0B
    ,DEVCAP_OFFSET_DEVICE_ID_L      = 0x0C
    ,DEVCAP_OFFSET_SCRATCHPAD_SIZE  = 0x0D
    ,DEVCAP_OFFSET_INT_STAT_SIZE    = 0x0E
    ,DEVCAP_OFFSET_RESERVED         = 0x0F
    // this one must be last
    ,DEVCAP_SIZE
}DevCapOffset;


typedef enum
{
	OFFSET_MHL_VERSION_MAJOR_LSB  	  = 0x0
	,OFFSET_MHL_VERSION_MAJOR_MSB     = 0x3
	,OFFSET_MHL_VERSION_MINOR_LSB     = 0x4
	,OFFSET_MHL_VERSION_MINOR_MSB     = 0x7
}MHLVersion_Offset;

typedef enum
{
	OFFSET_DEV_TYPE_LSB  	= 0x0
	,OFFSET_DEV_TYPE_MSB    = 0x3
	,OFFSET_POW     		= 0x4
	,OFFSET_PLIM0     		= 0x5
	,OFFSET_PLIM1     		= 0x6
}DevCategory_Offset;



typedef enum
{
	OFFSET_SUPP_RGB444        = 0x0
	,OFFSET_SUPP_YCBCR444     = 0x1
	,OFFSET_SUPP_YCBCR422     = 0x2
	,OFFSET_SUPP_PackedPixel  = 0x3
	,OFFSET_SUPP_ISLANDS      = 0x4
	,OFFSET_SUPP_VGA          = 0x5
}VidLinkMode_Offset;

typedef enum
{
	OFFSET_AUD_2CH        = 0x0
	,OFFSET_AUD_8CH       = 0x1	
}AudioLinkMode_Offset;

typedef enum
{
	OFFSET_VT_GRAPHICS =0x0
	,OFFSET_VT_PHOTO   =0x1
	,OFFSET_VT_CINEMA  =0x2
	,OFFSET_VT_GAME    =0x3
	,OFFSET_SUPP_VT	   =0x7	
}VideoType_Offset;

typedef enum
{
	OFFSET_LD_DISPLAY 	=0x0
	,OFFSET_LD_VIDEO 	=0x1
	,OFFSET_LD_AUDIO 	=0x2
	,OFFSET_LD_MEDIA 	=0x3
	,OFFSET_LD_TUNER 	=0x4
	,OFFSET_LD_RECORD 	=0x5
	,OFFSET_LD_SPEAKER 	=0x6
	,OFFSET_LD_GUI 		=0x7
}LogicalDevice_Offset;


typedef enum
{
	OFFSET_RCP_SUPPORT 			=0x0
	,OFFSET_RAP_SUPPORT			=0x1
	,OFFSET_SP_SUPPORT			=0x2
	,OFFSET_UCP_SEND_SUPPORT	=0x3
	,OFFSET_UCP_RECV_SUPPORT	=0x4
}FeatureSupport_Offset;		

typedef enum
{
	OFFSET_INIT_SIZE_LSB	=0x0
	,OFFSET_INIT_SIZE_MSB	=0x3
	,OFFSET_STAT_SIZE_LSB	=0x4
	,OFFSET_STAT_SIZE_MSB	=0x7
	
}IntStatSize_Offset;	
		
enum
{
	MHL_MSC_MSG_MSGE            = 0x02,     // MSGE Error sub-command
    MHL_MSC_MSG_RCP             = 0x10,     // RCP sub-command
    MHL_MSC_MSG_RCPK            = 0x11,     // RCP Acknowledge sub-command
    MHL_MSC_MSG_RCPE            = 0x12,     // RCP Error sub-command
    MHL_MSC_MSG_RAP             = 0x20,     // Mode Change Warning sub-command
    MHL_MSC_MSG_RAPK            = 0x21,     // MCW Acknowledge sub-command
	MHL_MSC_MSG_UCP             = 0x30,     // UTF-8 Character Protocol sub-command
	MHL_MSC_MSG_UCPK            = 0x31,     // UCP Acknowledge sub-command
	MHL_MSC_MSG_UCPE            = 0x32,     // UCP Error sub-command
};

enum
{
    MHL_MSC_MSG_RCPE_NO_ERR            = 0x00,     // No Error
	MHL_MSC_MSG_RCPE_UNREC_ACT_CODE    = 0x01,     // Unrecognized Action Code           
	MHL_MSC_MSG_RCPE_UNSUP_ACT_CODE    = 0x02,     // Unsupported Action Code
	MHL_MSC_MSG_RCPE_RES_BUSY		   = 0x03,     // Responder Busy
};

enum
{
	MHL_EOF						= 0x32,	// End of Frame
	MHL_ACK						= 0x33,	// Command or Data byte acknowledge
	MHL_NACK					= 0x34,	// Command or Data byte not acknowledge
	MHL_ABORT					= 0x35,	// Transaction abort
	MHL_WRITE_STAT				= 0x60,	
	//MHL_SET_INT					= 0x60,	// Write one interrupt register
	MHL_READ_DEVCAP				= 0x61,	// Read one register
	MHL_GET_STATE				= 0x62,	// Read CBUS revision level from follower
	MHL_GET_VENDOR_ID			= 0x63,	// Read vendor ID value from follower.
	MHL_SET_HPD					= 0x64,	// Set Hot Plug Detect in follower
	MHL_CLR_HPD					= 0x65,	// Clear Hot Plug Detect in follower
	//MHL_SET_CAP_ID				= 0x66,	// Set Capture ID for downstream device.
	//MHL_GET_CAP_ID				= 0x67,	// Get Capture ID from downstream device.
	MHL_MSC_MSG					= 0x68,	// VS command to send RCP sub-commands
	MHL_GET_SC1_ERRORCODE		= 0x69,	// Get Vendor-Specific command error code.
	MHL_GET_DDC_ERRORCODE		= 0x6A,	// Get DDC channel command error code.
	MHL_GET_MSC_ERRORCODE		= 0x6B,	// Get MSC command error code.
	MHL_WRITE_BURST				= 0x6C,	// Write 1-16 bytes to responder's scratchpad.
	MHL_GET_SC3_ERRORCODE		= 0x6D,	// Get channel 3 command error code.
};

#define MHL_SET_INT  MHL_WRITE_STAT

#define MHL_STATUS_REG_CONNECTED_RDY        0x30
#define MHL_STATUS_REG_LINK_MODE            0x31

#define MHL_RCHANGE_INT                     0x20
#define MHL_DCHANGE_INT                     0x21


#define MSC_IRQ_wr_stat   		MSC_IRQ_wr_stat_irq_shift            //(31)										
#define MSC_IRQ_rd_devcap 		MSC_IRQ_rd_devcap_irq_shift          //(30)                                     
#define MSC_IRQ_get_stat 		MSC_IRQ_get_stat_irq_shift           //(29)                                     
#define MSC_IRQ_get_id  		MSC_IRQ_get_id_irq_shift             //(28)											
#define MSC_IRQ_get_msg 		MSC_IRQ_get_msg_irq_shift            //(27)											
#define MSC_IRQ_sc1_err 		MSC_IRQ_sc1_err_irq_shift            //(26)											
#define MSC_IRQ_ddc_err 		MSC_IRQ_ddc_err_irq_shift            //(25)											
#define MSC_IRQ_msc_err 		MSC_IRQ_msc_err_irq_shift            //(24)                                     
#define MSC_IRQ_wr_burst 		MSC_IRQ_wr_burst_irq_shift           //(23)                                     
#define MSC_IRQ_sc3_err 		MSC_IRQ_sc3_err_irq_shift            //(22)                                     
#define MSC_IRQ_fwdef_cmd 		MSC_IRQ_fwdef_cmd_irq_shift          //(21)                                     
#define MSC_IRQ_allmsc_cmd 		MSC_IRQ_allmsc_cmd_irq_shift         //(20)                                     
#define MSC_IRQ_abort_res 		MSC_IRQ_abort_res_irq_shift          //(19)											
#define MSC_IRQ_abort_req 		MSC_IRQ_abort_req_irq_shift          //(18)											
#define MSC_IRQ_ddc_abort 		MSC_IRQ_ddc_abort_irq_shift          //(17)                                     
#define MSC_IRQ_ddc_nack 		MSC_IRQ_ddc_nack_irq_shift           //(16)                                     
#define MSC_IRQ_msge 			MSC_IRQ_msge_irq_shift               //(15)												
#define MSC_IRQ_rcp  			MSC_IRQ_rcp_irq_shift                //(14)												
#define MSC_IRQ_rcpk 			MSC_IRQ_rcpk_irq_shift               //(13)												
#define MSC_IRQ_rcpe 			MSC_IRQ_rcpe_irq_shift               //(12)                                     
#define MSC_IRQ_rap  			MSC_IRQ_rap_irq_shift                //(11)												
#define MSC_IRQ_rapk 			MSC_IRQ_rapk_irq_shift               //(10)												
#define MSC_IRQ_ucp  			MSC_IRQ_ucp_irq_shift                //(9)												
#define MSC_IRQ_ucpe 			MSC_IRQ_ucpe_irq_shift               //(8)												
#define MSC_IRQ_ucpk 			MSC_IRQ_ucpk_irq_shift               //(7)                                           
#define MSC_IRQ_msg_sub 		MSC_IRQ_msg_sub_irq_shift            //(6)                                            
#define MSC_IRQ_det_rxsense 	MSC_IRQ_det_rxsense_irq_shift        //(5)                                             
#define MSC_IRQ_msc_hpd 		MSC_IRQ_msc_hpd_irq_shift            //(4)


/*
queue implementation
*/

#define QUEUE_SIZE(x) (sizeof(x.queue)/sizeof(x.queue[0]))
#define MAX_QUEUE_DEPTH(x) (QUEUE_SIZE(x) -1)
#define QUEUE_DEPTH(x) ((x.head <= x.tail)?(x.tail-x.head):(QUEUE_SIZE(x)-x.head+x.tail))
#define QUEUE_FULL(x) (QUEUE_DEPTH(x) >= MAX_QUEUE_DEPTH(x))

#define ADVANCE_QUEUE_HEAD(x) { x.head = (x.head < MAX_QUEUE_DEPTH(x))?(x.head+1):0; }
#define ADVANCE_QUEUE_TAIL(x) { x.tail = (x.tail < MAX_QUEUE_DEPTH(x))?(x.tail+1):0; }

#define RETREAT_QUEUE_HEAD(x) { x.head = (x.head > 0)?(x.head-1):MAX_QUEUE_DEPTH(x); }


#endif  //__MHLTX_DEF_H__