//Copyright (C) 2007-2013 Realtek Semiconductor Corporation.
#ifndef __MHLTX_DEV_H__
#define __MHLTX_DEV_H__

#include <linux/kernel.h>
#include <linux/device.h>
#include <linux/switch.h>
#include <linux/miscdevice.h>


typedef struct{  
	char*  name;	
    struct miscdevice  miscdev;
	struct switch_dev sdev;
    struct device dev;   
	void __iomem *reg_base;
	void __iomem *hdmi_base;
	unsigned int irq_num;	
	int cbus_status;
	struct workqueue_struct *workqueue;
}mhltx_device_t;

#define to_mhltx_device(x)  container_of(x, mhltx_device_t, dev)
 
static inline void *mhltx_get_drvdata (mhltx_device_t *device)
{
    return dev_get_drvdata(&device->dev);
}
 
static inline void mhltx_set_drvdata (mhltx_device_t *device, void *data)
{
    struct device *dev = &device->dev;
    dev_set_drvdata(dev, data);
}
 
extern int register_mhltx_switchdev(mhltx_device_t * device);
extern void deregister_mhltx_switchdev(mhltx_device_t * device);
extern void mhltx_switchdev_HPD_handler(void);
extern int mhltx_switchdev_set_HPD_status(int HPD_status);
extern int mhltx_switchdev_show_HPD_status(void);
struct delayed_work *mhltx_submit_work(int event,__u64 rx_event, int delay);

#endif  //__MHLTX_DEV__H__

