/*
 * Realtek MMC/SD/SDIO driver
 *
 * Authors:
 * Copyright (C) 2008-2009 Realtek Ltd.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 */

#include <linux/module.h>
#include <linux/init.h>
#include <linux/io.h>
#include <linux/platform_device.h>
#include <linux/mbus.h>
#include <linux/delay.h>
#include <linux/interrupt.h>
#include <linux/dma-mapping.h>
#include <linux/scatterlist.h>
#include <linux/irq.h>
#include <linux/gpio.h>
#include <linux/mmc/host.h>
#include <asm/unaligned.h>

#include <linux/sched.h>                //liao
#include <linux/wait.h>                 //liao
#include <linux/slab.h>                 //liao
#include <linux/semaphore.h>            //liao
#include <linux/mmc/card.h>             //liao
#include <linux/mmc/mmc.h>              //liao
#include <linux/mmc/sd.h>               //liao
#include <linux/workqueue.h>            //liao
#include <linux/completion.h>           //liao
#include <rbus/reg_mmc.h>               //liao
#include <rbus/reg_iso.h>               //liao
#include <rbus/reg_sys.h>               //liao
#include <mach/cpu.h>
#include "rtkemmc.h"                  //liao
#include "rtksd_ops.h"                  //liao
#include "../mmc_debug.h"               //liao

#ifdef CONFIG_REALTEK_PCBMGR
#include <mach/pcbMgr.h>
#ifdef CONFIG_REALTEK_GPIO
#include <mach/venus_gpio.h>
#define EMMC_SHOUTDOWN_PROTECT
#endif
#endif

#include <asm/system_info.h>

#define DRIVER_NAME "rtkemmc"
#define BANNER      "Realtek eMMC Driver"
#define VERSION     "$Id: rtkemmc.c Phoenix 2014-03-26 10:00 $"

#ifdef MONI_MEM_TRASH
#define MAX_BLK_NUM 0x01
#endif

#ifndef CONFIG_MMC_RTKEMMC_HK_ATTR
#define CONFIG_MMC_RTKEMMC_HK_ATTR
#endif

//#define SHOW_MMC_PRD

static int maxfreq = RTKSD_CLOCKRATE_MAX;
static int nodma;
struct mmc_host * mmc_host_local = NULL;
static u32 rtk_emmc_bus_wid = 0;
volatile u8 g_cmd[6];
static unsigned char* pRSP=NULL;
static unsigned char* pRSP_org=NULL;
static unsigned int  g_crinit=0;
static struct rw_semaphore cr_rw_sem;

static void rtksd_request(struct mmc_host *host, struct mmc_request *mrq);
static int rtksd_get_ro(struct mmc_host *mmc);
static void rtksd_set_ios(struct mmc_host *host, struct mmc_ios *ios);

//static int rtksd_re_init_proc(struct mmc_card *card);
static void set_cmd_info(struct mmc_card *card,struct mmc_command * cmd,
                  struct sd_cmd_pkt * cmd_info,u32 opcode,u32 arg,u8 rsp_para);
/*
static void set_str_info(struct mmc_card *card,struct mmc_command* cmd,
                  struct mmc_data *data,struct sd_cmd_pkt * cmd_info,
                  u32 opcode,u32 arg,u16 byte_count,u16 block_count,
                  unsigned char * dma_buf);
*/

static int rtksd_stop_transmission(struct mmc_card *card);
static int rtksd_send_status(struct mmc_card *card,u16 * state,u8 divider);
static int rtksd_wait_status(struct mmc_card *card,u8 state,u8 divider);

static void rtkcr_set_speed(struct rtksd_host *sdport,u8 level);

typedef void (*set_gpio_func_t)(u32 gpio_num,u8 dir,u8 level);
static int bSendCmd0=0;

static const struct mmc_host_ops rtkemmc_ops = {
    .request        = rtksd_request,
    .get_ro         = rtksd_get_ro,
    .set_ios        = rtksd_set_ios,
    //liao .enable_sdio_irq    = rtksd_enable_sdio_irq,
};

#define UNSTUFF_BITS(resp,start,size)					\
	({								\
		const int __size = size;				\
		const u32 __mask = (__size < 32 ? 1 << __size : 0) - 1;	\
		const int __off = 3 - ((start) / 32);			\
		const int __shft = (start) & 31;			\
		u32 __res;						\
									\
		__res = resp[__off] >> __shft;				\
		if (__size + __shft > 32)				\
			__res |= resp[__off-1] << ((32 - __shft) % 32);	\
		__res & __mask;						\
	})

static void rtksd_hold_card(struct rtksd_host *sdport)
{
    u32 iobase = sdport->base_io;
    u32 loop = 1000;

    printk(KERN_ERR "%s(%u)",__func__,__LINE__);

    while(loop--){
        //printk(KERN_ERR "wait eMMC END_STATE!!!\n");
        if (cr_readb(iobase+SD_TRANSFER) & END_STATE)
            break;
        rtkcr_mdelay(1);
    }

    //TBD, chk if we need to do sth related to CR GPIO
    #if 0
    //pull low 10us eMMC reset
    rtkcr_set_mis_gpio(20,GPIO_OUT,GPIO_LOW);

	//keep DATA[7:0] floating
	rtkcr_set_mis_gpio(16,GPIO_IN,GPIO_LOW);
	rtkcr_set_mis_gpio(17,GPIO_IN,GPIO_LOW);
	rtkcr_set_mis_gpio(18,GPIO_IN,GPIO_LOW);
	rtkcr_set_mis_gpio(21,GPIO_IN,GPIO_LOW);
	rtkcr_set_mis_gpio(22,GPIO_IN,GPIO_LOW);
	rtkcr_set_mis_gpio(23,GPIO_IN,GPIO_LOW);
	rtkcr_set_mis_gpio(24,GPIO_IN,GPIO_LOW);
	rtkcr_set_mis_gpio(25,GPIO_IN,GPIO_LOW);

	//hold eMMC CMD high
	rtkcr_set_mis_gpio(7,GPIO_OUT,GPIO_HIGH);

	rtkcr_mdelay(1);
    //hold eMMC clock high
    rtkcr_set_mis_gpio(19,GPIO_OUT,GPIO_HIGH);

	rtkcr_mdelay(1);
    //pull high eMMC reset and keep
    rtkcr_set_mis_gpio(20,GPIO_OUT,GPIO_HIGH);
    #endif
}

static void rtkemmc_set_crt_muxpad(struct rtksd_host *sdport)
{
    u32 reg_val=0;
    
    MMCPRINTF("\n");

    //set default i/f to cr
    reg_val = cr_readl(SYS_muxpad0);
    reg_val &= ~0xFFFF0FFF;
    reg_val |= 0xaaaa0aa8;
    cr_writel(reg_val,SYS_muxpad0);
   
    if (soc_is_rtk1195() && (realtek_rev() == RTK1195_REV_B))
    {
	cr_writel(0xe0003, PLL_EMMC1); //LDO1.8v
	cr_writel(0x0, CR_PAD_CTL); //PAD to 1.8v
	printk("detect 1195 REV_B \n");
    }
}

u32 swap_endian(u32 input)
{
        u32 output;
        output = (input & 0xff000000)>>24|
                         (input & 0x00ff0000)>>8|
                         (input & 0x0000ff00)<<8|
                         (input & 0x000000ff)<<24;
        return output;
}

/*
 * card power have ON/OFF item.
 * if want to power on card,the rtksd_host is necessary.
 * but power off is always working, no matter rtksd_host wether exist.
 */
//static void rtkcr_card_power(struct rtksd_host *sdport,u8 status)
//{
//    /* nothing to do for eMMC */
//}

static void rtksd_read_rsp(struct rtksd_host *sdport,u32 *rsp, int reg_count)
{
    u32 iobase = sdport->base_io;

    MMCPRINTF("*rsp=0x%p; reg_count=%u\n", rsp, reg_count);

    if ( reg_count==6 ){
        rsp[0] = cr_readb(iobase+SD_CMD1) << 24 |
                 cr_readb(iobase+SD_CMD2) << 16 |
                 cr_readb(iobase+SD_CMD3) << 8 |
                 cr_readb(iobase+SD_CMD4);
        MMCPRINTF("rsp[0]=0x%08x\n",rsp[0]);

    }else if(reg_count==16){
        rsp[0] = swap_endian(rsp[0]);
        rsp[1] = swap_endian(rsp[1]);
        rsp[2] = swap_endian(rsp[2]);
        rsp[3] = swap_endian(rsp[3]);
    }
    else
        MMCPRINTF("rsp[0]=0x%08x\n",rsp[0]);
}

static void rtkcr_set_div(struct rtksd_host *sdport,u32 set_div)
{
    u32 iobase = sdport->base_io;
    u32 tmp_div;
    unsigned long flags;

    spin_lock_irqsave(&sdport->lock,flags);
    tmp_div = cr_readb(iobase+SD_CONFIGURE1) & ~MASK_CLOCK_DIV;
    if (set_div != CLOCK_DIV_NON)
    {
        cr_writeb(tmp_div|set_div|SDCLK_DIV, iobase+SD_CONFIGURE1);
    }
    else
        cr_writeb(tmp_div, iobase+SD_CONFIGURE1);
    spin_unlock_irqrestore(&sdport->lock, flags);

    MMCPRINTF(KERN_INFO "%s: set div to 0x%02x, 0x18012180=%08x\n",
              DRIVER_NAME, tmp_div|set_div, cr_readb(iobase+SD_CONFIGURE1));
}

static void rtksd_set_bits(struct rtksd_host *sdport,u8 set_bit)
{
    u32 iobase = sdport->base_io;
    u32 tmp_bits;
    unsigned long flags;

    spin_lock_irqsave(&sdport->lock,flags);
    tmp_bits = cr_readb(iobase+SD_CONFIGURE1);
    if((tmp_bits & MASK_BUS_WIDTH) != set_bit ){
        tmp_bits &= ~MASK_BUS_WIDTH;
        cr_writeb(tmp_bits|set_bit,iobase+SD_CONFIGURE1);
        spin_unlock_irqrestore(&sdport->lock, flags);
        MMCPRINTF(KERN_INFO "%s: change to %s mode, 0x18012180=%08x\n",
                DRIVER_NAME,bit_tlb[set_bit], cr_readb(iobase+SD_CONFIGURE1));
    }
    else   
        spin_unlock_irqrestore(&sdport->lock, flags);
}
#if 0
static void rtksd_set_phase(struct rtksd_host *sdport,u8 level)
{
    u32 iobase = sdport->base_io;
    u32 tmp_bits;
    unsigned long flags;

    MMCPRINTF("\n");
    spin_lock_irqsave(&sdport->lock,flags);
    tmp_bits = cr_readb(iobase+SD_CONFIGURE1) & ~DELAY_PHA_MASK;

    if(level == LVL_HI){
        tmp_bits |= DELAY_PHA_HIGH;
    }else{
        tmp_bits |= DELAY_PHA_NORM;
    }

    cr_writel(tmp_bits,iobase+SD_CONFIGURE1);
    spin_unlock_irqrestore(&sdport->lock, flags);

}
#endif
static void rtkcr_set_speed(struct rtksd_host *sdport,u8 level)
{
    u32 iobase = sdport->base_io;
    u32 tmp_para;
    unsigned long flags;

    MMCPRINTF("\n");
    spin_lock_irqsave(&sdport->lock,flags);
    cr_writeb(0x66,iobase+EMMC_CARD_PAD_DRV);
    cr_writeb(0x64,iobase+EMMC_CMD_PAD_DRV);
    cr_writeb(0x66,iobase+EMMC_DATA_PAD_DRV);
    //cr_writel(0x40,iobase+SD_SAMPLE_POINT_CTL); //3.3v , fixed 1/4
    
    switch(level)
    {
        case 0:  //ddr52 , highest speed
    	    cr_writeb( 0x8,  sdport->base_io+SD_SAMPLE_POINT_CTL );    //sample point = SDCLK / 4
            cr_writeb( 0x10, sdport->base_io+SD_PUSH_POINT_CTL );      //output ahead SDCLK /4 
            cr_writel(0x2100,iobase+EMMC_CKGEN_CTL);
            break;
        case 1:
            cr_writel(0x2100,iobase+EMMC_CKGEN_CTL);
            break;
        case 2:
        default :
            cr_writel(0x2102,iobase+EMMC_CKGEN_CTL);
            break;          
    }
    sync();
    spin_unlock_irqrestore(&sdport->lock, flags);
}

static void rtkemmc_bus_speed_down(struct rtksd_host *sdport)
{
    cr_writeb( 0x8,  sdport->base_io+SD_SAMPLE_POINT_CTL );    //sample point = SDCLK / 4
    cr_writeb( 0x10, sdport->base_io+SD_PUSH_POINT_CTL );     //output ahead SDCLK /4 
}

static u8 rtksd_get_rsp_len(u8 rsp_para)
{
    MMCPRINTF("\n");
    switch (rsp_para & 0x3) {
    case 0:
        return 0;
    case 1:
        return 6;
    case 2:
        return 16;
    default:
        return 0;
    }
}

static u32 rtksd_get_cmd_timeout(struct sd_cmd_pkt *cmd_info)
{
    struct rtksd_host *sdport   = cmd_info->sdport;
    u16 block_count             = cmd_info->block_count;
    u32 tmout = 0;

    MMCPRINTF("\n");
    if(cmd_info->cmd->data)
    {
        tmout = msecs_to_jiffies(200);
        if(block_count>0x100)
        {
            tmout = tmout + msecs_to_jiffies(block_count>>1);
        }
    }
    else
        tmout = msecs_to_jiffies(80);

#ifdef CONFIG_ANDROID
    tmout += msecs_to_jiffies(100);
#endif

    cmd_info->timeout = sdport->tmout = tmout;
    return 0;
}

#define SD_ALLOC_LENGTH     2048
static int rtksd_allocate_dma_buf(struct rtksd_host *sdport, struct mmc_command *cmd)
{
    extern unsigned char* pPSP;
    if (!pRSP)
        pRSP_org = pRSP = dma_alloc_coherent(sdport->dev, SD_ALLOC_LENGTH, &sdport->paddr ,GFP_KERNEL);
    else
        return 0;

    if(!pRSP){
        WARN_ON(1);
        cmd->error = -ENOMEM;
        return 0;
    }    

    MMCPRINTF("allocate rtk dma buf : dma addr=0x%08x, phy addr=0x%08x\n", pRSP, sdport->paddr);
    return 1;
}
static int rtksd_free_dma_buf(struct rtksd_host *sdport)
{    
    if (pRSP_org)
        dma_free_coherent(sdport->dev, SD_ALLOC_LENGTH, pRSP_org ,sdport->paddr);
    else
        return 0;

    MMCPRINTF("free rtk dma buf \n");
    return 1;
}

static int rtksd_get_next_block()
{
    if (pRSP_org)
    {
        if ((pRSP+0x200) >= (pRSP_org+SD_ALLOC_LENGTH))
            pRSP = pRSP_org;
        else
            pRSP+=0x200;
    }
}

static int rtksd_set_rspparam(struct sd_cmd_pkt *cmd_info)
{
    MMCPRINTF("rsp param reset : idx=0x%02x\n", cmd_info->cmd->opcode);
    //correct emmc setting for rt1195
    switch(cmd_info->cmd->opcode)
    {
        case MMC_GO_IDLE_STATE:
            cmd_info->rsp_para1 = SD1_R0;
            cmd_info->rsp_para2 = 0x50|SD_R0;
            cmd_info->rsp_para3 = 0;
            break;
        case MMC_SEND_OP_COND:
            cmd_info->rsp_para1 = SD1_R0;
            cmd_info->rsp_para2 = SD_R3;
            cmd_info->rsp_para3 = 0;
	    if (soc_is_rtk1195() && (realtek_rev() == RTK1195_REV_B))
	    {
            	cmd_info->cmd->arg = MMC_SECTOR_ADDR|MMC_VDD_165_195;
	    }
	    else
	    {
            	cmd_info->cmd->arg = MMC_VDD_30_31|MMC_VDD_31_32|MMC_VDD_32_33|MMC_VDD_33_34|MMC_SECTOR_ADDR; //sector mode
	    }
            break;
        case MMC_ALL_SEND_CID:
            cmd_info->rsp_para1 = SD1_R0;
            cmd_info->rsp_para2 = SD_R2;
            cmd_info->rsp_para3 = SD2_R0;
            break;
        case MMC_SET_RELATIVE_ADDR:
            cmd_info->rsp_para1 = SD1_R0;
            cmd_info->rsp_para2 = SD_R1|CRC16_CAL_DIS;
            cmd_info->rsp_para3 = 0;
            cmd_info->cmd->arg = 0x10000;
            break;
        case MMC_SEND_CSD:
        case MMC_SEND_CID:
            cmd_info->rsp_para1 = 0;
            cmd_info->rsp_para2 = SD_R2;
            cmd_info->rsp_para3 = 0x0;
            cmd_info->cmd->arg = 0x10000;
            break;
        case MMC_SEND_EXT_CSD:
            cmd_info->rsp_para1 = -1;
            cmd_info->rsp_para2 = SD_R1;
            cmd_info->rsp_para3 = -1;
            break;
        case MMC_SELECT_CARD:
            cmd_info->rsp_para1 = 0;
            cmd_info->rsp_para2 = SD_R1b|CRC16_CAL_DIS;
            cmd_info->rsp_para3 = -1;
            cmd_info->cmd->arg = 0x10000;
            break;
        case MMC_SWITCH:
            cmd_info->rsp_para1 = -1;
            cmd_info->rsp_para2 = SD_R1b|CRC16_CAL_DIS;
            cmd_info->rsp_para3 = -1;
            break;
        case MMC_SEND_STATUS:
            cmd_info->rsp_para1 = -1;
            cmd_info->rsp_para2 = SD_R1|CRC16_CAL_DIS;
            cmd_info->rsp_para3 = 0;
            cmd_info->cmd->arg = 0x10000;
            break;
        case MMC_STOP_TRANSMISSION:
            cmd_info->rsp_para1 = -1;
            cmd_info->rsp_para2 = SD_R1|CRC16_CAL_DIS;
            cmd_info->rsp_para3 = -1;
            break;
        case MMC_READ_MULTIPLE_BLOCK:
            cmd_info->rsp_para1 = -1;
            cmd_info->rsp_para3 = 0x04;
            break;
        case MMC_WRITE_MULTIPLE_BLOCK:
            cmd_info->rsp_para1 = -1;
            cmd_info->rsp_para3 = 0x03;
            break;
        default:
            cmd_info->rsp_para1 = -1;     //don't update
            cmd_info->rsp_para3 = -1;     //don't update
            break;            
    }    
}

static int SD_SendCMDGetRSP_Cmd(struct sd_cmd_pkt *cmd_info)
{
    volatile u8 cmd_idx              = cmd_info->cmd->opcode;
    volatile u32 sd_arg;
    volatile s8 rsp_para1=0;
    volatile s8 rsp_para2=0;
    volatile s8 rsp_para3=0;
    u8 rsp_len              = cmd_info->rsp_len;
    u32 *rsp                = (u32 *)&cmd_info->cmd->resp;
    struct rtksd_host *sdport = cmd_info->sdport;
    u32 iobase = sdport->base_io;
    int err;
    unsigned long flags;
    u32 dma_val=0;
    u32 byte_count = 0x200, block_count = 1, cpu_mode=0, sa=0;
    u8 tmp9_buf[1024]={0};
    u32 buf_ptr=NULL;

    rtksd_set_rspparam(cmd_info);   //for 119x
    sd_arg              = cmd_info->cmd->arg;
    rsp_para1           = cmd_info->rsp_para1;
    rsp_para2           = cmd_info->rsp_para2;
    rsp_para3           = cmd_info->rsp_para3;

    //printk("cmd %s: cmd_idx=%u, rsp_addr=0x%08x\nsd_arg=0x%08x; rsp_para1=0x%x rsp_para2=0x%x rsp_para3=0x%x rsp_len=0x%x\n",
    //            DRIVER_NAME,cmd_idx,rsp,sd_arg,rsp_para1,rsp_para2,rsp_para3,rsp_len);
    if(sdport->rtflags & RTKCR_FOPEN_LOG){
        printk("cmd %s: cmd_idx=%u, rsp_addr=0x%08x\nsd_arg=0x%08x; rsp_para1=0x%x rsp_para2=0x%x rsp_para3=0x%x rsp_len=0x%x\n",
                DRIVER_NAME,cmd_idx,rsp,sd_arg,rsp_para1,rsp_para2,rsp_para3,rsp_len);
    }

    if(rsp == NULL) {
        BUG_ON(1);
    }
    if ((g_crinit == 0)&&(cmd_idx > MMC_SET_RELATIVE_ADDR))
    {
        printk("%s : ignore cmd:0x%02x since we're still in emmc init stage\n",DRIVER_NAME,cmd_idx);
        return CR_TRANSFER_FAIL;
    }

    if (rsp_para1 != -1)
        cr_writeb(rsp_para1, iobase+SD_CONFIGURE1);
    cr_writeb(rsp_para2,     iobase+SD_CONFIGURE2);
    if (rsp_para3 != -1)
        cr_writeb(rsp_para3, iobase+SD_CONFIGURE3);
    g_cmd[0] = (0x40|cmd_idx);
    g_cmd[1] = (sd_arg>>24)&0xff;
    g_cmd[2] = (sd_arg>>16)&0xff;
    g_cmd[3] = (sd_arg>>8)&0xff;
    g_cmd[4] = sd_arg&0xff;
    g_cmd[5] = 0x00;
   
    cr_writeb((0x40|cmd_idx),iobase+SD_CMD0);
    cr_writeb((sd_arg>>24)&0xff,iobase+SD_CMD1);
    cr_writeb((sd_arg>>16)&0xff,iobase+SD_CMD2);
    cr_writeb((sd_arg>>8)&0xff,iobase+SD_CMD3);
    cr_writeb(sd_arg&0xff,    iobase+SD_CMD4);
    //cr_writeb(g_cmd[5],    iobase+SD_CMD4);
    sdport->cmd_opcode = cmd_idx;
    sync();
    if (bSendCmd0)
    	printk("0 cmd0:0x%02x,cmd1:0x%02x,cmd2:0x%02x,cmd3:0x%02x,cmd4:0x%02x,cmd5:0x%02x\n", cr_readb(iobase+SD_CMD0),cr_readb(iobase+SD_CMD1),cr_readb(iobase+SD_CMD2),cr_readb(iobase+SD_CMD3),cr_readb(iobase+SD_CMD4),cr_readb(iobase+SD_CMD5));
    MMCPRINTF("0 cmd0:0x%02x,cmd1:0x%02x,cmd2:0x%02x,cmd3:0x%02x,cmd4:0x%02x,cmd5:0x%02x\n", cr_readb(iobase+SD_CMD0),cr_readb(iobase+SD_CMD1),cr_readb(iobase+SD_CMD2),cr_readb(iobase+SD_CMD3),cr_readb(iobase+SD_CMD4),cr_readb(iobase+SD_CMD5));

    rtksd_get_cmd_timeout(cmd_info);
    if (RESP_TYPE_17B & rsp_para2)
    {
        //remap the resp dst buffer to un-cache
        #if 1
        MMCPRINTF("cmdx cmd buf addr : 0x%08x\n", g_cmd);
        MMCPRINTF("cmdx tmp buf addr : 0x%08x\n", pRSP);
        buf_ptr = ((u32)pRSP&~0xff);
        MMCPRINTF(",chg buf addr : 0x%08x\n", buf_ptr);
        sa = buf_ptr/8;
        MMCPRINTF(",final buf addr : 0x%08x\n", sa);
        #else
        sa = (u32)rsp/8;
        #endif
        
        dma_val = RSP17_SEL|DDR_WR|DMA_XFER;
        MMCPRINTF("-----rsp 17B-----\n DMA_sa=0x%08x DMA_len=0x%08x DMA_setting=0x%08x\n", sa,1,dma_val);
        cr_writeb(byte_count,       iobase+SD_BYTE_CNT_L);     //0x24
        cr_writeb(byte_count>>8,    iobase+SD_BYTE_CNT_H);     //0x28
        cr_writeb(block_count,      iobase+SD_BLOCK_CNT_L);    //0x2C
        cr_writeb(block_count>>8,   iobase+SD_BLOCK_CNT_H);    //0x30
        if (cpu_mode && (iobase==EM_BASE_ADDR))
            cr_writel( CPU_MODE_EN, iobase+EMMC_CPU_ACC); //enable cpu mode
        else
            cr_writel( 0, iobase+EMMC_CPU_ACC);
        cr_writel(sa, iobase+CR_DMA_CTL1);   //espeical for R2
        cr_writel(1, iobase+CR_DMA_CTL2);   //espeical for R2
        cr_writel(dma_val, iobase+CR_DMA_CTL3);   //espeical for R2
        rtksd_get_next_block();
    }
    else if (RESP_TYPE_6B & rsp_para2)
    {
        MMCPRINTF("-----rsp 6B-----\n");
        cr_writel( 0x00, iobase+EMMC_CPU_ACC);
    }

    MMCPRINTF("1 cmd0:0x%02x,cmd1:0x%02x,cmd2:0x%02x,cmd3:0x%02x,cmd4:0x%02x,cmd5:0x%02x\n", g_cmd[0],g_cmd[1],g_cmd[2],g_cmd[3],g_cmd[4],g_cmd[5]);

    err = rtkcr_wait_opt_end(DRIVER_NAME,sdport,SD_SENDCMDGETRSP,0);

    if(err == CR_TRANS_OK){
	sync();
      	//handle DDR50 case
    	if ((cmd_idx == MMC_SWITCH)&&(((sd_arg>>0x8)&0xff)==EXT_CSD_CMD_SET_NORMAL)&&(((sd_arg>>16)&0xff)==EXT_CSD_HS_TIMING))
    	{
		printk("%s : we got DDR50 send from mmc stack\n",DRIVER_NAME);	
    	    	cr_writeb( 0x8,  iobase+SD_SAMPLE_POINT_CTL );    //sample point = SDCLK / 4
            	cr_writeb( 0x10, iobase+SD_PUSH_POINT_CTL );      //output ahead SDCLK /4 
            	cr_writel(0x2100,iobase+EMMC_CKGEN_CTL);
    	}

        if(buf_ptr != NULL)
        {
            //ignore start pattern
            buf_ptr++;
            rtksd_read_rsp(sdport,(u32*)buf_ptr, rsp_len);
            if (cmd_idx == MMC_SEND_EXT_CSD)
                memcpy(rsp, (u32*)buf_ptr, 512);
            else
                memcpy(rsp, (u32*)buf_ptr, 16);
        }
        else
            rtksd_read_rsp(sdport,rsp, rsp_len);
        sync();
        if (cmd_idx == MMC_SET_RELATIVE_ADDR)
        {
            g_crinit = 1;
            MMCPRINTF("emmc init done ...\n");
        }
    }
    else{
        printk(KERN_WARNING "%s: %s cmd trans fail, err=%d \n",DRIVER_NAME,__func__, err);
    }
    return err;
}

static int SD_SendCMDGetRSP(struct sd_cmd_pkt * cmd_info)
{
    int rc;
    MMCPRINTF("\n");


    rc = SD_SendCMDGetRSP_Cmd(cmd_info);

    return rc;
}

static void duplicate_pkt(struct sd_cmd_pkt* sour,struct sd_cmd_pkt* dist)
{
    dist->sdport      = sour->sdport;
    dist->cmd         = sour->cmd;
    dist->data        = sour->data;

    dist->dma_buffer  = sour->dma_buffer;
    dist->byte_count  = sour->byte_count;
    dist->block_count = sour->block_count;

    dist->flags       = sour->flags;
    dist->rsp_para1    = sour->rsp_para1;
    dist->rsp_para2    = sour->rsp_para2;
    dist->rsp_para3    = sour->rsp_para3;
    dist->rsp_len     = sour->rsp_len;
    dist->timeout     = sour->timeout;
}

static int rtksd_err_handle(u16 cmdcode,struct sd_cmd_pkt *cmd_info)
{
    struct mmc_host *host       = cmd_info->sdport->mmc;
    //struct rtksd_host *sdport   = cmd_info->sdport;
    //u8 cmd_idx                  = cmd_info->cmd->opcode;
    //u32 iobase                  = sdport->base_io;
    u16 state = 0;
    int err = 0;

    if(host->card){
        if(cmdcode == SD_AUTOWRITE2){
            if( cmd_info->cmd->opcode == 18 ||
                cmd_info->cmd->opcode == 25 )
            {
                int stop_loop = 5;
                while(stop_loop--){

                    err = rtksd_stop_transmission(host->card);
                    if(err){
                        mdelay(1);
                        rtksd_send_status(host->card,&state,0);
                        if(state == STATE_TRAN)
                            break;
                    }else{
                        break;
                    }
                }
            }
        }
        err = rtksd_wait_status(host->card,STATE_TRAN,0);
    }
	return err;
}

static int SD_Stream_Cmd34(u16 cmdcode,struct sd_cmd_pkt *cmd_info)
{
    u16 byte_count              = cmd_info->byte_count;
    u16 block_count             = cmd_info->block_count;
    void *data                  = cmd_info->dma_buffer;
    struct rtksd_host *sdport   = cmd_info->sdport;
    u32 iobase                  = sdport->base_io;
    int err;
    unsigned long flags;
    u32 cpu_mode=0;
    u32 sa=0;

    if(data == NULL)
        BUG_ON(1);

    if( cmdcode != SD_AUTOREAD3  && cmdcode != SD_AUTOREAD4 &&
        cmdcode != SD_AUTOWRITE3 && cmdcode != SD_AUTOWRITE4 ){
        BUG_ON(1);
    }

    sa = (u32)data/8;

    if(cmd_info->cmd->data->flags & MMC_DATA_READ){
        MMCPRINTF("-----mmc data ddr read-----\n");
        cr_writel( 0x00, iobase+EMMC_CPU_ACC);
        cr_writel( (u32)sa, iobase+CR_DMA_CTL1);
        cr_writel( block_count, iobase+CR_DMA_CTL2);
        cr_writel( DDR_WR|DMA_XFER, iobase+CR_DMA_CTL3);
    }else if(cmd_info->cmd->data->flags & MMC_DATA_WRITE){
        MMCPRINTF("-----mmc data write-----\n");
        MMCPRINTF("DMA sa = 0x%x\nDMA len = 0x%x\nDMA set = 0x%x\n", (u32)sa, block_count, DMA_XFER);
 
        cr_writel( 0, iobase+EMMC_CPU_ACC);
        cr_writel( (u32)sa, iobase+CR_DMA_CTL1);
        cr_writel( block_count, iobase+CR_DMA_CTL2);
        cr_writel( DMA_XFER, iobase+CR_DMA_CTL3);
    }
    else //sram read
    {
        MMCPRINTF("-----mmc data sram read (cpu mode)-----\n");
        MMCPRINTF("CR_CPU_ACC(0x18012080) = 0x%x\n", CPU_MODE_EN);

        cpu_mode = 1;
        cr_writel( 0, iobase+EMMC_CPU_ACC);
        cr_writel( CPU_MODE_EN, iobase+EMMC_CPU_ACC);
        cr_writel( (u32)sa, iobase+CR_DMA_CTL1);
        cr_writel( block_count, iobase+CR_DMA_CTL2);
        cr_writel( DDR_WR|DMA_XFER, iobase+CR_DMA_CTL3);
    }
    cr_writeb(byte_count,       iobase+SD_BYTE_CNT_L);     //0x24
    cr_writeb(byte_count>>8,    iobase+SD_BYTE_CNT_H);     //0x28
    cr_writeb(block_count,      iobase+SD_BLOCK_CNT_L);    //0x2C
    cr_writeb(block_count>>8,   iobase+SD_BLOCK_CNT_H);    //0x30

    sdport->cmd_opcode = 0xf1;
    rtksd_get_cmd_timeout(cmd_info);
    err = rtkcr_wait_opt_end(DRIVER_NAME,sdport,cmdcode,cpu_mode);
    if(err)
        mmcmsg3(KERN_WARNING "%s: %s fail\n",DRIVER_NAME,__func__);

    return err;
}

static int SD_Stream_Cmd(u16 cmdcode,struct sd_cmd_pkt *cmd_info)
{
    u8 cmd_idx              = cmd_info->cmd->opcode;
    u32 sd_arg              = cmd_info->cmd->arg;
    s8 rsp_para1             = cmd_info->rsp_para1;
    s8 rsp_para2             = cmd_info->rsp_para2;
    s8 rsp_para3             = cmd_info->rsp_para3;
    int rsp_len             = cmd_info->rsp_len;
    u32 *rsp                = (u32 *)&cmd_info->cmd->resp;
    u16 byte_count          = cmd_info->byte_count;
    u16 block_count         = cmd_info->block_count;
    struct rtksd_host *sdport = cmd_info->sdport;
    u32 iobase = sdport->base_io;
    int err;
    u8 *data              = cmd_info->dma_buffer;
    unsigned long flags;
    u32 cpu_mode=0;
    u32 sa=0;

    if(sdport->rtflags & RTKCR_FOPEN_LOG){
        printk("%s: cmd_idx=%u, rsp_addr=0x%08x\nsd_arg=0x%08x; rsp_para1=0x%x rsp_para2=0x%x rsp_para3=0x%x rsp_len=0x%x\n",
                DRIVER_NAME,cmd_idx,rsp,sd_arg,rsp_para1,rsp_para2,rsp_para3,rsp_len);
    }

    if((u32)data == NULL) {
        BUG_ON(1);
    }
    if(rsp == NULL) {
        BUG_ON(1);
    }

#ifdef TEST_POWER_RESCYCLE
    cmd_info->sdport->test_count++;
    mmcspec("test_count=%d\n",cmd_info->sdport->test_count);
#endif

    rtksd_set_rspparam(cmd_info);   //for 119x
    sd_arg              = cmd_info->cmd->arg;
    if (rsp_para1 != -1)
        rsp_para1           = cmd_info->rsp_para1;
    rsp_para2           = cmd_info->rsp_para2;
    if (rsp_para3 != -1)
        rsp_para3           = cmd_info->rsp_para3;
    sa = (u32)data/8;

    if((cmdcode==SD_NORMALWRITE) || (cmdcode==SD_NORMALREAD))
    {
        //rsp_para2|=CRC16_CAL_DIS;
        byte_count = 512;
    }

    g_cmd[0] = (0x40|cmd_idx);
    g_cmd[1] = (sd_arg>>24)&0xff;
    g_cmd[2] = (sd_arg>>16)&0xff;
    g_cmd[3] = (sd_arg>>8)&0xff;
    g_cmd[4] = sd_arg&0xff;
    g_cmd[5] = 0x00;

    cr_writeb(g_cmd[0],    iobase+SD_CMD0);           //0x10
    cr_writeb(g_cmd[1],    iobase+SD_CMD1);           //0x14
    cr_writeb(g_cmd[2],    iobase+SD_CMD2);           //0x18
    cr_writeb(g_cmd[3],    iobase+SD_CMD3);           //0x1C
    cr_writeb(g_cmd[4],    iobase+SD_CMD4);           //0x20
    cr_writeb(g_cmd[5],    iobase+SD_CMD5);           //0x20
    
    if (rsp_para1 != -1)
    {
        MMCPRINTF("reset configure1 : 0x%02x\n", rsp_para1);
        cr_writeb(rsp_para1,         iobase+SD_CONFIGURE1);     //0x0C
        MMCPRINTF("read configure1 : 0x%02x\n", cr_readb(iobase+SD_CONFIGURE1));
    }
    cr_writeb(rsp_para2,         iobase+SD_CONFIGURE2);     //0x0C
    if (rsp_para3 != -1)
    {
        MMCPRINTF("reset configure3 : 0x%02x\n", rsp_para3);
        cr_writeb(rsp_para3,         iobase+SD_CONFIGURE3);     //0x0C
        MMCPRINTF("read configure3 : 0x%02x\n", cr_readb(iobase+SD_CONFIGURE3));
    }
    cr_writeb(byte_count,       iobase+SD_BYTE_CNT_L);     //0x24
    cr_writeb(byte_count>>8,    iobase+SD_BYTE_CNT_H);     //0x28
    cr_writeb(block_count,      iobase+SD_BLOCK_CNT_L);    //0x2C
    cr_writeb(block_count>>8,   iobase+SD_BLOCK_CNT_H);    //0x30

    if(cmd_info->cmd->data->flags & MMC_DATA_READ){
        MMCPRINTF("-----mmc data ddr read-----\n");
        cr_writel( 0x00, iobase+EMMC_CPU_ACC);
        cr_writel( (u32)sa, iobase+CR_DMA_CTL1);
        cr_writel( block_count, iobase+CR_DMA_CTL2);
        cr_writel( DDR_WR|DMA_XFER, iobase+CR_DMA_CTL3);
    }else if(cmd_info->cmd->data->flags & MMC_DATA_WRITE){
        MMCPRINTF("-----mmc data write-----\n");
        MMCPRINTF("DMA sa = 0x%x\nDMA len = 0x%x\nDMA set = 0x%x\n", (u32)sa, block_count, DMA_XFER);
 
        cr_writel( 0, iobase+EMMC_CPU_ACC);
        cr_writel( (u32)sa, iobase+CR_DMA_CTL1);
        cr_writel( block_count, iobase+CR_DMA_CTL2);
        cr_writel( DMA_XFER, iobase+CR_DMA_CTL3);
    }
    else //sram read
    {
        MMCPRINTF("-----mmc data sram read (cpu mode)-----\n");
        MMCPRINTF("CR_CPU_ACC(0x18012080) = 0x%x\n", CPU_MODE_EN);

        cpu_mode = 1;
        cr_writel( 0, iobase+EMMC_CPU_ACC);
        cr_writel( CPU_MODE_EN, iobase+EMMC_CPU_ACC);
        cr_writel( (u32)sa, iobase+CR_DMA_CTL1);
        cr_writel( block_count, iobase+CR_DMA_CTL2);
        cr_writel( DDR_WR|DMA_XFER, iobase+CR_DMA_CTL3);
    }

    sdport->cmd_opcode = cmd_idx;

    rtksd_get_cmd_timeout(cmd_info);
    
    err = rtkcr_wait_opt_end(DRIVER_NAME,sdport,cmdcode,cpu_mode);

    if(err == RTK_SUCC){
        if((cmdcode == SD_AUTOREAD1) || (cmdcode == SD_AUTOWRITE1))
        {
            MMCPRINTF("AUTO READ/WRITE 1 skip response~\n");
        }
        else
        {
            //TBD 
            #if 0
            if( cmd_info->xfer_flag == RTK_MMC_SRAM_READ ) {
                if ((ret_err = mmccr_read_sram_dma_data(phy_buf_addr, block_count)) == ERR_EMMC_SRAM_DMA_TIME)
                    return ret_err;
                udelay(1000);
            }
            else
            #endif
                rtksd_read_rsp(sdport,rsp, rsp_len);
            MMCPRINTF("---stream cmd done---\n");
        }
    }

    if(err){
        mmcmsg3(KERN_WARNING "%s: %s fail\n",DRIVER_NAME,__func__);
    }
    return err;
}

static u32 rtkcr_chk_cmdcode(struct mmc_command* cmd){
    u32 cmdcode;

    if(cmd->opcode < 56){
        cmdcode = (u32)rtk_sd_cmdcode[cmd->opcode][0];
        WARN_ON(cmd->data == NULL);
        if(cmd->data->flags & MMC_DATA_WRITE){
            if(cmd->opcode == 42)
                cmdcode = SD_NORMALWRITE;
            else if(cmd->opcode == 56)
                cmdcode = SD_AUTOWRITE2;
        }
    }else{
        cmdcode = SD_CMD_UNKNOW;
    }

    return cmdcode;

}

static u32 rtkcr_chk_r1_type(struct mmc_command* cmd){
    return 0;
}

static u8 rtk_get_rsp_type(struct mmc_command* cmd){
    u32 rsp_type;
    if ( mmc_resp_type(cmd)==MMC_RSP_R1 ){
        rsp_type = SD_R1;
    }else if ( mmc_resp_type(cmd)== MMC_RSP_R1B ){
        rsp_type = SD_R1b;
    }else if ( mmc_resp_type(cmd)== MMC_RSP_R2 ){
        rsp_type = SD_R2;
    }else if ( mmc_resp_type(cmd)== MMC_RSP_R3 ){
        rsp_type = SD_R3;
    }else if ( mmc_resp_type(cmd)== MMC_RSP_R6 ){
        rsp_type = SD_R6;
    }else if ( mmc_resp_type(cmd)== MMC_RSP_R7 ){
        rsp_type = SD_R7;
    }else{
        rsp_type = SD_R0;
    }
    return rsp_type;
}

//#define USE_TMP_BUF
static int SD_Stream(struct sd_cmd_pkt *cmd_info)
{
    int err=0;
    u32 i;
    struct scatterlist *sg;
    u32 dir = 0;
    u32 dma_nents = 0;
    u32 dma_leng;
    u32 dma_addr;
    u32 dma_addr_sys = 0;
    u32 old_arg;
    u8 one_blk=0;
    u8 f_in_dma = 0;
    u16 cmdcode = 0;
    unsigned long flags;
    //enum dma_data_direction	direction;
    //dma_addr_t		dma_addr = 0;

    struct mmc_host *host = cmd_info->sdport->mmc;
    struct rtksd_host *sdport = cmd_info->sdport;

    rtksd_set_rspparam(cmd_info);   //for 119x

    MMCPRINTF("\n");
    if(cmd_info->data->flags & MMC_DATA_READ){
        dir = DMA_FROM_DEVICE;
    }else{
        // KWarning: checked ok by alexkh@realtek.com
        if(host->card && mmc_card_cmd24_err(host->card))
        {
            one_blk = 1;
        }

        dir = DMA_TO_DEVICE;
    }

    cmd_info->data->bytes_xfered=0;
    dma_nents = dma_map_sg( mmc_dev(host), cmd_info->data->sg,
                            cmd_info->data->sg_len,  dir);
    sg = cmd_info->data->sg;

#ifdef SHOW_MMC_PRD
    printk("sg_len:%u\n",cmd_info->data->sg_len);
    printk("sg:0x%p; dma_nents:%u\n",sg,dma_nents);
#endif
    old_arg=cmd_info->cmd->arg;

    for(i=0; i<dma_nents; i++,sg++){
        dma_leng = sg_dma_len(sg);

        if(dma_leng & 0x1ff){
            dma_addr_sys = sg_dma_address(sg);

            if(sdport->tmp_buf){    //use tmp buffer
                printk("coherent buffer active!!\n");
                printk("dma_addr:0x%x; dma_leng:0x%x\n",dma_addr_sys,dma_leng);
                f_in_dma = 1;
                dma_addr = sdport->tmp_buf_phy_addr;
#ifndef USE_TMP_BUF
                WARN_ON(1);
#endif
            }else{                  //use default buffer
                dma_addr = dma_addr_sys;
            }
        }else{
            dma_addr = sg_dma_address(sg);
        }

        //dma_addr = dma_map_page(host->parent, sg_page(sg), 0,
		//				PAGE_SIZE, dir);
#ifdef SHOW_MMC_PRD
        printk("dma_addr:0x%x; dma_leng:0x%x\n",dma_addr,dma_leng);
        mmcinfo("host=%p\n",host);
        if(host->card){
            mmcinfo("card=%p\n",host->card);
            if(mmc_card_blockaddr(host->card))
                printk("arg:0x%x blk\n",cmd_info->cmd->arg);
            else
                printk("arg:0x%x byte\n",cmd_info->cmd->arg);
        }
#endif

        if(one_blk){    /* occur at write case only */
            u8 i;
            u32 blk_cnt;
            struct sd_cmd_pkt tmp_pkt;

            blk_cnt = dma_leng/BYTE_CNT;
            if(blk_cnt == 0){
                WARN_ON(1);
                blk_cnt = 1;
            }
            duplicate_pkt(cmd_info,&tmp_pkt);

            tmp_pkt.byte_count  = BYTE_CNT;
            tmp_pkt.block_count = 1;
            tmp_pkt.dma_buffer  = (unsigned char *)dma_addr;

            if(tmp_pkt.cmd->opcode == 25){
                tmp_pkt.cmd->opcode = 24;
            }

            if(tmp_pkt.cmd->opcode == 18){
                tmp_pkt.cmd->opcode = 17;
            }

            cmdcode = sdport->ops->chk_cmdcode(tmp_pkt.cmd);
            for(i=0;i<blk_cnt;i++){

                err = SD_Stream_Cmd(cmdcode,&tmp_pkt);

                if(err == 0){
                    if(host->card){
                        if(tmp_pkt.cmd->opcode == 24)
                            host->card->state &= ~MMC_STATE_CMD24_ERR;
                    }

                    if(host->card && mmc_card_blockaddr(host->card))
                        tmp_pkt.cmd->arg += 1;
                    else
                        tmp_pkt.cmd->arg += BYTE_CNT;

                    tmp_pkt.dma_buffer += BYTE_CNT;
                    tmp_pkt.data->bytes_xfered += BYTE_CNT;

                }else{
                    if(rtksd_err_handle(cmdcode,&tmp_pkt)){

                        if(tmp_pkt.cmd->opcode == 24){
                            int err34 = 0;

                            err34 = SD_Stream_Cmd34(SD_AUTOWRITE3,&tmp_pkt);
                            if(err34 ){
                                if(rtksd_err_handle(SD_AUTOWRITE3,&tmp_pkt)){
                                    mmcmsg3(KERN_INFO "%s: error recover fail 1\n",
                                        DRIVER_NAME);
                                }
                            }else{
                                rtksd_wait_status(host->card,STATE_TRAN,0);
                            }

                        }else{
                            mmcmsg3(KERN_INFO "%s: error recover fail 2\n",
                                DRIVER_NAME);
                        }
                    }
                    break;
                }
            }
//liaokh            dma_cache_wback(KSEG0ADDR(dma_addr), dma_leng);
                //dma_unmap_page(host->parent, dma_addr, PAGE_SIZE, dir);
        }
        else
        {
            u32 blk_cnt;
            cmd_info->byte_count = BYTE_CNT;     //rtk HW limite, one trigger 512 byte pass.
            blk_cnt = dma_leng/BYTE_CNT;

            if(blk_cnt == 0 && dma_leng){
                blk_cnt = 1;
            }

            cmd_info->block_count = blk_cnt;
            cmd_info->dma_buffer = (unsigned char *)dma_addr;

            //if(cmd_info->data->flags & MMC_DATA_READ){
//liaokh                dma_cache_inv(KSEG0ADDR(dma_addr), dma_leng);
            //}
            //else
            //{
                //rtksd_wait_status(host->card,STATE_TRAN,0);
            //}

            cmdcode = sdport->ops->chk_cmdcode(cmd_info->cmd);
            err = SD_Stream_Cmd(cmdcode,cmd_info);


            //if(cmd_info->data->flags & MMC_DATA_WRITE){
//liaokh                dma_cache_wback(KSEG0ADDR(dma_addr), dma_leng);
            //}
            //dma_unmap_page(host->parent, dma_addr, PAGE_SIZE, dir);

            if(err == 0){
                if(host->card){
                    if( (cmd_info->cmd->opcode == 25) &&
                        (cmdcode == SD_AUTOWRITE2) )
                    {
                        int stop_err;

                        stop_err = rtksd_stop_transmission(host->card);
                        if(stop_err){
                            MMCPRINTF("rtksd_stop_transmission fail\n");
                            goto ERR_HANDLE;
                        }
                    }
                }

                if(host->card && mmc_card_blockaddr(host->card))
                    cmd_info->cmd->arg += cmd_info->block_count;
                else
                    cmd_info->cmd->arg += dma_leng;

                cmd_info->data->bytes_xfered += dma_leng;

            }else{
ERR_HANDLE:
                if(rtksd_err_handle(cmdcode,cmd_info)){
                    if(cmd_info->cmd->opcode == 18
                    || cmd_info->cmd->opcode == 25)
                    {
                        if(host->card){
                            int stop_err;
                            stop_err = rtksd_stop_transmission(host->card);
                            if(stop_err){
                                MMCPRINTF("rtksd_stop_transmission fail\n");
                                //goto ERR_HANDLE;
                            }
                            rtksd_wait_status(host->card,STATE_TRAN,0);
                        }

                    }else if(cmd_info->cmd->opcode == 24){
                        int err34 = 0;
                        err34 = SD_Stream_Cmd34(SD_AUTOWRITE3,cmd_info);
                        if(err34 ){
                            if(rtksd_err_handle(SD_AUTOWRITE3,cmd_info)){
                                mmcmsg3(KERN_INFO "%s: error recover fail 3\n",
                                            DRIVER_NAME);
                            }
                        }else{
                            if(host->card)
                                rtksd_wait_status(host->card,STATE_TRAN,0);
                        }

                    }else{
                        mmcmsg3(KERN_INFO "%s: error recover fail 4\n",
                                            DRIVER_NAME);
                    }
                }
            }
        }

        if(err){
            cmd_info->cmd->arg = old_arg;
            break;
        }

        if(f_in_dma){
            u32 i;
            u8 * ptr1 = phys_to_virt(dma_addr_sys);
            u8 * ptr2 = phys_to_virt(dma_addr);
            f_in_dma = 0;
            for(i=0; i<dma_leng;i++)
                *ptr1 = *ptr2;
        }
    }
    dma_unmap_sg( mmc_dev(host), cmd_info->data->sg,
                            cmd_info->data->sg_len,  dir);

    //reset cmd0
    g_cmd[0] = 0x00;

    return err;

}

static void rtkcr_req_end_tasklet(unsigned long param)
{
    struct rtksd_host *sdport;
    struct mmc_request* mrq;
    unsigned long flags;

    sdport = (struct rtksd_host *)param;
    spin_lock_irqsave(&sdport->lock,flags);

    mrq = sdport->mrq;
    sdport->mrq = NULL;

    spin_unlock_irqrestore(&sdport->lock, flags);
    mmc_request_done(sdport->mmc, mrq);
}

static void rtksd_send_command(struct rtksd_host *sdport, struct mmc_command *cmd)
{
    int rc = 0;
    struct sd_cmd_pkt cmd_info;
    unsigned long flags;
    memset(&cmd_info, 0, sizeof(struct sd_cmd_pkt));

    if ( !sdport || !cmd ){
        printk(KERN_ERR "%s: sdport or cmd is null\n",DRIVER_NAME);
        return ;
    }
   
    cmd_info.cmd    = cmd;
    cmd_info.sdport = sdport;
    cmd_info.rsp_para2 = rtk_get_rsp_type(cmd_info.cmd);
    cmd_info.rsp_len  = rtksd_get_rsp_len(cmd_info.rsp_para2);

    if (cmd->data){
        cmd_info.data = cmd->data;
        if(cmd->data->flags == MMC_DATA_READ){
            /* do nothing */
        }else if(cmd->data->flags == MMC_DATA_WRITE){
            if(sdport->wp ==1){
                printk(KERN_WARNING "%s: card is locked!",
                            DRIVER_NAME);
                rc = -1;
                cmd->retries = 0;
                goto err_out;
            }
        }else{
	    if (bSendCmd0)
	    {
		cmd_info.data = NULL;
		rc = SD_SendCMDGetRSP(&cmd_info);
               	printk("send cmd0 rc=%d\n",rc);
	    	cmd->error = -MMC_ERR_INVALID; //TODO: force stop
            	cmd->retries = 0;
		goto err_out;
	    }
            printk(KERN_ERR "error: cmd->data->flags=%d\n",
                    cmd->data->flags);
	    cmd->error = -MMC_ERR_INVALID;
            cmd->retries = 0;
            goto err_out;
        }
        rc = SD_Stream(&cmd_info);

    }
    else{
        rc = SD_SendCMDGetRSP(&cmd_info);
    }

    if(cmd->opcode == MMC_SELECT_CARD)
    {
        rtkcr_set_div(sdport,CLOCK_DIV_NON);
    }

    if(cmd->opcode == MMC_SWITCH){
         if((cmd->arg & 0xffff00ff) == 0x03b30001) {
            if((cmd->arg & 0x0000ff00)==0){
                sdport->rtflags |= RTKCR_USER_PARTITION;
            }else{
                sdport->rtflags &= ~RTKCR_USER_PARTITION;
            }
         }
    }

err_out:
    if (rc){
        if(rc == -RTK_RMOV)
            cmd->retries = 0;

        cmd->error = -MMC_ERR_FAILED;
    }
    tasklet_schedule(&sdport->req_end_tasklet);
}

static void rtksd_request(struct mmc_host *host, struct mmc_request *mrq)
{
    struct rtksd_host *sdport;
    struct mmc_command *cmd;
    //struct mmc_card  *card;
    unsigned long flags;
#ifdef USE_TMP_BUF
    unsigned char *tmp_buf=NULL;
#endif

    MMCPRINTF("\n");

    sdport = mmc_priv(host);
    BUG_ON(sdport->mrq != NULL);

    //spin_lock_irqsave(&sdport->lock,flags);
    down_write(&cr_rw_sem);
    cmd = mrq->cmd;
    sdport->mrq = mrq;

    if (!(sdport->rtflags & RTKCR_FCARD_DETECTED)){
        cmd->error = -MMC_ERR_RMOVE;
        cmd->retries = 0;
        goto done;
    }

/*
 * the "tmp_buf" should used for sg_init_one() in blksz small than 512 byte case.
 * because RTK DMA HW issue,the samllest DMA size is 512 byte
 */
#ifdef USE_TMP_BUF
    if (cmd->data) {

        if(cmd->data->blksz < 512){
            WARN_ON(1);
            printk("blksz=%d\n",cmd->data->blksz);

            tmp_buf = dma_alloc_coherent(sdport->dev, 512,
                    &sdport->tmp_buf_phy_addr, GFP_KERNEL);

            if(!tmp_buf){
                WARN_ON(1);
                cmd->error = -ENOMEM;
                goto done;
            }
            memset(tmp_buf,0,512);
            sdport->tmp_buf = tmp_buf;
            //printk("%s(%u)buf=0x%p phy_addr=0x%x\n",
            //        __func__,__LINE__,
            //        sdport->tmp_buf,sdport->tmp_buf_phy_addr);
        }else{
            sdport->tmp_buf = NULL;
        }
    }
#endif  //#ifdef USE_TMP_BUF

    if ( sdport && cmd ){
        rtksd_allocate_dma_buf(sdport, cmd);
        rtksd_send_command(sdport, cmd);
    }else{
done:
        tasklet_schedule(&sdport->req_end_tasklet);
    }
        up_write(&cr_rw_sem);
        //spin_unlock_irqrestore(&sdport->lock, flags);
}

static void rtksd_set_ios(struct mmc_host *host, struct mmc_ios *ios)
{
    struct rtksd_host *sdport;
    u32 tmp_clock, busmode=0;
    unsigned long flags;
    sdport = mmc_priv(host);
    
    down_write(&cr_rw_sem);

    MMCPRINTF("ios->bus_mode = %u\n",ios->bus_mode);
    MMCPRINTF("ios->clock = %u\n",ios->clock);
    MMCPRINTF("ios->bus_width = %u\n",ios->bus_width);
    MMCPRINTF("ios->timing = %u\n",ios->timing);

    if (ios->bus_mode == MMC_BUSMODE_PUSHPULL){
        MMCPRINTF("ios busmode = pushpull\n");

        if (ios->bus_width == MMC_BUS_WIDTH_8){
            MMCPRINTF("set bus width 8\n");
            rtksd_set_bits(sdport,BUS_WIDTH_8);
            busmode = BUS_WIDTH_8;
        }else if (ios->bus_width == MMC_BUS_WIDTH_4){
            rtksd_set_bits(sdport,BUS_WIDTH_4);
            MMCPRINTF("set bus width 4\n");
            busmode = BUS_WIDTH_4;
        }else{
            rtksd_set_bits(sdport,BUS_WIDTH_1);
            MMCPRINTF("set bus width 1\n");
            busmode = BUS_WIDTH_1;
        }

        if(ios->clock > 400000)
        {
            rtkcr_set_div(sdport,CLOCK_DIV_NON);
            rtkcr_set_speed(sdport, 0);
            printk("[LY] rtkemmc : high speed, bus=%d\n", busmode);
        }
        else if(ios->clock > 200000)
        {
            rtkcr_set_div(sdport,CLOCK_DIV_128);  
            rtkcr_set_speed(sdport, 2);
            printk("[LY] rtkemmc : mid speed, bus=%d\n", busmode);
        }
        else
        {
            rtkcr_set_div(sdport,CLOCK_DIV_128); 
            rtkcr_set_speed(sdport, 2);
            printk("[LY] rtkemmc : low speed, bus=%d\n", busmode);
        }
    }
    else{  //MMC_BUSMODE_OPENDRAIN
        MMCPRINTF("ios busmode != pushpull\n");
        rtkcr_set_div(sdport,CLOCK_DIV_128);
        rtksd_set_bits(sdport,BUS_WIDTH_1);
    }

    up_write(&cr_rw_sem);
}

static void rtkemmc_chk_card_insert(struct rtksd_host *sdport)
{
    struct mmc_host *host=sdport->mmc;

    MMCPRINTF("%s : \n", __func__);
    rtksd_set_bits(sdport,BUS_WIDTH_1);
    rtkcr_set_speed(sdport, 2);
    rtkcr_set_div(sdport,CLOCK_DIV_128);
    host->card_type_pre = CR_EM;  //default flow is sd
    host->ops = &rtkemmc_ops;
    sdport->rtflags |= RTKCR_FCARD_DETECTED;
}

static void rtksd_timeout_timer(unsigned long data)
{
    struct rtksd_host *sdport;
    u8 wflag = 0;
    u32 int_status = 0;
    u32 sd_status1 = 0, sd_status2 = 0, bus_status = 0;
    u32 sd_trans = 0, dma_trans=0;
    unsigned long flags;

    sdport = (struct rtksd_host *)data;
    MMCPRINTF("rtksd_timeout_timer fired ...\n");
    MMCPRINTF("%s - int_wait=%08x\n", __func__, sdport->int_waiting);
    spin_lock_irqsave(&sdport->lock,flags);
    //down_write(&cr_rw_sem);
    #ifdef ENABLE_EMMC_INT_MODE
    if(sdport->int_waiting)
    #else
    if (1)
    #endif
    {
        MMCPRINTF("0. get sd trans \n");
        wflag = 0x01;
        #ifdef ENABLE_EMMC_INT_MODE
        MMCPRINTF("========== C1 ==========\n");
        rtkcr_hold_int_dec(sdport->base_io);
        rtkcr_clr_int_sta(sdport->base_io);
        sync();
        rtkcr_get_int_sta(sdport->base_io,&int_status);
        sdport->int_status  = int_status;
        #endif
        MMCPRINTF("1. get sd trans \n");
        MMCPRINTF("baseio=0x%08x\n",sdport->base_io);
        rtkcr_get_sd_trans(sdport->base_io,&sd_trans);
        rtkcr_get_dma_trans(sdport->base_io,&dma_trans);
        
        MMCPRINTF("2. get sd status \n");
        rtkcr_get_sd_sta(sdport->base_io,&sd_status1,&sd_status2,&bus_status);

        sdport->sd_trans    = sd_trans;
        sdport->sd_status1   = sd_status1;
        sdport->sd_status2   = sd_status2;
        sdport->bus_status   = bus_status;
        sdport->dma_trans    = dma_trans;
        MMCPRINTF("int sts : 0x%08x sd_trans : 0x%08x, sd_st1 : 0x%08x\n", sdport->int_status, sdport->sd_trans, sdport->sd_status1);
        MMCPRINTF("int st2 : 0x%08x bus_sts : 0x%08x dma_trans : 0x%08x\n", sdport->sd_status2, sdport->bus_status, sdport->dma_trans);        
        #ifdef ENABLE_EMMC_INT_MODE
        //rtkcr_en_int(sdport->base_io);
        #endif
    }else{
        WARN_ON(1);
    }
        
    if(sdport->int_waiting)
        rtk_op_complete(sdport);

    spin_unlock_irqrestore(&sdport->lock, flags);
    //up_write(&cr_rw_sem);
    #ifdef ENABLE_EMMC_INT_MODE
    MMCPRINTF(KERN_WARNING "%s: %s %s card access time out!\n",
            DRIVER_NAME,
            (wflag & 0x01) ? "int error;" : "",
            (wflag & 0x10) ? "dma error;" : "" );
    #endif

}

#ifdef EMMC_SHOUTDOWN_PROTECT
static void rtksd_gpio_isr(VENUS_GPIO_ID gid,
                                  unsigned char assert,
                                  void *dev)
{
    struct rtksd_host *sdport = dev;
    u32 reg_tmp;
    u32 bit_tmp;
    u32 reginfo;
    unsigned char assert_tmp;

    printk("%s(%u) sdport=0x%p (0x%x) [assert:%x]\n",
            __func__,__LINE__,sdport,gid,assert);

    reginfo = GET_PIN_TYPE(sdport->gpio_isr_info);
    bit_tmp = GET_PIN_INDEX(sdport->gpio_isr_info);

    reg_tmp = ((bit_tmp & 0xffffffe0)>>5)<<2;
    bit_tmp = (bit_tmp & 0x1fUL);

    switch(reginfo){
        case PCB_PIN_TYPE_GPIO:
            reg_tmp += GP0DATI;
            printk(KERN_ERR "PIN type is PCB_PIN_TYPE_GPIO\n");
            break;
        case PCB_PIN_TYPE_ISO_GPIO:
            reg_tmp += ISO_GPDATI;
            printk(KERN_ERR "PIN type is PCB_PIN_TYPE_ISO_GPIO\n");
            break;
        default:
            printk(KERN_ERR "PIN group not match\n");
            WARN_ON(1);
            return;
    }

    reginfo = cr_readl(reg_tmp);
    assert_tmp = (unsigned char)((reginfo & (0x01UL << bit_tmp))>>bit_tmp);
    WARN_ON(assert_tmp != assert);

    if((reginfo & (0x01UL <<bit_tmp)) == 0)
    {
        printk(KERN_ERR "%s(%u)Hold eMMC RSENT!!!\n",
            __func__,__LINE__);

        rtksd_hold_card(sdport);
    }
}

#endif

static irqreturn_t rtksd_irq(int irq, void *dev)
{
    struct rtksd_host *sdport = dev;

    int irq_handled = 0;
    u32 reginfo = 0;
    u32 int_status = 0;
    u32 sd_trans   = 0, dma_trans=0;
    u32 sd_status1 = 0,sd_status2 = 0, bus_status = 0;
    unsigned long flags;

    MMCPRINTF("rtksd_irq interrupted ...\n");

    rtkcr_hold_int_dec(sdport->base_io);
    rtkcr_get_int_sta(sdport->base_io,&int_status);
    rtkcr_clr_int_sta(sdport->base_io);
    sync();

    //down_write(&cr_rw_sem);
    //spin_lock(&sdport->lock);

    MMCPRINTF("int_status =%08x, int_waiting=%08x\n", int_status, sdport->int_waiting);
    if(int_status & (ISRSTA_INT1|ISRSTA_INT2|ISRSTA_INT4)) //card_end ?
    {
        MMCPRINTF("========== C2 ==========\n");
        rtkcr_get_sd_trans(sdport->base_io,&sd_trans);
        rtkcr_get_dma_trans(sdport->base_io,&dma_trans);
        rtkcr_get_sd_sta(sdport->base_io,&sd_status1,&sd_status2,&bus_status);
	sync();

        MMCPRINTF("we get int end \n");

#ifdef  SHOW_INT_STATUS
        printk("INT=0x%08x sdport=0x%p\n",int_status,sdport);
#endif
        sdport->int_status  = int_status;
        sdport->sd_trans    = sd_trans;
        sdport->sd_status1   = sd_status1;
        sdport->sd_status2   = sd_status2;
        sdport->bus_status   = bus_status;
        sdport->dma_trans    = dma_trans;
        if(sdport->int_waiting){
            MMCPRINTF("int wait clear 1\n");
            del_timer(&sdport->timer);
            rtk_op_complete(sdport);
            MMCPRINTF("int wait clear 2\n");
        }else{
            MMCPRINTF("No int_waiting!!!\n");
        }
        //rtkcr_en_int(sdport->base_io);
        irq_handled = 1;
    }
    else
    {
        printk("INT no END_STATE!!!\n");
    }

    sync();

    //up_write(&cr_rw_sem);
    //spin_unlock(&sdport->lock);
    
    if(irq_handled)
        return IRQ_HANDLED;      //liao
    else
        return IRQ_NONE;

}

/* liao ********************
 * check read only func
 *
 *
 ***************************/
static int rtksd_get_ro(struct mmc_host *mmc)
{
    //struct rtksd_host *sdport = mmc_priv(mmc);
    //struct mmc_card *card = mmc->card;

    return 0;
}

static int rtksd_wait_status(struct mmc_card *card,u8 state,u8 divider)
{
    struct mmc_command cmd;
    struct sd_cmd_pkt cmd_info;
    unsigned long timeend;
    int err;

    MMCPRINTF("\n");
    timeend = jiffies + msecs_to_jiffies(100);    /* wait 100ms */

    do {
        memset(&cmd, 0, sizeof(struct mmc_command));
        memset(&cmd_info, 0, sizeof(struct sd_cmd_pkt));

        set_cmd_info(card,&cmd,&cmd_info,
                     MMC_SEND_STATUS,
                     (card->rca)<<RCA_SHIFTER,
                     SD_R1|divider);
        err = SD_SendCMDGetRSP_Cmd(&cmd_info);

        if(err){
            mmcmsg1("wait %s fail\n",state_tlb[state]);
            break;
        }else{
            u8 cur_state = R1_CURRENT_STATE(cmd.resp[0]);
            mmcmsg1("cur_state=%s\n",state_tlb[cur_state]);
            err = -1;
            if(cur_state == state){
                if(cmd.resp[0] & R1_READY_FOR_DATA){
                    err = 0;
                    break;
                }
            }
        }

    }while(time_before(jiffies, timeend));  
    return err;
}

static int rtksd_send_status(struct mmc_card *card,u16 * state,u8 divider)
{
    struct mmc_command cmd;
    struct sd_cmd_pkt cmd_info;
    int err;

    MMCPRINTF("\n");

    memset(&cmd, 0, sizeof(struct mmc_command));
    memset(&cmd_info, 0, sizeof(struct sd_cmd_pkt));

    set_cmd_info(card,&cmd,&cmd_info,
                 MMC_SEND_STATUS,
                 (card->rca)<<RCA_SHIFTER,
                 SD_R1|divider);
    err = SD_SendCMDGetRSP_Cmd(&cmd_info);

    if(err){
        mmcmsg3(KERN_WARNING "%s: MMC_SEND_STATUS fail\n",DRIVER_NAME);
    }else{
        u8 cur_state = R1_CURRENT_STATE(cmd.resp[0]);
        *state = cur_state;
        mmcmsg1("cur_state=%s\n",state_tlb[cur_state]);

    }

    return err;
}

static int rtksd_switch_user_partition(struct mmc_card *card)
{
    struct mmc_command cmd;
    struct sd_cmd_pkt cmd_info;
    int err = 0;

    MMCPRINTF("\n");

    memset(&cmd, 0, sizeof(struct mmc_command));
    memset(&cmd_info, 0, sizeof(struct sd_cmd_pkt));

    set_cmd_info(card,&cmd,&cmd_info,
                 MMC_SWITCH,
                 0x03b30001,
                 SD_R1b);
    err = SD_SendCMDGetRSP_Cmd(&cmd_info);

    if(err){
        mmcmsg3(KERN_WARNING "%s: MMC_SWITCH fail\n",DRIVER_NAME);
    }
    return err;

}

#ifdef CONFIG_MMC_RTKEMMC_HK_ATTR
//#define HACK_BOOT_PART_RW

#define NORMAL_PART 0
#define BOOT1_PART  1
#define BOOT2_PART  2
#define GP1_PART    3
#define GP2_PART    4
#define GP3_PART    5
#define GP4_PART    6

#ifdef HACK_BOOT_PART_RW
static int rtksd_switch_partition(struct mmc_card *card,u8 acc_part)
{

    rtksd_switch(card,
                 MMC_SWITCH_MODE_WRITE_BYTE,
                 EXT_CSD_PART_CONFIG,
                 acc_part,
                 EXT_CSD_CMD_SET_NORMAL);

    return 0;

}
#endif

static int rtksd_switch(struct mmc_card *card,
                        u8 acc_mod,
                        u8 index,
                        u8 value,
                        u8 cmd_set)
{
    struct mmc_command cmd;
    struct sd_cmd_pkt cmd_info;
    u32 arg = 0;
    int err = 0;

    memset(&cmd, 0, sizeof(struct mmc_command));
    memset(&cmd_info, 0, sizeof(struct sd_cmd_pkt));

    //printk("acc_mod=%x, index=%u value=%x, set=%x\n",
    //        acc_mod,index,value,cmd_set);
    arg = (acc_mod << 24) |
          (index <<16) |
          (value << 8) |
          (cmd_set);

    MMCPRINTF("%s : arg=0x%08x\n",__func__,arg);
    set_cmd_info(card,&cmd,&cmd_info,
                 MMC_SWITCH,
                 arg,
                 SD_R1b);

    err = SD_SendCMDGetRSP_Cmd(&cmd_info);
    err = 0;

    if(err){
        mmcmsg3(KERN_WARNING "%s: MMC_SWITCH fail\n",DRIVER_NAME);
    }
    return err;

}
#endif

static int rtksd_stop_transmission(struct mmc_card *card)
{
    struct mmc_command cmd;
    struct sd_cmd_pkt cmd_info;
    int err = 0;

    MMCPRINTF("\n");

    memset(&cmd, 0, sizeof(struct mmc_command));
    memset(&cmd_info, 0, sizeof(struct sd_cmd_pkt));

    set_cmd_info(card,&cmd,&cmd_info,
                 MMC_STOP_TRANSMISSION,
                 0x00,
                 SD_R1b);
    err = SD_SendCMDGetRSP_Cmd(&cmd_info);

    if(err){
        mmcmsg3(KERN_WARNING "%s: MMC_STOP_TRANSMISSION fail\n",DRIVER_NAME);
    }
    return err;

}

//#define MMC_VDD_30_31   0x00040000  /* VDD voltage 3.0 ~ 3.1 */
//#define MMC_VDD_31_32   0x00080000  /* VDD voltage 3.1 ~ 3.2 */
//#define MMC_VDD_32_33   0x00100000  /* VDD voltage 3.2 ~ 3.3 */
//#define MMC_VDD_33_34   0x00200000  /* VDD voltage 3.3 ~ 3.4 */
//#define MMC_VDD_34_35   0x00400000  /* VDD voltage 3.4 ~ 3.5 */
//#define MMC_VDD_35_36   0x00800000  /* VDD voltage 3.5 ~ 3.6 */
//#define MMC_CARD_BUSY   0x80000000  /* Card Power up status bit */
//#define RTL_HOST_VDD    MMC_VDD_33_34|MMC_VDD_32_33|MMC_VDD_31_32|MMC_VDD_30_31

//static int rtksd_re_init_proc(struct mmc_card *card)    //re_initial_card
//{
//    struct sd_cmd_pkt cmd_info;
//    struct mmc_command cmd;
//    u32 arg = 0;
//    u8 i;
//    int err=0;
//    struct rtksd_host *sdport = mmc_priv(card->host);
//    u32 iobase = sdport->base_io;
//    unsigned long timeend;
//
//    MMCPRINTF("\n");
//    sdport->rt_parameter=0;
//    rtkcr_set_clk(sdport,CARD_SWITCHCLOCK_30MHZ);
//
//    if(card->type == MMC_TYPE_SD)
//    {
//
//        for(i=0;i<4;i++){
//            cr_writel(0x48, iobase+CR_REG_CMD_1);
//            cr_writel(0x00, iobase+CR_REG_CMD_2);
//            cr_writel(0xff, iobase+CR_REG_CMD_3);
//            cr_writel(0xff, iobase+CR_REG_CMD_4);
//            cr_writel(0xff, iobase+CR_REG_CMD_5);
//            cr_writel(0xff, iobase+CR_REG_CMD_6);
//            cr_writel(0xff, iobase+CR_REG_CMD_7);
//            cr_writel(0x90, iobase+CR_REG_CMD_8);
//            rtkcr_wait_opt_end(sdport);
//        }
//    }
//
//
//    set_cmd_info(card,&cmd,&cmd_info,MMC_GO_IDLE_STATE,
//                 0x00000000,SD_R0|DIVIDE_128);
//    err = SD_SendCMDGetRSP_Cmd(&cmd_info);
//    if(err){
//        goto err_out;
//    }
//
//    if(card->type == MMC_TYPE_SD){
//        mmcmsg1("SD re_initial\n");
//        if(card->scr.sda_vsn == 2){    //SD spec 2.0
//            //CMD8_SEND_IF_COND
//            set_cmd_info(card,&cmd,&cmd_info,SD_SEND_IF_COND,
//                         0x000001AA,SD_R7|DIVIDE_128);
//            err=SD_SendCMDGetRSP_Cmd(&cmd_info);
//
//            if(err)
//                goto err_out;
//        }
//
//        if ( mmc_card_blockaddr(card))
//            arg = 0x40000000;   //SD_HCS;
//
//        timeend = jiffies + 2*HZ;
//        while (1){
//            if(time_after(jiffies, timeend)){
//                mmcspec("SD ACMD41_SD_APP_OP_COND time out\n");
//                err=-1;
//                goto err_out;
//            }
//
//            set_cmd_info(card,&cmd,&cmd_info,MMC_APP_CMD,
//                         0x00000000,SD_R1|DIVIDE_128);
//            err=SD_SendCMDGetRSP_Cmd(&cmd_info);
//            if(err)
//                goto err_out;
//
//            mdelay(1);
//            set_cmd_info(card,&cmd,&cmd_info,SD_APP_OP_COND,
//                         arg|RTL_HOST_VDD,SD_R3|DIVIDE_128);
//            err=SD_SendCMDGetRSP_Cmd(&cmd_info);
//            if(err)
//                goto err_out;
//
//            if (cmd.resp[0] & MMC_CARD_BUSY)
//                break;
//
//        }
//        mdelay(1);
//        set_cmd_info(card,&cmd,&cmd_info,MMC_ALL_SEND_CID,
//                         0x00000000,SD_R2|DIVIDE_128);
//        err=SD_SendCMDGetRSP_Cmd(&cmd_info);
//        if(err)
//            goto err_out;
//
//        set_cmd_info(card,&cmd,&cmd_info,SD_SEND_RELATIVE_ADDR,
//                         0x00000000,SD_R6|DIVIDE_128);
//        err=SD_SendCMDGetRSP_Cmd(&cmd_info);
//        if(err)
//            goto err_out;
//
//        card->rca = cmd.resp[0]>>RCA_SHIFTER;
//        mmcspec("card->rca:0x%x\n",card->rca);
//
//        set_cmd_info(card,&cmd,&cmd_info,MMC_SELECT_CARD,
//                         (card->rca)<<RCA_SHIFTER,SD_R1b|DIVIDE_128);
//        err=SD_SendCMDGetRSP_Cmd(&cmd_info);
//        if(err)
//            goto err_out;
//
//        if( mmc_card_highspeed(card))   //support high-speed
//        {
//            mmcspec("high-speed mode\n");
//            //set_cmd_info(card,&cmd,&cmd_info,CMD6_SWITCH_FUNC,
//            //             0x80fffff1,SD_R1);
////            err=SD_SendCMDGetRSP_Cmd(&cmd_info);
//            rtkcr_set_clk(sdport,CARD_SWITCHCLOCK_40MHZ);
//        }
//        else
//        {
//            mmcspec("normal-speed mode\n");
//            //rtksd_set_phase(card->host,RTK_PHASE_LOW);
//            rtkcr_set_clk(sdport,CARD_SWITCHCLOCK_30MHZ);
//        }
//
//        if(card->scr.bus_widths &0x04) //support 4-bits
//        {
//
//            set_cmd_info(card,&cmd,&cmd_info,MMC_APP_CMD,
//                         card->rca<<RCA_SHIFTER,SD_R1);
//            err=SD_SendCMDGetRSP_Cmd(&cmd_info);
//            if(err)
//                goto err_out;
//
//            set_cmd_info(card,&cmd,&cmd_info,SD_APP_SET_BUS_WIDTH,
//                         0x02,SD_R1);
//            err=SD_SendCMDGetRSP_Cmd(&cmd_info);
//            if(err)
//                goto err_out;
//
//            err=rtksd_set_bits(sdport,BUS_WIDTH_4);
//            if(err)
//                goto err_out;
//            else
//                mmcspec("SD/SDHC 4-bits mode\n");
//
//        }
//
//    }else{  //MMC card
//        mmcmsg1("%s: MMC re_initial\n",DRIVER_NAME);
//        timeend=jiffies+HZ;
//        while (1){
//            if(time_after(jiffies, timeend)){
//                mmcspec("SD ACMD41_SD_APP_OP_COND time out\n");
//                err=-1;
//                goto err_out;
//            }
//
//            set_cmd_info(card,&cmd,&cmd_info,MMC_SEND_OP_COND,
//                         RTL_HOST_VDD,SD_R3|DIVIDE_128);
//            err=SD_SendCMDGetRSP_Cmd(&cmd_info);
//            if(err)
//                goto err_out;
//
//            mdelay(1);
//
//            if (cmd.resp[0] & MMC_CARD_BUSY)
//                break;
//
//        }
//
//        mdelay(1);
//        set_cmd_info(card,&cmd,&cmd_info,MMC_ALL_SEND_CID,
//                         0x00000000,SD_R2|DIVIDE_128);
//        err=SD_SendCMDGetRSP_Cmd(&cmd_info);
//        if(err)
//            goto err_out;
//
//        mmcspec("%s: card->rca:0x%x\n",DRIVER_NAME,card->rca);
//        set_cmd_info(card,&cmd,&cmd_info,MMC_SET_RELATIVE_ADDR,
//                         (card->rca)<<RCA_SHIFTER,SD_R1|DIVIDE_128);
//        err=SD_SendCMDGetRSP_Cmd(&cmd_info);
//        if(err)
//            goto err_out;
//
//        set_cmd_info(card,&cmd,&cmd_info,MMC_SELECT_CARD,
//                         (card->rca)<<RCA_SHIFTER,SD_R1b|DIVIDE_128);
//        err=SD_SendCMDGetRSP_Cmd(&cmd_info);
//        if(err)
//            goto err_out;
//
//        //speed up to 40MHz
//        rtkcr_set_clk(sdport,CARD_SWITCHCLOCK_40MHZ);
//
//        arg=(MMC_SWITCH_MODE_WRITE_BYTE << 24)
//            | (EXT_CSD_BUS_WIDTH << 16)
//            | (1 << 8)
//            | EXT_CSD_CMD_SET_NORMAL;
//        set_cmd_info(card,&cmd,&cmd_info,MMC_SWITCH,
//                         arg,SD_R1b);
//        err=SD_SendCMDGetRSP_Cmd(&cmd_info);
//        if(err)
//            goto err_out;
//
//        timeend=jiffies+HZ;
//        do {
//            if(time_after(jiffies, timeend)){
//                err=-1;
//                goto err_out;
//            }
//
//            set_cmd_info(card,&cmd,&cmd_info,MMC_SEND_STATUS,
//                         (card->rca)<<RCA_SHIFTER,SD_R1);
//            err=SD_SendCMDGetRSP_Cmd(&cmd_info);
//            if(err)
//                goto err_out;
//
//        }while(((cmd.resp[0] & 0x00001E00) >> 9)==7);   //0x00001E00; the 1E is card state window
//
//        if(cmd.resp[0]&0xFDFFA000){ //0xFDFFA000 is card status error bits
//            err=-1;
//            goto err_out;
//        }
//
//        if (cmd.resp[0] & (1<<7)){
//            err=-1;
//            goto err_out;
//        }else{
//            err=rtksd_set_bits(sdport,BUS_WIDTH_4);
//            if(err)
//                goto err_out;
//            else
//                mmcspec("MMC 4-bits mode\n");
//        }
//    }
//
//err_out:
//
//    if(err ){
//        mmcspec("re_initial fail !!\n");
//
//    }else{
//        mmcspec("re_initial success\n");
//    }
//    return err;
//}

static void set_cmd_info(struct mmc_card *card,struct mmc_command * cmd,
                         struct sd_cmd_pkt * cmd_info,u32 opcode,u32 arg,u8 rsp_para)
{
    memset(cmd, 0, sizeof(struct mmc_command));
    memset(cmd_info, 0, sizeof(struct sd_cmd_pkt));

    cmd->opcode         = opcode;
    cmd->arg            = arg;
    cmd_info->cmd       = cmd;
    cmd_info->sdport    = mmc_priv(card->host);
    cmd_info->rsp_para2  = rsp_para;
    cmd_info->rsp_len   = rtksd_get_rsp_len(rsp_para);
}

static struct rtk_host_ops emmc_ops = {
    .func_irq       = NULL,
    .re_init_proc   = NULL,
    .card_det       = NULL,
    .card_power     = NULL,
	.chk_card_insert= rtkemmc_chk_card_insert,
	.set_crt_muxpad = rtkemmc_set_crt_muxpad,
	.set_clk        = NULL,
	//we don't need to do the rst
    .reset_card     = NULL,
    .reset_host     = NULL,
    .bus_speed_down = rtkemmc_bus_speed_down,
    .get_cmdcode    = NULL, //rtk_get_emmc_cmdcode,
    .get_r1_type    = NULL, //rtk_emmc_get_r1_type,
    .chk_cmdcode    = rtkcr_chk_cmdcode,
    .chk_r1_type    = rtkcr_chk_r1_type,
};

#ifdef CONFIG_MMC_RTKEMMC_HK_ATTR
static int mmc_send_data_cmd(unsigned int hc_cmd,
                        unsigned int cmd_arg,
                        unsigned int blk_cnt,
                        unsigned char * buffer)
{
    int err = 0;
    //unsigned int rw_mode;
    struct mmc_host * mmc = mmc_host_local;
    unsigned long flags;

    printk(KERN_ERR "cmd=%u, arg=0x%08x, size=0x%08x, buf=0x%p\n",
            hc_cmd,cmd_arg,blk_cnt,buffer);
    if(mmc){
        struct rtksd_host *sdport = mmc_priv(mmc);
        struct mmc_card *card = mmc->card;
        struct mmc_request mrq = {0};
        struct mmc_command cmd = {0};
	    struct mmc_data	data   = {0};
	    struct scatterlist sg;

        sdport = mmc_priv(mmc);
        mmc_claim_host(mmc);
        spin_lock_irqsave(&sdport->lock,flags);

        cmd.opcode = hc_cmd;
        cmd.arg = cmd_arg;
	    cmd.flags = MMC_RSP_R1 | MMC_CMD_ADTC;

        if(blk_cnt)
        {   //date info setting
    		data.sg = &sg;
    		data.sg_len = 1;
    		data.blksz = 512;
    		data.blocks = blk_cnt;

    		sg_init_one(data.sg, buffer, (blk_cnt<<9));

            if( hc_cmd == MMC_WRITE_MULTIPLE_BLOCK ||
                hc_cmd == MMC_WRITE_BLOCK )
            {
    	        data.flags = MMC_DATA_WRITE;
            }
            else if( hc_cmd == MMC_SEND_EXT_CSD ||
                     hc_cmd == MMC_READ_MULTIPLE_BLOCK ||
                     hc_cmd == MMC_READ_SINGLE_BLOCK )
            {
    		    data.flags = MMC_DATA_READ;
            }else{
                printk(KERN_ERR "not supported command");
                spin_unlock_irqrestore(&sdport->lock, flags);
                goto ERR_OUT;
            }

            mmc_set_data_timeout(&data, card);
        }

	    data.mrq = &mrq;
	    cmd.mrq = &mrq;
	    cmd.data = &data;
	    cmd.retries =3;

CMD_RETRY:
        mrq.data = &data;
        mrq.cmd = &cmd;

        if(sdport->mrq){
            sdport->mrq = NULL;
        }

        cmd.error = 0;
	    data.error = 0;

        spin_unlock_irqrestore(&sdport->lock, flags);
        mmc_wait_for_req(mmc, &mrq);
        spin_lock_irqsave(&sdport->lock,flags);

        err = cmd.error;

        if(err && cmd.retries){
            printk(KERN_ERR "%s(%u)last retry %d counter.\n",
                    __func__,__LINE__,cmd.retries);
            cmd.retries--;
            goto CMD_RETRY;
        }
        spin_unlock_irqrestore(&sdport->lock, flags);
        mmc_release_host(mmc);
    }else{
        err = -ENODEV;
    }

ERR_OUT:
    if(err)
        printk(KERN_ERR "err=%d\n",err);
    return err;
}

static void show_ext_csd(u8 *ext_csd)
{
    int i;
    for(i=0; i<512; i+=8){
        printk(KERN_ERR
            "[%03u]=%02x [%03u]=%02x [%03u]=%02x [%03u]=%02x "
            "[%03u]=%02x [%03u]=%02x [%03u]=%02x [%03u]=%02x\n",
            i,*(ext_csd+i),i+1,*(ext_csd+i+1),i+2,*(ext_csd+i+2),i+3,*(ext_csd+i+3),
            i+4,*(ext_csd+i+4),i+5,*(ext_csd+i+5),i+6,*(ext_csd+i+6),i+7,*(ext_csd+i+7));
    }
    printk(KERN_ERR "\n");
}

#define PF2_SHOW_EXT_CSD 0x01UL
#define PF2_FULL_PARAM   0x02UL
#define PF2_SET_EXT_CSD  0x04UL

#ifdef HACK_BOOT_PART_RW
/*
Note : this function not complete yet.
*/
static void hk_fill_bp(struct device *dev,
                       size_t p_count,
                       unsigned char *cr_param)
{
    u8 *emmc_buf;
    //u32 i;
    u32 param1;
    u32 param2;
    u32 param3;
    u32 buf_size;
    u8 part_config;
    struct mmc_host *host;
    struct mmc_card *card;

    printk(KERN_ERR "%s(%u)3013/08/15 17:30\n",__func__,__LINE__);

    host = dev_get_drvdata(dev);
    if(host)
        card = host->card;

    if(card == NULL){
        printk(KERN_ERR "card is not exist.\n");
        goto ERR_OUT;
    }

    rtkcr_chk_param(&param1,8,cr_param);
    rtkcr_chk_param(&param2,8,cr_param+9);
    rtkcr_chk_param(&param3,8,cr_param+18);

    printk(KERN_ERR "param1=0x%x\n",param1); //enh_start_addr
    printk(KERN_ERR "param2=0x%x\n",param2); //enh_block_cnt
    printk(KERN_ERR "param3=0x%x\n",param3);

    buf_size = 512;
    part_config = card->ext_csd.part_config;

    if(host && card){
        int idx;
        printk(KERN_ERR "erased byte = 0x%x\n",card->erased_byte);
        printk(KERN_ERR "part_config=0x%x\n",part_config);
        printk(KERN_ERR "card's partition information\n");
        for (idx = 0; idx < card->nr_parts; idx++) {
	        if (card->part[idx].size) {
	            printk(KERN_ERR "\n===> \nPART %u; name:%s\n",
	                    idx,card->part[idx].name);
	            printk(KERN_ERR "    part_cfg = 0x%x; size:0x%x\n",
	                    card->part[idx].part_cfg,
	                    card->part[idx].size >> 9);
	            printk(KERN_ERR "    force_ro = 0x%x; area_type = 0x%x\n",
	                    card->part[idx].force_ro,
	                    card->part[idx].area_type);
                if(card->part[idx].part_cfg < EXT_CSD_PART_CONFIG_ACC_GP0)
                {
                    printk(KERN_ERR "cfg: EXT_CSD_PART_CONFIG_ACC_BOOT%x\n",
                        (card->part[idx].part_cfg)-EXT_CSD_PART_CONFIG_ACC_BOOT0);
                }else{
                    printk(KERN_ERR "cfg: EXT_CSD_PART_CONFIG_ACC_GP%u\n",
                        (card->part[idx].part_cfg)-EXT_CSD_PART_CONFIG_ACC_GP0);
                }
                if(card->part[idx].area_type == MMC_BLK_DATA_AREA_MAIN)
                    printk(KERN_ERR "type: MMC_BLK_DATA_AREA_MAIN\n");
                if(card->part[idx].area_type == MMC_BLK_DATA_AREA_BOOT)
                    printk(KERN_ERR "type: MMC_BLK_DATA_AREA_BOOT\n");
                if(card->part[idx].area_type == MMC_BLK_DATA_AREA_GP)
                    printk(KERN_ERR "type: MMC_BLK_DATA_AREA_GP\n");
	        }
        }
    }

    buf_size = 512 * 16;
    emmc_buf = kmalloc(buf_size, GFP_KERNEL);
    if(!emmc_buf){
        printk(KERN_ERR "emmc_buf is NULL\n");
        goto ERR_OUT;
    }

    memset(emmc_buf, 0, buf_size);

    printk(KERN_ERR "emmc_buf=0x%p\n",emmc_buf);

    mmc_send_data_cmd(MMC_SEND_EXT_CSD,
                      0,1,emmc_buf);

    printk(KERN_ERR "[EXT_CSD] :\n");
    show_ext_csd(emmc_buf);

    rtksd_switch_partition(card,BOOT1_PART);

    mmc_send_data_cmd(MMC_SEND_EXT_CSD,
                      0,1,emmc_buf);

    printk(KERN_ERR "{F} [EXT_CSD] :\n");
    show_ext_csd(emmc_buf);

    if(*(emmc_buf+EXT_CSD_PART_CONFIG) & 0x01){
        u32 boot_part_blk_cnt;

        boot_part_blk_cnt = (*(emmc_buf+EXT_CSD_BOOT_MULT))<<8;
        printk(KERN_ERR "have changed to boot partition 1. [%x block]\n",
                boot_part_blk_cnt);

        //mmc_send_data_cmd(MMC_READ_MULTIPLE_BLOCK,
        //              0,boot_part_blk_cnt,emmc_buf);

    }

    kfree(emmc_buf);

ERR_OUT:
    return;
}
#endif

static void hk_set_wr_rel(struct device *dev,
                          size_t p_count,
                          unsigned char *cr_param)
{
    u8 *emmc_buf;
    u8 acc_mod;
    u8 index;
    u8 value;
    u8 i;
    u8 idx_lop;
    u8 cmd_set;
    u32 param1;
    u32 param2;
    u32 param3;
    u32 buf_size;
    struct mmc_host *host;
    struct mmc_card *card = NULL;

    printk(KERN_ERR "%s(%u)3013/08/15 17:30\n",__func__,__LINE__);

    if( p_count != 38){
        printk(KERN_ERR "Command format:\n"
               "    echo set_wr_rel=param1,param2,param3 > emmc_hacking;\n"
               "        param1[7:0] is value in byte you want to set.\n"
               "        param2 :\n"
               "            [bit0] TO show all ext_csd.\n"
               "            [bit1] Send CMD6. if this bit is set.\n"
               "                   param1 change to 32 bits parameter of argument of AMD6.\n"
               "        param3 must be 2379beef to make sure you want to do this.\n"
               "ex:\n"
               "    echo set_wr_rel=00000001,00000000,2379beef > emmc_hacking;\n"
               "        param1=0x00000001 enable user data area write reliability\n"
               "        param2=0x00020000 do not show all ext_csd.\n"
               "        param3=2379beef make sure that want to do this.\n"
               "\n"
               "    echo set_wr_rel=03a71f01,00000002,2379beef > emmc_hacking;\n"
               "        param1=0x03a71f01 set ext_cse[0xa7], value=0x1f, cmd_set=1\n"
               "        param2=0x00000002 send CMD6. param1 is argument in 32 bits.\n"
               "        param3=2379beef make sure that want to do this.\n" );
        goto ERR_OUT;
    }

    host = dev_get_drvdata(dev);
    if(host)
        card = host->card;

    // KWarning: checked ok by alexkh@realtek.com
    if(card == NULL){
        printk(KERN_ERR "card is not exist.\n");
        goto ERR_OUT;
    }

    rtkcr_chk_param(&param1,8,cr_param);
    rtkcr_chk_param(&param2,8,cr_param+9);
    rtkcr_chk_param(&param3,8,cr_param+18);

    printk(KERN_ERR "param1=0x%x\n",param1);
    printk(KERN_ERR "param2=0x%x\n",param2);
    printk(KERN_ERR "param3=0x%x\n",param3);

    if(param2 & PF2_FULL_PARAM){
        printk(KERN_ERR "Send CMD6 alert\n");
        acc_mod = (u8)((param1>>24)&0xff);
        index   = (u8)((param1>>16)&0xff);
        value   = (u8)((param1>> 8)&0xff);
        cmd_set = (u8)(param1&0xff);
    }else{
        printk(KERN_ERR "Enable Write Reliability\n");
        acc_mod = MMC_SWITCH_MODE_WRITE_BYTE;
        index   = EXT_CSD_WR_REL_SET;
        value   = (u8)param1;
        cmd_set = 1;
    }

    printk(KERN_ERR "acc_mod=0x%x; index=%u; value=0x%x; cmd_set=0x%x\n",
            acc_mod,index,value,cmd_set);

    buf_size = 512;
    emmc_buf = kmalloc(buf_size, GFP_KERNEL);
    if(!emmc_buf){
        printk(KERN_ERR "emmc_buf is NULL\n");
        goto ERR_OUT;
    }
    //printk(KERN_ERR "emmc_buf=0x%p\n",emmc_buf);

    memset(emmc_buf, 0, 512);
    mmc_send_data_cmd(MMC_SEND_EXT_CSD,
                      0,1,emmc_buf);

    printk(KERN_ERR "[EXT_CSD] :\n");
    if(param2){
        if(param2 & PF2_SHOW_EXT_CSD)
            show_ext_csd(emmc_buf);
        if(param2 & PF2_FULL_PARAM){
            if( index==249 || index==242 ||
                index==212 || index==136 )
                idx_lop = 4;
            else if( index==157 || index==140)
                idx_lop = 3;
            else if( index==143)
                idx_lop = 12;
            else
                idx_lop = 1;

            for(i=0; i<idx_lop; i++)
                printk(KERN_ERR "    [%03u]=%02x\n",index+i,*(emmc_buf+index+i));
        }

    }else{
        printk(KERN_ERR "    [%03u]=%02x [%03u]=%02x\n",
                    166,*(emmc_buf+166),
                    167,*(emmc_buf+167));
    }

    if(index == EXT_CSD_WR_REL_SET){
        if((*(emmc_buf+EXT_CSD_WR_REL_PARAM) & 0x05) == 0x05 ){
            if(*(emmc_buf+EXT_CSD_PARTITION_SETTING_COMP) & 0x01){
                printk(KERN_ERR "This chip PARTITION configuration have completed\n");
                printk(KERN_ERR "  ENH_SATRT_ADDR = 0x%08x\n",
                          (*(emmc_buf+EXT_CSD_ENH_START_ADDR+3)<<24) |
                          (*(emmc_buf+EXT_CSD_ENH_START_ADDR+2)<<16) |
                          (*(emmc_buf+EXT_CSD_ENH_START_ADDR+1)<<8) |
                          (*(emmc_buf+EXT_CSD_ENH_START_ADDR)));
                printk(KERN_ERR "  ENH_SIZE_MULT  = 0x%06x\n",
                          (*(emmc_buf+EXT_CSD_ENH_SIZE_MULT+2)<<16) |
                          (*(emmc_buf+EXT_CSD_ENH_SIZE_MULT+1)<<8) |
                          (*(emmc_buf+EXT_CSD_ENH_SIZE_MULT)));
                printk(KERN_ERR "  PARTITION_ATTRIBUTE  = 0x%06x\n",
                        (*(emmc_buf+EXT_CSD_PARTITION_ATTRIBUTE)));
                printk(KERN_ERR "  WR_REL_SET  = 0x%x\n",
                        (*(emmc_buf+EXT_CSD_WR_REL_SET)));
                goto FINISH_OUT;
            }

        }else{
            printk(KERN_ERR "Device not support setting write reliability\n");
            printk(KERN_ERR "  WR_REL_PARAM = 0x%x\n",
                      *(emmc_buf+EXT_CSD_WR_REL_PARAM));
            goto FINISH_OUT;
        }
    }

    if(param3 == 0x2379beef)
        rtksd_switch(card,acc_mod,index,value,cmd_set);
    else{
        printk(KERN_ERR "param3 != 0x2379beef skip command.\n");
        goto FINISH_OUT;
    }

    memset(emmc_buf, 0, 512);
    mmc_send_data_cmd(MMC_SEND_EXT_CSD,
                      0,1,emmc_buf);

    printk(KERN_ERR "{F} [EXT_CSD] :\n");
    if(param2){
        if(param2 & PF2_SHOW_EXT_CSD)
            show_ext_csd(emmc_buf);
        if(param2 & PF2_FULL_PARAM){
            if( index==249 || index==242 ||
                index==212 || index==136 )
                idx_lop = 4;
            else if( index==157 || index==140)
                idx_lop = 3;
            else if( index==143)
                idx_lop = 12;
            else
                idx_lop = 1;

            for(i=0; i<idx_lop; i++)
                printk(KERN_ERR "    [%03u]=%02x\n",index+i,*(emmc_buf+index+i));
        }
    }else{
        printk(KERN_ERR "    [%03u]=%02x [%03u]=%02x\n",
                    166,*(emmc_buf+166),
                    167,*(emmc_buf+167));
    }

FINISH_OUT:
    kfree(emmc_buf);

ERR_OUT:
    return;

}

static void hk_red_ext_csd(struct device *dev,
                           size_t p_count,    //39
                           unsigned char *cr_param)
{
    u8 *emmc_buf;
    u32 param1; //target emmc address
    u32 param2; //block number
    u32 param3; //1: write; 0: read
    u32 buf_size ;
    struct mmc_host *host;
    struct mmc_card *card = NULL;

    printk(KERN_ERR "%s(%u)3013/08/15 17:30\n",__func__,__LINE__);
    host = dev_get_drvdata(dev);
    if(host)
        card = host->card;

    // KWarning: checked ok by alexkh@realtek.com
    if(card == NULL){
        printk(KERN_ERR "card is not exist.\n");
        goto ERR_OUT;
    }

    rtkcr_chk_param(&param1,8,cr_param);
    rtkcr_chk_param(&param2,8,cr_param+9);
    rtkcr_chk_param(&param3,8,cr_param+18);

    printk(KERN_ERR "param1=0x%x\n",param1); //enh_start_addr
    printk(KERN_ERR "param2=0x%x\n",param2); //enh_block_cnt
    printk(KERN_ERR "param3=0x%x\n",param3);

    buf_size = 512;
    emmc_buf = kmalloc(buf_size, GFP_KERNEL);
    if(!emmc_buf){
        printk(KERN_ERR "emmc_buf is NULL\n");
        goto ERR_OUT;
    }
    printk(KERN_ERR "emmc_buf=0x%p\n",emmc_buf);

    memset(emmc_buf, 0, 512);
    mmc_send_data_cmd(MMC_SEND_EXT_CSD,
                      0,1,emmc_buf);

    printk(KERN_ERR "[EXT_CSD] :\n");

    if(param1 && !(param2 & PF2_SHOW_EXT_CSD)){
        u8 i;
        u8 item_cnt;
        for(i=0;i<4;i++){
            item_cnt = param1>>(i*8);
            printk(KERN_ERR "    [%03u]=%02x ",item_cnt,*(emmc_buf+item_cnt));
        }
        printk(KERN_ERR "\n");
    }else{
        show_ext_csd(emmc_buf);
    }
    kfree(emmc_buf);

ERR_OUT:
    return;
}

static void hk_set_enh_user_area(struct device *dev,
                                 size_t p_count,
                                 unsigned char *cr_param)
{
    u8 *emmc_buf;
    u32 param1;
    u32 param2;
    u32 param3;
    u32 buf_size ;
    struct mmc_host *host;
    struct mmc_card *card = NULL;

    printk(KERN_ERR "%s(%u)3013/08/15 17:30\n",__func__,__LINE__);
    host = dev_get_drvdata(dev);
    if(host)
        card = host->card;

    // KWarning: checked ok by alexkh@realtek.com
    if(card == NULL){
        printk(KERN_ERR "card is not exist.\n");
        goto ERR_OUT;
    }
    rtkcr_chk_param(&param1,8,cr_param);
    rtkcr_chk_param(&param2,8,cr_param+9);
    rtkcr_chk_param(&param3,8,cr_param+18);

    printk(KERN_ERR "param1=0x%x\n",param1); //enh_start_addr
    printk(KERN_ERR "param2=0x%x\n",param2); //enh_block_cnt
    printk(KERN_ERR "param3=0x%x\n",param3);

    buf_size = 512;
    emmc_buf = kmalloc(buf_size, GFP_KERNEL);
    if(!emmc_buf){
        printk(KERN_ERR "emmc_buf is NULL\n");
        goto ERR_OUT;
    }
    printk(KERN_ERR "emmc_buf=0x%p\n",emmc_buf);

    memset(emmc_buf, 0, 512);
    mmc_send_data_cmd(MMC_SEND_EXT_CSD,
                      0,1,emmc_buf);

    printk(KERN_ERR "[EXT_CSD] :\n");
    if((*(emmc_buf+EXT_CSD_PARTITION_SUPPORT) &0x03) == 0x03){
        u32 i;
        //u8 item_cnt;
        u32 max_enh_size_mult;
        u32 enh_size_base_blk;
        u32 sec_cnt;
        u8 hc_wp_grp_size;
        u8 hc_erase_grp_size;

        hc_wp_grp_size = *(emmc_buf+EXT_CSD_HC_WP_GRP_SIZE);
        hc_erase_grp_size = *(emmc_buf+EXT_CSD_HC_ERASE_GRP_SIZE);

        sec_cnt = (*(emmc_buf+EXT_CSD_SEC_CNT+3)<<24) |
                  (*(emmc_buf+EXT_CSD_SEC_CNT+2)<<16) |
                  (*(emmc_buf+EXT_CSD_SEC_CNT+1)<<8) |
                  (*(emmc_buf+EXT_CSD_SEC_CNT));

        max_enh_size_mult = (*(emmc_buf+EXT_CSD_MAX_ENH_SIZE_MULT+2)<<16) |
                            (*(emmc_buf+EXT_CSD_MAX_ENH_SIZE_MULT+1)<<8) |
                            (*(emmc_buf+EXT_CSD_MAX_ENH_SIZE_MULT));

        enh_size_base_blk = (u32)hc_wp_grp_size *
                            (u32)hc_erase_grp_size * 1024;

        printk(KERN_ERR "  ERASE_GROUP_DEF = 0x%x\n",
                *(emmc_buf+EXT_CSD_ERASE_GROUP_DEF));
        printk(KERN_ERR "  HC_WP_GRP_SIZE = 0x%x\n",hc_wp_grp_size);
        printk(KERN_ERR "  HC_ERASE_GRP_SIZE = 0x%x\n",hc_erase_grp_size);
        printk(KERN_ERR "  SEC_CNT = 0x%x\n",sec_cnt);
        printk(KERN_ERR "  MAX_ENH_SIZE_MULT = 0x%x\n",max_enh_size_mult);
        printk(KERN_ERR "Enhanced User Data Area base=\n"
               "            %u kBytes(0x%x block)\n",
                (enh_size_base_blk>>1),enh_size_base_blk);
        printk(KERN_ERR "Enhanced User Data Area x Size=\n"
               "            ENH_SIZE_MULT x HC_WP_GRP_SIZE x\n"
               "            HC_ERASE_GRP_SIZE x 512 kBytes\n");

        if(*(emmc_buf+EXT_CSD_PARTITION_SETTING_COMP) & 0x01){
            printk(KERN_ERR "This chip PARTITION configuration have completed\n");
            printk(KERN_ERR "  ENH_SATRT_ADDR = 0x%08x\n",
                      (*(emmc_buf+EXT_CSD_ENH_START_ADDR+3)<<24) |
                      (*(emmc_buf+EXT_CSD_ENH_START_ADDR+2)<<16) |
                      (*(emmc_buf+EXT_CSD_ENH_START_ADDR+1)<<8) |
                      (*(emmc_buf+EXT_CSD_ENH_START_ADDR)));
            printk(KERN_ERR "  ENH_SIZE_MULT  = 0x%06x\n",
                      (*(emmc_buf+EXT_CSD_ENH_SIZE_MULT+2)<<16) |
                      (*(emmc_buf+EXT_CSD_ENH_SIZE_MULT+1)<<8) |
                      (*(emmc_buf+EXT_CSD_ENH_SIZE_MULT)));
            printk(KERN_ERR "  PARTITION_ATTRIBUTE  = 0x%06x\n",
                    (*(emmc_buf+EXT_CSD_PARTITION_ATTRIBUTE)));

            goto FINISH_OUT;
        }

        if(param2 > enh_size_base_blk){
            i = param2 % enh_size_base_blk;
            param2 = (param2/enh_size_base_blk);
            if(i)
                param2 += 1;
        }else{
            param2 = 1;
        }
        if(param2 > max_enh_size_mult)
            param2 = max_enh_size_mult;

        printk(KERN_ERR "ENH_SATRT_ADDR = 0x%08x\n",param1);
        printk(KERN_ERR "ENH_SIZE_MULT  = 0x%06x\n",param2);

        if(p_count == 38 && (param3 == 0x2379beef)){
            u32 part_switch_time;
            /* doing set enhance user data param to ext_csd */
            /* setting ENH_SATRT_ADDR */
            rtksd_switch(card,MMC_SWITCH_MODE_WRITE_BYTE,
                         EXT_CSD_ENH_START_ADDR,(u8)(param1&0xff),1);
            rtksd_switch(card,MMC_SWITCH_MODE_WRITE_BYTE,
                         EXT_CSD_ENH_START_ADDR+1,(u8)((param1>>8)& 0xff),1);
            rtksd_switch(card,MMC_SWITCH_MODE_WRITE_BYTE,
                         EXT_CSD_ENH_START_ADDR+2,(u8)((param1>>16)& 0xff),1);
            rtksd_switch(card,MMC_SWITCH_MODE_WRITE_BYTE,
                         EXT_CSD_ENH_START_ADDR+3,(u8)((param1>>24)& 0xff),1);
            /* setting ENH_SIZE_MULT */
            rtksd_switch(card,MMC_SWITCH_MODE_WRITE_BYTE,
                         EXT_CSD_ENH_SIZE_MULT,(u8)(param2& 0xff),1);
            rtksd_switch(card,MMC_SWITCH_MODE_WRITE_BYTE,
                         EXT_CSD_ENH_SIZE_MULT+1,(u8)((param2>>8)& 0xff),1);
            rtksd_switch(card,MMC_SWITCH_MODE_WRITE_BYTE,
                         EXT_CSD_ENH_SIZE_MULT+2,(u8)((param2>>16)& 0xff),1);
            /* settig user data area to enhance mode */
            rtksd_switch(card,MMC_SWITCH_MODE_WRITE_BYTE,
                         EXT_CSD_PARTITION_ATTRIBUTE,0x01,1);
            /* setting partition configuration complete */
            rtksd_switch(card,MMC_SWITCH_MODE_WRITE_BYTE,
                         EXT_CSD_PARTITION_SETTING_COMP,0x01,1);

            part_switch_time = *(emmc_buf+EXT_CSD_PART_SWITCH_TIME);
            printk(KERN_ERR "Partition Switch Time is %u0ms.\n",part_switch_time);
            mdelay(10*(part_switch_time+10));
        }else{
            printk(KERN_ERR "Command format:\n"
                   "    echo set_ehuser=param1,param2,param3 > emmc_hacking;\n"
                   "        param1 is enhance user data area start address in block(8 hex).\n"
                   "        param2 is enhance user data area size in block(8 hex).\n"
                   "        param3 must be 2379beef to make sure you want to do this.\n"
                   "ex:\n"
                   "    echo set_ehuser=00000000,00020000,2379beef > emmc_hacking;\n"
                   "        param1=0x00000000 EUDA start address is 0.\n"
                   "        param2=0x00020000 EUDA size is 0x2000.\n"
                   "        param3=2379beef make sure that want to do this.\n" );
        }

    }else{
        printk(KERN_ERR "device do not support enhance uaer data area.\n");
    }
FINISH_OUT:
    kfree(emmc_buf);

ERR_OUT:
    return;
}
#endif

/* ========================================================
 * blk_addr    : eMMC read/write target address, block base.
 * data_size   : tarnsfer data size, block base.
 * buffer      : DMA address
 * rw_mode     : fast read or fast write
 ========================================================== */
#define FAST_READ   0x1278
#define FAST_WRITE  0x3478
static int mmc_fast_rw( unsigned int blk_addr,
                   unsigned int data_size,
                   unsigned char * buffer,
                   unsigned int rw_mode )
{
    int err = 0;
    struct mmc_host * mmc = mmc_host_local;
    unsigned long flags;

    if(mmc){
        struct rtksd_host *sdport;
        struct mmc_card *card;
        struct mmc_request mrq = {0};
        struct mmc_command cmd = {0};
	    struct mmc_data	data   = {0};
	    struct scatterlist sg;

        sdport = mmc_priv(mmc);
        mmc_claim_host(mmc);
        spin_lock_irqsave(&sdport->lock,flags);

        card = mmc->card;

        if((sdport->rtflags & RTKCR_USER_PARTITION)==0){
            int try_loop = 3;
            do{
                err = 0;
                spin_unlock_irqrestore(&sdport->lock, flags);
                err = rtksd_switch_user_partition(card);
                spin_lock_irqsave(&sdport->lock,flags);

            }while(try_loop-- && err );
            if(err){
                spin_unlock_irqrestore(&sdport->lock, flags);
                mmc_release_host(mmc);
                goto ERR_OUT;
            }
            else
                sdport->rtflags |= RTKCR_USER_PARTITION;
        }

        if(data_size>1){

            if(rw_mode == FAST_WRITE)
                cmd.opcode = MMC_WRITE_MULTIPLE_BLOCK;
            else
                cmd.opcode = MMC_READ_MULTIPLE_BLOCK;

        }else{

            if(rw_mode == FAST_WRITE)
                cmd.opcode = MMC_WRITE_BLOCK;
            else
                cmd.opcode = MMC_READ_SINGLE_BLOCK;
        }

	    cmd.arg = blk_addr;
	    cmd.flags = MMC_RSP_R1 | MMC_CMD_ADTC;

        if(data_size)
        {   //date info setting
    		data.sg = &sg;
    		data.sg_len = 1;
    		data.blksz = 512;
    		data.blocks = data_size;

    		sg_init_one(data.sg, buffer, (data_size<<9));

            if(rw_mode == FAST_WRITE)
    	        data.flags = MMC_DATA_WRITE;
            else
    		    data.flags = MMC_DATA_READ;

            mmc_set_data_timeout(&data, card);
        }

	    data.mrq = &mrq;
	    cmd.mrq = &mrq;
	    cmd.data = &data;
        cmd.retries =5;

CMD_RETRY:
        mrq.data = &data;
        mrq.cmd = &cmd;

        if(sdport->mrq){
            sdport->mrq = NULL;
        }
        cmd.error = 0;
        data.error = 0;
        spin_unlock_irqrestore(&sdport->lock, flags);
        mmc_wait_for_req(mmc, &mrq);
        spin_lock_irqsave(&sdport->lock,flags);
        err = cmd.error;
        if((err==0) && (rw_mode==FAST_WRITE))
        {
            spin_unlock_irqrestore(&sdport->lock, flags);
            err = rtksd_wait_status(mmc->card,STATE_TRAN,0);
            spin_lock_irqsave(&sdport->lock,flags);
        }
        if(err && cmd.retries){
            printk("%s(%u)last retry %d counter.\n",
                    __func__,__LINE__,cmd.retries);
            cmd.retries--;
            goto CMD_RETRY;
        }
        spin_unlock_irqrestore(&sdport->lock, flags);
        mmc_release_host(mmc);
    }else{
        err = -ENODEV;
    }

ERR_OUT:
    if(err)
        printk("err=%d\n",err);
    return err;
}

#define MAX_XFER_BLK_A    0x100
#define MAX_XFER_BLK_B    0x400
static int mmc_fast_rw_loop(unsigned int blk_addr,
                            unsigned int data_size,
                            unsigned char * buffer,
                            unsigned int rw_mode )
{
    int err = 0;

    unsigned int tmp_addr   = blk_addr;
    unsigned int tmp_size   = data_size;
    unsigned int org_size   = data_size;
    unsigned char * tmp_buf = buffer;
    unsigned int max_xfer_blk;
    do{
        /* max 1M bytes read/write per transfer */

        if(rtkcr_chk_VerA())
            max_xfer_blk = MAX_XFER_BLK_A;
        else
            max_xfer_blk = MAX_XFER_BLK_B;

        if(data_size > max_xfer_blk){
            tmp_size = max_xfer_blk;
        }else{
            tmp_size = data_size;
        }

        err = mmc_fast_rw(tmp_addr,tmp_size,tmp_buf,rw_mode);

        if(err)
            break;

        if(data_size > max_xfer_blk){
            tmp_addr    += max_xfer_blk;
            data_size   -= max_xfer_blk;
            tmp_buf     += (max_xfer_blk<<9);
        }else{
            data_size = 0;
        }

    }while(data_size);

    if(err == 0)
         return org_size-data_size;
    else
        return err;
}

int mmc_fast_read( unsigned int blk_addr,
                   unsigned int data_size,
                   unsigned char * buffer )
{
    int err = 0;
    err = mmc_fast_rw_loop(blk_addr,data_size,buffer,FAST_READ);
    return err;
}
EXPORT_SYMBOL(mmc_fast_read);

int mmc_fast_write( unsigned int blk_addr,
                    unsigned int data_size,
                    unsigned char * buffer )
{
    int err = 0;
    if(blk_addr<0x20000){
        printk("target small then save area.\n");
        err = -1;
    }
    err = mmc_fast_rw_loop(blk_addr,data_size,buffer,FAST_WRITE);
    return err;
}
EXPORT_SYMBOL(mmc_fast_write);

int mmc_send_cmd0()
{
    int err = 0;
    struct mmc_host * mmc = mmc_host_local;
    unsigned long flags;

    printk("%s(%u)\n",__func__,__LINE__);

    if(mmc){
        struct rtksd_host *sdport;
        struct mmc_card *card;
        struct mmc_request mrq = {0};
        struct mmc_command cmd = {0};
	struct mmc_data	data   = {0};
	struct scatterlist sg;

        sdport = mmc_priv(mmc);
        mmc_claim_host(mmc);
        spin_lock_irqsave(&sdport->lock,flags);
	bSendCmd0=1;
        card = mmc->card;

        cmd.opcode = MMC_GO_IDLE_STATE;
	cmd.arg = 0;
	cmd.flags = MMC_RSP_R1;

	cmd.mrq = &mrq;
	cmd.data = NULL;
        cmd.retries =3;

CMD_RETRY:
        mrq.data = &data;
        mrq.cmd = &cmd;

        if(sdport->mrq){
            sdport->mrq = NULL;
        }
        cmd.error = 0;
        data.error = 0;
        spin_unlock_irqrestore(&sdport->lock, flags);
        mmc_wait_for_req(mmc, &mrq);
        spin_lock_irqsave(&sdport->lock,flags);
        err = cmd.error;
        if(err && cmd.retries){
            printk("%s(%u)last retry %d counter.\n",
                    __func__,__LINE__,cmd.retries);
            cmd.retries--;
            goto CMD_RETRY;
        }
	bSendCmd0=0;
        spin_unlock_irqrestore(&sdport->lock, flags);
        mmc_release_host(mmc);
    }else{
    	printk("%s(%u)\n",__func__,__LINE__);
        err = -ENODEV;
    }

ERR_OUT:
    if(err)
        printk("err=%d\n",err);
    printk("%s : err=%d\n",__func__,err);
    return err;
}
EXPORT_SYMBOL(mmc_send_cmd0);

/* mmc device attribute *********************************************************** */
#define TEST_BLK_SIZE 10
static ssize_t
cr_send_cmd0_dev_show(struct device *dev,
                     struct device_attribute *attr,
                     const char *buf,
                     size_t count)
{
    struct mmc_host * host = dev_get_drvdata(dev);

    printk("%s(%u)\n",__func__,__LINE__);
    return sprintf(buf, "send cmd0\n");
}
static ssize_t
cr_send_cmd0_dev_store(struct device *dev,
                     struct device_attribute *attr,
                     const char *buf,
                     size_t count)
{
	int err=0;

	err = mmc_send_cmd0();
	return err;
}
DEVICE_ATTR(cr_send_cmd0, S_IRUGO | S_IWUSR,
            cr_send_cmd0_dev_show,cr_send_cmd0_dev_store);


static ssize_t
cr_fast_RW_dev_show(struct device *dev, struct device_attribute *attr,
        char *buf)
{
    struct mmc_host * host = dev_get_drvdata(dev);

    printk("%s(%u)\n",__func__,__LINE__);

    if(host && host->card){
        rtksd_switch_user_partition(host->card);
    }
    return sprintf(buf, "send SWITCH command\n");
}

static ssize_t
cr_fast_RW_dev_store(struct device *dev,
                     struct device_attribute *attr,
                     const char *buf,
                     size_t count)
{

    unsigned char *cr_param;


    printk("%s(%u)\n",__func__,__LINE__);
    printk("%s\n",buf);
    printk("count=%d\n",count);

    cr_param=(char *)rtkcr_parse_token(buf,"cr_param");

    if(cr_param){
        u8 *emmc_buf;
        u32 param1; //target emmc address
        u32 param2; //block number
        u32 param3; //1: write; 0: read

        rtkcr_chk_param(&param1,8,cr_param);
        rtkcr_chk_param(&param2,8,cr_param+9);
        rtkcr_chk_param(&param3,8,cr_param+18);
        printk("param1=0x%x param2=0x%x param3=0x%x\n",
                param1,param2,param3);

        emmc_buf = kmalloc(BYTE_CNT*param2, GFP_KERNEL);
        if(!emmc_buf){
            printk("emmc_buf is NULL\n");
            goto ERR_OUT;
        }

        printk("emmc_buf=0x%p\n",emmc_buf);

        if(param3 == 1){
            mmc_fast_write(param1, param2, emmc_buf );
        }else{
            mmc_fast_read(param1, param2, emmc_buf );
        }
        kfree(emmc_buf);
    }else{
        printk("have no parameter searched.\n");
    }

ERR_OUT:
    /*
    return value must be equare or big then "count"
    to finish this attribute
    */

    return count;
}
DEVICE_ATTR(cr_fast_RW, S_IRUGO | S_IWUSR,
            cr_fast_RW_dev_show,cr_fast_RW_dev_store);

static ssize_t
em_open_log_dev_show(struct device *dev, struct device_attribute *attr,
        char *buf)
{
    struct mmc_host * host = dev_get_drvdata(dev);
    struct rtksd_host *sdport = mmc_priv(host);

    if(sdport->rtflags & RTKCR_FOPEN_LOG){
        sdport->rtflags &= ~RTKCR_FOPEN_LOG;
    }else{
        sdport->rtflags |=  RTKCR_FOPEN_LOG;
    }

    return sprintf(buf, "%s log %s\n",
            DRIVER_NAME,
            (sdport->rtflags & RTKCR_FOPEN_LOG)?"open":"close");
}

static ssize_t
em_open_log_dev_store(struct device *dev,
                     struct device_attribute *attr,
                     const char *buf,
                     size_t count)
{

    printk("%s(%u)Not thing to do.\n",__func__,__LINE__);

    return count;
}
DEVICE_ATTR(em_open_log, S_IRUGO | S_IWUSR,
              em_open_log_dev_show,em_open_log_dev_store);

#ifdef CONFIG_MMC_RTKEMMC_HK_ATTR
static ssize_t
emmc_hacking_dev_show(struct device *dev, struct device_attribute *attr,
        char *buf)
{
    //struct mmc_host * host = dev_get_drvdata(dev);
    //struct mmc_card *card = host->card;

    printk(KERN_ERR "%s(%u)3013/08/12 10:55\n",__func__,__LINE__);

    printk(KERN_ERR "Supported hacking below:\n");
#ifdef HACK_BOOT_PART_RW
    printk(KERN_ERR "    fill_par    : fill data  to specific partition\n");
#endif
    printk(KERN_ERR "    set_wr_rel  : enable write reliability.\n");
    printk(KERN_ERR "    red_ext_csd : show ext_csd.\n");
    printk(KERN_ERR "    set_ehuser  : enable enhance user date area.\n");

    return sprintf(buf, "emmc_hacking_dev_show\n");
}

static ssize_t
emmc_hacking_dev_store(struct device *dev,
                     struct device_attribute *attr,
                     const char *buf,
                     size_t count)
{
    unsigned char *cr_param;

    printk(KERN_ERR "%s(%u)2013/08/15 17:30\n",__func__,__LINE__);
    //printk("%s\n",buf);
    printk(KERN_ERR "count=%d\n",count);

#ifdef HACK_BOOT_PART_RW
    cr_param=(char *)rtkcr_parse_token(buf,"fill_par");
    if(cr_param){
        hk_fill_bp(dev,count,cr_param);
        goto FINISH_OUT;
    }
#endif //#ifdef HACK_BOOT_PART_RW

    cr_param=(char *)rtkcr_parse_token(buf,"set_wr_rel");
    if(cr_param){
        hk_set_wr_rel(dev,count,cr_param);
        goto FINISH_OUT;
    }

    cr_param=(char *)rtkcr_parse_token(buf,"red_ext_csd");
    if(cr_param){
        hk_red_ext_csd(dev,count,cr_param);
        goto FINISH_OUT;
    }

    cr_param=(char *)rtkcr_parse_token(buf,"set_ehuser");
    if(cr_param){
        hk_set_enh_user_area(dev,count,cr_param);
        goto FINISH_OUT;
    }

    printk(KERN_ERR "have no match command!!\n");

FINISH_OUT:
    /*
    return value must be equare or big then "count"
    to finish this attribute
    */
    return count;
}
DEVICE_ATTR(emmc_hacking, S_IRUGO | S_IWUSR,
            emmc_hacking_dev_show,emmc_hacking_dev_store);

#endif

static ssize_t
emmc_id_dev_show(struct device *dev, struct device_attribute *attr,
        char *buf)
{
    struct mmc_host * host = dev_get_drvdata(dev);
    struct mmc_card *card = host->card;

    printk(KERN_ERR "%s(%u)%s %s\n",__func__,__LINE__,__DATE__, __TIME__);

    return sprintf(buf, "0x%02x%02x\n",
                    (unsigned char)(card->cid.manfid),
                    (unsigned char)(card->cid.oemid) );
}

static ssize_t
emmc_id_dev_store(struct device *dev,
                     struct device_attribute *attr,
                     const char *buf,
                     size_t count)
{
    unsigned char *cr_param;

    printk(KERN_ERR "%s(%u)Nothing to do\n",__func__,__LINE__);

    /*
    return value must be equare or big then "count"
    to finish this attribute
    */
    return count;
}
DEVICE_ATTR(emmc_id, S_IRUGO | S_IWUSR,
            emmc_id_dev_show,emmc_id_dev_store);

static int rtkemmc_probe(struct platform_device *pdev)
{
    struct mmc_host *mmc = NULL;
    struct rtksd_host *sdport = NULL;
//    const struct rtksdio_platform_data *rtksd_data;
    struct resource *r;
    int ret, irq;
    int att_err;

#ifdef EMMC_SHOUTDOWN_PROTECT
    u64 rtk_tmp_gpio;
#endif
    
    MMCPRINTF("\n");

    rtkcr_chk_VerA();

    att_err = device_create_file(&pdev->dev, &dev_attr_cr_send_cmd0);
    att_err = device_create_file(&pdev->dev, &dev_attr_cr_fast_RW);
    att_err = device_create_file(&pdev->dev, &dev_attr_em_open_log);
    att_err = device_create_file(&pdev->dev, &dev_attr_emmc_id);
#ifdef CONFIG_MMC_RTKEMMC_HK_ATTR
    att_err = device_create_file(&pdev->dev, &dev_attr_emmc_hacking);
#endif
    r = platform_get_resource(pdev, IORESOURCE_MEM, 0);
    irq = platform_get_irq(pdev, 0);

    MMCPRINTF("%s : IRQ = %x\n",DRIVER_NAME, irq);

    if (!r || irq < 0){
        return -ENXIO;
    }

    r = request_mem_region(r->start, 0x3FF, DRIVER_NAME);
    if (!r)
        return -EBUSY;

    mmc = mmc_alloc_host(sizeof(struct rtksd_host), &pdev->dev);

    if (!mmc) {
        ret = -ENOMEM;
        goto out;
    }
    mmc_host_local = mmc;

    sdport = mmc_priv(mmc);
    memset(sdport, 0, sizeof(struct rtksd_host));

    sdport->mmc = mmc;
    sdport->dev = &pdev->dev;
    sdport->res = r;
    sdport->base_io = EM_BASE_ADDR;
    sdport->ops = &emmc_ops;

    sema_init(&sdport->sem,1);
    sema_init(&sdport->sem_op_end,1);

    mmc->ocr_avail = MMC_VDD_30_31 | MMC_VDD_31_32 |
                     MMC_VDD_32_33 | MMC_VDD_33_34;

    mmc->caps = MMC_CAP_4_BIT_DATA
              | MMC_CAP_8_BIT_DATA
              | MMC_CAP_SD_HIGHSPEED
              | MMC_CAP_MMC_HIGHSPEED
              | MMC_CAP_NONREMOVABLE;

    if(rtk_emmc_bus_wid == 4 || rtk_emmc_bus_wid == 5){
        mmc->caps &= ~MMC_CAP_8_BIT_DATA;
    }

    mmc->f_min = 10000000>>8;   /* RTK min bus clk is 10Mhz/256 */
    mmc->f_max = 48000000;      /* RTK max bus clk is 48Mhz */

    mmc->max_segs = 1;
    mmc->max_blk_size   = 512;

    if(rtkcr_chk_VerA())
        mmc->max_blk_count  = 0x100;
    else
        mmc->max_blk_count  = 0x400;

    mmc->max_seg_size   = mmc->max_blk_size * mmc->max_blk_count;
    mmc->max_req_size   = mmc->max_blk_size * mmc->max_blk_count;

    spin_lock_init(&sdport->lock);
    init_rwsem(&cr_rw_sem);
    tasklet_init(&sdport->req_end_tasklet, rtkcr_req_end_tasklet,
		        (unsigned long)sdport);

    sdport->base = ioremap(r->start, 0x000003F0);

    //Force enable dbg log
    #ifdef MMC_DBG
    sdport->rtflags |= RTKCR_FOPEN_LOG;
    #endif

    if(rtk_emmc_bus_wid == 9 || rtk_emmc_bus_wid == 5){
        sdport->rtflags |= RTKCR_FOPEN_LOG;
    }

    MMCPRINTF("\n");

    if (!sdport->base) {
        printk(KERN_INFO "---- Realtek EMMC Controller Driver probe fail - nomem ----\n\n");
        ret = -ENOMEM;
        goto out;
    }

#ifdef ENABLE_EMMC_INT_MODE
    rtkcr_hold_int_dec(sdport->base_io);       /* hold status interrupt */
    rtkcr_clr_int_sta(sdport->base_io);
#endif

    ret = request_irq(irq, rtksd_irq, IRQF_SHARED, DRIVER_NAME, sdport);   //rtkcr_interrupt
    if (ret) {
        printk(KERN_ERR "%s: cannot assign irq %d\n", DRIVER_NAME, irq);
        goto out;
    } else{
        sdport->irq = irq;
    }

#ifdef EMMC_SHOUTDOWN_PROTECT

//#define FAKE_AC_DET_PIN
#ifdef FAKE_AC_DET_PIN
    //POWER_EN  0x101010c04
    if(pcb_mgr_get_enum_info_byname("POWER_EN", &rtk_tmp_gpio)==0)
#else
    if(pcb_mgr_get_enum_info_byname("PIN_AC_DETECT", &rtk_tmp_gpio)==0)
#endif
    {
        unsigned int gpio_group;
        unsigned int rtk_gpio_num;
        set_gpio_func_t gpio_func;;

        printk("PIN_AC_DETECT got.(0x%x)\n",(u32)rtk_tmp_gpio);

        gpio_group   = GET_PIN_TYPE(rtk_tmp_gpio);
        rtk_gpio_num = GET_PIN_INDEX(rtk_tmp_gpio);

#ifdef FAKE_AC_DET_PIN
        printk("gpio_group = %x\n",gpio_group);
        printk("rtk_gpio_num = %x\n",rtk_gpio_num);

        printk("\nfor test change PIN_AC_DETECT to ISO_GPIO 3.\n");
        rtk_tmp_gpio = 0x1010304;
        gpio_group  = GET_PIN_TYPE(rtk_tmp_gpio);
        rtk_gpio_num = GET_PIN_INDEX(rtk_tmp_gpio);
        printk("gpio_group = %x\n",gpio_group);
        printk("rtk_gpio_num = %x\n",rtk_gpio_num);
#endif
        sdport->gpio_isr_info = (u32)rtk_tmp_gpio;

        switch(gpio_group){
        case PCB_PIN_TYPE_GPIO:
            printk("PIN type is PCB_PIN_TYPE_GPIO\n");
            if(rtk_gpio_num > MAX_MIS_GPIO_CNT)
            {
                printk("Error Pin define,Skip AC_DET function\n");
                goto AC_DET_OUT;
            }
            gpio_group = MIS_GPIO;
            gpio_func = rtkcr_set_mis_gpio;
            break;
        case PCB_PIN_TYPE_ISO_GPIO:
            printk("PIN type is PCB_PIN_TYPE_ISO_GPIO\n");
            if(st_gpio_map[rtk_gpio_num] == 0xff ||
               rtk_gpio_num > MAX_ISO_GPIO_CNT)
            {
                printk("Error Pin define,Skip AC_DET function\n");
                goto AC_DET_OUT;
            }
            gpio_group = ISO_GPIO;
            gpio_func = rtkcr_set_iso_gpio;
            break;
        default:
            printk("PIN group not match\n");
                goto AC_DET_OUT;
            //break;
            }

        printk("PIN_AC_DETECT is %s_GPIO %u.\n",
                    gpio_group==ISO_GPIO? "ISO":"MIS",rtk_gpio_num);

        gpio_func(rtk_gpio_num,GPIO_IN,GPIO_LOW);
        venus_gpio_set_debounce(venus_gpio_id(gpio_group, rtk_gpio_num),
                        VENUS_GPIO_DEBOUNCE_100us);
        venus_gpio_set_dir(venus_gpio_id(gpio_group, rtk_gpio_num), 0);
        venus_gpio_clear_isr(venus_gpio_id(gpio_group, rtk_gpio_num));
        if(venus_gpio_request_irq( venus_gpio_id(gpio_group,rtk_gpio_num),
                                   rtksd_gpio_isr,
				                   DRIVER_NAME,
				                   sdport))
        {
            printk("%s: request gpio isr fail\n",DRIVER_NAME);
            goto AC_DET_OUT;
        }
        venus_gpio_set_irq_enable(venus_gpio_id(gpio_group, rtk_gpio_num), 1);

    }
AC_DET_OUT:

#else   //#ifdef EMMC_SHOUTDOWN_PROTECT
    printk(KERN_INFO"%s: EMMC_SHOUTDOWN_PROTECT  not define\n"
                    "",DRIVER_NAME);
#endif  //#ifdef EMMC_SHOUTDOWN_PROTECT

    setup_timer(&sdport->timer, rtksd_timeout_timer, (unsigned long)sdport);

    sdport->ops->set_crt_muxpad(sdport);
    if (sdport->ops->reset_card)
        sdport->ops->reset_card(sdport);
    sdport->ops->chk_card_insert(sdport);

    #ifdef ENABLE_EMMC_INT_MODE
    //rtkcr_en_int(sdport->base_io);
    #endif

    platform_set_drvdata(pdev, mmc);

    ret = mmc_add_host(mmc);
    if (ret)
        goto out;

    #ifdef CONFIG_MMC_FOR_RTK_FPGA
    cr_writel( 0x200000, CR_DUMMY_SYS );
    cr_writel( 0xf2100, sdport->base_io+EMMC_CKGEN_CTL );
    #endif
    cr_writeb( 0x2, sdport->base_io+CARD_SELECT );            //for emmc, select SD ip
    cr_writeb( 0x8,  sdport->base_io+SD_SAMPLE_POINT_CTL );    //sample point = SDCLK / 4
    cr_writeb( 0x10, sdport->base_io+SD_PUSH_POINT_CTL );     //output ahead SDCLK /4 
    sync();
    memset(g_cmd,0x00,6);
    MMCPRINTF("\ncard sample ctl : 0x%08x\n", cr_readb(SD_SAMPLE_POINT_CTL));
    MMCPRINTF("\ncard push point ctl : 0x%08x\n",cr_readb(SD_PUSH_POINT_CTL));
    g_crinit=0;

    printk(KERN_NOTICE "%s: %s driver initialized\n",
               mmc_hostname(mmc), DRIVER_NAME);

    return 0;

out:
    if (sdport) {
        if (sdport->irq)
            free_irq(sdport->irq, sdport);

        if (sdport->base)
            iounmap(sdport->base);
    }
    if (r)
        release_resource(r);
    if (mmc)
        mmc_free_host(mmc);
    return ret;
}

static int __exit rtksd_remove(struct platform_device *pdev)
{
    struct mmc_host *mmc = platform_get_drvdata(pdev);
    MMCPRINTF("\n");

    device_remove_file(&pdev->dev, &dev_attr_cr_send_cmd0);
    device_remove_file(&pdev->dev, &dev_attr_cr_fast_RW);
    device_remove_file(&pdev->dev, &dev_attr_em_open_log);
    device_remove_file(&pdev->dev, &dev_attr_emmc_id);

#ifdef CONFIG_MMC_RTKEMMC_HK_ATTR
    device_remove_file(&pdev->dev, &dev_attr_emmc_hacking);
#endif

    if (mmc) {
        struct rtksd_host *sdport = mmc_priv(mmc);

        flush_scheduled_work();

        rtksd_free_dma_buf(sdport);

        mmc_remove_host(mmc);
        if(!mmc){
            printk("eMMC host have removed.\n");
            mmc_host_local = NULL;
        }
        free_irq(sdport->irq, sdport);

        del_timer_sync(&sdport->timer);
        iounmap(sdport->base);

        release_resource(sdport->res);
        mmc_free_host(mmc);
    }
    platform_set_drvdata(pdev, NULL);
    return 0;
}

#ifdef CONFIG_PM
static int rtksd_suspend(struct platform_device *dev, pm_message_t state)
{
    struct mmc_host *mmc = platform_get_drvdata(dev);
    int ret = 0;

    printk(KERN_INFO "%s: Prepare to suspend...\n",DRIVER_NAME);

    if (mmc){
        struct rtksd_host *sdport = mmc_priv(mmc);
        if(sdport->ins_event){
            printk(KERN_INFO "%s: waiting ins_event...\n",DRIVER_NAME);
            rtkcr_mdelay(50);
        }
        ret = mmc_suspend_host(mmc);
        /* should turn of plug timer */
    }

    // reset eMMC flow ***
    printk(KERN_INFO "%s: Holding eMMC reset pin...\n",DRIVER_NAME);
    if (mmc){
        struct rtksd_host *sdport = mmc_priv(mmc);
        rtksd_hold_card(sdport);
    }
    return ret;
}

static int rtksd_resume(struct platform_device *dev)
{
    struct mmc_host *mmc = platform_get_drvdata(dev);
    unsigned long flags;
    int ret = 0;

    printk(KERN_INFO "%s: wake up to resume...\n",DRIVER_NAME);
    if (mmc){
        struct rtksd_host *sdport = mmc_priv(mmc);

        emmc_show_config123(sdport);

        sdport->ops->set_crt_muxpad(sdport);
        sdport->ops->reset_card(sdport);

        //spin_lock_irqsave(&sdport->lock, flags);
        down_write(&cr_rw_sem);
        sdport->ins_event = EVENT_NON;
        //spin_unlock_irqrestore(&sdport->lock, flags);
        up_write(&cr_rw_sem);
        ret = mmc_resume_host(mmc);
    }

    printk("%s(%u)resume finish~~\n",__func__,__LINE__);
    return ret;
}

const struct dev_pm_ops rtk_emmc_pm_ops = {
        .suspend        = rtksd_suspend,
        .resume         = rtksd_resume,
        .poweroff       = rtksd_suspend,
        .restore        = rtksd_resume,
};

#define RTK_EMMC_PM_OPS (&rtk_emmc_pm_ops)
#else
#define RTK_EMMC_PM_OPS NULL
#endif

/*****************************************************************************************/
/* driver / device attache area                                                                                                               */
/*****************************************************************************************/
static struct resource rtkemmc_resources[] = {
    [0] = {
        .start  = GET_MAPPED_RBUS_ADDR((u32)EM_BASE_ADDR),
        .end    = GET_MAPPED_RBUS_ADDR((u32)EM_BASE_ADDR + 0x3ff),
        .flags  = IORESOURCE_MEM,
    },
    [1] = {
        .start  = IRQ_CR,
        .end    = IRQ_CR,
        .flags  = IORESOURCE_IRQ,
    },
};

static u64 rtkemmc_dmamask = DMA_BIT_MASK(32);

static struct platform_device * rtkemmc_device;

static struct platform_driver rtkemmc_driver = {
    .probe      = rtkemmc_probe,
    .remove     = __exit_p(rtksd_remove),
    .driver     = 
    {
            .name   = "rtkemmc",
	        .pm	= RTK_EMMC_PM_OPS,
            .owner  = THIS_MODULE,
    },
};

static void rtkcr_display_version (void)
{
    const __u8 *revision;
    const __u8 *date;
    const __u8 *time;
    char *running = (__u8 *)VERSION;

    strsep(&running, " ");
    strsep(&running, " ");
    revision = strsep(&running, " ");
    date = strsep(&running, " ");
    time = strsep(&running, " ");
    printk(BANNER " Rev:%s (%s %s)\n", revision, date, time);
    printk("%s: build at %s %s\n",DRIVER_NAME, __DATE__, __TIME__);

#ifdef CONFIG_MMC_BLOCK_BOUNCE
    printk("%s: CONFIG_MMC_BLOCK_BOUNCE enable\n",DRIVER_NAME);
#else
    printk("%s: CONFIG_MMC_BLOCK_BOUNCE disable\n",DRIVER_NAME);
#endif

#ifdef CONFIG_SMP
    printk("%s: ##### CONFIG_SMP alert!! #####\n",DRIVER_NAME);
#else
    printk("%s: ##### CONFIG_SMP disable!! #####\n",DRIVER_NAME);
#endif
	strcpy(&media_type[0], "emmc");
}

static int rtkemmc_set_bus_width(char * buf){
    /*
    get eMMC bus width setting by bootcode parameter, like below
    bootargs=console=ttyS0,115200 earlyprintk emmc_bus=8
    the keyword is "emmc_bus"
    the getted parameter is hex.
    example:
        emmc_bus=8
    */

    rtkcr_chk_param(&rtk_emmc_bus_wid,1,buf+1);
    printk("%s: setting bus width is %u-bit\n",
                DRIVER_NAME,rtk_emmc_bus_wid);
    return 0;
}

static int __init rtkemmc_init(void)
{
    int rc = 0;

    MMCPRINTF("\n");

    rtkcr_display_version();

#ifdef CONFIG_ANDROID
    printk(KERN_INFO "%s: Android timming setting\n",DRIVER_NAME);
#endif

	rc = platform_driver_register(&rtkemmc_driver);

	if (!rc) {
		rtkemmc_device = platform_device_alloc("rtkemmc", 0);
        rtkemmc_device->num_resources = ARRAY_SIZE(rtkemmc_resources);
        rtkemmc_device->dev.dma_mask = &rtkemmc_dmamask;
        rtkemmc_device->dev.coherent_dma_mask = DMA_BIT_MASK(32);
        rtkemmc_device->resource = rtkemmc_resources;
		if (rtkemmc_device)
        {
			//rtkemmc_device->dev.platform_data = &rtk_ion_data;
			rc = platform_device_add(rtkemmc_device);
		}
		else {
			rc = -ENOMEM;
		}
		if (rc) {
			platform_device_put(rtkemmc_device);
			platform_driver_unregister(&rtkemmc_driver);
		}
	}

    if (rc < 0){
        printk(KERN_INFO "Realtek EMMC Controller Driver installation fails.\n\n");
        return -ENODEV;
    }else{
#ifdef ENABLE_EMMC_INT_MODE
        printk(KERN_INFO "Realtek EMMC Controller Driver is running interrupt mode.\n\n");
#endif
        printk(KERN_INFO "Realtek EMMC Controller Driver is successfully installing.\n\n");
        return 0;
    }

    return rc;
}

static void __exit rtkemmc_exit(void)
{
    MMCPRINTF("\n");
    platform_driver_unregister(&rtkemmc_driver);
}

// allow emmc driver initialization earlier
module_init(rtkemmc_init);
module_exit(rtkemmc_exit);

/* maximum card clock frequency (default 50MHz) */
module_param(maxfreq, int, 0);

/* force PIO transfers all the time */
module_param(nodma, int, 0);

MODULE_AUTHOR("Elbereth");
MODULE_DESCRIPTION("Realtek EMMC Host Controller driver");
MODULE_LICENSE("GPL");
MODULE_ALIAS("platform:rtkemmc");

__setup("emmc_bus",rtkemmc_set_bus_width);



